#!/bin/bash
#Date:2011-05-15
#Written by manifold.
#Readme:check the process revision.
#Change:2011-11-16
#Readme:新增ChangLogLevel.sh为常驻进程的功能。

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
exit 0

# if not a ubuntu system,exit.
cat /etc/issue|grep -E "Ubuntu" || exit 1

# basic define
BASENAME=`basename $0`
SHORT_NAME=check_process
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
PUBLIC_DIR=/usr/local/i386/public_repos

# get ip address 
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

# exclude list(manifold own the master control privilege,and sam own secondary control privilege)
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1
cat $PUBLIC_DIR/initial_system/snmp/check_process_revision_exclude.log|grep -w $IPADDR && exit 1

# define insert alert function
INSERT_MYSQL () {
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

# check the revision
cat $PUBLIC_DIR/initial_system/snmp/check_process_revision.log | while read PROCESS_NAME PROCESS_REVISION
do
	:
	# 越明那边不维护版本，我这边停用此功能 2012-07-16
	# if [ -f /home/dspeak/release/bin/$PROCESS_NAME ];then
		# cd /home/dspeak/release/bin
		# NOW_PROCESS_REVISION=`./$PROCESS_NAME -v | awk -F ':' '{print $NF}'`
		# ./$PROCESS_NAME -v | grep -E "$PROCESS_REVISION"
		# if [ "$?" -ne 0 ];then
			# PROCESS_LINE=`ps aux|grep -w $PROCESS_NAME|grep -v grep|wc -l`
			# if [ "$PROCESS_LINE" -gt 0 ];then
				# INSERT_MYSQL "Wrong revision:$PROCESS_NAME:$NOW_PROCESS_REVISION,Must be:$PROCESS_REVISION -- running"
			# else
				# INSERT_MYSQL "Wrong revision:$PROCESS_NAME:$NOW_PROCESS_REVISION,Must be:$PROCESS_REVISION -- not running"
			# fi
		# fi
		
		# ConfigServerAddr_xml_tel_md5=`cat $PUBLIC_DIR/initial_system/snmp/check_process_revision_md5.log|awk '{if($1~/ConfigServerAddr.xml_tel/) print $2}'`
		# ConfigServerAddr_xml_cnc_md5=`cat $PUBLIC_DIR/initial_system/snmp/check_process_revision_md5.log|awk '{if($1~/ConfigServerAddr.xml_cnc/) print $2}'`
		# siduri_xml_md5=`cat $PUBLIC_DIR/initial_system/snmp/check_process_revision_md5.log|awk '{if($1~/siduri.xml/) print $2}'`
		# ISP_NUM=`cat /home/dspeak/yyms/hostinfo|python -mjson.tool|awk '{if($1~/isp/) print $2}'|head -n 1`
		# if [ "$ISP_NUM" -eq 5 ];then
			# ConfigServerAddr_xml_md5=$ConfigServerAddr_xml_cnc_md5
		# else
			# ConfigServerAddr_xml_md5=$ConfigServerAddr_xml_tel_md5
		# fi
		# for CHECK_FILE in ConfigServerAddr.xml siduri.xml
		# do
			# D_MD5=`md5sum $CHECK_FILE|awk '{print $1}'`
			# S_VAR=`echo $CHECK_FILE|awk -F '.' '{print $1"_"$2"_md5"}'`
			# S_MD5=${!S_VAR}
			# if [ "$D_MD5" != "$S_MD5" ];then
				# INSERT_MYSQL "Wrong revision:$PROCESS_NAME $CHECK_FILE md5 error,isp:$ISP_NUM."
			# fi
		# done
		
	# fi
done
		
# 越明那边要求的change log level进程守护。
if [ -f /home/dspeak/release/bin/changeLogLevel/ChangLogLevel.sh ];then
	PROCESS_LINE=`ps aux|grep "/bin/bash.*ChangLogLevel.sh"|grep -v grep|wc -l`
	if [ "$PROCESS_LINE" -eq 0 ];then
		CHANGE=yes
	elif [ "$PROCESS_LINE" -gt 1 ];then
		sleep 10
		PROCESS_LINE=`ps aux|grep "/bin/bash.*ChangLogLevel.sh"|grep -v grep|wc -l`
		if [ "$PROCESS_LINE" -gt 1 ];then
			ps aux|grep "/bin/bash.*ChangLogLevel.sh"|grep -v grep >> $LOG_DIR/sysop_manager.log
			ps aux|grep "/bin/bash.*ChangLogLevel.sh"|grep -v grep|grep -v mysql|awk '{print $2}'|xargs kill -9
			CHANGE=yes
		fi
	fi
fi

if [ "$CHANGE" = "yes" ];then
	cd /home/dspeak/release/bin/changeLogLevel
	/bin/bash ChangLogLevel.sh > /dev/null 2>&1 &
fi

# 林樾那边的需求，在截图服务器配置定期执行/home/dspeak/release/bin/目录下的clean.sh脚本
IP_LIST_CLEAN () {
cat <<EOF
119.84.84.213
219.153.55.102
222.186.49.23
222.186.49.43
61.158.244.174
61.158.244.175
122.141.244.39
122.141.244.32
113.106.100.90
222.186.54.148
61.158.244.173
122.141.244.43
111.178.146.60
61.183.37.38
61.55.172.25
222.134.66.115
EOF
}

IP_LIST_CLEAN|grep -w ^$IPADDR
if [ "$?" -eq 0 ];then
	if [ `date "+%H"` = "06" ] && [ ! -f /tmp/`date "+%Y%m%d%H"`.clean.sh.log ];then
		cd /home/dspeak/release/bin
		/bin/bash clean.sh &
		touch /tmp/`date "+%Y%m%d%H"`.clean.sh.log
	fi
fi
