#!/bin/bash
#Date:2011-05-15
#Written by manifold.
#Readme:report server's process and user info to platform.

REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
source /usr/local/i386/${REPOS_NAME}/auto/function.sh
noblock_lock
trap "noblock_unlock;" 0 1 2 9 15

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
cat /etc/issue|grep -i -E "CentOS|Red" >/dev/null 2>&1 && LINUX_VERSION=centos
cat /etc/issue|grep -i -E "Ubuntu|Debian" > /dev/null 2>&1 && LINUX_VERSION=ubuntu

# basic define
BASENAME=`basename $0`
SHORT_NAME=report_info
LOG_DIR=/var/log/sysop_manager
ACTION="check"
#ACTION="collect"

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# get ip address
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
IPADDR_ALL=`/sbin/ifconfig|grep "inet addr"|awk '{print $2}'|awk -F ":" '{print $2}'|grep -v -E "^127\.|^172\."`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

wget_action () {
	wget --http-user=manifold --http-passwd=dw_manifold --limit-rate=40k --output-document=$1 --timeout=$2 --tries=$3 "http://$4:63217/$5"
}

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

# define insert alert function
if [ "$ACTION" = "check" ];then
	INSERT_MYSQL () {
		/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
	}
elif [ "$ACTION" = "collect" ];then
	REPOS_DB_ADDRESS_FILE=$LOG_DIR/repos_db_address.log
	MYSQL_ADDRESS=`cat $REPOS_DB_ADDRESS_FILE`
	DEPARTMENT=yy
	DATE=`date "+%Y_%m_%d"`
	# define insert alert function
	INSERT_MYSQL () {
		CONTENT=`echo "insert into crontab_script_monitor.collect_server_info_$DATE (script,ip,other_info,status,department) value ('$0','$IPADDR','$1','3','$DEPARTMENT');"|base64|base64|tr -d '\n'`
		wget --http-user=manifold --http-passwd=dw_manifold --output-document=$LOG_DIR/wget.log --timeout=8 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/insert_message.php?content=$CONTENT"
	}

	SEND_MESSAGE_DETECT () {
		SELECT_ROLE="mysql"
		address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep -v $MYSQL_ADDRESS|grep "$SELECT_ROLE"|awk '{print $1}'))
		until [ "${#address_array[*]}" -eq 0 ];do
			address_array=(${address_array[*]})
			address_array_num=${#address_array[*]}
			xuhao=$((RANDOM%address_array_num))
			ADDRESS=${address_array[$xuhao]}
			unset address_array[$xuhao]
			MYSQL_ADDRESS="$ADDRESS"
			echo "MESSAGE_ADDRESS:$MYSQL_ADDRESS"
			INSERT_MYSQL
			RESULT="$?"
			if [ "$RESULT" -eq 0 ];then
				echo "$MYSQL_ADDRESS" > $REPOS_DB_ADDRESS_FILE
				# 把break脱离出来，而不是直接跟在echo文件后面 && ，是因为假如文件系统崩溃，或者是空间满的时候，写不进去的话不会中断，会发送N条信息。和repos update script的这一部分功能重复
				break
			fi
		done
	}
fi

# defind unlock process function.
UNLOCK_PROCESS () {
	/bin/bash $COMM_DIR/auto/unlock_process.sh "$1" "$2"
}
UNLOCK_PROCESS "/bin/bash $COMM_DIR/auto/mon_yyms_agent_2.sh" "300"
UNLOCK_PROCESS "/bin/bash $COMM_DIR/auto/mon_yymp.sh" "1800"
UNLOCK_PROCESS "python op_ccc.py" "300"
UNLOCK_PROCESS "/bin/bash $COMM_DIR/monitor/monitor_slab.sh" "300"

check_uuid () {
	if [ ! -f /tmp/2011092601 ];then
		if [ ! -f /home/dspeak/yyms/uuid ];then
			INSERT_MYSQL "collect_uuid"
		fi
		touch /tmp/2011092601
	fi
}

kill_lock_process () {
	if [ ! -f /tmp/2011110901 ];then
		ps aux|grep -w "python agent_transfer.py"|grep -v grep|awk '{print $2}'|xargs kill -9
		touch /tmp/2011110901
	fi
}

function run_on_boot_time () {
	if [[ ! -f /tmp/fstab ]] && [[ "`cat /proc/uptime|awk '{if($1 < 300){printf("%s",int($1))}else{print "999999"}}'`" -lt 300 ]];then
		#run scripts on boot time
		ntpdate manager.repos.yy.duowan.com >> $LOG_DIR/sysop_manager.log
		/bin/bash /usr/local/i386/*/auto/system_router.sh
		[ "$(uname -r)" == '3.2.0-23-generic' ] && \
		echo 1 > /sys/module/rcutree/parameters/rcu_cpu_stall_suppress
		[[ -f /usr/local/i386/public_repos/initial_system/hardware/collect_hardware_info_to_cmdb.v2.sh ]] \
			&& /bin/bash /usr/local/i386/public_repos/initial_system/hardware/collect_hardware_info_to_cmdb.v2.sh query
	fi
}
run_on_boot_time

function modify_fstab () {
	if [[ ! -f /tmp/fstab ]] || [[ ! -s /etc/fstab ]];then
		if [ ! -s /etc/fstab ];then
			for a in `ls /var/log/sysop_manager/fstab_201*|sort -nr`;do
				if [ -s $a ];then
					cp -f $a /etc/fstab
					break;
				fi
			done
		fi
		wall_time=`date +%Y%m%d-%H-%M-%S`
		cp -f /etc/fstab /var/log/sysop_manager/fstab_$wall_time
		awk '{if($1~"^UUID=*"||$1~"/dev/*"){if($2!="/"){$6="0"}} print $0}' /etc/fstab > /tmp/fstab
		[[ -s /tmp/fstab ]] && cp -f /tmp/fstab /etc/fstab
		chmod 644 /etc/fstab
	fi
}
modify_fstab

collect_process_info () {
	if [ `date "+%H"` = "05" ] && [ ! -f /tmp/`date "+%Y%m%d%H"`.scan_process.log ];then
		su - yuwanfu -c "cd $COMM_DIR/other;/bin/bash procscan.sh 2>/dev/null" > /tmp/process_scan.log
		MSG=`cat /tmp/process_scan.log|tr \' \"`
		INSERT_MYSQL "processscan:$MSG"
		touch /tmp/`date "+%Y%m%d%H"`.scan_process.log
	fi
}

collect_process_info_yyms () {
	if [ `date "+%H"` = "05" ] && [ ! -f /tmp/`date "+%Y%m%d%H"`.scan_process_yyms.log ];then
		ps -e -o pid,etime,cmd | grep -v '\['|sed 's/^/'"${IPADDR}"': /g' 2>/dev/null > /tmp/process_scan_yyms.log
		MSG=`cat /tmp/process_scan_yyms.log`
		INSERT_MYSQL "yyms_process_scan:$MSG"
		touch /tmp/`date "+%Y%m%d%H"`.scan_process_yyms.log
	fi
}


e1000_info_collect () {
	lsmod|grep e1000
	if [ "$?" -eq 0 ];then
		if [ `date "+%H"` = "20" ] || [ `date "+%H"` = "21" ] || [ `date "+%H"` = "22" ];then
			if [ ! -f /tmp/`date "+%Y%m%d%H"`.e1000_info_collect.log ];then
				MSG=`tc -s qdisc|grep Sent|awk -F ',' '{print $1}'|awk '{print $NF}'`
				INSERT_MYSQL "e1000_info_collect:$MSG"
				touch /tmp/`date "+%Y%m%d%H"`.e1000_info_collect.log
			fi
		fi
	fi
}

check_nginx () {
	if [ ! -f /tmp/2011102607 ];then
		# 若存在nginx进程，则检测nginx的安装方式，安装位置，版本号
		ps aux|grep -v grep|grep "nginx: master process"
		if [ "$?" -eq 0 ];then
			/usr/sbin/nginx -v > /tmp/nginx_version.log 2>&1
			NGINX_VERSION=`cat /tmp/nginx_version.log|grep "nginx version"|awk -F ':' '{print $NF}'`
			if [ "$NGINX_VERSION" = "" ];then
				/usr/local/nginx/sbin/nginx -v > /tmp/nginx_version.log 2>&1
				NGINX_VERSION=`cat /tmp/nginx_version.log|grep "nginx version"|awk -F ':' '{print $NF}'`
			fi
			INSERT_MYSQL "nginx_collect:$NGINX_VERSION"
		fi
		touch /tmp/2011102607
	fi
}

find_igb_machine () {
	if [ ! -f /tmp/2011102608 ];then
		lsmod|grep ^igb
		if [ "$?" -eq 0 ];then
			which ethtool
			if [ "$?" -eq 0 ];then
				IGB_DRIVER_VERSION=`ethtool -i eth0|grep ^version`
			else
				IGB_DRIVER_VERSION="no ethtool tool,please check."
			fi
			INSERT_MYSQL "igb_collect:$IGB_DRIVER_VERSION"
		fi
		touch /tmp/2011102608
	fi
}

del_zabbix_auto_start () {
	if [ ! -f /tmp/2011111001 ];then
		if [ -f /etc/rc2.d/S20zabbix-agent ];then
			rm -fr /etc/rc2.d/S20zabbix-agent
		fi
		if [ -f /etc/init.d/zabbix-agent ];then
			rm -fr /etc/init.d/zabbix-agent
		fi
		pkill zabbix_agentd
		touch /tmp/2011111001
	fi
}

detect_dir_changeLogLevel () {
	if [ ! -f /tmp/2011111601 ];then
		if [ -d /home/dspeak/release/bin/changeLogLevel ];then
			INSERT_MYSQL "directory changeLogLevel"
		fi
		touch /tmp/2011111601
	fi
}

check_disk_space () {
	if [ ! -f /tmp/2011111702 ];then
		DISK_SPACE=`df -lh|grep -v Filesystem|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>95) print}'`
		if [ "$DISK_SPACE" != "" ];then
			INSERT_MYSQL "DISK_SPACE:$DISK_SPACE"
		fi
	fi
	touch /tmp/2011111702
}


function configure_syslog-ng_again
{
	if [ ! -f /tmp/2011120700002 ]
	then
		[[ "$(cat /etc/issue)" =~ Ubuntu ]] && [[ "$(/usr/sbin/syslog-ng --version)" =~ syslog-ng(.)3 ]] \
			&& sed -i -e 's/^SYSLOGNG_OPTS="--no-caps"/SYSLOGNG_OPTS=""/' \
			-e 's/-- -p "$PIDFILE"  $SYSLOGNG_OPTS/-- -p "$PIDFILE"  $SYSLOGNG_OPTS --no-caps/g'  /etc/init.d/syslog-ng \
			&& /etc/init.d/syslog-ng restart
		touch /tmp/2011120700002
	fi
}
#configure_syslog-ng_again

collect_passwd () {
	if [ ! -f /tmp/2011121902 ];then
		MAN=`cat /etc/passwd|awk -F ':' '{print $1,":",$3,":",$4}'`
		INSERT_MYSQL "collect_passwd:$MAN"
	fi
	touch /tmp/2011121902
}
#collect_passwd

function create_core_files_dir
{
	if [ ! -f /tmp/2011-12-28-0001 ]
	then
		[ ! -d /data/core_files ] && mkdir -p /data/core_files
		chmod 777 /data/core_files
		[ -d /data/yy/core_files ] && rm -rf /data/yy/core_files
	fi
	touch /tmp/2011-12-28-0001
}
#create_core_files_dir


check_disk_space2 () {

		DISK_SPACE=`df -lh|grep -v Filesystem|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>95) print}'`
		if [ "$DISK_SPACE" != "" ]
		then
			rm -f /data/core_files/core-*
		fi
		DISK_SPACE=`df -lh|grep -v Filesystem|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>95) print}'`
		if [ "$DISK_SPACE" != "" ];then
			INSERT_MYSQL "DISK_SPACE:$DISK_SPACE"
		fi
}
#check_disk_space2

function detect_core_files
{
        touch  /data/core_files/.core_info
        cd  /data/core_files
        OLD_CORE_FILES="$(cat /data/core_files/.core_info |xargs)"
        NOW_CORE_FILES=$( /bin/ls core-* 2>/dev/null|xargs )
        CORE_COUNT=$( /bin/ls core-* 2>/dev/null| wc -l )
        NEW_CORE_FILE=$( /bin/ls core-* 2>/dev/null )

        if [ $CORE_COUNT -le 0 ]
        then
                # now, there is no core down files, do nothing
                :
        elif [ "$OLD_CORE_FILES" = "" ]
        then
                # completely new files, alarm directly.
                INSERT_MYSQL "Detected new core file in /data/core_files : $NOW_CORE_FILES . Altogether $CORE_COUNT files."
        else
                for FILE in $OLD_CORE_FILES
                do
                        NEW_CORE_FILE=$(echo "$NEW_CORE_FILE"|grep -Ev "^$FILE$")
                done
                # OK , new core down files found, alarm.
                if [ "$NEW_CORE_FILE" != "" ]
                then
                        INSERT_MYSQL "Detected new core file in /data/core_files : $(echo $NEW_CORE_FILE|xargs) . Altogether $CORE_COUNT files."
                fi
        fi

        /bin/ls core-* 2>/dev/null  > /data/core_files/.core_info
        return 0
}


# 2012-02-20 下载pycrypto-2.5.tar.gz的文件，限制带宽20k，共2500台机器，随机random，看到4台管理机的峰值带宽大概为30M

install_python_lib () {
	API_ROLE="mysql"
	api_address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep "$API_ROLE"|awk '{print $1}'))
	api_address_array_num=${#api_address_array[*]}
	api_num_index=$((RANDOM%api_address_array_num))
	API_ADDRESS=${api_address_array[$api_num_index]}
	wget_action /usr/local/src/pycrypto-2.5.tar.gz 55 1 $API_ADDRESS revision/package/pycrypto-2.5.tar.gz
	if [ -f /usr/local/src/pycrypto-2.5.tar.gz ];then
		cd /usr/local/src
		tar -zxvf pycrypto-2.5.tar.gz
		cd pycrypto-2.5
		python setup.py build
		mkdir -p pylibs
		mv /usr/local/src/pycrypto-2.5/build/*/Crypto /home/dspeak/yyms/pylibs
	else
		INSERT_MYSQL "no such file /usr/local/src/pycrypto-2.5.tar.gz"
	fi
}

install_python_lib_action () {
	if [ ! -f /tmp/2012022001 ];then
		install_python_lib
	fi
	touch /tmp/2012022001
}

move_python_lib_data () {
	if [ ! -f /tmp/2012022010 ];then
		cd /home/dspeak/yyms/pylibs && mkdir Crypto
		cd /home/dspeak/yyms/pylibs && mv * Crypto
		INSERT_MYSQL "move_python_lib_data"
	fi
	touch /tmp/2012022010
}

function change_resolv.conf () {
	if [ ! -f /tmp/2012041201 ];then
		BJ_DNS_LINE=`cat /etc/resolv.conf|grep 219.141.148.42|wc -l`
		if [ "$BJ_DNS_LINE" -gt 0 ];then
			sed -i '/8.8.8.8/d' /etc/resolv.conf
		else
			sed -i 's/8.8.8.8/219.141.148.42/g' /etc/resolv.conf
			sed -i 's/208.67.222.222/202.106.0.20/g' /etc/resolv.conf
			sed -i '/208.67.220.220/d' /etc/resolv.conf
		fi
	fi
	touch /tmp/2012041201
}

function detect_sudo_version () {
	if [ ! -f /tmp/2012041603 ];then
		dpkg -l|grep "sudo.*1.8.3"
		if [ "$?" -eq 0 ];then
			INSERT_MYSQL "sudo file found."
		fi
		touch /tmp/2012041603
	fi
}

function check_java_process () {
	if [ ! -f /tmp/2012060808 ];then
		touch /tmp/2012060808
		INFO=`ps aux|grep -v grep|grep java`
		if [ "$INFO" != "" ];then
			# resin
			ps aux|grep -v grep|grep resin
			if [ "$?" -eq 0 ];then
				for CONF_FILE in `ps aux|grep -v grep|grep resin|awk -F '-conf' '{print $2}'|awk '{print $1}'|grep -v ^$`
				do
					WWW_DIR=`cat $CONF_FILE|grep web-app|grep directory|grep -v ROOT|awk -F '"' '{print $4}'`
					if [ "$WWW_DIR" != "" ];then
						RESULT=`find $WWW_DIR -name "struts2-core*.jar"`
						if [ "$RESULT" != "" ];then
							INSERT_MYSQL "java_report:$RESULT"
						fi
					else
						INSERT_MYSQL "java_report:wwwdir null"
					fi
				done
			fi

			# tomcat
			ps aux|grep -v grep|grep tomcat
			if [ "$?" -eq 0 ];then
				for CONF_DIR in `ps aux|grep -v grep|grep tomcat|awk -F '-Dcatalina.base=' '{print $2}'|awk '{print $1}'|grep -v ^$`
				do
					CONF_FILE=$CONF_DIR/conf/server.xml
					for WWW_DIR in `cat $CONF_FILE|grep "docBase"|awk -F '"' '{print $4}'`
					do
						if [ "$WWW_DIR" != "" ];then
							RESULT=`find $WWW_DIR -name "struts2-core*.jar"`
							if [ "$RESULT" != "" ];then
								INSERT_MYSQL "java_report:$RESULT"
							fi
						else
							INSERT_MYSQL "java_report:wwwdir null"
						fi
					done
				done
			fi

			# other
			OTHER_PROCESS_LINE=`ps aux|grep -v grep|grep -v tomcat|grep -v resin|wc -l`
			if [ "$OTHER_PROCESS_LINE" -gt 0 ];then
				RESULT=`find /data -name "struts2-core*.jar"`
				if [ "$RESULT" != "" ];then
					INSERT_MYSQL "java_report:$RESULT"
				fi
			fi
		fi
	fi
}

function kill_yymp_transfer_d () {
	if [ ! -f /tmp/2014031903 ];then
		touch /tmp/2014031903 || exit 1
		ps aux | grep -E 'agent_channel' | grep -vE 'ssh|grep'|awk '{print $2}'|xargs kill -9
		sleep 3
		#bash /usr/local/i386/*/auto/mon_yymp.sh
		bash /usr/local/i386/*/auto/mon_yyms_agent_2.sh
	fi
}

function statistic_crashdump () {
	if [ ! -f /tmp/2014040101 ];then
		touch /tmp/2014040101 || exit 1
		sleep $((RANDOM%20))
		local num=$(ls -d /var/crash/vm*| wc -l)
		[ "$num" -gt 0 ] && INSERT_MYSQL "statistic_crashdump: $num"
		local p_num=$(awk '{if($0 ~ /^Processor/){print $NF}}' /etc/hardware_info)
		local serverid=$(awk -F '=' '{if($0 ~ /^server_id/){print $2}}' /home/dspeak/yyms/hostinfo.ini)
		INSERT_MYSQL "processor_num: $serverid 	$p_num"
	fi
}

function collect_libssl () {
	if [ ! -f /tmp/2014040901 ];then
		touch /tmp/2014040901 || exit 1
		sleep $((RANDOM%20))
		if [ "$LINUX_VERSION" = "ubuntu" ];then
			ssl_ver=$(dpkg -s libssl1.0.0 | awk -F ':' '{if($0 ~ /^Version/){print $2}}')

			if [ "x${ssl_ver}" != "x" ];then
				buss=$(awk -F '=' '{if($0 ~ /buss_name/){print $2}}' /home/dspeak/yyms/hostinfo.ini)
				sysop=$(awk -F '=' '{if($0 ~ /sysopResponsibleAdmin_dw/){print $2}}' /home/dspeak/yyms/hostinfo.ini)
				repos=$(awk -F '=' '{if($0 ~ /responsibleAdmin_dw/){print $2}}' /home/dspeak/yyms/hostinfo.ini)
				INSERT_MYSQL "libssl_version: $ssl_ver $sysop $repos $buss"
			fi
		fi
	fi
}

function nic_info () {
	tmpfile="/tmp/2014050601"
	if [ ! -f $tmpfile ];then
		touch $tmpfile || exit 1
		read count nic < <(sed -n 's/.*\(eth[0-9]\).*/\1/p' /proc/interrupts |sort | uniq -c|sort| head -n1)
		ethtool -i ${nic} > $tmpfile
		nic_driver=$(awk -F ':' '{if($1 == "driver"){print $2}}' $tmpfile)
		driver_ver=$(awk -F ':' '{if($1 == "version"){print $2}}' $tmpfile)
		read nic_mac < /sys/class/net/${nic}/address
		eth_nic=$(grep -i "$nic_mac" /etc/hardware_info|awk '{for(i=1;i<=NF;i++){if($i ~ /[0-9]+[a-zA-Z]*/){print $i;exit}}}')

		if [ -x /usr/sbin/megacli ];then
			megacli_ver=$(megacli -V |awk '{for(i=1;i<=NF;i++){if(tolower($i) ~ /ver/){print $(i+1);exit}}}')
			manu=$(dmidecode -s system-manufacturer|cut -d ' ' -f1)
			manu="${manu}:${megacli_ver}"
		fi

		if [ -s /home/dspeak/yyms/hostinfo.ini ];then
			room=$(awk -F '=' '{if($1 == "room"){print $2}}' /home/dspeak/yyms/hostinfo.ini)
			sysopadm=$(awk -F '=' '{if($1 == "sysopResponsibleAdmin_dw"){print $2}}' /home/dspeak/yyms/hostinfo.ini)
			reposadm=$(awk -F '=' '{if($1 == "responsibleAdmin_dw"){print $2}}' /home/dspeak/yyms/hostinfo.ini)
			buss=$(awk -F '=' '{if($1 == "buss_name"){print $2}}' /home/dspeak/yyms/hostinfo.ini)

		fi
		sleep $((RANDOM%45))
		INSERT_MYSQL "nic_info1: ${eth_nic}:${count}:${nic_driver}:${driver_ver}&${LINUX_VERSION}:${manu}&${room}:${sysopadm}:${reposadm}:${buss}"

	fi
}

function update_megacli () {
	if [ ! -f /tmp/2014051201 ];then
		touch /tmp/2014051201 || exit 1
		sleep $((RANDOM%45))
		if [ -f /usr/sbin/megacli ];then
			megacli_ver=$(megacli -V |awk '{for(i=1;i<=NF;i++){if(tolower($i) ~ /ver/){print $(i+1);exit}}}')
			if  ! echo $megacli_ver| grep -qw '8.07.14';then
				if [ "$LINUX_VERSION" = "centos" ];then
					rpm -e MegaCli
				elif [ "$LINUX_VERSION" = "ubuntu" ];then
					dpkg --remove megacli
				fi
				bash /usr/local/i386/public_repos/initial_system/hardware/collect_hardware_info_to_cmdb.v2.sh ns > /dev/null 2>&1
			fi
		fi

		if [ -f /usr/sbin/megacli ];then
			megacli_ver=$(megacli -V |awk '{for(i=1;i<=NF;i++){if(tolower($i) ~ /ver/){print $(i+1);exit}}}')
			manu=$(dmidecode -s system-manufacturer|cut -d ' ' -f1)
			manu="${manu}:${megacli_ver}"
			INSERT_MYSQL "megacli_version: ${LINUX_VERSION}:${manu}"
		fi
	fi
}

function start_nic_affinity () {
	if [ ! -f /tmp/2014051501 ];then
		touch /tmp/2014051501 || exit 1

		if [ ! -s /etc/init.d/nic_irq_affinity ];then
			cp /usr/local/i386/*/initial_system/other/nic_irq_affinity.sh  /etc/init.d/nic_irq_affinity
			chmod 755 /etc/init.d/nic_irq_affinity
			ln -s /etc/init.d/nic_irq_affinity /etc/rc2.d/S25nic_irq_affinity
			ln -s /etc/init.d/nic_irq_affinity /etc/rc3.d/S25nic_irq_affinity
			ln -s /etc/init.d/nic_irq_affinity /etc/rc4.d/S25nic_irq_affinity
			ln -s /etc/init.d/nic_irq_affinity /etc/rc5.d/S25nic_irq_affinity
			ln -s /etc/init.d/nic_irq_affinity /etc/cron.hourly/start_nic_irq_affinity
			/etc/init.d/nic_irq_affinity start > /dev/null 2>&1

			INSERT_MYSQL "start_nic_affinity"
		fi

	fi
}

function scan_ip () {
	if [ ! -f /tmp/2014081901 ];then
		touch /tmp/2014081901 || exit 1
		all_ip=$(get_all_ip|grep -vE '127.0.0.1|^192.168\.'|tr -s '\n' ' ')
		SN=$(split_tag 'serial-number' '/etc/hardware_info' ':')
		sid=$(split_tag 'server_id' '/home/dspeak/yyms/hostinfo.ini' '=')
		sleep $((RANDOM%30))
		INSERT_MYSQL "scan_ip1:${SN},${sid},${all_ip}"
	fi
}

function scan_bmc_mac () {
	if [ ! -f /tmp/2014073101 ];then
		touch /tmp/2014073101 || exit 1
		sleep $((RANDOM%30))
		SYSTEM_MANUFACTURER=$(split_tag 'Manufacturer' /etc/hardware_info ':')
		case $SYSTEM_MANUFACTURER in
			"HP")
				BMC_CHANNEL=2;;
			"IBM")
				BMC_CHANNEL=1;;
			"Powerleader")
				BMC_CHANNEL=1;;
			"Intel")
				BMC_CHANNEL=1;;
			"Lenovo")
				BMC_CHANNEL=1;;
			Dell*|dell*)
				BMC_CHANNEL=1
				USER="root";;
			Inspur*)
				BMC_CHANNEL=8;;
			*)
				BMC_CHANNEL=1;;
		esac
		SN=$(split_tag 'serial-number' /etc/hardware_info ':')
		[ "${SN}" = "" ] && SN=$(dmidecode -s system-serial-number)
		SID=$(split_tag 'server_id' /home/dspeak/yyms/hostinfo.ini '=')
		[ "${SYSTEM_MANUFACTURER}" = "Inspur" ] && upload_channel=1

		for c_channel in ${BMC_CHANNEL} $upload_channel;
		do
			BMC_MAC=$(ipmitool lan print $c_channel |awk '{if($0 ~ /^MAC Address/){print $NF}}')
			wget -q --timeout=4 --tries=2 --user=manifold --password=dw_manifold -O /dev/null \
			"http://manager.repos.yy.duowan.com:63217/external/record_ipmi_info.php?bmc_mac=${BMC_MAC}&sn=${SN}&sid=${SID}"
		done
		rm -f /tmp/201405???? /tmp/201406????
	fi
}

function remove_module () {
	if [ ! -f /tmp/2014082201 ];then
		touch /tmp/2014082201 || exit 1
		if lsmod| grep -q 'netconsole';then
			modprobe -r netconsole
			if lsmod | grep -q 'netconsole';then
				sleep $((RANDOM%30))
				INSERT_MYSQL "kernel: netconsole"
			fi
		fi
		[ -s /etc/modprobe.d/netconsole.conf ] && \
			mv /etc/modprobe.d/netconsole.conf /var/log/sysop_manager/.
		dmesg -n 3
	fi
}

function yizhuang_change_ip () {
	if [ ! -f /tmp/2014090301 ];then
		touch /tmp/2014090301 || exit 1
		one_ip=$(get_one_ip)
		sid=$(split_tag 'server_id' '/home/dspeak/yyms/hostinfo.ini' '=')
		buss=$(split_tag 'buss_name' '/home/dspeak/yyms/hostinfo.ini' '=')
		room=$(split_tag 'room' '/home/dspeak/yyms/hostinfo.ini' '=')
		ip_tag="106.120.184|110.172.210|111.206.28|114.111.160|114.111.163|114.111.165|114.111.166|220.181.178"
		need_ch_host=$(grep -vE '^$|^#' /etc/hosts| grep -E "${ip_tag}" | tr -s '\n' ',')
		change_iptable=$(grep -vE '^$|^#' /usr/local/virus/iptables/iptables.add |grep -cE "$ip_tag")
		sleep $((RANDOM%45))
		[ "x${need_ch_host}" != "x" ] && INSERT_MYSQL "change_host: $one_ip:$sid:$room:$buss:$need_ch_host"
		[ "x${change_iptable}" != "x0" ] && INSERT_MYSQL "change_iptable: $one_ip:$sid:$room:$buss:$change_iptable"
	fi
}

function scan_stop_run () {
	if [ ! -f /tmp/2014091001 ];then
		touch /tmp/2014091001 || exit 1
		sleep $((RANDOM%40))
		cd /var/log/sysop_manager;a=$(ls stop_run*|tr -s '\n' ' ');cd -
		[ "x${a}" != "x" ] && INSERT_MYSQL "scan_stop_run: ${a}"
		[ -f /var/log/sysop_manager/stop_run_base_config ] && \
		INSERT_MYSQL "scan_stop_baseconfig"
	fi
}

function restart_yyagent () {
	if [ ! -f /tmp/2014092601 ];then
		touch /tmp/2014092601 || exit 1
		ps aux | grep -E 'yymp_agent_d' | grep -vE 'ssh|grep'|awk '{print $2}'|xargs kill -9
		sleep $((RANDOM%10))
		bash /usr/local/i386/*/auto/mon_yymp.sh
		rm -f /tmp/201407*
	fi
}

function scan_bmc_fw () {
	if [ ! -f /tmp/2014092801 ];then
		touch /tmp/2014092801 || exit 1
		if grep -qi "Huawei" /etc/hardware_info;then
			SN=$(split_tag "serial-number" /etc/hardware_info ":")
			SID=$(split_tag "server_id" "/home/dspeak/yyms/hostinfo.ini" "=")
			bmc_fw=$(ipmitool mc info | grep "Firmware Revision" | awk '{print $NF}')
			INSERT_MYSQL "scan_bmc_fw: ${SN}:${SID}:${bmc_fw}"
		fi
	fi
}

function scan_info1() {
	if [ ! -f /tmp/2014101401 ];then
		touch /tmp/2014101401 || exit 1
		rm -f /home/dspeak/yyms/yymp/yyac_worker_ant/bin/logs/app.*
		rdir=$(ls -l /usr/local/i386/| grep -E 'repos|webdep'| grep -v public_repos | wc -l)
		grep -q "Product.*RD640" /etc/hardware_info && \
			megafw=$(megacli -adpallinfo -aall| grep 'FW Version'| awk '{print $NF}')

		if [ $rdir -gt 1 ] || [ "x${megafw}" != "x" ];then
			INSERT_MYSQL "scan_info1: rdir:${rdir}, megafw:${megafw}"
		fi
		rm -f /tmp/201408????
	fi
}

function scan_info2() {
	if [ ! -f /tmp/2014102102 ];then
		touch /tmp/2014102102 || exit 1
		cat /usr/local/i386/*/initial_system/etc_security_limits.conf.content > /etc/security/limits.conf
	fi
}

function scan_info3() {
	if [ ! -f /tmp/2014102401 ];then
		touch /tmp/2014102401 || exit 1
		if [ -s /etc/init.d/nic_irq_affinity ];then
			chmod 755 /etc/init.d/nic_irq_affinity
			bash /etc/init.d/nic_irq_affinity start
		else
			INSERT_MYSQL "found_not nic_irq_affinity"
		fi
	fi
}

function scan_info4() {
	if [ ! -f /tmp/2014111301 ];then
		touch /tmp/2014111301 || exit 1
		pro_num=$(ps -C control.sh |wc -l)
		sleep $((RANDOM%20))
		INSERT_MYSQL "proc_found: control.sh ${pro_num}"
	fi
}

function scan_info5() {
	if [ ! -f /tmp/2014112601 ];then
		touch /tmp/2014112601 || exit 1
		con=$(grep -E -A1 "cfs_rq.*:/$" /proc/sched_debug | \
			awk -F ':' '{if($0 ~ /exec_clock/ && $2 < 0){print "yes";exit}}')
		if [ "x${con}" = "xyes" ];then
			room=$(split_tag 'room' "$HOSTFILE" '=')
			server_id=$(split_tag 'server_id' "$HOSTFILE" '=')
			buss_name=$(split_tag 'buss_name' "$HOSTFILE" '=')
			responsibleAdmin=$(split_tag 'responsibleAdmin' "$HOSTFILE" '=')
			sysopResponsibleAdmin=$(split_tag 'sysopResponsibleAdmin' "$HOSTFILE" '=')

			sleep $((RANDOM%20))
			INSERT_MYSQL "scan5: ${server_id}|${room}|${sysopResponsibleAdmin}|${responsibleAdmin}|${buss_name}"

		fi
		rm -f /tmp/201409???? /tmp/201410????
	fi
}

function scan_info6() {
	if [ ! -f /tmp/2014120101 ];then
		touch /tmp/2014120101 || exit 1
		sleep $((RANDOM%50))
		upload_logfile "/etc/hosts"
		[ $? -ne 0 ] && \
		( upload_logfile "/etc/hosts" >/dev/null 2>&1 ) &
	fi
}

function scan_info7() {
	if [ ! -f /tmp/2014120102 ];then
		touch /tmp/2014120102 || exit 1

		USER_CHECK="linrunjin"
		USER_CHECK_ID=$(id -u $USER_CHECK)
		if [ $? -eq 0 ];then
			USER_ONLINE=$(ps aux|grep -E "^$USER_CHECK|^$USER_CHECK_ID"| \
				grep -vcE "grep");
			[ "$USER_ONLINE" -ne 0 ] && MSG="processes"
			cron_line1=$(crontab -u $USER_CHECK -l 2>/dev/null| \
				grep -vcE '^#|^$')
			cron_line2=$(grep "$USER_CHECK" /etc/crontab|grep -vcE '^#|^$')
			if [ "$cron_line1" -ne 0 ] || [ "$cron_line2" -ne 0 ];then
				MSG="${MSG} crontab"
			fi
			sleep $((RANDOM%30))
			[ "x${MSG}" != "x" ] && INSERT_MYSQL "scan_info7: $MSG"
		fi
	fi
}

function scan_info8() {
	if [ ! -f /tmp/2014121801 ];then
		touch /tmp/2014121801 || exit 1
		if lsmod|grep -qw "igb" && modinfo igb| grep -wq 'RSS';then

			if grep -wq 'RSS=4' /etc/modprobe.d/igb.conf;then
				room=$(split_tag 'room' "$HOSTFILE" '=')
				server_id=$(split_tag 'server_id' "$HOSTFILE" '=')
				buss_name=$(split_tag 'buss_name' "$HOSTFILE" '=')
				responsibleAdmin=$(split_tag 'responsibleAdmin' "$HOSTFILE" '=')
				sysopResponsibleAdmin=$(split_tag 'sysopResponsibleAdmin' "$HOSTFILE" '=')

				sleep $((RANDOM%20))
				INSERT_MYSQL "scan_info8: ${server_id}|${room}|${sysopResponsibleAdmin}|${responsibleAdmin}|${buss_name}"

			fi
		fi
	fi
}

function scan_info9() {
	if [ ! -f /tmp/2014121802 ];then
		touch /tmp/2014121802 || exit 1
		sleep $((RANDOM%20))
		a=$(grep '^nameserver' /etc/resolv.conf | awk '{printf("%s ",$NF)}')
		[ "x${a}" != "x" ] && INSERT_MYSQL "scan_info9: $a"
	fi
}

function scan_info10() {
	if [ ! -f /tmp/2014122201 ];then
		touch /tmp/2014122201 || exit 1
		find /data/yy/data/linkd_d  /home/dspeak/release/bin -maxdepth 1  -type f -name 'jifen.*.*' -mmin +680 -exec rm -f {} \;
	fi
}

function scan_info11() {
	if [ ! -f /tmp/2014122501 ];then
		touch /tmp/2014122501 || exit 1
		ps aux | grep -E 'yymp_transfer_d' | grep -vE 'ssh|grep'|awk '{print $2}'|xargs kill -9
		sleep $((RANDOM%10))
		bash /usr/local/i386/*/auto/mon_yymp.sh
		rm -f /tmp/201411????
	fi
}

function scan_info12() {
	if [ ! -f /tmp/2014122601 ];then
		touch /tmp/2014122601 || exit 1
		sleep $((RANDOM%30))
		string=$(python /usr/local/i386/public_repos/strategy.py)
		if [ "x${string}" != "x" ] && [ "x${string}" != 'xNone' ];then
			string=$(echo $string|awk -F ':' '{print $1}')
			INSERT_MYSQL "scan_info12: $string"
		fi
	fi
}

function scan_info13() {
	if [ ! -f /tmp/2014122901 ];then
		touch /tmp/2014122901 || exit 1
		agent_count=$(ps aux | grep -E 'netatopd' | grep -vcE 'ssh|grep')
		sleep $((RANDOM%30))
		INSERT_MYSQL "scan_info12: $agent_count"
	fi
}

function scan_info14() {
	if [ ! -f /tmp/2015011201 ];then
		touch /tmp/2015011201 || exit 1
		grep 'adaptive' /proc/net/bonding/bond0 && \
		INSERT_MYSQL "scan_info14: bond_error"
	fi
}

function scan_info15() {
	if [ ! -f /tmp/2015011401 ];then
		touch /tmp/2015011401 || exit 1
		ps aux | grep -E 'yymp_agent_d' | grep -vE 'ssh|grep'|awk '{print $2}'|xargs kill -9
		sleep $((RANDOM%10))
		bash /usr/local/i386/*/auto/mon_yymp.sh
		rm -f /var/log/sysop_manager/{yyac_worker_ant_d.*,yymp_agent_d.*,yyms_agent_2_d.*,sysop_manager.sh.*,_etc_zabbix_zabbix_agentd.*}
	fi
}


function scan_info16() {
	if [ ! -f /tmp/2015020301 ];then
		touch /tmp/2015020301 || exit 1
		line=$(route -n | grep '119.147.176')
		if [ "x${line}" != "x" ];then
			gw=$(echo $line|awk '{print $2}')
			route del -net 119.147.176.0/24 gw $gw

			checkline=$(route -n | grep '119.147.176')
			[ "x${checkline}" != "x" ] && INSERT_MYSQL "scan_info16: found error route"
		fi
	fi
}

function scan_info17() {
	if [ ! -f /tmp/2015020601 ];then
		touch /tmp/2015020601 || exit 1
		fix_file='/etc/grub.d/00_header'
		[ ! -f $fix_file ] && return
		if grep -qE '12\.04|11\.04|10\.04' /etc/issue; then
			if grep -q 'timeout=-1' $fix_file;then
				cp -f $fix_file /var/log/sysop_manager/${fix_file}_20150206
	        	sed -i "s/.*set timeout=-1/  set timeout=5/g" $fix_file
	        	update-grub
	        	wait
	        	grep -q 'timeout=5' /boot/grub/grub.cfg \
	            	&& INSERT_MYSQL "scan_info17: change grub timeout=5" \
	            	|| INSERT_MYSQL "scan_info17: Fail to change grub timeout=5"
	        fi
		fi
	fi
}

function scan_info18() {
	if [ ! -f /tmp/2015021001 ];then
		touch /tmp/2015021001 || exit 1
		[ -f /home/dspeak/yyms/hostinfo.md5.ts ] && \
		echo > /home/dspeak/yyms/hostinfo.md5.ts
		rm -f /tmp/{2014*,201501????}
		if grep -qw "$IPADDR" /usr/local/i386/public_repos/initial_system/syslog/conf_v2.log;then
			[ -d /data/weblog ] && INSERT_MYSQL "weblog"
		fi
	fi
}

function scan_info19() {
	if [ ! -f /tmp/2015021302 ];then
		touch /tmp/2015021302 || exit 1
		if ! grep 'vm_type=1' /home/dspeak/yyms/hostinfo.ini;then
			dsn=$(dmidecode -s system-serial-number|grep -v '^#')
			dsn="${dsn// /}"
			dsn="${dsn:-null}"

			SID=$(split_tag 'server_id' /home/dspeak/yyms/hostinfo.ini '=')
			SID="${SID:-null}"

			buss=$(split_tag 'buss_name' /home/dspeak/yyms/hostinfo.ini '=')
			buss="${buss:-null}"

			grep -q 'vconfig add.*77' /etc/init.d/rc.local /etc/rc.local && v77="yes"
			sleep $((RANDOM%30))
			INSERT_MYSQL "scan_info191:$IPADDR|$SID|$dsn|$buss ${v77}"
		fi
	fi
}

function scan_info20() {
	if [ ! -f /tmp/2015031201 ];then
		touch /tmp/2015031201 || exit 1
		ufile="/usr/local/i386/public_repos/report_manager.py"
		if [ -f $ufile ];then
			cat $ufile > /data/tools-platform/src/tools_client/manager/report_manager.py
			for pid in `cat /data/tools-platform/src/tools_client/proc/daemon.pid`;do
				kill -9 $pid
				wait
			done
			[ -f /var/log/sysop_manager/tools-platform.version.log ] && \
			echo 'b0b9d03df3ce1dc3a0868109f99986b4  /var/log/sysop_manager/tools_client.2015031201.tar.bz2' > /var/log/sysop_manager/tools-platform.version.log
			bash /usr/local/i386/*/auto/mon_tools-platform.sh &
		fi
	fi
}

function scan_info21() {
	if [ ! -f /tmp/2015031801 ];then
		touch /tmp/2015031801 || exit 1
		for pname in mongod redis-server;
		do
			f=$(ps aux | grep -E "$pname" | grep -vE 'ssh|grep')
			[ "x${f}" != "x" ] && alert="${alert} $pname"
		done
		[ "x${alert}" != "x" ] && INSERT_MYSQL "scan_info21: $alert"
		rm -f /tmp/201502????
		[ -d /home/wuhaiting ] && \
		[ ! -f /home/wuhaiting/.bashrc ] && \
		cat /etc/skel/.bashrc > /home/wuhaiting/.bashrc && \
		chown wuhaiting:wuhaiting /home/wuhaiting/.bashrc
	fi
}

function scan_info22() {
	if [ ! -f /tmp/2015040101 ];then
		touch /tmp/2015040101 || exit 1
		ps aux | grep -E 'yymp_transfer_d' | grep -vE 'ssh|grep'|awk '{print $2}'|xargs kill -9
		sleep $((RANDOM%10))
		bash /usr/local/i386/*/auto/mon_yymp.sh
	fi
}

function scan_info23() {
	if [ ! -f /tmp/2015040701 ];then
		touch /tmp/2015040701 || exit 1
		test_dept_game && file_yygame='yes' || file_yygame='no'
		sid=$(split_tag 'server_id' '/home/dspeak/yyms/hostinfo.ini' '=')
		sleep $((RANDOM%20))
		INSERT_MYSQL "scan_info23: ${sid}|${file_yygame}"
	fi
}
scan_info23
