#!/bin/bash
#Date:2011-05-15
#Written by manifold.
#Readme:report server's process and user info to platform.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# check linux version
cat /etc/issue|grep -E "CentOS|Red" && LINUX_VERSION="centos"
cat /etc/issue|grep -E "Ubuntu" && LINUX_VERSION="ubuntu"
if [ "$LINUX_VERSION" = "" ];then exit 1;fi

# basic define
BASENAME=`basename $0`
SHORT_NAME=report_info
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME

# get ip address 
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi 

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

REPOS_DB_ADDRESS_FILE=$LOG_DIR/repos_db_address.log
MYSQL_ADDRESS=`cat $REPOS_DB_ADDRESS_FILE`
DEPARTMENT="yy"

# for database table_name.
DATE=`date "+%Y_%m_%d"`

# define insert alert function
INSERT_MYSQL () {
	CONTENT=`echo "insert into crontab_script_monitor.collect_server_info_$DATE (script,ip,other_info,status,department) value ('$0','$IPADDR','$1','2','$DEPARTMENT');"|base64|base64|tr -d '\n'`
	wget --http-user=manifold --http-passwd=dw_manifold --output-document=$LOG_DIR/wget.schedule.log --timeout=8 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/insert_message.php?content=$CONTENT"
}

SEND_MESSAGE_DETECT () {
SELECT_ROLE="mysql"
address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep -v $MYSQL_ADDRESS|grep "$SELECT_ROLE"|awk '{print $1}'))
until [ "${#address_array[*]}" -eq 0 ];do
address_array=(${address_array[*]})
address_array_num=${#address_array[*]}
xuhao=$((RANDOM%address_array_num))
ADDRESS=${address_array[$xuhao]}
unset address_array[$xuhao]
MYSQL_ADDRESS="$ADDRESS"
echo "MESSAGE_ADDRESS:$MYSQL_ADDRESS"
INSERT_MYSQL
RESULT="$?"
if [ "$RESULT" -eq 0 ];then
	echo "$MYSQL_ADDRESS" > $REPOS_DB_ADDRESS_FILE
	# breakֱӸechoļ && ΪļϵͳǿռʱдȥĻжϣᷢNϢrepos update scriptһֹظ
	break
fi
done
}

# fetch user and process info
fetch_user_and_process_info () {

#PROCESS=`ps -e|awk '{$1="";$2="";$3="";print $0}'|grep -E "_d|_m|slave|mysql|nginx|relay_V|squid|apache|live_relay|memcached|killer|./ttserver|./access|mongod|jdk1.6|java|icegridnode|live_proxy|./live_session|./live_plugin|./Receiver"|grep -v yyms_agent_d|sort -u|column -t|tr '\n' ' '`
PROCESS=`ps aux|grep -E -v "COMMAND|grep|awk|sed|tail|cat|yyms_agent_d|sysop_manager"|awk '{N=11;while (N<=NF) {printf $N"\n";N++}}'|grep -E "_d|_m|slave|mysql|nginx|relay_V|squid|apache|live_relay|memcached|killer|./ttserver|./access|mongod|jdk1.6|java|icegridnode|live_proxy|./live_session|./live_plugin|./Receiver|/usr/sbin/named"|sort -u|column -t|tr '\n' ' '`
if [ "$PROCESS" = "" ];then
	PROCESS="No process."
fi

if [ "$LINUX_VERSION" = "ubuntu" ];then
    USER=`cat /etc/passwd|grep -v -E -w "/sbin/nologin|/bin/false|/usr/sbin/nologin"|awk -F ':' '{print $1}'|grep -E -w -v "root|daemon|bin|sys|sync|games|man|lp|mail|news|uucp|proxy|www-data|backup|list|irc|gnats|nobody|vsftp|libuuid|mysql|oracle|postgres"|tr '\n' ' '`
else
    USER=`cat /etc/passwd|grep -v -E -w "/sbin/nologin|/bin/false|/usr/sbin/nologin"|awk -F ':' '{print $1}'|grep -E -w -v "root|sync|shutdown|halt|news"|tr '\n' ' '`  
fi
if [ "$USER" = "" ];then
	USER="No auth user."
fi

ONLINE_USER=`who|awk '{print $1}'|sort -u|tr '\n' ' '`
if [ "$ONLINE_USER" = "" ];then
	ONLINE_USER="No online user."
fi

INSERT_MYSQL "Running process:$PROCESS Auth user:$USER Online user:$ONLINE_USER"
if [ "$?" -ne 0 ];then
	SEND_MESSAGE_DETECT
fi

}

fetch_user_and_process_info

# clean up yyms log
> $LOG_DIR/execute_run.sh.log
