#!/bin/bash
#Date:2011-10-19
#Written by manifold.
#Readme:deploy process - client.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# basic define
BASENAME=`basename $0`
SHORT_NAME=deploy_client
LOG_DIR=/var/log/sysop_manager

# prepare directory
if [ ! -d $LOG_DIR/proc_deploy ];then
	mkdir -p $LOG_DIR/proc_deploy
fi

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME

# Ƿ
if [ ! -d $LOG_DIR/sysop-oa ] ; then
	ln -s $LOG_DIR/sysop-oa $COMM_DIR/initial_system/snmp/ext/sysop-oa
fi

# get ip address 
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi 

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

# define insert alert function
INSERT_MYSQL () {
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

# ̽
UNLOCK_PROCESS () {
	/bin/bash $COMM_DIR/auto/unlock_process.sh "$1" "$2"
}

# ܳ300룬ɱ
UNLOCK_PROCESS "/bin/bash $COMM_DIR/auto/deploy_client_new.sh" "300"

# ѾнУֱ˳
PS_LINE=`ps aux|grep -E -v "grep|mysql|tail|cat|vi|ssh -p32200 -f"|grep "/bin/bash $COMM_DIR/auto/deploy_client_new.sh"|wc -l`
if [ "$PS_LINE" -gt 1 ];then
	exit 1
fi

# wget function
wget_action () {
	wget --http-user=manifold --http-passwd=dw_manifold --output-document=$1 --timeout=$2 --tries=$3 "http://$4:63217/$5"
}

# wget_detect function
wget_action_retry () {
	SELECT_ROLE="mysql"
	address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep -v $MYSQL_ADDRESS|grep "$SELECT_ROLE"|awk '{print $1}'))
	until [ "${#address_array[*]}" -eq 0 ];do
		address_array=(${address_array[*]})
		address_array_num=${#address_array[*]}
		xuhao=$((RANDOM%address_array_num))
		ADDRESS=${address_array[$xuhao]}
		unset address_array[$xuhao]
		MYSQL_ADDRESS="$ADDRESS"
		echo "MYSQL_ADDRESS:$MYSQL_ADDRESS"
		wget_action "$1" "$2" "$3" "$MYSQL_ADDRESS" "$5"
		RESULT="$?"
		if [ "$RESULT" -eq 0 ];then
			echo "$MYSQL_ADDRESS" > $REPOS_DB_ADDRESS_FILE
			break
		fi
	done
}

REPOS_DB_ADDRESS_FILE=$LOG_DIR/repos_db_address.log
MYSQL_ADDRESS=`cat $REPOS_DB_ADDRESS_FILE`

# stop signal
wget_action $LOG_DIR/proc_deploy/deploy_control.html 8 1 $MYSQL_ADDRESS deploy/deploy_control.html
if [ "$?" -ne 0 ];then
	wget_action_retry $LOG_DIR/proc_deploy/deploy_control.html 8 1 $MYSQL_ADDRESS deploy/deploy_control.html
fi
RUN_FLAG=`cat $LOG_DIR/proc_deploy/deploy_control.html`
if [ "$RUN_FLAG" != "yes" ];then
	exit 1
fi

# get uuid
UUID=`cat /home/dspeak/yyms/uuid`
if [ "$UUID" = "" ];then
	INSERT_MYSQL "uuid null,please check."
	exit 1
fi

# ʼļʱȡID
if [ ! -f $LOG_DIR/proc_deploy/task_id_location ] ; then
	wget_action $LOG_DIR/proc_deploy/task_id_location 8 1 $MYSQL_ADDRESS deploy/query_max_task_id.php
fi
# task_id_locationtask_idλ
task_id_location=`cat $LOG_DIR/proc_deploy/task_id_location`
if [ "$task_id_location" = "" ];then
	INSERT_MYSQL "task_id_location null,please check."
	exit 1
else
	wget_action $LOG_DIR/proc_deploy/query_task_id.php 8 1 $MYSQL_ADDRESS deploy/query_task_id.php?id="$task_id_location"
	if [ -s $LOG_DIR/proc_deploy/query_task_id.php ];then
		cat $LOG_DIR/proc_deploy/query_task_id.php|sort -n >> $LOG_DIR/proc_deploy/task_id
		# tash_id_locationλļ
		cat $LOG_DIR/proc_deploy/task_id|sort -n|tail -n 1 > $LOG_DIR/proc_deploy/task_id_location
	fi
fi

for DO_TASK_ID in `cat $LOG_DIR/proc_deploy/task_id`
do
	if [ ! -f $LOG_DIR/proc_deploy/deploy_info_"$DO_TASK_ID".html ];then
		wget_action $LOG_DIR/proc_deploy/deploy_info_"$DO_TASK_ID".html 8 1 $MYSQL_ADDRESS deploy/deploy_info_"$DO_TASK_ID".html
		if [ "$?" -ne 0 ];then
			wget_action_retry $LOG_DIR/proc_deploy/deploy_info_"$DO_TASK_ID".html 8 1 $MYSQL_ADDRESS deploy/deploy_info_"$DO_TASK_ID".html
		fi
		# ȡļʧܣֱӽһtask_id
		if [ ! -s $LOG_DIR/proc_deploy/deploy_info_"$DO_TASK_ID".html ];then
			INSERT_MYSQL "wget DO_TASK_ID file error."
			continue
		fi
	fi
	
	# ȡļûд˷uuid˷Ҫִдɾtask_idͬʱһtask_id
	# ǱߺϲjasonuuidispϢϲˣuuid,dianxin/wangtongҪ","
	cat $LOG_DIR/proc_deploy/deploy_info_"$DO_TASK_ID".html|grep -v ^# |grep -E "^$UUID,|default,"
	if [ "$?" -ne 0 ];then
		sed -i '/'"${DO_TASK_ID}"'/d' $LOG_DIR/proc_deploy/task_id
		continue
	fi

	# ӻȡtask_idļѰұӦ
	ENTRY_LINE=`cat $LOG_DIR/proc_deploy/deploy_info_"$DO_TASK_ID".html|grep -v ^# |grep -E "^$UUID,|default,"|uniq|wc -l`
	if [ "$ENTRY_LINE" -gt 0 ];then
		ENTRY_INFO=`cat $LOG_DIR/proc_deploy/deploy_info_"$DO_TASK_ID".html|grep -v ^# |grep -E "^$UUID,|default,"|uniq`
		read deploy_uuid deploy_id deploy_entry_id deploy_name deploy_time1 deploy_time2 deploy_version deploy_md5 <<EOF
		$ENTRY_INFO
EOF
	else
		echo "entry null,exit."
		exit 1
	fi
	
	# ָdeploy_uuidispȡ
	deploy_isp=`echo "$deploy_uuid"|awk -F ',' '{print $2}'`
	
	# ̲ʱ
	deploy_time="$deploy_time1 $deploy_time2"
	
	# ȡϵͳλ
	SYSTEM_BIT=`getconf LONG_BIT`
	
	# ذmd5壬ͬʱҪص
	# *****  32:*****,64:*****
	DEFAULT_MD5=`echo "$deploy_md5"|grep "32:.*64:"|wc -l`
	if [ "$DEFAULT_MD5" -eq 0 ];then
		deploy_md5=$deploy_md5
		deploy_package="${deploy_name}"-"${deploy_version}".tar.bz2
	else
		if [ "$SYSTEM_BIT" = "32" ];then
			deploy_md5=`echo $deploy_md5|awk -F ',' '{print $1}'|awk -F ':' '{print $2}'`
		elif [ "$SYSTEM_BIT" = "64" ];then
			deploy_md5=`echo $deploy_md5|awk -F ',' '{print $2}'|awk -F ':' '{print $2}'`
		fi
		deploy_package="$deploy_name"-"$deploy_version"-x"$SYSTEM_BIT".tar.bz2
	fi
	
	deploy_time_unix=`date --date="$deploy_time" +%s`
	current_time_unix=`date +%s`
	deploy_interval=$(($deploy_time_unix-$current_time_unix))
	if [ "$deploy_interval" -ge 0 ];then
		# ʱ60룬˳ȴһѭ
		if [ "$deploy_interval" -gt 60 ];then
			continue
		else
			sleep $deploy_interval
			deploy=yes
		fi
	else
		last_time=`cat $LOG_DIR/proc_deploy/deploy_info_"$DO_TASK_ID".html|grep -v ^#|awk '{print $5}'|sort|tail -n 1`
		last_time_unix=`date --date="$last_time" +%s`
		last_deploy_interval=$(($current_time_unix-$last_time_unix))
		if [ "$last_deploy_interval" -gt 0 ];then
			deploy=yes
			sleep $((RANDOM%60))
		fi
	fi

	# ذļ
	if [ "$deploy" = "yes" ];then

		isp_address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep "$deploy_isp"|awk '{print $1}'))
		EXECUTE_TIME=0
		until [ "${#isp_address_array[*]}" -eq 0 ];do
			isp_address_array=(${isp_address_array[*]})
			isp_address_array_num=${#isp_address_array[*]}
			isp_xuhao=$((RANDOM%isp_address_array_num))
			ISP_ADDRESS=${isp_address_array[$ispxuhao]}
			ISP_ADDRESS="$ISP_ADDRESS"
			echo "ISP_ADDRESS:$ISP_ADDRESS"
			wget_action $LOG_DIR/proc_deploy/$deploy_package 8 1 $ISP_ADDRESS deploy/packages/$deploy_name/$deploy_package
			RESULT="$?"
			if [ "$RESULT" -eq 0 ];then
				echo "$ISP_ADDRESS" > $REPOS_DB_ADDRESS_FILE
				break
			else
				if [ "$EXECUTE_TIME" -ge 3 ];then
					break
				else
					EXECUTE_TIME=$(($EXECUTE_TIME+1))
				fi
			fi
		done

		if [ ! -f $LOG_DIR/proc_deploy/$deploy_package ];then
			INSERT_MYSQL "deploy_entry_id $deploy_entry_id:download package $deploy_package failed."
			continue
		fi
		
		# generate file deploy_entry_id.txt
		echo $deploy_entry_id > $LOG_DIR/proc_deploy/deploy_entry_id.txt
		REAL_MD5=`md5sum $LOG_DIR/proc_deploy/$deploy_package|awk '{print $1}'`
		if [ "$REAL_MD5" != "$deploy_md5" ];then
			INSERT_MYSQL "deploy_entry_id $deploy_entry_id:wget $deploy_package file successful,but md5 error."
			continue
		fi
		
		# ִغ
		cd $LOG_DIR/proc_deploy
		# ֮ǰɴĿ¼ֱɾĿ¼ֳͻ
		if [ -d $LOG_DIR/proc_deploy/"$deploy_name"_"$deploy_version"_"$deploy_entry_id" ];then
			rm -fr $LOG_DIR/proc_deploy/"$deploy_name"_"$deploy_version"_"$deploy_entry_id"
		fi
		mkdir -p $LOG_DIR/proc_deploy/"$deploy_name"_"$deploy_version"_"$deploy_entry_id"
		tar -jxvf $deploy_package -C $LOG_DIR/proc_deploy/"$deploy_name"_"$deploy_version"_"$deploy_entry_id"
		cd $LOG_DIR/proc_deploy/"$deploy_name"_"$deploy_version"_"$deploy_entry_id"/$deploy_name
		for RUN_SCRIPT in `cat run.txt`
		do
			cat sh/$RUN_SCRIPT|grep -E "shutdown|reboot|halt|init"
			if [ "$?" -eq 0 ];then
				"deploy_entry_id $deploy_entry_id:illegal command." >> $LOG_DIR/proc_deploy/"$deploy_name"_"$deploy_version"_"$deploy_entry_id"/$deploy_name/run.log
				INSERT_MYSQL "deploy_entry_id $deploy_entry_id:illegal command."
				python /var/log/sysop_manager/sysop-oa/sendLog.py $deploy_name $deploy_version
				exit 6
			else
				/bin/bash sh/$RUN_SCRIPT
				if [ "$?" -ne 0 ];then
					echo "$RUN_SCRIPT run error." >> $LOG_DIR/proc_deploy/${deploy_name}_${deploy_version}_${deploy_entry_id}/${deploy_name}/run.log
					INSERT_MYSQL "$RUN_SCRIPT run error."
					python /var/log/sysop_manager/sysop-oa/sendLog.py $deploy_name $deploy_version
					exit 7
				fi
			fi
		done
		
		sed -i '/'"${DO_TASK_ID}"'/d' $LOG_DIR/proc_deploy/task_id
			
		# invoke sendLog.py
		python /var/log/sysop_manager/sysop-oa/sendLog.py $deploy_name $deploy_version
	fi
	
done
