#!/bin/bash
#Date:2011-05-15
#Written by manifold.
#Readme:monitor crontab entry in /etc/crontab

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# basic define
BASENAME=`basename $0`
SHORT_NAME=crontab
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME

# get ip address
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

BACKUP_DATE=`date +%Y-%m-%d-%H-%M-%S`

# define insert alert function
INSERT_MYSQL () {
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

# check crontab entry
PRINT_CRONTAB_ENTRY () {
(
cat <<'EOF'
rsync_jifen.sh */30 * * * *   root /bin/bash /home/dspeak/rsync_jifen.sh
check_rsync_jifen.sh */30 * * * *   root /bin/bash /home/dspeak/check_rsync_jifen.sh
pkg-stat 0 6 * * * root /data/pkg/public-scripts/bin/pkg-stat.sh &>/dev/null
proc-report */1 * * * * root /data/pkg/public-scripts/bin/proc-report.sh &>/dev/null
network_sent */2 * * * * root /bin/bash /usr/local/i386/public_repos/initial_system/snmp/ext/network_sent.sh >/dev/null 2>&1
installed-pkg.sh 10 6 * * * root /bin/bash /data/pkg/public-scripts/bin/installed-pkg.sh &>/dev/null
check_proc_not_running.sh */5 * * * * root /bin/bash /data/pkg/public-scripts/bin/check_proc_not_running.sh &>/dev/null
report_no_pkg_proc_resouce.sh */2 * * * * root /bin/bash /data/pkg/public-scripts/bin/report_no_pkg_proc_resouce.sh &>/dev/null
EOF
)
}

# ע͵Уȥļ⣬Ƚɫָٷſ
# logrotate 10 *     * * *   root    /etc/cron.daily/logrotate

PRINT_CRONTAB_ENTRY | while read ENTRY ENTRY_CONTENT
do
	ENTRY_LINE=$(grep -v "^#" /etc/crontab|grep -cw "$ENTRY")
	# ӦĿֱһ
	if [ "$ENTRY_LINE" -eq 0 ];then
		echo "$ENTRY_CONTENT" >> /etc/crontab
		INSERT_MYSQL "Add /etc/crontab entry: $ENTRY_CONTENT."
	elif [ "$ENTRY_LINE" -eq 1 ];then
		# awk '{N=2;while (N<NF) { printf $N;N=N+1};if (N==NF) print}'
		GREP_ENTRY=`echo "$ENTRY_CONTENT"|awk '{N=1;while (N<=NF) {printf $N".*";N++}}'`
		cat /etc/crontab|grep -w "$GREP_ENTRY"
		if [ "$?" -ne 0 ];then
			# ӦĿһµĿƥ
			INSERT_MYSQL "Have one entry,but not match,please check /etc/crontab about $ENTRY."
			ENTRY=`echo $ENTRY | tr -s "/" "."`
			sed -i "/$ENTRY/d" /etc/crontab
			echo "$ENTRY_CONTENT" >> /etc/crontab
		fi
	elif [ "$ENTRY_LINE" -gt 1 ];then
		INSERT_MYSQL "More than two entrys,please check /etc/crontab about $ENTRY."
		ENTRY=`echo $ENTRY | tr -s "/" "."`
		sed -i "/$ENTRY/d" /etc/crontab
		echo "$ENTRY_CONTENT" >> /etc/crontab
	fi
done


