#!/bin/bash
#Date:2011-05-15
#Written by manifold.
#Readme:monitor some file about snmp.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# if not a ubuntu or centos system,exit.
cat /etc/issue|grep -E "CentOS|Red" && LINUX_VERSION="centos"
cat /etc/issue|grep -E "Ubuntu" && LINUX_VERSION="ubuntu"
if [ "$LINUX_VERSION" = "" ];then exit 1;fi

# basic define
BASENAME=$(basename $0)
SHORT_NAME=snmp
LOG_DIR=/var/log/sysop_manager
# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
PUBLIC_DIR=/usr/local/i386/public_repos

# check host heartbeat
/bin/bash -c "cd /home/dspeak/yyms/yyms_agent_2_d/cron && python op_ccc.py >/dev/null 2>&1" &
echo "`date +%Y-%m-%d-%T` $0 yyms run op.ccc" >> $LOG_DIR/sysop_manager.log && disk_wirte=yes

# define insert alert function
INSERT_MYSQL () {
	/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

if [ -s $LOG_DIR/sysop_manager.log ]; then
	cron_runtime=$(stat -c %Y $LOG_DIR/cron_run_time)
	[ -z "$cron_runtime" ] && cron_runtime=0
	cur_date_time=$(expr "$(date +%s)" - "$cron_runtime")
	if [ "$cur_date_time" -ge 600 ] && [ -f /home/dspeak/yyms/yymp/script/host/disk_basic.sh ]; then
		running_time=$(awk -F '.' '{print $1}' /proc/uptime)
		if [ "$running_time" -ge 600 ] && [ "$disk_wirte" = "yes" ]; then
			if grep -q 'disk_basic.sh' /etc/crontab; then
				INSERT_MYSQL "crontab: /etc/crontab not running, $cur_date_time,$cron_runtime"
				python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py 11067 75395 0 "stop running ${cur_date_time}s"
			fi
		fi
	fi
fi

# check syslog-ng memory leak
if [ -f /usr/local/sbin/syslog-ng ];then
	SYSLOG_BIN=/usr/local/sbin/syslog-ng
elif [ -f /sbin/syslog-ng ];then
	SYSLOG_BIN=/sbin/syslog-ng
else
	SYSLOG_BIN=/usr/sbin/syslog-ng
fi
for LOG_PID in `pidof syslog-ng`;do
	SYSLOG_MEM=$(awk '{if($0 ~ /VmRSS/){print $2}}' /proc/$LOG_PID/status)
	if [ $SYSLOG_MEM -ge 150000 ];then
		pkill syslog-ng
		rm -f /var/run/syslog-ng.pid > /dev/null 2>&1
		sleep 2
		$SYSLOG_BIN -p /var/run/syslog-ng.pid
		INSERT_MYSQL "Detected syslog-ng memory leak ${SYSLOG_MEM}KB"
		break;
	fi
done

# /etc/resolv.conf monitor
/bin/bash $COMM_DIR/auto/mk_resolv.sh

# prepare /etc/snmp/ext for snmp invoked
if [ -d $PUBLIC_DIR/initial_system/snmp/ext ];then
	LINK_DIR=$(readlink /etc/snmp/ext)
	if [ "x${LINK_DIR}" != "x" ];then
		if [ "$LINK_DIR" != "$PUBLIC_DIR/initial_system/snmp/ext" ];then
			unlink /etc/snmp/ext
			ln -s $PUBLIC_DIR/initial_system/snmp/ext /etc/snmp/ext
		fi
	else
		ln -s $PUBLIC_DIR/initial_system/snmp/ext /etc/snmp/ext
	fi
fi
