#!/bin/bash
#Date:2011-05-15
#Written by manifold.
#Readme:iptables monitor.including:ensure only have one iptables process;ensure the iptables's version.
#Change:2011-10-14
#Reamde:콫iptables.sh.testݸƵiptables.shȥˣִ°ǽԺȫ°ǽ

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
exit 0
# if not a ubuntu system,exit.
cat /etc/issue|grep -E "Ubuntu" || exit 1

EXCLUDE_IP_LIST () {
(
cat <<'EOF'
test
EOF
)
}

# basic define
BASENAME=`basename $0`
SHORT_NAME=iptables
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
PUBLIC_DIR=/usr/local/i386/public_repos

# get ip address 
IPADDR_ALL=`/sbin/ifconfig|grep "inet addr"|awk '{print $2}'|awk -F ":" '{print $2}'|grep -v -E "^127\.|^192\.|^10\.|^172\."|tr -s "\n" " "`
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi  

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

BACKUP_DATE=`date +%Y-%m-%d-%H-%M-%S`

# define insert alert function
INSERT_MYSQL () {
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

# base iptables check
if [ ! -d /home/dspeak/iptables/ ];then
	mkdir -p /home/dspeak/iptables/
fi

if [ ! -x /home/dspeak/iptables/iptables.sh ];then
	chmod 755 /home/dspeak/iptables/iptables.sh
fi

# exclude policy
for ip in $IPADDR_ALL;
do
	grep -qw $ip $PUBLIC_DIR/initial_system/cmdb/exclude_iptables_icmp.log && EXCLUDE_IP=yes
done

EXCLUDE_APPLICATION_LINE=`ps aux|grep -E "nginx|mysql.*pid.*sock|squid|lbsd_d"|grep -v -E "vi|tail|cat|grep"|wc -l`
if [[ "$EXCLUDE_APPLICATION_LINE" -gt 0 ]] || [[ "$EXCLUDE_IP" == "yes" ]];then
	if [ `ps aux|grep /iptables.sh|grep -E -v "vi|tail|cat|grep|mysql"|wc -l` -gt 0 ];then
		pkill iptables.sh
        iptables -t raw -F
		INSERT_MYSQL "must not run iptables,kill it."
	fi
	exit 1
fi

# check iptables version
EXCLUDE_IP_LINE=`EXCLUDE_IP_LIST|grep -w $IPADDR|wc -l`
if [ "$EXCLUDE_IP_LINE" -gt 0 ];then
	REAL_iptables_md5=`md5sum $COMM_DIR/initial_system/iptables/iptables.sh.test|awk '{print $1}'`
else
	REAL_iptables_md5=`md5sum $COMM_DIR/initial_system/iptables/iptables.sh|awk '{print $1}'`
fi

NOW_iptables_md5=`md5sum /home/dspeak/iptables/iptables.sh|awk '{print $1}'`

if [ "$REAL_iptables_md5" != "$NOW_iptables_md5" ];then
		BACKUP_FILE="`echo /home/dspeak/iptables/iptables.sh|sed 's#/#_#g'`.$BACKUP_DATE"
		/bin/cp /home/dspeak/iptables/iptables.sh $LOG_DIR/$BACKUP_FILE
		if [ "$EXCLUDE_IP_LINE" -gt 0 ];then
			cat $COMM_DIR/initial_system/iptables/iptables.sh.test > /home/dspeak/iptables/iptables.sh
		else
			cat $COMM_DIR/initial_system/iptables/iptables.sh > /home/dspeak/iptables/iptables.sh
		fi
		chmod 755 /home/dspeak/iptables/iptables.sh
        ps aux|grep /iptables.sh|grep -E -v "grep|mysql"|awk '{print $2}'|xargs kill -9
		CHANGE=yes
fi

# check iptables running or not
SESSION_PROCESS=`ps aux|grep -E "(sessiond_d|slave_session|sesscached_d|canoded_d)"|grep -E -v "ssh|grep|mysql"|wc -l`
IPTABLES_LINE=`ps aux|grep /iptables.sh|grep -E -v "grep|mysql"|wc -l`
if [ "$IPTABLES_LINE" -eq 0 ] && [ "$SESSION_PROCESS" -ge 1 ];then
	sleep 10
	if [ `ps aux|grep /iptables.sh|grep -E -v "grep|mysql"|wc -l` -eq 0 ] && [ "$SESSION_PROCESS" -ge 1 ];then
		cd /home/dspeak/iptables
		bash -c "./iptables.sh > log &"
		if [ "$CHANGE" = "yes" ];then
			INSERT_MYSQL "iptables rule changed,restart it."
		else
			INSERT_MYSQL "no iptables process, now start iptables."
		fi
		echo "start iptables finished"
	fi

	# if more than two iptables process,keep one,kill other
	if [ `ps aux|grep /iptables.sh|grep -E -v "grep|mysql"|awk '{if($10!="0:00") print}'|wc -l` -gt 1 ];then
		ps aux|grep /iptables.sh|grep -E -v "grep|mysql"|head -n -1|awk '{print $2}'|xargs kill -9
		iptables -t raw -F
		INSERT_MYSQL "more than two iptables process,keep one,kill other."
		echo "kill iptables finished."
	fi
elif [ "$IPTABLES_LINE" -ge 1 ] && [ "$SESSION_PROCESS" -eq 0 ];then
	pkill iptables.sh
    iptables -t raw -F
	INSERT_MYSQL "must not run iptables,kill it."
fi

