#!/bin/bash
#Date:2012-05-04
#Written by manifold.
#Readme:insert message function.
#Change:2012-08-27
#Readme:fix bug for read-only filesystem.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# Define useful function.
function OUTPUT_GREEN ()
{
if [ -n "$2" ];then
        echo -e -n "\033[32;40;1m$1\033[0m"
else
        echo -e "\033[32;40;1m$1\033[0m"
fi
}

# basic define
BASENAME=`basename $0`
LOG_DIR=/var/log/sysop_manager

if [ ! -d $LOG_DIR ];then
	mkdir -p $LOG_DIR
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
REPOS_DB_ADDRESS_FILE=$LOG_DIR/repos_db_address.log

IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

if [ ! -f $REPOS_DB_ADDRESS_FILE ] || [ ! -s $REPOS_DB_ADDRESS_FILE ];then
	# svn info $COMM_DIR|awk -F ':' '{if($1~/URL/) print $3}'|tr -d '\/' > $REPOS_DB_ADDRESS_FILE
	API_ROLE="mysql"
	api_address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep "$API_ROLE"|awk '{print $1}'))
	api_address_array_num=${#api_address_array[*]}
	api_num_index=$((RANDOM%api_address_array_num))
	API_ADDRESS=${api_address_array[$api_num_index]}
	echo "$API_ADDRESS" > $REPOS_DB_ADDRESS_FILE
fi

MYSQL_ADDRESS=`cat $REPOS_DB_ADDRESS_FILE`
DEPARTMENT="yy"

# mysql data insert
WGET_LOG_FILE=$LOG_DIR/package_info_wget.log

# readonly detect
TEMP_FILE=`mktemp -p $LOG_DIR`
FILE_DETECT_RESULT="$?"
if [ "$FILE_DETECT_RESULT" -ne 0 ];then
	function INSERT_MYSQL () {
		if [ "$HOST_IP" != "" ];then
			wget --http-user=manifold --http-passwd=dw_manifold --timeout=12 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/package_info.php?ip=$HOST_IP&business=$BUSINESS&process=$PROCESS&status=$STATUS&ip_whitelist=$IP_WHITELIST&proc_whitelist=$PROC_WHITELIST"
		else
			wget --http-user=manifold --http-passwd=dw_manifold --timeout=12 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/package_info.php?business=$BUSINESS&process=$PROCESS&status=$STATUS&ip_whitelist=$IP_WHITELIST&proc_whitelist=$PROC_WHITELIST"
		fi
	}
else
	function INSERT_MYSQL () {
		if [ "$HOST_IP" != "" ];then
			wget --http-user=manifold --http-passwd=dw_manifold --output-document=$WGET_LOG_FILE --timeout=12 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/package_info.php?ip=$HOST_IP&business=$BUSINESS&process=$PROCESS&status=$STATUS&ip_whitelist=$IP_WHITELIST&proc_whitelist=$PROC_WHITELIST"
		else
			wget --http-user=manifold --http-passwd=dw_manifold --output-document=$WGET_LOG_FILE --timeout=12 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/package_info.php?business=$BUSINESS&process=$PROCESS&status=$STATUS&ip_whitelist=$IP_WHITELIST&proc_whitelist=$PROC_WHITELIST"
		fi
	}
	rm -f $TEMP_FILE
fi

SEND_MESSAGE_DETECT () {
	SELECT_ROLE="mysql"
	address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep -v $MYSQL_ADDRESS|grep "$SELECT_ROLE"|awk '{print $1}'))
	until [ "${#address_array[*]}" -eq 0 ];do
		address_array=(${address_array[*]})
		address_array_num=${#address_array[*]}
		xuhao=$((RANDOM%address_array_num))
		ADDRESS=${address_array[$xuhao]}
		unset address_array[$xuhao]
		MYSQL_ADDRESS="$ADDRESS"
		echo "MESSAGE_ADDRESS:$MYSQL_ADDRESS"
		INSERT_MYSQL
		if [ "$FILE_DETECT_RESULT" -ne 0 ];then
			RESULT=0
		else
			RESULT=`cat $WGET_LOG_FILE`
		fi
		if [ "$RESULT" = "0" ];then
			echo "$MYSQL_ADDRESS" > $REPOS_DB_ADDRESS_FILE
			break
		fi
	done
}

if [ "$#" -lt 3 ];then
	echo 
	OUTPUT_GREEN "Usage:$0 -h ip_address -b business -p process -s status"
	echo
	exit 1
else
	while test -n "$1";do
		case "$1" in
		-h)
			HOST_IP="$2"
			shift
			;;
		-b)
			BUSINESS="$2"
			shift
			;;
		-p)
			PROCESS="$2"
			shift
			;;
		-s)
			STATUS="$2"
			shift
			;;
		-I)
			IP_WHITELIST="$2"
			shift
			;;
		-P)
			PROC_WHITELIST="$2"
			shift
			;;
	   esac
	   shift
	done
fi

echo "`date +%Y-%m-%d-%T` $BASENAME HOST_IP:$HOST_IP,BUSINESS:$BUSINESS,PROCESS:$PROCESS,STATUS=$STATUS" >> $LOG_DIR/sysop_manager.log 2>&1
INSERT_MYSQL
if [ "$FILE_DETECT_RESULT" -ne 0 ];then
	RESULT=0
else
	RESULT=`cat $WGET_LOG_FILE`
fi
if [ "$RESULT" != "0" ];then
	RETRY=3
	until [ $RETRY -eq 0 ];do
		SEND_MESSAGE_DETECT
		if [ "$RESULT" != "0" ];then
			RETRY=$(($RETRY-1))
			if [ $RETRY -eq 0 ];then
				python $COMM_DIR/monitor/send_messages.py to_beiyong5 "PYC: $IPADDR $BASENAME $DEPARTMENT HOST_IP:$HOST_IP,BUSINESS:$BUSINESS,PROCESS:$PROCESS,STATUS=$STATUS"
			fi
		else
			break
		fi
	done
fi
