#!/bin/bash
#Date:2011-06-20
#Written by manifold.
#Readme:monitor iptables.
#Change:2011-12-16
#turn on iptables.deny function.
#Change:2012-09-08
#Readme:еԱʹãΪ˰ȫ,iptablesģ.ͬʱԸݲͬҵص㣬ʹģ壬Ժ

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
export LANG=C
export LC_ALL=C

# check linux version
cat /etc/issue|grep -i -E "CentOS|Red" && LINUX_VERSION="centos"
cat /etc/issue|grep -i -E "Ubuntu|debian" && LINUX_VERSION="ubuntu"
if [ "$LINUX_VERSION" = "" ];then exit 1;fi

# basic define
BASENAME=`basename $0`
SHORT_NAME=mon_secure
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME

# get ip address
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

BACKUP_DATE=`date +%Y-%m-%d-%H-%M-%S`

# define insert alert function
INSERT_MYSQL () {
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

# define detect file function
Detect_file () {
	if [ ! -f $S_FILE ];then
		INSERT_MYSQL "no file $S_FILE."
	elif [ ! -f $D_FILE ];then
		/bin/cp $S_FILE $D_FILE
		if [ "$?" -eq 0 ];then
			INSERT_MYSQL "add file $D_FILE successful."
			CHANGE=yes
		else
			INSERT_MYSQL "add file $D_FILE failed."
		fi
	else
		S_MD5=`md5sum $S_FILE|awk '{print $1}'`
		D_MD5=`md5sum $D_FILE|awk '{print $1}'`
		if [ "$S_MD5" != "$D_MD5" ];then
			BACKUP_FILE="`echo $D_FILE|sed 's#/#_#g'`.$BACKUP_DATE"
			/bin/cp $D_FILE $LOG_DIR/$BACKUP_FILE
			cat $S_FILE > $D_FILE
			if [ "$?" -eq 0 ];then
				CHANGE=yes
				INSERT_MYSQL "$D_FILE changed success"
			else
				INSERT_MYSQL "$D_FILE changed failed"
			fi
		fi
	fi
}

# inculde some ip address
INCLUDE_ROOM_LIST () {
(
cat <<'EOF'
test
EOF
)
}

room_id=$(awk -F '=' '{if($1 == "idc_id"){print $2}}' /home/dspeak/yyms/hostinfo.ini)

# check iptables command exist or not.
which iptables
if [ "$?" -ne 0 ];then
	INSERT_MYSQL "no iptables command,please check."
	exit 1
fi

IPTABLES_DIRECTORY=/usr/local/virus/iptables

# check iptables directory exist or not.
if [ ! -d $IPTABLES_DIRECTORY ];then
	mkdir -p $IPTABLES_DIRECTORY
fi

# check some file's revision
INCLUDE_ROOM_LIST |grep -w "$room_id"
if [ "$?" -eq 0 ];then
	# check if the $IPADDR in iptables_version.log
	MODEL_FILE=`cat $COMM_DIR/iptables/iptables_version.log|grep -v ^#|awk '{if($1=="'"${IPADDR}"'") print $2}'|uniq|head -n 1`
	if [ "$MODEL_FILE" != "" ] && [ -f $COMM_DIR/iptables/$MODEL_FILE ];then
		S_FILE=$COMM_DIR/iptables/$MODEL_FILE
		D_FILE=$IPTABLES_DIRECTORY/iptables.model
		Detect_file
	fi

	# check iptables.sh file's revision
	S_FILE=$COMM_DIR/iptables/iptables.secure_new.sh
	D_FILE=$IPTABLES_DIRECTORY/iptables.sh
	[ -s $S_FILE ] && Detect_file

	# check iptables.allow file's revision
	S_FILE=$COMM_DIR/iptables/iptables.allow.new
	D_FILE=$IPTABLES_DIRECTORY/iptables.allow
	Detect_file

	# check iptables.deny file's revision
	#S_FILE=$COMM_DIR/iptables/iptables.secure.deny.new
	#D_FILE=$IPTABLES_DIRECTORY/iptables.deny
	#Detect_file
else
	# check if the $IPADDR in iptables_version.log
	MODEL_FILE=`cat $COMM_DIR/iptables/iptables_version.log|grep -v ^#|awk '{if($1=="'"${IPADDR}"'") print $2}'|uniq|head -n 1`
	if [ "$MODEL_FILE" != "" ] && [ -f $COMM_DIR/iptables/$MODEL_FILE ];then
		S_FILE=$COMM_DIR/iptables/$MODEL_FILE
		D_FILE=$IPTABLES_DIRECTORY/iptables.model
		Detect_file
	fi

	# check iptables.sh file's revision
	S_FILE=$COMM_DIR/iptables/iptables.secure.sh
	D_FILE=$IPTABLES_DIRECTORY/iptables.sh
	Detect_file

	# check iptables.allow file's revision
	S_FILE=$COMM_DIR/iptables/iptables.secure.allow
	D_FILE=$IPTABLES_DIRECTORY/iptables.allow
	Detect_file

	# check iptables.deny file's revision
	S_FILE=$COMM_DIR/iptables/iptables.secure.deny
	D_FILE=$IPTABLES_DIRECTORY/iptables.deny
	Detect_file
fi

# refresh iptables rule
if [ "$CHANGE" = "yes" ];then
	# backup iptables old rule.
	iptables -L -n -v >> $LOG_DIR/sysop_manager.log
	/bin/bash $IPTABLES_DIRECTORY/iptables.sh
	if [ "$?" -eq 0 ];then
		INSERT_MYSQL "iptables rule changed,and refresh iptables rule successful."
	else
		INSERT_MYSQL "iptables rule changed,but refresh iptables rule failed."
	fi
fi

# if server is openstack's compute node, turn off policy
if grep -qw 'CloudComputing\[ComputeNode\]' /home/dspeak/yyms/hostinfo.ini ; then
	echo "OpenStack ComputeNode turn off iptables policy !!"
	exit 0
fi

# if system reboot,maybe have no iptables rule,check it.
POLICY_LINE=`iptables -L -n|grep -v -E "Chain INPUT|Chain FORWARD|Chain OUTPUT"|grep -E "ACCEPT|DROP"|wc -l`
if [ "$POLICY_LINE" -eq 0 ];then
    /bin/bash $IPTABLES_DIRECTORY/iptables.sh
    POLICY_LINE=`iptables -L -n|grep -v -E "Chain INPUT|Chain FORWARD|Chain OUTPUT"|grep -E "ACCEPT|DROP"|wc -l`
    [[ "$POLICY_LINE" -eq 0 ]] && INSERT_MYSQL "no iptables secure policy,please check."
else
	# check ssh protect policy
	SSH_POLICY_LINE=`iptables -L -n|grep -E "ACCEPT.*multiport dports 32200|DROP.*multiport dports 32200"|wc -l`
	if [ "$SSH_POLICY_LINE" -lt 2 ];then
        /bin/bash $IPTABLES_DIRECTORY/iptables.sh
        SSH_POLICY_LINE=`iptables -L -n|grep -E "ACCEPT.*multiport dports 32200|DROP.*multiport dports 32200"|wc -l`
        [[ "$SSH_POLICY_LINE" -lt 2 ]] && INSERT_MYSQL "iptables secure rule error,no ssh protect."
	fi

	# check iptables policy about mysql -- developing.

	# check other iptables's rule
	#RULE_LINE_SHOULD_BE=`cat $LOG_DIR/mon_secure.log`
	# invert mac entry from iptables rule list.
	#RULE_LINE_ACTUALLY=`iptables -L -n |grep -v MAC|wc -l`
	#if [ "$RULE_LINE_SHOULD_BE" != "$RULE_LINE_ACTUALLY" ];then
	#	INSERT_MYSQL "iptables secure rule line should be $RULE_LINE_SHOULD_BE,but now have $RULE_LINE_ACTUALLY actually."
	#fi
fi

# iptables other rule.
#if [ -f $IPTABLES_DIRECTORY/iptables.add ];then
#	DISOBEY_RULE_LINE=`cat $IPTABLES_DIRECTORY/iptables.add|grep -v ^#|grep -E -w "iptables.*32200|iptables.*-I|iptables.*-F|iptables.*-X|iptables.*-Z"|wc -l`
#	if [ "$DISOBEY_RULE_LINE" -gt 0 ];then
#		INSERT_MYSQL "something error about the file iptables.add,please check."
#	fi
#fi

# base config,allow yt server to connect this server.
iptables -L -n|grep -q "ACCEPT.*121.14.36.27"
if [ "$?" -ne 0 ];then
	iptables -I INPUT -p ALL -s 121.14.36.27 -j ACCEPT
fi

NF_CONNTRACK_PARM="net.netfilter.nf_conntrack_max"
NF_CONNTRACK_MAX=$(/sbin/sysctl -q "$NF_CONNTRACK_PARM" 2>/dev/null |awk '{print $NF}')
NF_CONNTRACK_COUNT=$(/sbin/sysctl -q "net.netfilter.nf_conntrack_count" 2>/dev/null | awk '{print $NF}')
if [ -z "$NF_CONNTRACK_MAX" ];then
	NF_CONNTRACK_PARM="net.ipv4.ip_conntrack_max"
	NF_CONNTRACK_MAX=$(/sbin/sysctl -q "$NF_CONNTRACK_PARM" 2>/dev/null | awk '{print $NF}')
	NF_CONNTRACK_COUNT=$(/sbin/sysctl -q "ip_conntrack_count" 2>/dev/null | awk '{print $NF}')
fi
COM_NUM=$(echo "$NF_CONNTRACK_MAX  $NF_CONNTRACK_COUNT"|awk '{a=$2/$1*100;if(a > 90){b=$1*2}else if(a < 30){b=$1*0.75}else{b=$1};if(b > 6553600){b=6553600}else if(b < 655360){b=655360};print b}')

if [[ "$COM_NUM" != "$NF_CONNTRACK_MAX" ]] && [[ "$COM_NUM" != "" ]];then
	sysctl -w "$NF_CONNTRACK_PARM=$COM_NUM"
fi

iptables -L -n|grep -q "state RELATED,ESTABLISHED" || INSERT_MYSQL "something error about the file iptables,no state RELATED,ESTABLISHED,please check."

