#!/bin/bash
#Written by wuhaiting
#Data 2012-10-21
#Readme:工具平台客户端

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
export LANG=C
export LC_ALL=C
# check linux version
cat /etc/issue|grep -E -w "Ubuntu|Debian" >/dev/null && LINUX_VERSION=ubuntu
cat /etc/issue|grep -E -w "CentOS|Red" >/dev/null && LINUX_VERSION=centos
PYTHON_DIR=`which python`
[[ -x /usr/local/bin/python2.6 ]] && PYTHON_DIR=/usr/local/bin/python2.6

# basic define
BASENAME=`basename $0`
SHORT_NAME=tools-platform
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

#exec 200<>$0
#flock -n -e 200 || { echo "Already Running, exit!";exit 1; }

# wget function
wget_action () {
	wget --http-user=manifold --http-passwd=dw_manifold --output-document=$1 --timeout=$2 --tries=$3 "http://$4:63217/$5"
}

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
PUBLIC_DIR=/usr/local/i386/public_repos


# get ip address
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

BACKUP_DATE=`date +%Y-%m-%d-%H-%M-%S`

# define insert alert function
INSERT_MYSQL () {
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

Detect_file () {
	if [ ! -f $S_FILE ];then
		INSERT_MYSQL "no file $S_FILE."
	elif [ ! -f $D_FILE ];then
		/bin/cp $S_FILE $D_FILE
		if [ "$?" -eq 0 ];then
			INSERT_MYSQL "add file $D_FILE successful."
			CHANGE=yes
		else
			INSERT_MYSQL "add file $D_FILE failed."
		fi
	else
		S_MD5=`md5sum $S_FILE|awk '{print $1}'`
		D_MD5=`md5sum $D_FILE|awk '{print $1}'`
		if [ "$S_MD5" != "$D_MD5" ];then
			BACKUP_FILE="`echo $D_FILE|sed 's#/#_#g'`.$BACKUP_DATE"
			/bin/cp $D_FILE $LOG_DIR/$BACKUP_FILE
			cat $S_FILE > $D_FILE
			if [ "$?" -eq 0 ];then
				CHANGE=yes
				INSERT_MYSQL "$D_FILE changed success"
			else
				INSERT_MYSQL "$D_FILE changed failed"
			fi
		fi
	fi
	unset S_FILE
	unset D_FILE
}

# 系统版本检测
SYSTEM_BIT=`getconf LONG_BIT`

# 获取对应IP的发布信息
DEPLOY_INFO_FILE=$PUBLIC_DIR/initial_system/snmp/tools-platform.revision.log
cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$IPADDR $SYSTEM_BIT"
if [ "$?" -eq 0 ];then
	FLAG=$IPADDR
else
	FLAG=default
fi
id=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $3}'`
task_id=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $4}'`
entry_id=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $5}'`
deploy_process=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $6}'`
deploy_path=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $7}'`
deploy_time=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $8}'`
deploy_version=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $9}'`
api_filename=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $10}'`
tornado_filename=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $11}'`

# define insert message.
REPOS_DB_ADDRESS_FILE=$LOG_DIR/repos_db_address.log

if [ ! -f $REPOS_DB_ADDRESS_FILE ] || [ ! -s $REPOS_DB_ADDRESS_FILE ];then
	svn info $COMM_DIR|awk -F ':' '{if($1~/URL/) print $3}'|tr -d '\/' > $REPOS_DB_ADDRESS_FILE
fi

MYSQL_ADDRESS=`cat $REPOS_DB_ADDRESS_FILE`

INSERT_MYSQL_DEPLOY () {
CONTENT=`echo "insert into deploy_info_log (deploy_id,task_id,entry_id,deploy_process,deploy_ip,deploy_time,deploy_version,deploy_path,log_info,status) value ('$id','$task_id','$entry_id','$deploy_process','$IPADDR','$deploy_time','$deploy_version','$deploy_path','$1','$2');"|base64|base64|tr -d '\n'`
wget --http-user=manifold --http-passwd=dw_manifold --output-document=$LOG_DIR/wget.log --timeout=8 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/insert_message_deploy.php?content=$CONTENT"
RESULT="$?"
if [ "$RESULT" -ne 0 ];then
	SELECT_ROLE="mysql"
	address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep -v $MYSQL_ADDRESS|grep "$SELECT_ROLE"|awk '{print $1}'))
	until [ "${#address_array[*]}" -eq 0 ];do
		address_array=(${address_array[*]})
		address_array_num=${#address_array[*]}
		xuhao=$((RANDOM%address_array_num))
		MYSQL_ADDRESS=${address_array[$xuhao]}
		unset address_array[$xuhao]
		wget --http-user=manifold --http-passwd=dw_manifold --output-document=$LOG_DIR/wget.log --timeout=8 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/insert_message_deploy.php?content=$CONTENT"
		if [ "$?" -eq 0 ];then
			echo "$MYSQL_ADDRESS" > $REPOS_DB_ADDRESS_FILE
			break
		fi
	done
fi
}

PROCESS_DIR=/data/tools-platform

# check directory
for DIRECTORY in $PROCESS_DIR/src $PROCESS_DIR/log/tools
do
	if [ ! -d $DIRECTORY ];then
		mkdir -p $DIRECTORY
	fi
done

# repository ip address
REPOS_ADDRESS=`svn info $COMM_DIR|awk -F ':' '{if($1~/URL/) print $3}'|tr -d '\/'`

WGET_DETECT () {
SELECT_ROLE="repos"
address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep -v $REPOS_ADDRESS|grep "$SELECT_ROLE"|awk '{print $1}'))
until [ "${#address_array[*]}" -eq 0 ];do
# gather all array element as a new array(regenerate a new array).
address_array=(${address_array[*]})
# calculate the amount of the new array's element.
address_array_num=${#address_array[*]}
echo address_array_num:$address_array_num
# get a random element.
num_index=$((RANDOM%address_array_num))
ADDRESS=${address_array[$num_index]}
# drop the element which already used.
unset address_array[$num_index]
echo "REPOS_ADDRESS:$ADDRESS"
wget_action $LOG_DIR/$WGET_FILE 15 1 $REPOS_ADDRESS $WGET_FILE && break
done
}

# update symbol
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR .*no_up_tools_client" || UPDATE_SYMBOL=yes

function install_python () {
	# 先安装zlibc包
	wget_action $LOG_DIR/zlib-1.2.7.tar.gz 8 1 $REPOS_ADDRESS revision/package/zlib-1.2.7.tar.gz
	if [ "$?" -eq 0 ];then
		tar zxf $LOG_DIR/zlib-1.2.7.tar.gz -C $LOG_DIR/
		cd $LOG_DIR/zlib-1.2.7
		./configure && make && make install
		rm -rf $LOG_DIR/zlib*

		cd /tmp && wget http://www.python.org/ftp/python/2.6.1/Python-2.6.1.tgz && tar zxf Python-2.6.1.tgz && cd /tmp/Python-2.6.1 && ./configure && make && make install
		rm -rf /tmp/Python-2.6.1* && cd -
		if [ -x /usr/local/bin/python2.6 ];then
			PYTHON_DIR=/usr/local/bin/python2.6
			INSERT_MYSQL "tools-platform install python version 2.6.1 successful."
		fi
	fi
}

# update process file
if [ "$UPDATE_SYMBOL" = "yes" ];then
	REMOTE_MD5=$deploy_version
	REMOTE_FILE=$api_filename
	LOCAL_MD5=`cat $LOG_DIR/tools-platform.version.log|awk '{print $1}'`
	# 假如md5码不匹配，wget远端的进程文件下来
	if [ "$REMOTE_MD5" != "$LOCAL_MD5" ];then
		sleep $((RANDOM%80))
		# 假如有wget进程正在取数据，直接退出
		ps aux|grep -v grep|grep wget && exit 1

		# 检查python版本
		unset IS_UPDATE_PYTHON
		IS_UPDATE_PYTHON=`$PYTHON_DIR -V 2>&1 | awk '{print $2}'|awk -F '.' '{i=$1"."$2;if(i <= 2.4){print "yes"};}'`
		if [ "$IS_UPDATE_PYTHON" == "yes" ];then
			install_python
		fi
		unset IS_UPDATE_PYTHON

		# 检查tornado是否已经安装
		$PYTHON_DIR -m tornado.__init__
		if [ "$?" -ne 0 ];then
			wget_action $LOG_DIR/$tornado_filename 8 1 $REPOS_ADDRESS revision/package/$tornado_filename
			if [ "$?" -eq 0 ];then
				tar jxf $LOG_DIR/$tornado_filename -C $LOG_DIR/ && cd $LOG_DIR/tornado-2.0/
				[[ -f setup.py ]] && $PYTHON_DIR setup.py install
				cd - && rm -rf $LOG_DIR/tornado*
				$PYTHON_DIR -m tornado.__init__
			else
				INSERT_MYSQL "tools-platform wget $tornado_filename fail, please check."
				exit 1
			fi
		fi
		$PYTHON_DIR -m tornado.__init__
		if [ "$?" -eq 0 ];then
			INSERT_MYSQL "tools-platform install tornado success."
		else
			[[ "$LINUX_VERSION" == "ubuntu" ]] && apt-get -y install python-dev >/dev/null 2>&1
            if [ "$LINUX_VERSION" == "centos" ];then
                SYSTEM_VERSION=`lsb_release -a |grep Release:|awk '{print $2}'|awk -F "." '{print $1}'`
			    [[ "$SYSTEM_VERSION" == "6" ]] && yum -y install python-devel > /dev/null 2>&1
            fi
			INSERT_MYSQL "tools-platform install tornado fail, please check."
			exit 1
		fi

		WGET_FILE=$REMOTE_FILE
		# 回取新进程文件
		wget_action $LOG_DIR/$WGET_FILE 8 1 $REPOS_ADDRESS revision/package/$WGET_FILE
		if [ "$?" -ne 0 ];then
			WGET_DETECT
			if [ "$?" -ne 0 ];then
				INSERT_MYSQL "wget tools_client process file failed."
				INSERT_MYSQL_DEPLOY "wget tools_client process file failed." 1
			fi
		fi
		# 假如get file成功
		if [ -f $LOG_DIR/$WGET_FILE ];then
			# 确认wget下来的包无损坏
			LOCAL_MD5=`md5sum $LOG_DIR/$WGET_FILE|awk '{print $1}'`
			if [ "$REMOTE_MD5" = "$LOCAL_MD5" ];then
				cd $deploy_path/src/tools_client/ && $PYTHON_DIR $deploy_process stop && cd -;
				rm -rf $deploy_path/src/* $deploy_path/log/tools/*
				tar -jxvf $LOG_DIR/$WGET_FILE -C $deploy_path/src/ >> $LOG_DIR/sysop_manager.log 2>&1
				md5sum $LOG_DIR/$WGET_FILE > $LOG_DIR/tools-platform.version.log
				INSERT_MYSQL "Update file $PROCESS_DIR/src/tools_client/$deploy_process successful."
				INSERT_MYSQL_DEPLOY "Update file $PROCESS_DIR/src/tools_client/$deploy_process successful." 2
			else
				INSERT_MYSQL "Update file $PROCESS_DIR/src/tools_client/$deploy_process failed,result in:wget file successful,but md5 error."
				INSERT_MYSQL_DEPLOY "Update file $PROCESS_DIR/src/tools_client/$deploy_process failed,result in:wget file successful,but md5 error." 1
			fi
		else
			INSERT_MYSQL "Update file $PROCESS_DIR/src/tools_client/$deploy_process failed,result in:wget file failed."
			INSERT_MYSQL_DEPLOY "Update file $PROCESS_DIR/src/tools_client/$deploy_process failed,result in:wget file failed." 1
		fi
	fi
fi

$PYTHON_DIR -m tornado.__init__ >/dev/null 2>&1
if [[ "$?" -ne 0 ]] || [[ ! -f "$PROCESS_DIR/src/tools_client/$deploy_process" ]];then
	rm $LOG_DIR/tools-platform.version.log
	if [ "$UPDATE_SYMBOL" = "yes" ];then
		INSERT_MYSQL "no $deploy_process process file."
		INSERT_MYSQL_DEPLOY "no $deploy_process process file." 1
	fi
else
	# check configure_file revision
	for a in `ls -l $PUBLIC_DIR/initial_system/snmp/ext/tools-platform_etc|grep -v -E "total|grep"|awk '{print $NF}'`
	do
		S_FILE=$PUBLIC_DIR/initial_system/snmp/ext/tools-platform_etc/$a
		D_FILE=$PROCESS_DIR/src/tools_client/etc/$a
		Detect_file
	done

	# tools_agent_d in /etc/rc.local
#	tools-agent_LINE=`cat /etc/rc.local|grep "cd $PROCESS_DIR/src/tools_client && sh startup.sh &"|wc -l`
#	if [ "$tools-agent_LINE" -eq 0 ];then
#		echo "cd $PROCESS_DIR/src/tools_client && sh startup.sh &" >> /etc/rc.local
#	elif [ "$tools-agent_LINE" -gt 1 ];then
#		sed -i '/tools_client.*/d' /etc/rc.local
#		echo "cd $PROCESS_DIR/src/tools_client && sh startup.sh &" >> /etc/rc.local
#		INSERT_MYSQL "Del more than one line $deploy_process entry in rc.local,num: $tools-agent_LINE"
#	fi

	# check process running or not.
	for PROCESS_NAME in "$deploy_process"
	do
		ProcessThresholdValue=1
		PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "$PROCESS_NAME"|wc -l`
		if [ "$PS_LINE" -lt "$ProcessThresholdValue" ];then
			# tools_agent_d有可能被别人杀掉，留下了pid
			rm -rf $PROCESS_DIR/src/tools_client/proc/daemon.pid >/dev/null 2>&1
			cd $PROCESS_DIR/src/tools_client
			export LC_ALL="C"
			$PYTHON_DIR $deploy_process start > /dev/null 2>&1 &
			INSERT_MYSQL "start $deploy_process"
			sleep 5
			PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "$PROCESS_NAME"|wc -l`
			if [ "$PS_LINE" -lt "$ProcessThresholdValue" ];then
				INSERT_MYSQL "$PROCESS_NAME ps num:$PS_LINE,and start it failed."
				INSERT_MYSQL_DEPLOY "$PROCESS_NAME ps num:$PS_LINE,and start it failed." 1
				# 检查可能是由于zlibc没有安装导致的
				$PYTHON_DIR $deploy_process start 2>&1 |grep -wq "zlib"
				if [ "$?" -eq 0 ];then
					install_python
					INSERT_MYSQL "$PROCESS_NAME try to install zlib and python."
				fi

			else
				INSERT_MYSQL "$PROCESS_NAME ps num:$PS_LINE,and start it successful."
			fi
		elif [ "$PS_LINE" -gt "$ProcessThresholdValue" ];then
			sleep 5
			PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "\./$deploy_process$"|wc -l`
			if [ "$PS_LINE" -gt "$ProcessThresholdValue" ];then
				INSERT_MYSQL "more than $ProcessThresholdValue $deploy_process process.process_num: $PS_LINE."
				ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "$deploy_process" >> $LOG_DIR/sysop_manager.log
				pkill -9 -f $deploy_process && rm $PROCESS_DIR/src/tools_client/proc/*
				cd $PROCESS_DIR/src/tools_client && $PYTHON_DIR $deploy_process start > /dev/null 2>&1 &
				INSERT_MYSQL "start $deploy_process"
			fi
		fi
	done
	# 检查tools_agent_d.py是否挂死
	if [ "$deploy_process" == "tools_agent_d.py" ];then
		TMP_FILE1=`mktemp /tmp/check_tool_agent.alive.XXXXX`
		wget --timeout=2 --tries=2 "http://127.0.0.1:10029" -O $TMP_FILE1
		cat $TMP_FILE1|grep -wq "welcome"
		if [[ "$?" -ne 0 ]] || [[ ! -s /data/tools-platform/log/tools/agent.log ]];then
			[ ! -s /data/tools-platform/log/tools/agent.log ] && INSERT_MYSQL "$PROCESS_NAME dead and no agent.log"
			pkill -9 -f $deploy_process
			rm -rf $PROCESS_DIR/src/tools_client/proc/daemon.pid $PROCESS_DIR/log/tools/agent.log > /dev/null 2>&1
			cd $PROCESS_DIR/src/tools_client && $PYTHON_DIR $deploy_process start > /dev/null 2>&1 &
			cd - ;
			sleep 5
			PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "$PROCESS_NAME"|wc -l`
			[[ "$PS_LINE" -ge 1 ]] && INSERT_MYSQL "$PROCESS_NAME dead and restart successful"
		fi
		rm $TMP_FILE1
	fi

fi
