#!/bin/bash
#Date:2011-05-15
#Written by manifold.
#Readme:monitor the user on server.
#Change:2011-10-17
#Readme:cat /etc/passwd|grep -v -E -w "/sbin/nologin|/bin/false|/usr/sbin/nologin" -> cat /etc/passwd|grep -v -E "/sbin/nologin$|/bin/false$"
#2011-10-17 06:02:01 | 121.9.221.215 | Detected unauthorized user: sshd dspeak . 

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# check linux version
cat /etc/issue|grep -E "CentOS|Red" && LINUX_VERSION="centos"
cat /etc/issue|grep -E "Ubuntu" && LINUX_VERSION="ubuntu"
if [ "$LINUX_VERSION" = "" ];then exit 1;fi

# basic define
BASENAME=`basename $0`
SHORT_NAME=ch_user
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
PUBLIC_DIR=/usr/local/i386/public_repos

# get ip address 
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi 

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

# define insert alert function
INSERT_MYSQL () {
    sleep $((RANDOM%60))
    /bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

# yuwanfu@ubuntu:~$ cat /etc/passwd|grep -w yuwanfu
# yuwanfu:x:1002:1002:,,,:/home/yuwanfu:/bin/bash
# yuwanfu@ubuntu:~$ echo $?
# 0
# yuwanfu@ubuntu:~$ cat /etc/passwd|grep -w yuwanfu >> /tmpyes/yes
# -bash: /tmpyes/yes: No such file or directory
# yuwanfu@ubuntu:~$ echo $?
# 1

# del user action
function DEL_USER () {
	USER_NAME=$1
	cat /etc/passwd|grep -w $USER_NAME >> $LOG_DIR/sysop_manager.log
	cat /etc/passwd|grep -w $USER_NAME
	if [ "$?" -eq 0 ];then
		skill -9 $USER_NAME
		userdel -f $USER_NAME
		if [ -d /home/$USER_NAME ];then
			mv /home/$USER_NAME /home/backup
		fi
		INSERT_MYSQL "del user:$USER_NAME"
	fi
}

# del user
if [ -f $PUBLIC_DIR/initial_system/user/dimission_user.log ];then
	for USER_NAME in `cat $PUBLIC_DIR/initial_system/user/dimission_user.log|grep -v ^#|grep -v ^$`
	do
		DEL_USER $USER_NAME
	done
fi

unset USER_NAME

# monitor user
if [ -f $PUBLIC_DIR/initial_system/user/normal_user.log ];then
	# attention: luobaohang is from kingsoft
	NORMAL_USER=`cat $PUBLIC_DIR/initial_system/user/normal_user.log|awk '{print $1}'|grep -Ev "^#|^$"|tr '\n' '\|'|sed 's/|$//'`
	if [ "$LINUX_VERSION" = "ubuntu" ];then
		USER=`cat /etc/passwd|grep -v -E "/sbin/nologin$|/bin/false$"|awk -F ':' '{print $1}'|grep -E -w -v "root|daemon|bin|sys|sync|games|man|lp|mail|news|uucp|proxy|www-data|backup|list|irc|gnats|nobody|vsftp|libuuid|mysql|oracle|postgres|$NORMAL_USER"|tr '\n' ' '`
	elif [ "$LINUX_VERSION" = "centos" ];then
		USER=`cat /etc/passwd|grep -v -E "/sbin/nologin$|/bin/false$"|awk -F ':' '{print $1}'|grep -E -w -v "root|sync|shutdown|halt|news|www-data|mysql|$NORMAL_USER"|tr '\n' ' '`
	fi

	if [ "$USER" != "" ];then
		INSERT_MYSQL "Detected unauthorized user: $USER."
	fi
fi

id user_00 || useradd -s /bin/bash user_00