#!/bin/bash
#Date:2012-08-30
#Written by manifold and wuhaiting.
#Readme:yyac monitor system.
#Readme:在小余的mon_yyms_agent_2.sh监控脚本基础上作出调整修改.


export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
export LANG=C
export LC_ALL=C
# basic define
BASENAME=`basename $0`
SHORT_NAME=yyac
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

#exec 200<>$0
#flock -n -e 200 || { echo "Already Running, exit!";exit 1; }

# wget function
wget_action () {
	wget --http-user=manifold --http-passwd=dw_manifold --output-document=$1 --timeout=$2 --tries=$3 "http://$4:63217/$5"
}

# status 1 ?
[ -s /home/dspeak/yyms/hostinfo.ini ] \
	&& machine_status=$(awk -F '=' '{if($1 ~ /^status/){print $2;exit}}' /home/dspeak/yyms/hostinfo.ini)

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
PUBLIC_DIR=/usr/local/i386/public_repos

# 紧急停止signal
get_remote_revision () {
	API_ROLE="$1"
	api_address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep "$API_ROLE"|awk '{print $1}'))
	until [ "${#api_address_array[*]}" -eq 0 ];do
		api_address_array=(${api_address_array[*]})
		api_address_array_num=${#api_address_array[*]}
		echo api_address_array_num:$api_address_array_num
		api_num_index=$((RANDOM%api_address_array_num))
		API_ADDRESS=${api_address_array[$api_num_index]}
		unset api_address_array[$api_num_index]
		echo "API_ADDRESS:$API_ADDRESS"
		wget_action $LOG_DIR/deploy_info_yyac.log 8 1 $API_ADDRESS revision/deploy_info_yyac.html && break
	done
}
#get_remote_revision api

#RUN_FLAG=`cat $LOG_DIR/deploy_info_yyac.log`
#if [ "$RUN_FLAG" != "yes" ];then
#	exit 2
#fi

# get ip address
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

BACKUP_DATE=`date +%Y-%m-%d-%H-%M-%S`

# define insert alert function
INSERT_MYSQL () {
[ "$machine_status" != "1" ] && return
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

Detect_file () {
	if [ ! -f $S_FILE ];then
		INSERT_MYSQL "no file $S_FILE."
	elif [ ! -f $D_FILE ];then
		/bin/cp $S_FILE $D_FILE
		if [ "$?" -eq 0 ];then
			INSERT_MYSQL "add file $D_FILE successful."
			CHANGE=yes
		else
			INSERT_MYSQL "add file $D_FILE failed."
		fi
	else
		S_MD5=`md5sum $S_FILE|awk '{print $1}'`
		D_MD5=`md5sum $D_FILE|awk '{print $1}'`
		if [ "$S_MD5" != "$D_MD5" ];then
			BACKUP_FILE="`echo $D_FILE|sed 's#/#_#g'`.$BACKUP_DATE"
			#/bin/cp $D_FILE $LOG_DIR/$BACKUP_FILE
			cat $S_FILE > $D_FILE
			if [ "$?" -eq 0 ];then
				CHANGE=yes
				INSERT_MYSQL "$D_FILE changed success"
			else
				INSERT_MYSQL "$D_FILE changed failed"
			fi
		fi
	fi
	unset S_FILE
	unset D_FILE
}

function kill_func () {
	local ppids=$(pidof $1)
	[ "x${ppids}" = "x" ] && return

	for ppid in $ppids;do
		kill -15 $ppid
	done
	sleep 15
	local ppids=$(pidof $1)
	for ppid in $ppids;do
		kill -9 $ppid
	done
}

# 系统版本检测
SYSTEM_BIT=`getconf LONG_BIT`

# 机房ID
ROOM_ID=`awk '{for(i=1;i<=NF;i++){if($i ~ /room_id/){gsub("\"room_id\":","",$i);gsub(",","",$i);print $i}}}' /home/dspeak/yyms/hostinfo`

# 获取对应IP的发布信息
DEPLOY_INFO_FILE=$PUBLIC_DIR/initial_system/snmp/yyac_worker_ant_d.revision.log
awk '{print $1}' $DEPLOY_INFO_FILE | grep -qw "$ROOM_ID"
if [ "$?" -eq 0 ];then
	FLAG=`awk '{print $1}' $DEPLOY_INFO_FILE|grep -w "$ROOM_ID" | head -n1`
else
	FLAG=default
fi
id=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $3}'`
task_id=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $4}'`
entry_id=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $5}'`
deploy_process=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $6}'`
deploy_path=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $7}'`
deploy_time=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $8}'`
deploy_version=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $9}'`
api_filename=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $10}'`
configure_file=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $11}'`
[ -z $deploy_process ] && exit 1

# define insert message.
REPOS_DB_ADDRESS_FILE=$LOG_DIR/repos_db_address.log

if [ ! -f $REPOS_DB_ADDRESS_FILE ] || [ ! -s $REPOS_DB_ADDRESS_FILE ];then
	svn info $COMM_DIR|awk -F ':' '{if($1~/URL/) print $3}'|tr -d '\/' > $REPOS_DB_ADDRESS_FILE
fi

MYSQL_ADDRESS=`cat $REPOS_DB_ADDRESS_FILE`

INSERT_MYSQL_DEPLOY () {
[ "$machine_status" != "1" ] && return
CONTENT=`echo "insert into deploy_info_log (deploy_id,task_id,entry_id,deploy_process,deploy_ip,deploy_time,deploy_version,deploy_path,log_info,status) value ('$id','$task_id','$entry_id','$deploy_process','$IPADDR','$deploy_time','$deploy_version','$deploy_path','$1','$2');"|base64|base64|tr -d '\n'`
wget --http-user=manifold --http-passwd=dw_manifold --output-document=$LOG_DIR/wget.log --timeout=8 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/insert_message_deploy.php?content=$CONTENT"
RESULT="$?"
if [ "$RESULT" -ne 0 ];then
	SELECT_ROLE="mysql"
	address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep -v $MYSQL_ADDRESS|grep "$SELECT_ROLE"|awk '{print $1}'))
	until [ "${#address_array[*]}" -eq 0 ];do
		address_array=(${address_array[*]})
		address_array_num=${#address_array[*]}
		xuhao=$((RANDOM%address_array_num))
		MYSQL_ADDRESS=${address_array[$xuhao]}
		unset address_array[$xuhao]
		wget --http-user=manifold --http-passwd=dw_manifold --output-document=$LOG_DIR/wget.log --timeout=8 --tries=1 --quiet "http://$MYSQL_ADDRESS:63217/insert_message_deploy.php?content=$CONTENT"
		if [ "$?" -eq 0 ];then
			echo "$MYSQL_ADDRESS" > $REPOS_DB_ADDRESS_FILE
			break
		fi
	done
fi
}

# yyac_worker_ant_d
PROCESS_DIR=/home/dspeak/yyms/yymp/yyac_worker_ant

# check directory
for DIRECTORY in $PROCESS_DIR/bin $PROCESS_DIR/etc
do
	if [ ! -d $DIRECTORY ];then
		mkdir -p $DIRECTORY
	fi
done

# repository ip address
REPOS_ADDRESS=`svn info $COMM_DIR|awk -F ':' '{if($1~/URL/) print $3}'|tr -d '\/'`

WGET_DETECT () {
SELECT_ROLE="repos"
address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep -v $REPOS_ADDRESS|grep "$SELECT_ROLE"|awk '{print $1}'))
until [ "${#address_array[*]}" -eq 0 ];do
# gather all array element as a new array(regenerate a new array).
address_array=(${address_array[*]})
# calculate the amount of the new array's element.
address_array_num=${#address_array[*]}
echo address_array_num:$address_array_num
# get a random element.
num_index=$((RANDOM%address_array_num))
ADDRESS=${address_array[$num_index]}
# drop the element which already used.
unset address_array[$num_index]
echo "REPOS_ADDRESS:$ADDRESS"
wget_action $LOG_DIR/$WGET_FILE 8 1 $ADDRESS revision/package/$WGET_FILE && break
done
}

# update symbol
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR .*no_up_yyac_worker" || UPDATE_SYMBOL=yes

# update process file
if [ "$UPDATE_SYMBOL" = "yes" ];then
	REMOTE_MD5=$deploy_version
	REMOTE_FILE=$api_filename
	LOCAL_MD5=`md5sum $PROCESS_DIR/bin/$deploy_process|awk '{print $1}'`
	# 假如md5码不匹配，wget远端的进程文件下来
	if [ "$REMOTE_MD5" != "$LOCAL_MD5" ];then
		WGET_FILE=$REMOTE_FILE
		sleep $((RANDOM%300))
		# 假如有wget进程正在取数据，直接退出
		ps aux|grep -v grep|grep "wget.*yyac" && exit 1
		# 回取新进程文件
		wget_action $LOG_DIR/$WGET_FILE 8 1 $REPOS_ADDRESS revision/package/$WGET_FILE
		if [ "$?" -ne 0 ];then
			WGET_DETECT
			if [ "$?" -ne 0 ];then
				INSERT_MYSQL "wget yyac_worker_ant_d process file failed."
				INSERT_MYSQL_DEPLOY "wget yyac_worker_ant_d process file failed." 1
			fi
		fi
		# 假如get file成功
		if [ -f $LOG_DIR/$WGET_FILE ];then
			tar -jxvf $LOG_DIR/$WGET_FILE -C $LOG_DIR >> $LOG_DIR/sysop_manager.log 2>&1
			# 确认wget下来的包无损坏
			LOCAL_MD5=`md5sum $LOG_DIR/$deploy_process|awk '{print $1}'`
			if [ "$REMOTE_MD5" = "$LOCAL_MD5" ];then
				cd $PROCESS_DIR/bin
				#mv $deploy_process $LOG_DIR/$deploy_process.$BACKUP_DATE
				rm -f $deploy_process
				mv -f $LOG_DIR/$deploy_process $deploy_process
				kill_func $deploy_process
				INSERT_MYSQL "Update file $PROCESS_DIR/bin/$deploy_process successful."
				INSERT_MYSQL_DEPLOY "Update file $PROCESS_DIR/bin/$deploy_process successful." 2
			else
				INSERT_MYSQL "Update file $PROCESS_DIR/bin/$deploy_process failed,result in:wget file successful,but md5 error.$LOG_DIR/$deploy_process md5 is $LOCAL_MD5,want to deploy's md5 is $REMOTE_MD5"
				INSERT_MYSQL_DEPLOY "Update file $PROCESS_DIR/bin/$deploy_process failed,result in:wget file successful,but md5 error." 1
			fi
		else
			INSERT_MYSQL "Update file $PROCESS_DIR/bin/$deploy_process failed,result in:wget file failed."
			INSERT_MYSQL_DEPLOY "Update file $PROCESS_DIR/bin/$deploy_process failed,result in:wget file failed." 1
		fi
	fi
fi

if [ ! -f "$PROCESS_DIR/bin/$deploy_process" ];then
	if [ "$UPDATE_SYMBOL" = "yes" ];then
		INSERT_MYSQL "no $deploy_process process file."
		INSERT_MYSQL_DEPLOY "no $deploy_process process file." 1
	fi
else
	# check configure_file revision
	for a in `ls -l $PUBLIC_DIR/initial_system/snmp/ext/yyac_etc/$configure_file |grep -v -E "total|grep"|awk '{print $NF}'`
	do
		S_FILE=$PUBLIC_DIR/initial_system/snmp/ext/yyac_etc/$configure_file/$a
		D_FILE=$PROCESS_DIR/etc/$a
		Detect_file
	done
	#根据升级需要重启进程
	if [ "$CHANGE" = "yes" ];then
		[ ! -z "$deploy_process" ] && kill_func $deploy_process
	fi

	# yyac_worker_ant_d in /etc/rc.local
	YYAC_LINE=`cat /etc/rc.local|grep "cd $PROCESS_DIR/bin && ./$deploy_process"|wc -l`
	if [ "$YYAC_LINE" -eq 0 ];then
		echo "cd $PROCESS_DIR/bin && ./$deploy_process &" >> /etc/rc.local
	elif [ "$YYAC_LINE" -gt 1 ];then
		sed -i "/\.\/$deploy_process &/d" /etc/rc.local
		echo "cd $PROCESS_DIR/bin && ./$deploy_process &" >> /etc/rc.local
		INSERT_MYSQL "Del more than one line $deploy_process entry in rc.local,num: $YYAC_LINE"
	fi

	# check process running or not.
	for PROCESS_NAME in "$deploy_process"
	do
		ProcessThresholdValue=1
		PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "$PROCESS_NAME"|wc -l`
		if [ "$PS_LINE" -lt "$ProcessThresholdValue" ];then
			cd $PROCESS_DIR/bin
			chmod 755 $deploy_process
			export LC_ALL="C"
			/bin/bash -c "./$deploy_process >/dev/null 2>&1 &"
			INSERT_MYSQL "start $deploy_process"
			sleep 5
			PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "$PROCESS_NAME"|wc -l`
			if [ "$PS_LINE" -lt "$ProcessThresholdValue" ];then
				INSERT_MYSQL "yyac:$PROCESS_NAME ps num:$PS_LINE,and start it failed."
				# 尝试删掉/home/dspeak/yyms/yymp/ant_seq.kch文件，如果这个文件有问题yyac不能起来
				[ -f /home/dspeak/yyms/yymp/ant_seq.kch ] && rm -f /home/dspeak/yyms/yymp/ant_seq.kch
			else
				INSERT_MYSQL "$PROCESS_NAME ps num:$PS_LINE,and start it successful."
			fi
		elif [ "$PS_LINE" -gt "$ProcessThresholdValue" ];then
			sleep 5
			PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "\./$deploy_process$"|wc -l`
			if [ "$PS_LINE" -gt "$ProcessThresholdValue" ];then
				INSERT_MYSQL "more than $ProcessThresholdValue $deploy_process process.process_num: $PS_LINE."
				ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "\./$deploy_process$" >> $LOG_DIR/sysop_manager.log
				[ ! -z "$deploy_process" ] && kill_func $deploy_process
				cd $PROCESS_DIR/bin && /bin/bash -c "./$deploy_process >/dev/null 2>&1 &"
				INSERT_MYSQL "start $deploy_process"
			fi
		fi
	done

fi

