#!/bin/bash
#Date:2012-06-25
#Written by manifold.
#Readme:yyms的yymp部分，此脚本每3分钟执行一次。

REPOS_NAME=comm_repos
source /usr/local/i386/$REPOS_NAME/auto/function.sh
noblock_lock
trap "noblock_unlock;" 0 1 2 9 15
export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# basic define
BASENAME=`basename $0`
SHORT_NAME=yymp
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# wget function
wget_action () {
	wget --http-user=manifold --http-passwd=dw_manifold --output-document=$1 --timeout=$2 --tries=$3 "http://$4:63217/$5"
}

# status 1 ?
[ -s /home/dspeak/yyms/hostinfo.ini ] \
	&& machine_status=$(split_tag 'status' /home/dspeak/yyms/hostinfo.ini '=')

# repository path
COMM_DIR=/usr/local/i386/$REPOS_NAME
PUBLIC_DIR=/usr/local/i386/public_repos

# 紧急停止signal
get_remote_revision () {
	API_ROLE="$1"
	api_address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep "$API_ROLE"|awk '{print $1}'))
	until [ "${#api_address_array[*]}" -eq 0 ];do
		api_address_array=(${api_address_array[*]})
		api_address_array_num=${#api_address_array[*]}
		echo api_address_array_num:$api_address_array_num
		api_num_index=$((RANDOM%api_address_array_num))
		API_ADDRESS=${api_address_array[$api_num_index]}
		unset api_address_array[$api_num_index]
		echo "API_ADDRESS:$API_ADDRESS"
		wget_action $LOG_DIR/deploy_info_yymp.log 3 1 $API_ADDRESS revision/deploy_info_yymp.html && break
	done
}
#get_remote_revision api
#
#RUN_FLAG=`cat $LOG_DIR/deploy_info_yymp.log`
#if [ "$RUN_FLAG" != "yes" ];then
#	exit 2
#fi

# get ip address
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

# 只允许部分机器执行
# cat $PUBLIC_DIR/initial_system/snmp/yymp_agent_d.ip.log|grep -w $IPADDR || exit 1

BACKUP_DATE=`date +%Y-%m-%d-%H-%M-%S`

# define insert alert function
INSERT_MYSQL () {
[ "$machine_status" != "1" ] && return
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

Detect_file () {
	if [ ! -f $S_FILE ];then
		INSERT_MYSQL "no file $S_FILE."
	elif [ ! -f $D_FILE ];then
		/bin/cp $S_FILE $D_FILE
		if [ "$?" -eq 0 ];then
			INSERT_MYSQL "add file $D_FILE successful."
			CHANGE=yes
		else
			INSERT_MYSQL "add file $D_FILE failed."
		fi
	else
		S_MD5=`md5sum $S_FILE|awk '{print $1}'`
		D_MD5=`md5sum $D_FILE|awk '{print $1}'`
		if [ "$S_MD5" != "$D_MD5" ];then
			BACKUP_FILE="`echo $D_FILE|sed 's#/#_#g'`.$BACKUP_DATE"
			/bin/cp $D_FILE $LOG_DIR/$BACKUP_FILE
			cat $S_FILE > $D_FILE
			if [ "$?" -eq 0 ];then
				CHANGE=yes
				INSERT_MYSQL "$D_FILE changed success"
			else
				INSERT_MYSQL "$D_FILE changed failed"
			fi
		fi
	fi
}


# 系统版本检测
SYSTEM_BIT=`getconf LONG_BIT`

# 灰度发布机房ID
ROOM_ID=`awk '{for(i=1;i<=NF;i++){if($i ~ /room_id/){gsub("\"room_id\":","",$i);gsub(",","",$i);print $i}}}' /home/dspeak/yyms/hostinfo`

# 获取对应IP的发布信息
DEPLOY_INFO_FILE=$PUBLIC_DIR/initial_system/snmp/yymp_agent_d.revision.log

cat $DEPLOY_INFO_FILE| grep -v "^#" |awk '{print $1}' |grep -qw "$ROOM_ID"
if [ "$?" -eq 0 ] && [ ! -z $ROOM_ID ];then
	FLAG=`awk '{print $1}' $DEPLOY_INFO_FILE|grep -w "$ROOM_ID" | head -n1`
else
	FLAG=default
fi

deploy_process=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $3}'`
deploy_path=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $4}'`
deploy_time=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $5}'`
deploy_version=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $6}'`
api_filename=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $7}'`
configure_file=`cat $DEPLOY_INFO_FILE|grep -v ^# |grep "^$FLAG $SYSTEM_BIT"|awk '{print $8}'`
[ -z $deploy_process ] && exit 1

# 进程所在目录
PROCESS_DIR=/home/dspeak/yyms/yymp

# 创建所需目录
for DIRECTORY in $PROCESS_DIR/rrd/common $PROCESS_DIR/rrd/proc $PROCESS_DIR/yymp_agent/bin/alarm_data $PROCESS_DIR/yymp_agent/bin/merged_data $PROCESS_DIR/yymp_agent/bin/proc_data
do
	if [ ! -d $DIRECTORY ];then
		mkdir -p $DIRECTORY
	fi
done

# 检查yymp相关文件到repos的相应软链是否存在
for SYNC_DIR in script yymp_cron_script yymp_pylibs yymp_report_script yymp_transfer_d lua_scripts
do
	if [ -d $PUBLIC_DIR/initial_system/snmp/ext/yymp/$SYNC_DIR ];then
		LINK_DIR=`ls -l $PROCESS_DIR/$SYNC_DIR|awk '{print $NF}'`
		if [ "$LINK_DIR" != "$PUBLIC_DIR/initial_system/snmp/ext/yymp/$SYNC_DIR" ];then
			unlink $PROCESS_DIR/$SYNC_DIR
		fi
		if [ ! -L $PROCESS_DIR/$SYNC_DIR ] || [ ! -d $PROCESS_DIR/$SYNC_DIR ] || [ ! -e $PROCESS_DIR/$SYNC_DIR ];then
			mv $PROCESS_DIR/$SYNC_DIR $PROCESS_DIR/$SYNC_DIR.$BACKUP_DATE
			ln -s $PUBLIC_DIR/initial_system/snmp/ext/yymp/$SYNC_DIR $PROCESS_DIR/$SYNC_DIR
		fi
	else
		INSERT_MYSQL "yymp:error:no such directory $PUBLIC_DIR/initial_system/snmp/ext/yymp/$SYNC_DIR."
	fi
done

# yymp配置文件不再使用符号链接，需要一同灰度发布
if [ -d $PROCESS_DIR/yymp_agent/etc ] && [ -L $PROCESS_DIR/yymp_agent/etc ]; then
	unlink $PROCESS_DIR/yymp_agent/etc
fi

if [ -d $PROCESS_DIR/yymp_agent/etc ];then
	for etc_file in $PUBLIC_DIR/initial_system/snmp/ext/yymp/yymp_agent/etc/$configure_file/* ;
	do
		etc_file="${etc_file##*/}"
		src_file_md5=$(md5sum $PUBLIC_DIR/initial_system/snmp/ext/yymp/yymp_agent/etc/$configure_file/$etc_file|awk '{print $1}')
		dst_file_md5=$(md5sum $PROCESS_DIR/yymp_agent/etc/$etc_file |awk '{print $1}')
		if [ "$src_file_md5" != "$dst_file_md5" ];then
			mv $PROCESS_DIR/yymp_agent/etc/$etc_file $LOG_DIR/${etc_file}.${BACKUP_DATE}
			cp -f $PUBLIC_DIR/initial_system/snmp/ext/yymp/yymp_agent/etc/$configure_file/$etc_file $PROCESS_DIR/yymp_agent/etc/$etc_file
			update_configure=yes
		fi
	done
else
	mkdir -p $PROCESS_DIR/yymp_agent/etc
	cp -R $PUBLIC_DIR/initial_system/snmp/ext/yymp/yymp_agent/etc/$configure_file/* $PROCESS_DIR/yymp_agent/etc/. && update_configure=yes
fi

# repository ip address
# REPOS_ADDRESS=`svn info $COMM_DIR|awk -F ':' '{if($1~/URL/) print $3}'|tr -d '\/'`
REPOS_ADDRESS=`cat /etc/hosts|grep -w manager.repos.yy.duowan.com|awk '{print $1}'`

WGET_DETECT () {
	SELECT_ROLE="repos"
	address_array=($(cat $COMM_DIR/initial_system/repos_server.log|grep -v $REPOS_ADDRESS|grep "$SELECT_ROLE"|awk '{print $1}'))
	until [ "${#address_array[*]}" -eq 0 ];do
		address_array=(${address_array[*]})
		address_array_num=${#address_array[*]}
		num_index=$((RANDOM%address_array_num))
		ADDRESS=${address_array[$num_index]}
		unset address_array[$num_index]
		REPOS_ADDRESS="$ADDRESS"
		echo "REPOS_ADDRESS:$REPOS_ADDRESS"
		wget_action $LOG_DIR/$WGET_FILE 3 1 $REPOS_ADDRESS revision/package/$WGET_FILE && break
	done
}

function add_crontab_entry () {
	ENTRY=$1
	# 暂时不将人为注释掉的考虑在内，后期会考虑
	SHORT_ENTRY_CONTENT="/bin/bash $PROCESS_DIR/script/host/$ENTRY"
	ENTRY_CONTENT="*/1 * * * * root /bin/bash $PROCESS_DIR/script/host/$ENTRY > /dev/null 2>&1"
	GREP_ENTRY=`echo "$ENTRY_CONTENT"|sed 's#\*#\\\*#g'|awk '{for(i=1;i<=NF;i++) if(i<NF) {printf $i" *"} else {printf $i}}'`
	ENTRY_LINE=`cat /etc/crontab|grep -w "$SHORT_ENTRY_CONTENT"|wc -l`

	# 无相应条目，直接增加一条
	if [ "$ENTRY_LINE" -eq 0 ];then
		echo "$ENTRY_CONTENT" >> /etc/crontab
		INSERT_MYSQL "yymp:Add /etc/crontab entry: $ENTRY_CONTENT."
	# 有相应条目，但不匹配，删掉重新加
	elif [ "$ENTRY_LINE" -eq 1 ];then
		cat /etc/crontab|grep -w "$GREP_ENTRY"
		if [ "$?" -ne 0 ];then
			CRONTAB_CHANGE="yes"
		fi
	# 有多于一条的相应条目，全部删掉，重新加
	elif [ "$ENTRY_LINE" -gt 1 ];then
		CRONTAB_CHANGE="yes"
	fi

	# /etc/crontab变更动作
	if [ "$CRONTAB_CHANGE" = "yes" ];then
		BACKUP_FILE="`echo /etc/crontab|sed 's#/#_#g'`.$BACKUP_DATE"
		/bin/cp /etc/crontab $LOG_DIR/$BACKUP_FILE
		# sed -i '#'"${SHORT_ENTRY_CONTENT}"'#d' /etc/crontab
		sed -i '/.*bash.*yymp.*script.*'"${ENTRY}"'/d' /etc/crontab
		echo "$ENTRY_CONTENT" >> /etc/crontab
		INSERT_MYSQL "yymp:Change /etc/crontab entry: $ENTRY_CONTENT."
	fi
}


# update symbol
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR .*no_up_yymp_process" || UPDATE_SYMBOL=yes

# update process file
if [ "$UPDATE_SYMBOL" = "yes" ];then
	REMOTE_MD5=$deploy_version
	REMOTE_FILE=$api_filename
	LOCAL_MD5=`md5sum $PROCESS_DIR/yymp_agent/bin/$deploy_process|awk '{print $1}'`

	# 假如md5码不匹配，wget远端的进程文件下来
	if [ "$REMOTE_MD5" != "$LOCAL_MD5" ];then

		WGET_FILE=$REMOTE_FILE

		# 检测写入的临界检测文件是否超时
		if [ -f $LOG_DIR/mon_yymp_sh_wget_file.log ];then
			CHANGE_TIME=`stat $LOG_DIR/mon_yymp_sh_wget_file.log|awk '{if($1=="Change:") print $2,$3}'|awk -F '.' '{print $1}'`
			CHANGE_TIME_STRING=`date --date "$CHANGE_TIME" +%s`
			CURRENT_TIME_STRING=`date +%s`
			CALC=`expr $CURRENT_TIME_STRING - $CHANGE_TIME_STRING`
			if [ "$CALC" -gt "600" ] || [ "$CALC" -lt 0 ];then
				TIMEOUT="yes"
				rm -f $LOG_DIR/mon_yymp_sh_wget_file.log
			fi
		fi

		# 多重进程间的互斥，避免多个进程同时从管理机拖进程文件下来
		if [ ! -f $LOG_DIR/mon_yymp_sh_wget_file.log ];then
			# 创建临界检测文件
			touch $LOG_DIR/mon_yymp_sh_wget_file.log

			# 错开时间段来下载进程文件
			sleep $((RANDOM%600))

			# 检测是否有wget进程正在取数据
			ps aux|grep -v grep|grep "wget.*$WGET_FILE"
			if [ "$?" -ne 0 ];then
				# 回取新进程文件
				wget_action $LOG_DIR/$WGET_FILE 3 1 $REPOS_ADDRESS revision/package/$WGET_FILE
				if [ "$?" -ne 0 ];then
					WGET_DETECT || INSERT_MYSQL "yymp:wget yymp process file failed."
				fi
			fi
			# 删除临界检测文件
			rm -f $LOG_DIR/mon_yymp_sh_wget_file.log

			# 假如get file成功
			if [ -f $LOG_DIR/$WGET_FILE ];then
				tar -jxvf $LOG_DIR/$WGET_FILE -C $LOG_DIR >> $LOG_DIR/sysop_manager.log 2>&1

				# 确认wget下来的包无损坏
				LOCAL_MD5=`md5sum $LOG_DIR/$deploy_process|awk '{print $1}'`
				if [ "$REMOTE_MD5" = "$LOCAL_MD5" ];then
					cd $PROCESS_DIR/yymp_agent/bin
					#mv $deploy_process $LOG_DIR/$deploy_process.$BACKUP_DATE
					rm -f $deploy_process
					mv $LOG_DIR/$deploy_process $deploy_process
					pkill ^$deploy_process
					INSERT_MYSQL "yymp:Update file $PROCESS_DIR/yymp_agent/bin/$deploy_process successful."
					sleep 15
				else
					INSERT_MYSQL "yymp:Update file $PROCESS_DIR/yymp_agent/bin/$deploy_process failed,result in:wget file successful,but md5 error.$LOG_DIR/$deploy_process md5 is $LOCAL_MD5,want to deploy md5 is $REMOTE_MD5"
				fi

			else
				INSERT_MYSQL "yymp:Update file $PROCESS_DIR/yymp_agent/bin/$deploy_process failed,result in:wget file failed."
			fi

		fi

	fi

fi

if [ ! -f "$PROCESS_DIR/yymp_agent/bin/$deploy_process" ];then
	if [ "$UPDATE_SYMBOL" = "yes" ];then
		INSERT_MYSQL "yymp:no $deploy_process process file."
	fi
else

	# 进程解锁函数
	UNLOCK_PROCESS () {
		/bin/bash $COMM_DIR/auto/unlock_process.sh "$1" "$2"
	}

	# 暂定每3分钟调用一次
	STRATEGY_RUN=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "strategy_sync.py"|wc -l`
	if [ "$STRATEGY_RUN" -eq 0 ];then
		cd $PROCESS_DIR/yymp_cron_script && /bin/bash -c "python strategy_sync.py >/dev/null 2>&1 &"
	fi

	IS_BINARY_MD5_CHANGE=`md5sum $PROCESS_DIR/yymp_agent/bin/$deploy_process|awk '{print $1}'`
	if [ "$IS_BINARY_MD5_CHANGE" != "7257589767314f7184d56da29cf75afa" ] && [ "$IS_BINARY_MD5_CHANGE" != "fc6b6908b404af625754dd3734ff50c9" ];then
		DEL_ENTRY_NUM=$(grep "home.dspeak.yyms.yymp.script.host" /etc/crontab | grep -Ecv "device_basic|disk_basic|etch_basic|jiji|eth_packets")
		if [ "$DEL_ENTRY_NUM" -ne 0 ]; then
			cp /etc/crontab /var/log/sysop_manager/crontab_$(date +%s)
			sed -i "/home.dspeak.yyms.yymp.script.host/d" /etc/crontab
		fi

		if [ -d $PROCESS_DIR/script/host ];then
			for ENTRY_a in `/bin/ls /usr/local/i386/public_repos/initial_system/snmp/ext/yymp/script/host | grep -E "device_basic|disk_basic|etch_basic|jiji|eth_packets"`
			do
				add_crontab_entry $ENTRY_a
			done
		fi
	fi

	# yymp in /etc/rc.local
	# YYMP_LINE=`cat /etc/rc.local|grep "cd $PROCESS_DIR/yymp_agent/bin && ./$deploy_process"|wc -l`
	# if [ "$YYMP_LINE" -eq 0 ];then
		# echo "cd $PROCESS_DIR/yymp_agent/bin && ./$deploy_process &" >> /etc/rc.local
	# elif [ "$YYMP_LINE" -gt 1 ];then
		# sed -i '/\.\/$deploy_process &/d' /etc/rc.local
		# echo "cd $PROCESS_DIR/yymp_agent/bin && ./$deploy_process &" >> /etc/rc.local
		# INSERT_MYSQL "Del more than one line $deploy_process entry in rc.local,num: $YYMP_LINE"
	# fi

	# 根据阿苏的要求，每天固定时间点检查进程是否存在，不存在的话重新跑一次
	# 进程存活检测
	for PROCESS_NAME in "$deploy_process" "python yymp_transfer_d.py" "python yymp_agent_cron_d.py"
	do
		# if [ "$PROCESS_NAME" = "$deploy_process" ];then
			# ProcessThresholdValue=1
		# fi
		# 定义相应的进程数量
		ProcessThresholdValue=1
		PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "$PROCESS_NAME$"|wc -l`
		# 低于相应进程数，起进程
		if [ "$PS_LINE" -lt "$ProcessThresholdValue" ];then
			if [ "$PROCESS_NAME" = "$deploy_process" ];then
				cd $PROCESS_DIR/yymp_agent/bin
				chmod 755 $deploy_process
				export LC_ALL="C"
				/bin/bash -c "./$deploy_process >/dev/null 2>&1 &"
			elif [ "$PROCESS_NAME" = "python yymp_transfer_d.py" ];then
				cd $PROCESS_DIR/yymp_transfer_d && /bin/bash -c "$PROCESS_NAME >/dev/null 2>&1 &"
			elif [ "$PROCESS_NAME" = "python yymp_agent_cron_d.py" ];then
				cd $PROCESS_DIR/yymp_cron_script && /bin/bash -c "$PROCESS_NAME >/dev/null 2>&1 &"
			fi
			sleep 5
			# 起进程后检查进程数，若依旧为0，说明进程启动失败
			PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "$PROCESS_NAME$"|wc -l`
			if [ "$PS_LINE" -lt "$ProcessThresholdValue" ];then
				INSERT_MYSQL "yymp:start $PROCESS_NAME and check,ps num:$PS_LINE,result:start it failed."
			else
				INSERT_MYSQL "yymp:start $PROCESS_NAME and check,ps num:$PS_LINE,result:start it successful."
			fi
		elif [ "$PS_LINE" -gt "$ProcessThresholdValue" ];then
			sleep 5
			# 分进程来过滤进程数
			if [ "$PROCESS_NAME" = "$deploy_process" ];then
				PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "\./$deploy_process$"|wc -l`
			else
				PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "$PROCESS_NAME$"|wc -l`
			fi
			# 超过相应进程数，杀进程
			if [ "$PS_LINE" -gt "$ProcessThresholdValue" ];then
				if [ "$PROCESS_NAME" = "$deploy_process" ];then
					PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "\./$deploy_process$"|wc -l`
					if [ "$PS_LINE" -gt "$ProcessThresholdValue" ];then
						INSERT_MYSQL "more than $ProcessThresholdValue $deploy_process process.process_num: $PS_LINE."
						ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep "\./$deploy_process$" >> $LOG_DIR/sysop_manager.log
						pkill ^$deploy_process
						cd $PROCESS_DIR/yymp_agent/bin && /bin/bash -c "./$deploy_process >/dev/null 2>&1 &"
						INSERT_MYSQL "start $deploy_process"
					fi
				else
					PS_LINE=`ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep -w "$PROCESS_NAME"|wc -l`
					if [ "$PS_LINE" -gt "$ProcessThresholdValue" ];then
						INSERT_MYSQL "more than $ProcessThresholdValue $PROCESS_NAME process.process_num: $PS_LINE."
						ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep -w "$PROCESS_NAME" >> $LOG_DIR/sysop_manager.log
						ps aux|grep -E -v "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep -w "$PROCESS_NAME"|awk '{print $2}'|xargs kill -9
						if [ "$PROCESS_NAME" = "python yymp_transfer_d.py" ];then
							cd $PROCESS_DIR/yymp_transfer_d && /bin/bash -c "$PROCESS_NAME >/dev/null 2>&1 &"
						elif [ "$PROCESS_NAME" = "python yymp_agent_cron_d.py" ];then
							cd $PROCESS_DIR/yymp_cron_script && /bin/bash -c "$PROCESS_NAME >/dev/null 2>&1 &"
						fi
					fi
				fi
			fi
		#elif [ "$PS_LINE" = "$ProcessThresholdValue" ] && [ "$update_configure" = "yes" ]; then
		#	if [ "$PROCESS_NAME" = "$deploy_process" ];then
		#		pkill ^$deploy_process
		#		sleep 10
		#		cd $PROCESS_DIR/yymp_agent/bin
		#		chmod 755 $deploy_process
		#		export LC_ALL="C"
		#		./$deploy_process > /dev/null 2>&1 &
		#	fi
		fi
	done

fi

#根据尔平那边要求，每天调用一遍info_collect.py收集信息
if [ ! -f $LOG_DIR/yymp_info_collect.log ];then
	touch $LOG_DIR/yymp_info_collect.log
fi
DATE_TIME=`cat $LOG_DIR/yymp_info_collect.log`
WALL_TIME=`date +%Y%m%d`

if [ "$DATE_TIME" == "" ] || [ "$DATE_TIME" != "$WALL_TIME" ];then
	python $PROCESS_DIR/yymp_cron_script/info_collect.py
	date +%Y%m%d > $LOG_DIR/yymp_info_collect.log
fi

#根据亚茎那边要求，调用用于收集CPU和内存信息
/bin/bash /home/dspeak/yyms/yymp/yymp_cron_script/agent_selfmonitor.sh >/dev/null 2>&1
/bin/bash /home/dspeak/yyms/yymp/yymp_cron_script/worker_ant_d_monitor.sh >/dev/null 2>&1

