#!/bin/bash
#Date:2011-10-18
#Written by manifold.
#Readme:check process's runtime.if process locked,kill it.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# basic define
BASENAME=`basename $0`
SHORT_NAME=unlock_process
LOG_DIR=/var/log/sysop_manager

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME

# get ip address 
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi  

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

# define insert alert function
INSERT_MYSQL () {
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

# fetch parameters.
if [ -z "$2" ];then
	echo "parameter error,exit"
	exit 1
else
	PROCESS_NAME=$1
	TRIGGER_TIME=$2
fi

# check process locked or not.
for PID in `ps aux|grep -v -E "grep|$0|mysql|tail|cat|vi|ssh -p32200 -f"|grep -E "$PROCESS_NAME"|awk '{print $2}'`
do
	PROCESS_JIFFIES=`cat /proc/$PID/stat | cut -d" " -f22`
	SYSTEM_UPTIME=`grep btime /proc/stat | cut -d" " -f2`
	PROCESS_START_SEC=$(( $SYSTEM_UPTIME + $PROCESS_JIFFIES / 100 ))
	NOW_SEC=`date -u --date 'now' "+%s"`
	PROCESS_RUN_SEC=$(( $NOW_SEC - $PROCESS_START_SEC ))
	# if process locked more than $TRIGGER_TIME seconds,kill the process.
	if [ "$PROCESS_RUN_SEC" -gt "$TRIGGER_TIME" ];then
		INSERT_MYSQL "Have found process PID:$PID,PROCESS:$PROCESS_NAME locked $PROCESS_RUN_SEC seconds,kill it."
		ps aux|awk '{if($2~/'"$PID"'/) print}' >> $LOG_DIR/sysop_manager.log
		kill -9 $PID
	else
		echo "unlock_process.sh: PID:$PID,PROCESS:$PROCESS_NAME have runned $PROCESS_RUN_SEC already."
	fi
done
