#!/bin/bash
#Date:2011-06-18
#Written by manifold.
#Readme:iptables for secure.
#Change:2011-10-24
#Readme:gotoӿٶȡ

REPOS_NAME=comm_repos
source /usr/local/i386/$REPOS_NAME/auto/function.sh
noblock_lock
trap "noblock_unlock;" 0 1 2 9 15
export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# check linux version
cat /etc/issue|grep -E "CentOS|Red" && LINUX_VERSION="centos"
cat /etc/issue|grep -E "Ubuntu|Debian" && LINUX_VERSION="ubuntu"
if [ "$LINUX_VERSION" = "" ];then exit 1;fi

# basic define
BASENAME=$(basename $0)
COMM_DIR=/usr/local/i386/$REPOS_NAME

# define insert alert function
INSERT_MYSQL () {
	/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

IPTABLES_DIRECTORY=/usr/local/virus/iptables

if [ ! -f $IPTABLES_DIRECTORY/iptables.allow ];then
	INSERT_MYSQL "no iptables.allow file,exit now."
	exit 1
fi

IPTABLES="/sbin/iptables"

############################
# ֻiptables filter  #
############################
$IPTABLES -F
$IPTABLES -X
$IPTABLES -Z

#######################################
# ֻfilterĬ϶ACCEPT  #
#######################################
$IPTABLES -P INPUT ACCEPT
$IPTABLES -P OUTPUT ACCEPT
$IPTABLES -P FORWARD ACCEPT

###############################################################################
# ſػںͱӣ´λذĹ  #
###############################################################################
$IPTABLES -A INPUT -i lo -j ACCEPT
$IPTABLES -A INPUT -p ALL -m state --state ESTABLISHED,RELATED -j ACCEPT

################################################################
# άصĶ˿ںicmpߵ/etc/is_yygameļ #
# 873ſߵinput                     #
################################################################
$IPTABLES -N PING_CHAIN
$IPTABLES -N GO_CHAIN

# ssh,rsync˿ڷڶGO_CHAIN
test_dept_game && multi_port="32200,10029:10040" || multi_port="32200,873,10029:10040"
$IPTABLES -A INPUT -p tcp -m multiport --destination-port $multi_port -g GO_CHAIN
$IPTABLES -A INPUT -p icmp -j PING_CHAIN

#ԺԸÿһͬҵ񣬵Ӧģ
[ -s $IPTABLES_DIRECTORY/iptables.model ] && \
	/bin/bash $IPTABLES_DIRECTORY/iptables.model

################################################################################
# /etc/is_yygameڣƵĻҪǱߵiptables perl  #
# ЩĲܸiptablesĶ(iptables -F)ᱻ  #
# ²ͣ                                                           #
################################################################################
test_dept_game && test -s /data/sa/iptables_real.pl && perl /data/sa/iptables_real.pl

#################################
# ҵԶiptables  #
#################################
if [ -f $IPTABLES_DIRECTORY/iptables.add ];then
	cd $IPTABLES_DIRECTORY
	/bin/bash $IPTABLES_DIRECTORY/iptables.add
fi

# deny list and allow list ip address
for IPTABLES_FILE in $IPTABLES_DIRECTORY/iptables.deny $IPTABLES_DIRECTORY/iptables.allow
do

	# judge file and policy is accept or drop.
	if [ "$IPTABLES_FILE" = "$IPTABLES_DIRECTORY/iptables.deny" ];then
		POLICY="DROP"
	elif [ "$IPTABLES_FILE" = "$IPTABLES_DIRECTORY/iptables.allow" ];then
		POLICY="ACCEPT"
	fi

	# if file exist,add some relate rule.
	if [ -f $IPTABLES_FILE ]; then
		/bin/cat $IPTABLES_FILE|grep -vE '^#|^$' | while read IP_ADDRESS PORT_STRING_1 PORT_STRING_2 PORT_STRING_3
		do
			for NUM in `seq 1 3`
			do
				PORT_STRING_NUM=PORT_STRING_"$NUM"
				PORT_STRING=${!PORT_STRING_NUM}
				if [ "$PORT_STRING" != "" ];then
					PROTOCAL=`echo $PORT_STRING|awk -F ':' '{print $1}'`
					if [ "$PROTOCAL" = "icmp" ];then
						$IPTABLES -A PING_CHAIN -p icmp -s $IP_ADDRESS -j $POLICY
					else
						PORT=`echo $PORT_STRING|awk -F '(tcp:)|(udp:)|(icmp)' '{print $2}'`
						if [ "$PORT" = "32200,873,10029:10040" ];then
							CHAIN="GO_CHAIN"
						else
							CHAIN="INPUT"
						fi
						[ ! -z "$PORT" ] && $IPTABLES -A $CHAIN -p $PROTOCAL -s $IP_ADDRESS -m multiport --destination-port $PORT -j $POLICY
					fi
				fi
			done
			if [ "$PORT_STRING_1" = "" ];then
				# Ϊ32200˿ݱGO_CHAINGO_CHAINԼⲿҪ
				$IPTABLES -A INPUT -p all -s $IP_ADDRESS -j $POLICY
				$IPTABLES -A GO_CHAIN -p all -s $IP_ADDRESS -j $POLICY
			fi
		done
	fi

	# unset variable
	unset IP_ADDRESS PORT_STRING_1 PORT_STRING_2 PORT_STRING_3

done

# GO_CHAINеĬϹ -- DROP
$IPTABLES -A GO_CHAIN -p tcp -m multiport --destination-port 32200,873,10029 -j DROP

# Ҫһ
$IPTABLES -I INPUT -p ALL -s 121.14.36.27 -j ACCEPT

$IPTABLES -L -n |wc -l > /var/log/sysop_manager/mon_secure.log

INSERT_MYSQL "refresh iptables."

exit 0
