#!/bin/bash
#Date:2011-06-18
#Written by manifold.
#Readme:iptables for secure.
#Change:2011-10-24
#Readme:gotoӿٶȡ

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# check linux version
cat /etc/issue|grep -E "CentOS|Red" && LINUX_VERSION="centos"
cat /etc/issue|grep -E "Ubuntu" && LINUX_VERSION="ubuntu"
if [ "$LINUX_VERSION" = "" ];then exit 1;fi

# basic define
BASENAME=`basename $0`
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME

# define insert alert function
INSERT_MYSQL () {
	/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

IPTABLES_DIRECTORY=/usr/local/virus/iptables

if [ ! -f $IPTABLES_DIRECTORY/iptables.allow ];then
	INSERT_MYSQL "no iptables.allow file,exit now."
	exit 1
fi

# if there is no iptables.sh script running,refresh iptables rule,or exit.
# because of subshell problem,IPTABLES_PROCESS_LINE will be 2.
IPTABLES_PROCESS_LINE=`ps aux|grep -v grep|grep "bash.*iptables.sh"|grep -v '/bin/bash ./iptables.sh'|grep -v 'sh -c'|wc -l`
if [ "$IPTABLES_PROCESS_LINE" -gt 2 ];then
	LOG_DIR=/var/log/sysop_manager
	ps aux|grep -v grep|grep "bash.*iptables.sh" >> $LOG_DIR/sysop_manager.log
	INSERT_MYSQL "found iptables.sh running,exit now."
	exit 1
fi

IPTABLES="/sbin/iptables"

$IPTABLES -F
$IPTABLES -X
$IPTABLES -Z

$IPTABLES -P INPUT ACCEPT
$IPTABLES -P OUTPUT ACCEPT
$IPTABLES -P FORWARD ACCEPT

$IPTABLES -A INPUT -i lo -j ACCEPT
$IPTABLES -A INPUT -p ALL -m state --state ESTABLISHED,RELATED -j ACCEPT

# һµGO_CHAIN(iptables -X)
$IPTABLES -N PING_CHAIN
$IPTABLES -N GO_CHAIN

# ssh,rsync˿ڷڶGO_CHAIN
$IPTABLES -A INPUT -p tcp -m multiport --destination-port 32200,873,10029:10040 -g GO_CHAIN
$IPTABLES -A INPUT -p icmp -j PING_CHAIN

#ԺԸÿһͬҵ񣬵Ӧģ
if [ -f $IPTABLES_DIRECTORY/iptables.model ];then
	
	/bin/bash $IPTABLES_DIRECTORY/iptables.model
fi

# ûԶ(Ҫһѹ)
if [ -f $IPTABLES_DIRECTORY/iptables.add ];then
	#ILLEGAL_LINE=`cat $IPTABLES_DIRECTORY/iptables.add|grep -v -E "port"|wc -l`
	#if [ "$ILLEGAL_LINE" -gt 0 ];then
	#	INSERT_MYSQL "illegal line in iptables.add,please check."
	#	exit 2
	#else
		# ·ԣֱenter·
		cd $IPTABLES_DIRECTORY
		/bin/bash $IPTABLES_DIRECTORY/iptables.add
	#fi
fi

# deny list and allow list ip address
for IPTABLES_FILE in $IPTABLES_DIRECTORY/iptables.deny $IPTABLES_DIRECTORY/iptables.allow
do

	# judge file and policy is accept or drop.
	if [ "$IPTABLES_FILE" = "$IPTABLES_DIRECTORY/iptables.deny" ];then
		POLICY="DROP"
	elif [ "$IPTABLES_FILE" = "$IPTABLES_DIRECTORY/iptables.allow" ];then
		POLICY="ACCEPT"
	fi
	
	# if file exist,add some relate rule.
	if [ -f $IPTABLES_FILE ]; then
		/bin/cat $IPTABLES_FILE|grep -vE '^#|^$' | while read IP_ADDRESS PORT_STRING_1 PORT_STRING_2 PORT_STRING_3
		do
			for NUM in `seq 1 3`
			do
				PORT_STRING_NUM=PORT_STRING_"$NUM"
				PORT_STRING=${!PORT_STRING_NUM}
				if [ "$PORT_STRING" != "" ];then
					PROTOCAL=`echo $PORT_STRING|awk -F ':' '{print $1}'`
					if [ "$PROTOCAL" = "icmp" ];then
						$IPTABLES -A PING_CHAIN -p icmp -s $IP_ADDRESS -j $POLICY
					else
						PORT=`echo $PORT_STRING|awk -F '(tcp:)|(udp:)|(icmp)' '{print $2}'`
						if [ "$PORT" = "32200,873,10029:10040" ];then
							CHAIN="GO_CHAIN"
						else
							CHAIN="INPUT"
						fi
						[ ! -z "$PORT" ] && $IPTABLES -A $CHAIN -p $PROTOCAL -s $IP_ADDRESS -m multiport --destination-port $PORT -j $POLICY
					fi
				fi
			done
			if [ "$PORT_STRING_1" = "" ];then
				# Ϊ32200˿ݱGO_CHAINGO_CHAINԼⲿҪ
				$IPTABLES -A INPUT -p all -s $IP_ADDRESS -j $POLICY
				$IPTABLES -A GO_CHAIN -p all -s $IP_ADDRESS -j $POLICY
			fi
		done
	fi

	# unset variable
	unset IP_ADDRESS PORT_STRING_1 PORT_STRING_2 PORT_STRING_3
	
done

# GO_CHAINеĬϹ -- DROP
$IPTABLES -A GO_CHAIN -p tcp -m multiport --destination-port 32200,873,10029 -j DROP

# configure conntrack num.
if [ "$LINUX_VERSION" = "ubuntu" ];then
	sysctl -w net.netfilter.nf_conntrack_max=655360
else
	echo 655360 > /proc/sys/net/ipv4/ip_conntrack_max
fi

# Ҫһ
$IPTABLES -I INPUT -p ALL -s 121.14.36.27 -j ACCEPT

$IPTABLES -L -n |wc -l > /var/log/sysop_manager/mon_secure.log

INSERT_MYSQL "refresh iptables."
