#!/bin/bash
#Date:2011-02-16
#Written by manifold.
#Readme:web api protect.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

IPTABLES="/sbin/iptables"

$IPTABLES -F
$IPTABLES -X
$IPTABLES -Z

$IPTABLES -P INPUT ACCEPT
$IPTABLES -P OUTPUT ACCEPT
$IPTABLES -P FORWARD ACCEPT

$IPTABLES -A INPUT -i lo -j ACCEPT
$IPTABLES -A INPUT -p ALL -m state --state ESTABLISHED,RELATED -j ACCEPT

# allow list ip address
ALLOW_LIST () {
(
cat <<'EOF'
222.88.95.224
61.54.27.224
122.141.244.42
61.164.142.165
EOF
)
}

for ALLOW_IP in `ALLOW_LIST`
do
	$IPTABLES -A INPUT -s $ALLOW_IP -j ACCEPT
done

# recent rule
$IPTABLES -A INPUT -p tcp --dport 80 -m state --state NEW -m recent --name webprobe --update --seconds 40 --hitcount 20 --rttl -j DROP
$IPTABLES -A INPUT -p tcp --dport 80 -m state --state NEW -m recent --name webprobe --set -j ACCEPT
