#!/bin/bash
#Change:2010-08-18
#Readme:add monitor server's ip address.
#Change:2010-08-31
#Readme:add process running check,add version check,add user check.
#Change:2010-09-01
#Readme:add policy for ssh,smokeping,snmp,rsync
#Change:2010-09-03
#Readme:all changed...
#Change:2010-09-05
#Readme:add smokeping policy.
#Change:2010-11-03
#Readme:change for platform.

export PATH=/usr/kerberos/sbin:/usr/kerberos/bin:/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin:/root/bin


# error print method
# for USER_TTY in `w|tail -n +3|awk '{print $2}'`;do echo -e "\ntest" > /dev/$USER_TTY;done

# enter directory
# cd /home/dspeak/iptables
cd `dirname $0`

# input chain: snmp,rsync,smokeping,ssh
# -------------------------------------------------------------------------------------------------------------

if [ -f /usr/local/i386/comm_repos/iptables/iptables.allow ]; then

iptables -F
iptables -X
iptables -Z

iptables -P INPUT ACCEPT
iptables -P OUTPUT ACCEPT
iptables -P FORWARD ACCEPT

iptables -A INPUT -i lo -j ACCEPT
iptables -A INPUT -p ALL -m state --state ESTABLISHED,RELATED -j ACCEPT

# Accept the host that write in iptables.allow.
# iptables更新部分改由platform操作
for ip in `cat /usr/local/i386/comm_repos/iptables/iptables.allow | grep -v ^# | awk -F '|' '{print $2}'`
do
    iptables -A INPUT -s $ip -j ACCEPT
done

iptables -A INPUT -p TCP -m multiport --dport 32200 -j DROP

fi

# -------------------------------------------------------------------------------------------------------------


# raw chain
iptables -t raw -F
iptables -t raw -X
iptables -t raw -Z


# *************************************************************************************************************

# raw new chain for icmp filter
iptables -t raw -N ICMP_FILTER

if [ -f /usr/local/i386/comm_repos/iptables/iptables.allow ]; then
    unset ip
    for ip in `cat /usr/local/i386/comm_repos/iptables/iptables.allow | grep -v ^# | awk -F '|' '{print $2}'`
    do
		iptables -t raw -A ICMP_FILTER -s $ip -j ACCEPT
    done
	iptables -t raw -A ICMP_FILTER -s 58.221.38.147 -j ACCEPT
	iptables -t raw -A ICMP_FILTER -j DROP
else
	iptables -t raw -A ICMP_FILTER -s 58.221.38.147 -j ACCEPT
	iptables -t raw -A ICMP_FILTER -j DROP
fi

# *************************************************************************************************************


GET_ICMP_ATTACK=0

while : ;do

		# inside iptables policy
        echo "TIME1 `date +%Y%m%d-%T`" 

        > current_syn_attack_port
        > port_string
        > no_attack_port

        iptables -t raw -I PREROUTING 1 -p tcp --syn -m statistic --mode nth --every 1000 -j LOG --log-prefix "IPTABLES DETECTING SYN: "
        iptables -t raw -I PREROUTING 1 -p icmp -m statistic --mode nth --every 300 -j LOG --log-prefix "IPTABLES DETECTING ICMP: "

        sleep 1

        iptables -t raw -D PREROUTING 1
        iptables -t raw -D PREROUTING 1

        cat /var/log/iptables.log | grep "IPTABLES DETECTING SYN" | tail -n +3 | awk -F "DPT=" '{print $2}' | awk '{print $1}' | sort -n | uniq  > current_syn_attack_port
        ICMP_LOG_NUM=`cat /var/log/iptables.log | grep "IPTABLES DETECTING ICMP" | wc -l`
        echo -e "ICMP_LOG_NUM: \033[31;40;1m$ICMP_LOG_NUM\033[0m"
        if [ "$ICMP_LOG_NUM" -gt 2 ];then
                echo -e "\033[31;40;1mexist ICMP attack\033[0m"
                if [ "$GET_ICMP_ATTACK" -eq 0 ];then
                        iptables -t raw -A PREROUTING -p icmp -g ICMP_FILTER
						# iptables -t raw -A PREROUTING -p icmp -s 58.221.38.147 -j ACCEPT
                        # iptables -t raw -A PREROUTING -p icmp -j DROP
                        GET_ICMP_ATTACK=1
                fi
        else
                echo -e "\033[32;40;1mno ICMP attack now!!!\033[0m"
                if [ "$GET_ICMP_ATTACK" -eq 1 ];then
						iptables -t raw -D PREROUTING -p icmp -g ICMP_FILTER
                        # iptables -t raw -D PREROUTING -p icmp -s 58.221.38.147 -j ACCEPT
                        # iptables -t raw -D PREROUTING -p icmp -j DROP
                        GET_ICMP_ATTACK=0
                fi
        fi

        if [ -s current_syn_attack_port ];then

                for PORT in `cat current_syn_attack_port`
                do
                        #DROP
                        echo -e "\033[31;40;1mexist SYN ATTACK on $PORT\033[0m"
                        SYN_LOG_NUM=`cat /var/log/iptables.log | grep "IPTABLES DETECTING SYN" | wc -l`
                        echo -e "SYN_LOG_NUM: \033[31;40;1m$SYN_LOG_NUM\033[0m"

                        exist=`iptables -t raw -L -n | grep "tcp dpt:$PORT" | grep "flags:0x17/0x02" | wc -l`

                        if [ "$exist" -eq 0 ];then
                                echo -e "\033[31;40;1madd\033[0m into iptables"
                                iptables -t raw -A PREROUTING -p tcp --syn --dport $PORT -j DROP
                        else
                                echo "PORT $PORT already exist in iptables"
                        fi

                        #FOR RECOVER
                        if [ ! -s port_string ];then
                                echo -n "dpt:$PORT" >> port_string
                        else
                                echo -n "\|dpt:$PORT" >> port_string
                        fi
                done
        fi

        #RECOVER
        ATTACK_PORTS=`cat port_string`
        if [ "$ATTACK_PORTS" != "" ];then
                echo -e "current attacked ports: \033[31;40;1m$ATTACK_PORTS\033[0m"

                iptables -t raw -L -n | grep DROP | grep -v "$ATTACK_PORTS" | grep -v icmp | grep -v length | awk -F "dpt:" '{print $2}' | awk '{print $1}' > no_attack_port
                if [ -s no_attack_port ];then
                        for OTHERPORT in `cat no_attack_port`
                        do
                                echo -e "\033[32;40;1mdelete\033[0m no attack port $OTHERPORT from iptables"
                                iptables -t raw -D PREROUTING -p tcp --syn --dport $OTHERPORT -j DROP
                        done
                fi
        else
                echo -e "\033[32;40;1mNO SYN attack now!!!\033[0m";
                iptables -t raw -L -n | grep DROP | grep -v icmp | grep -v length  | awk -F "dpt:" '{print $2}' | awk '{print $1}' > no_attack_port
                if [ -s no_attack_port ];then
                        for OTHERPORT in `cat no_attack_port`
                        do
                                echo -e "\033[32;40;1mdelete\033[0m no attack port $OTHERPORT from iptables"
                                iptables -t raw -D PREROUTING -p tcp --syn --dport $OTHERPORT -j DROP
                        done
                fi
        fi

		echo -e "TIME2 `date +%Y%m%d-%T`\n" 
		> /var/log/iptables.log
        sleep 1
done
