#!/bin/bash
#Date:2010-10-12
#Written by manifold.
#Readme:monitor the system's bandwidth.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# define alarm tool
#SEND="SEND:1"
SEND=""

# help function
PRINT_HELP () {
        echo
        echo "Usage: ./$0 -w VALUE1 -c VALUE2"
        echo
        echo "Options:"
		echo "        -d eth0/eth1"
		echo "        -i in"
		echo "        -o out"
        echo "        -w warnning value"
        echo "        -c critical value"
        echo
}

# none parameter
if [ -z "$1" ];then
        PRINT_HELP
        exit 1
fi

while [ -n "$1" ]; do
    case "$1" in
		-d)
			DEV=$2
			shift
			;;
		-i)
			IN_OR_OUT="in"
			;;
		-o)
			IN_OR_OUT="out"
			;;
        -w)
            WARN=$2
            shift
            ;;
        -c)
            CRIT=$2
            shift
            ;;
        *)
            echo
            echo "Unknown argument: $1"
            PRINT_HELP
            exit 1
            ;;
        esac
    shift
done

# in
a_in=`grep $DEV /proc/net/dev|awk -F: '{print $2}'|awk '{print $1}'`
sleep 3
b_in=`grep $DEV /proc/net/dev|awk -F: '{print $2}'|awk '{print $1}'`

# out
a_out=`grep $DEV /proc/net/dev|awk -F: '{print $2}'|awk '{print $9}'`
sleep 3
b_out=`grep $DEV /proc/net/dev|awk -F: '{print $2}'|awk '{print $9}'`

# calculate value
c_in=`expr $b_in - $a_in`
d_in=`expr "$c_in" / 1024 / 1024 / 3 \* 8`

c_out=`expr $b_out - $a_out`
d_out=`expr "$c_out" / 1024 / 1024 / 3 \* 8`

# judge bandwidth
if [ "$d_in" -gt 600 ] || [ "$d_out" -gt 600 ];then
	echo "Critical: IN=$d_in Mbps, OUT=$d_out Mbps $SEND"
	exit 2
elif [ "$d_in" -gt 500 ] || [ "$d_out" -gt 500 ];then
	echo "Warnning: IN=$d_in Mbps, OUT=$d_out Mbps $SEND"  
	exit 1
else
	echo "OK: IN=$d_in Mbps, OUT=$d_out Mbps"
	exit 0
fi
