#!/bin/bash
#Date:2010-10-12
#Written by manifold.
#Readme:monitor the system disk space.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# define alarm tool
SEND="SEND:2"

# help function
PRINT_HELP () {
	echo
	echo "Usage: $0 -w VALUE1 -c VALUE2"
	echo
	echo "Options:"
	echo "        -w warnning value"
	echo "        -c critical value"
	echo
}

# none parameter
if [ -z "$1" ];then
	PRINT_HELP
	exit 1
fi

while [ -n "$1" ]; do
    case "$1" in
        -w)
            WARN=$2
            shift
            ;;
        -c)
            CRIT=$2
            shift
            ;;
        *)
            echo
			echo "Unknown argument: $1"
			PRINT_HELP
            exit 1
            ;;
        esac
    shift
done

# 屏蔽外部提交参数，从内部直接定义warning和critical值

# 磁盘空间监控
WARN=$WARN
CRIT=$CRIT

LINE_W=`df -lh|grep -vE "Filesystem|nfsroot"|tr -d \%|awk '{if($5>'"$WARN"') print}'|awk '{print $NF" no space "$5"%"}'|wc -l`
LINE_C=`df -lh|grep -vE "Filesystem|nfsroot"|tr -d \%|awk '{if($5>'"$CRIT"') print}'|awk '{print $NF" no space "$5"%"}'|wc -l`

LINE_W_LVM=`df -lh|grep -vE "Filesystem|nfsroot"|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>'"$WARN"') print}'|wc -l`
LINE_C_LVM=`df -lh|grep -vE "Filesystem|nfsroot"|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>'"$CRIT"') print}'|wc -l`

# 磁盘inode监控
I_WARN=$WARN
I_CRIT=$CRIT

I_LINE_W=`df -li|grep -vE "Filesystem|nfsroot"|tr -d \%|awk '{if($5>'"$WARN"') print}'|awk '{print $NF" no space "$5"%"}'|wc -l`
I_LINE_C=`df -li|grep -vE "Filesystem|nfsroot"|tr -d \%|awk '{if($5>'"$CRIT"') print}'|awk '{print $NF" no space "$5"%"}'|wc -l`

I_LINE_W_LVM=`df -li|grep -vE "Filesystem|nfsroot"|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>'"$I_WARN"') print}'|wc -l`
I_LINE_C_LVM=`df -li|grep -vE "Filesystem|nfsroot"|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>'"$I_CRIT"') print}'|wc -l`


if [ "$LINE_C_LVM" -gt 0 ] || [ "$I_LINE_C_LVM" -gt 0 ];then
	if [ "$LINE_C_LVM" -gt 0 ];then
		df -lh|grep -v Filesystem|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>'"$CRIT"') print $1" no space "$2"%"}'|sed -e 's/$/ '"${SEND}"'/g'
	fi
	if [ "$I_LINE_C_LVM" -gt 0 ];then
		df -li|grep -v Filesystem|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>'"$I_CRIT"') print $1" no inode "$2"%"}'|sed -e 's/$/ '"${SEND}"'/g'
	fi
	exit 2
elif [ "$LINE_W_LVM" -gt 0 ] || [ "$I_LINE_W_LVM" -gt 0 ];then
	if [ "$LINE_W_LVM" -gt 0 ];then
		df -lh|grep -v Filesystem|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>'"$WARN"') print $1" no space "$2"%"}'|sed -e 's/$/ '"${SEND}"'/g'
	fi
	if [ "$I_LINE_W_LVM" -gt 0 ];then
		df -li|grep -v Filesystem|tr -d \%|awk '{print $NF,$(NF-1)}'|grep -v lvm|awk '{if($2>'"$I_WARN"') print $1" no inode "$2"%"}'|sed -e 's/$/ '"${SEND}"'/g'
	fi
	exit 1
else
	df -lh|grep -v Filesystem|awk '{print $NF,$(NF-1)}'|tr '\n' ' '
	# df -li|grep -v Filesystem|awk '{print $NF,$(NF-1)}'|tr '\n' ' '
	exit 0
fi

