#!/bin/bash
#Date:2010-10-16
#Written by manifold.
#Readme:monitor the system load.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# define alarm tool
#SEND="SEND:1"
SEND=""

# help function
PRINT_HELP () {
	echo
	echo "Usage: $0 -w VALUE1 -c VALUE2"
	echo
	echo "Options:"
	echo "        -w warnning value"
	echo "        -c critical value"
	echo
}

# none parameter
if [ -z "$1" ];then
	PRINT_HELP
	exit 1
fi

while [ -n "$1" ]; do
    case "$1" in
        -w)
            WARN=$2
            shift
            ;;
        -c)
            CRIT=$2
            shift
            ;;
        *)
            echo
			echo "Unknown argument: $1"
			PRINT_HELP
            exit 1
            ;;
        esac
    shift
done

# ȡ澯ֵ
W1=`echo $WARN|awk -F ',' '{print $1}'`
W2=`echo $WARN|awk -F ',' '{print $2}'`
W3=`echo $WARN|awk -F ',' '{print $3}'`

C1=`echo $CRIT|awk -F ',' '{print $1}'`
C2=`echo $CRIT|awk -F ',' '{print $2}'`
C3=`echo $CRIT|awk -F ',' '{print $3}'`

# ȡǰϵͳ
NOW=`w|grep "load average"|awk -F ':' '{print $NF}'`

N1=`echo $NOW|awk -F ',' '{print $1}'|awk -F . '{print $1}'`
N2=`echo $NOW|awk -F ',' '{print $2}'|awk -F . '{print $1}'`
N3=`echo $NOW|awk -F ',' '{print $3}'|awk -F . '{print $1}'`

# OK - load average: 3.62, 3.52, 3.58 
# WARNING - load average: 15.37, 15.06, 15.49 

if [ "$N1" -gt "$C1" ] && [ "$N2" -gt "$C2" ] && [ "$N3" -gt "$C3" ];then
	echo "CRITICAL - load average: $NOW $SEND"
	exit 2
elif [ "$N1" -gt "$W1" ] && [ "$N2" -gt "$W2" ] && [ "$N3" -gt "$W3" ];then
	echo "WARNING - load average: $NOW $SEND"
	exit 1
else
	echo "OK - load average: $NOW"
	exit 0
fi
