#!/bin/bash
#Date:2011-04-12
#Written by manifold.
#Readme:empty log automatic.
#Date:2013-03-04
#增加OOM报警

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
exit 0

# if not a ubuntu system,exit.
cat /etc/issue|grep -E "Ubuntu" || exit 1

df -lh |grep -i lvm && exit 1

WARN=85

LINE_W=`df -lh|grep -v Filesystem|tr -d \%|awk '{if($5>'"$WARN"') print $NF,$5}'|wc -l`

if [ "$LINE_W" -gt 0 ];then
	df -lh|grep -v Filesystem|tr -d \%|awk '{if($5>'"$WARN"') print $NF}'|grep -w '/'
	if [ "$?" -eq 0 ];then
		cat /dev/null > /var/log/messages
		cat /dev/null > /var/log/syslog
		cat /dev/null > /var/log/user.log
		cat /dev/null > /var/log/debug
		find /home/dspeak/release/bin/old_jifen/ -type f -mtime +7 -exec rm -fr {} \;
	fi

	df -lh|grep -v Filesystem|tr -d \%|awk '{if($5>'"$WARN"') print $NF}'|grep -w '/data'
	if [ "$?" -eq 0 ];then
		# find /data/yy/log -type f -mtime +30 -exec rm -fr {} \;
		echo "disk problem in /data."
	fi
fi

function warn_oom_killer () {
	LOG_MARK=/var/log/sysop_manager/hardware.mark
	
	function oom_killer_file () {
		[[ -s $1 ]] && check_file=$1 || return 1;
		MARK=$2
		
		NOW_LINE_NUM=`wc -l $check_file`;NOW_LINE_NUM=`echo ${NOW_LINE_NUM% *}`;
		OLD_LINE_NUM=`grep -w "$MARK" $LOG_MARK |tail -n1`;OLD_LINE_NUM=`echo ${OLD_LINE_NUM#* }`
		eval "sed -i "/$MARK.*/d" $LOG_MARK"
		echo "$MARK $NOW_LINE_NUM" >> $LOG_MARK
		
		[[ "$OLD_LINE_NUM" == "" ]] && return 1;
		[[ $OLD_LINE_NUM -gt $NOW_LINE_NUM ]] && OLD_LINE_NUM=0

		OLD_LINE_NUM=`expr $OLD_LINE_NUM + 1`
		msg_line=`eval "sed -n '$OLD_LINE_NUM,$NOW_LINE_NUM p' $check_file" | grep -iE "Out of memory:" |sort -u | awk '{for(i=1;i<=NF;i++){if($i ~ /oom-kill/){printf("%s\n",$(i-2))}else if($i == "process"){printf("%s\n",$(i+2))}}}'|tr -d "()"|sort -u| tr -s "\n" " "`
		
		if [ "$msg_line" != "" ];then
			/bin/bash /usr/local/i386/*/auto/insert_message.sh "(oom_monitor) 系统发生OOM , 进程 $msg_line 被杀, 日志文件$check_file."
			exit 0
		fi
	}
	
	oom_killer_file "/var/log/kern.log" "oom_killer_kern:"
	oom_killer_file "/var/log/dmesg" "oom_killer_dmesg:"
	oom_killer_file "/var/log/messages" "oom_killer_message:"
	oom_killer_file "/var/log/syslog" "oom_killer_syslog:"

}
#warn_oom_killer
