#!/bin/bash
#Written by wuhaiting
#date 2012-08
#Readme:该脚本在远处管理机上运行，监控openvpn client是否跟server掉线

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

#base define
BASENAME=`basename $0`
SHORT_NAME=mon_openvpn
LOG_DIR=/var/log/sysop_manager
PUBLIC_DIR=/usr/local/i386/public_repos
MGT_VPN_SERVER=$PUBLIC_DIR/initial_system/snmp/ext/mgt_server.log

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME

#stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
	exit 1
fi

# define insert alert function
INSERT_MYSQL () {
#WALL_TIME=`date +%Y-%m-%d:%H-%M-%S`
#echo "$WALL_TIME $1" >> $LOG_DIR/$SHORT_NAME.log
#echo "$1"
/bin/bash $COMM_DIR/auto/insert_message.sh "$BASENAME" "$1"
}

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

SERVER_GATEWAY=192.168.9.1

#检查服务器是否为远程管理机
cat $MGT_VPN_SERVER|grep -v -E "101\.226\.185\.88|140\.207\.209\.88"|grep $IPADDR || exit 1

#server变更IP或client变更key，vpn client自动更新
function check_vpn_server {
	VPN_SERVER=`cat $MGT_VPN_SERVER|grep -w "server"|awk '{print $1}'|wc -l`
	if [ "$?" -ne 1 ];then
		#选择最快的vpn服务器源IP
		unset VPN_SERVER
		b=99900
		while read SERVER_IP
		do
			a=`ping -c1 $SERVER_IP|grep "ttl"|awk '{print $(NF-1)}'|awk -F "=" '{print ($2*100)}'`
			if [ $a -lt $b ];then
				b=$a
				VPN_SERVER=$SERVER_IP
			fi
		done < <(cat $MGT_VPN_SERVER|grep -w "server"|grep -v "grep"|awk '{print $1}')
	fi
	[[ "$VPN_SERVER" == "" ]] && (VPN_SERVER=`cat $MGT_VPN_SERVER|grep -w "server" |tail -n1`)
	CLIENT_ORI=`cat /etc/openvpn/client.conf|grep remote|grep -v -E "^;|^#"|sed '/^$/d'|awk '{print $2}'`
	if [ "$VPN_SERVER" != "$CLIENT_ORI" ];then
		sed -i "s/^remote.*/remote $VPN_SERVER 11940/g" /etc/openvpn/client.conf
	fi
	#后面可能会增加vpn client key的自动更新
	/etc/init.d/openvpn restart
	sleep 3
	ps aux|grep "openvpn"|grep -v -E "grep|mon_openvpn\.sh"
	if [ "$?" -eq 0 ];then
		INSERT_MYSQL "openvpn have been restart successful."
	else
		INSERT_MYSQL "openvpn have been restart fail,check!"
	fi
}

#openvpn重启前需要进行状态判断
function vpn_check_restart {
	ifconfig tun0|grep "192\.168\.9" && TUN=1;
	ps aux |grep openvpn|grep -v grep >/dev/null && VPN=1;
	if [ "$VPN" != "1" ] && [ "$TUN" == "1" ];then
		INSERT_MYSQL "NO openvpn running,but dev:tun0 is running"
	elif [ "$VPN" == "1" ] && [ "$TUN" != "1" ];then
		check_vpn_server
	else
		/etc/init.d/openvpn restart
		sleep 3
		ps aux|grep "openvpn"|grep -v -E "grep|mon_openvpn\.sh"
		if [ "$?" -eq 0 ];then
			INSERT_MYSQL "openvpn have been restart now."
		else
			INSERT_MYSQL "openvpn have been restart fail,check!"
		fi
	fi
}

#通过检查VPN 服务器的网关来判断client是否断线
which fping
if [ "$?" -eq 0 ];then
	fping $SERVER_GATEWAY
	if [ "$?" -ne 0 ];then
		sleep 2
		fping $SERVER_GATEWAY || (vpn_check_restart);
	fi
else
	ping -i0.2 -w2 -c3 $SERVER_GATEWAY
	if [ "$?" -ne 0 ];then
		sleep 2
		ping -i0.2 -w1 -c3 $SERVER_GATEWAY || (vpn_check_restart);
	fi
fi

# client需要删掉10.20.0.0路由，防止client之间相互访问管理接口，造成安全问题
ps aux|grep "openvpn"|grep -v -E "grep|mon_openvpn\.sh" >/dev/null
if [ "$?" -eq 0 ];then
	cat $MGT_VPN_SERVER|grep -v -E "101\.226\.185\.88|140\.207\.209\.88"|grep "$IPADDR.*client" >/dev/null
	if [ "$?" -eq 0 ];then
		route -n|grep "10\.20\.0\.0.*tun0" >/dev/null 2>&1 && route del -net 10.20.0.0/16
		route -n|grep "10\.30\.0\.0.*tun0" >/dev/null 2>&1 && route del -net 10.20.0.0/16
	fi
fi
	
exit 0
