#!/bin/bash
#Date:2011-04-12
#Written by manifold.
#Readme:monitor slab kmalloc-4096
#Change:2011-09-21
#Readme:改发到管理机，不通过接口直接上报。
#Change:2012-05-28
#Readme:做部分修改用于检测1024和4096内存分配是否超标。
#Change:2012-08-20
#Readme:改为只告警，不杀进程。
#Change:2012-08-21
#Readme:关闭此功能后OOM机器数量急剧上升，再将此功能开起来。
exit 1
export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# if not a ubuntu system,exit.
cat /etc/issue|grep -E "Ubuntu" || exit 1

IPADDR=`/sbin/ifconfig|grep Bcast|grep -v "inet addr:192.168"|grep -v "inet addr:172.16"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`

if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

# include list
#cat /usr/local/i386/comm_repos/monitor/sar_dip_no_kill.log | grep -w $IPADDR
# cat /usr/local/i386/comm_repos/monitor/sar_dip.log | grep -w $IPADDR
#if [ "$?" -eq 0 ];then
	/bin/bash /usr/local/i386/comm_repos/monitor/monitor_slab_no_kill.sh &
	exit 1
#fi

cat /usr/local/i386/comm_repos/monitor/sar_dip.log | grep -w $IPADDR || exit 1
if [ "$?" -eq 0 ];then
	/bin/bash /usr/local/i386/comm_repos/monitor/monitor_slab_no_kill.sh &
	exit 1
fi

# 2012-08-20 改为全部跑no kill，若要通过过滤列表的话，把上面那段注释打开即可
#/bin/bash /usr/local/i386/comm_repos/monitor/monitor_slab_no_kill.sh
#exit 1

# 2012-06-29 改判断cache
# cat /usr/local/i386/comm_repos/monitor/all-4gb-host| grep -w $IPADDR
# if [ "$?" -eq 0 ];then
	# IN_LIST="yes"
# fi

# turn off swap
mem_all=`cat /proc/meminfo |grep "MemTotal"|awk '{print $2}'`
if [[ $mem_all -lt 4194304 ]] && [[ $mem_all -gt 3145728 ]];then mem_all=4G;fi

SWAP_LINE=`swapon -s|grep dev|wc -l`
if [[ "$SWAP_LINE" -gt 0 ]] && [[ "$mem_all" != "4G" ]];then
	swapoff -a
	/bin/bash /usr/local/i386/comm_repos/auto/insert_message.sh "$IPADDR:trun off swap"
	wait
fi
if [[ "$SWAP_LINE" == "0" ]] && [[ "$mem_all" == "4G" ]];then
    swapon -a
    /bin/bash /usr/local/i386/comm_repos/auto/insert_message.sh "$IPADDR:trun on swap"
    wait
fi

SS_LOG_TIME=0
if [ ! -d /data/yy/monitor ];then
    mkdir -p /data/yy/monitor
fi
SS_LOG_FILE=/data/yy/monitor/ss.`date +%Y-%m-%d`.log

for TIMES in `seq 1 55`
do
SLEEP=1
# 2012-06-29 改判断cache
# if [ "$IN_LIST" = "yes" ];then
	# VALUE=`awk '{if($1=="kmalloc-4096") printf "%5d MB %s\n", $3*$4/(1024*1024), $1}' < /proc/slabinfo|awk '{if($1>400) print}'`
# else
	# VALUE=`awk '{if($1=="kmalloc-4096") printf "%5d MB %s\n", $3*$4/(1024*1024), $1}' < /proc/slabinfo|awk '{if($1>100) print}'`
# fi
# if [ "$VALUE" = "" ];then
	# VALUE=`awk '{if($1=="kmalloc-2048") printf "%5d MB %s\n", $3*$4/(1024*1024), $1}' < /proc/slabinfo|awk '{if($1>200) print}'`
# fi

VALUE=`cat /proc/meminfo|awk '{if($1~/^Cached:/ && $2<30720) print $2}'`
# if [ "$VALUE" = "" ];then
	# VALUE=`top -bn 1|head -n 5|tr -d '%wa,'|awk '{if($1~/Cpu/ && $6>"2.0") print $6}'`
# fi
if [ "$VALUE" != "" ];then
	DATE=`date +%Y-%m-%d-%T`
	# 2011-03-03 增加ss -nat的log
	if [ "$SS_LOG_TIME" -eq 0 ];then
		uptime >> $SS_LOG_FILE
		ss -nat >> $SS_LOG_FILE
		echo >> $SS_LOG_FILE
		ss \( sport == :6081 or dport == :6081 or sport == :7081 or dport == :7081 or sport == :53 or dport == :53 \)  | sort -k 2,2nr | head -n 20 >> $SS_LOG_FILE
		echo >> $SS_LOG_FILE
		ss -s >> $SS_LOG_FILE
		echo >> $SS_LOG_FILE
		top -bn 1 >> $SS_LOG_FILE
		WA_DATA=`top -bn 1|head -n 5|grep Cpu|awk -F ',' '{print $5}'`
		echo >> $SS_LOG_FILE
		cat /proc/buddyinfo >> $SS_LOG_FILE
		echo >> $SS_LOG_FILE
		SS_LOG_TIME=$TIMES
	elif [ "$TIMES" -gt `expr $SS_LOG_TIME + 20` ];then
		uptime >> $SS_LOG_FILE
		ss -nat >> $SS_LOG_FILE
		echo >> $SS_LOG_FILE
		ss \( sport == :6081 or dport == :6081 or sport == :7081 or dport == :7081 or sport == :53 or dport == :53 \)  | sort -k 2,2nr | head -n 20 >> $SS_LOG_FILE
		echo >> $SS_LOG_FILE
		ss -s >> $SS_LOG_FILE
		echo >> $SS_LOG_FILE
		top -bn 1 >> $SS_LOG_FILE
		WA_DATA=`top -bn 1|head -n 5|grep Cpu|awk -F ',' '{print $5}'`
		echo >> $SS_LOG_FILE
		cat /proc/buddyinfo >> $SS_LOG_FILE
		echo >> $SS_LOG_FILE
		SS_LOG_TIME=$TIMES
	fi

	# 以下操作，并不会杀掉/bin/sh /usr/local/i386/comm_repos/auto/etc_syslog-ng_syslog-ng.conf_and_logrotate.sh
	# pkill -9 ^imlinkd_
	# if [ "$?" -eq 0 ];then
	# 	/bin/bash /usr/local/i386/comm_repos/auto/insert_message.sh "$DATE $IPADDR:$VALUE kill imlinkd_d NEW"
	# fi
	
	# 2012-06-29改杀slave_session
	# ps aux|grep -v grep|grep -v Channel|grep ./slave_session_|awk '{v=$NF;if(a[v]<$4){a[v]=$4;b[v]=$2}}END{for(i=1;i<=asorti(a,d);i++)print b[d[i]]}'|xargs kill -9
	
	NOW_MINUTE=`date +%s`
	if [ ! -f /tmp/monitor_slab.minute.log ];then
		echo "$NOW_MINUTE" > /tmp/monitor_slab.minute.log
	fi
	
	LAST_MINUTE=`cat /tmp/monitor_slab.minute.log`
	
	if [ `expr $NOW_MINUTE - $LAST_MINUTE` -ge 120 ];then
		
		# 2012-09-03 据正显要求，改成不杀media进程
		# for PID in `ps aux|grep -v grep|grep -v Channel|grep ./slave_session_|awk '{v=$NF;if(a[v]<$4){a[v]=$4;b[v]=$2}}END{for(i=1;i<=asorti(a,d);i++)print b[d[i]]}'`
		for PID in `ps aux|grep -v -E "grep|Channel|media"|grep ./slave_session_|awk '{v=$NF;if(a[v]<$4){a[v]=$4;b[v]=$2}}END{for(i=1;i<=asorti(a,d);i++)print b[d[i]]}'`
		do
			BIN_DIR=`readlink /proc/$PID/cwd`
			if [ "$BIN_DIR" != "" ];then
                PROCESS_START_COMMAND=$(ps --no-headers -opid,cmd $PID | cut -d ' ' -f 2-)
				# cd $BIN_DIR && ./slave_session_* &
                cd $BIN_DIR && $PROCESS_START_COMMAND &
				if [ "$?" -eq 0 ];then
					/bin/bash /usr/local/i386/comm_repos/auto/insert_message.sh "$DATE $IPADDR:cache size $VALUE invoke kill slave_session PID:$PID 先起后杀进程成功,wa data:$WA_DATA"
					echo $NOW_MINUTE > /tmp/monitor_slab.minute.log
					kill -9 $PID
				fi
			fi
		done
		
		#ps aux|grep -v grep|grep -v Channel|grep ./slave_session_|awk '{v=$NF;if(a[v]<$4){a[v]=$4;b[v]=$2}}END{for(i=1;i<=asorti(a,d);i++)print b[d[i]]}'|xargs kill -9
		#if [ "$?" -eq 0 ];then
			#/bin/bash /usr/local/i386/comm_repos/auto/insert_message.sh "$DATE $IPADDR:cache size $VALUE invoke kill slave_session 未杀进程"
			#echo $NOW_MINUTE > /tmp/monitor_slab.minute.log
		#fi
		
	fi
fi

sleep $SLEEP
done
