#!/bin/bash
#Date:2011-04-12
#Written by manifold and wuhaiting
#Readme:monitor slab kmalloc-4096
#Change:2011-09-21
#Readme:改发到管理机，不通过接口直接上报。
#Change:2012-05-28
#Readme:做部分修改用于检测1024和4096内存分配是否超标。
#Change:2013-02-28
#Readme:根据连福需求，重写整个脚本

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# if not a ubuntu system,exit.
cat /etc/issue|grep -E "Ubuntu" || exit 1

IPADDR=`/sbin/ifconfig|grep Bcast|grep -v "inet addr:192.168"|grep -v "inet addr:172.16"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`

if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

# turn off swap
#SWAP_LINE=`swapon -s|grep dev|wc -l`
#if [ "$SWAP_LINE" -eq 0 ];then
	#swapon -a
	#/bin/bash /usr/local/i386/comm_repos/auto/insert_message.sh "$IPADDR:trun on swap"
	#wait
#fi

SS_LOG_TIME=0
if [ ! -d /data/yy/monitor ];then
    mkdir -p /data/yy/monitor
fi
SS_LOG_FILE=/data/yy/monitor/ss.`date +%Y-%m-%d`.log

#TotalMEM_8=`cat /proc/meminfo |awk '{if($1 ~ /MemTotal:/){printf("%.f",$2/32)}}'`
TotalMEM_8=65536

MEM_INFO=`awk '{split("MemFree: Buffers: Cached: Active: Inactive: Active(anon): Inactive(anon): Active(file): Inactive(file): SwapFree: Slab: SReclaimable: SUnreclaim:",x," ");for(var in x){a=x[var];if($1 == '"a"'){printf("%s%s ",a,$2)};}}' /proc/meminfo`

SLAB_INFO=`awk '{split("kmalloc-2048 kmalloc-4096",x," ");for(var in x){a=x[var];if($1 == '"a"'){printf("%s:%s ",a,$2)};}}' /proc/slabinfo`

VM_STAT_0=`awk '{split("pgpgin pgpgout pswpin pswpout pageoutrun allocstall pgmajfault kswapd_low_wmark_hit_quickly kswapd_high_wmark_hit_quickly",x," ");for(var in x){a=x[var];if($1 ~ '"a"'){printf("%s:%s ",a,$2)}}}' /proc/vmstat |tr -d "\n"`
low_water_0=`echo ${VM_STAT_0#*kswapd_low_wmark_hit_quickly:}`;low_water_0=`echo ${low_water_0%% *}`;
high_water_0=`echo ${VM_STAT_0#*kswapd_high_wmark_hit_quickly:}`;high_water_0=`echo ${high_water_0%% *}`;


for TIMES in `seq 1 110`;do
	SLEEP=1
	TOTAL_SLEEP=`expr $TOTAL_SLEEP + $SLEEP`
	#记录0,2,4,6,8
	time2=`expr $TOTAL_SLEEP / 10`;
	time2=`expr $TOTAL_SLEEP - 10 \* $time2`
	NOW_TIME=`date +%s`
	
	if [ "`expr $time2 % 2`" == "0" ];then
		VM_STAT_10=`awk '{split("pgpgin pgpgout pswpin pswpout pageoutrun allocstall pgmajfault kswapd_low_wmark_hit_quickly kswapd_high_wmark_hit_quickly",x," ");for(var in x){a=x[var];if($1 ~ '"a"'){printf("%s:%s ",a,$2)}}}' /proc/vmstat |tr -d "\n"`
		low_water_10=`echo ${VM_STAT_10#*kswapd_low_wmark_hit_quickly:}`;low_water_10=`echo ${low_water_10%% *}`;
		high_water_10=`echo ${VM_STAT_10#*kswapd_high_wmark_hit_quickly:}`;high_water_10=`echo ${high_water_10%% *}`;

		# 获取 10s 前的数据
		TMP_VM_STAT=`echo \$\{VM_STAT_$time2\}`;
		VM_STAT_L=`eval "echo $TMP_VM_STAT"`
		low_water_L=`echo ${VM_STAT_L#*kswapd_low_wmark_hit_quickly:}`;low_water_L=`echo ${low_water_L%% *}`;
		high_water_L=`echo ${VM_STAT_L#*kswapd_high_wmark_hit_quickly:}`;high_water_L=`echo ${high_water_L%% *}`;
		
		water_mask=`echo $low_water_L $high_water_L $low_water_10 $high_water_10 |awk '{a=$1-$3;b=$2-$4;if(a<0){a=-a};if(b<0){b=-b};print a" "b}'`
		set -- $water_mask
		low_water_D=$1;high_water_D=$2;
		
		MEM_INFO=`awk '{split("MemFree: Buffers: Cached: Active: Inactive: Active(anon): Inactive(anon): Active(file): Inactive(file): SwapFree: Slab: SReclaimable: SUnreclaim:",x," ");for(var in x){a=x[var];if($1 == '"a"'){printf("%s%s ",a,$2)};}}' /proc/meminfo`
		CacheSize=`echo ${MEM_INFO#*Cached:}`;CacheSize=`echo ${CacheSize%% *}`
		MemFree=`echo ${MEM_INFO%% *}`;MemFree=`echo ${MemFree#*:}`
		
		SLAB_INFO=`awk '{split("kmalloc-2048 kmalloc-4096",x," ");for(var in x){a=x[var];if($1 == '"a"'){printf("%s:%s ",a,$2)};}}' /proc/slabinfo`
		KMALLOC_4096=`echo ${SLAB_INFO%% *}`;KMALLOC_4096=`echo ${KMALLOC_4096#*:}`
		KMALLOC_2048=`echo ${SLAB_INFO#* }`;KMALLOC_2048=`echo ${KMALLOC_2048#*:}`
		
		KMALLOC_4096_size=`expr $KMALLOC_4096 \* 4`
		KMALLOC_2048_size=`expr $KMALLOC_2048 \* 2`
		CHECK_MEM=ok
	fi
	
	if [ "$CHECK_MEM" == "ok" ];then
		#if [[ $low_water_D -gt 10 ]] || [[ $high_water_D -gt 10 ]] || ([[ $CacheSize -lt 32768 ]] && [[ $MemFree -lt $TotalMEM_8 ]]) || [[ $KMALLOC_4096_size -ge 204800 ]] || [[ $KMALLOC_2048_size -ge 102400 ]];then
		if [[ $CacheSize -lt 32768 ]] && [[ $MemFree -lt $TotalMEM_8 ]];then
			LAST_TIME=`cat /tmp/monitor_slab.minute.log`
			if [[ "$VM_STAT_L" != "" ]] && ([[ "$LAST_TIME" == "" ]] || [[ `expr $NOW_TIME - $LAST_TIME` -ge 120 ]]);then
				# 获取前10s的各项数据
				for a in pgpgin pgpgout pswpin pswpout pageoutrun allocstall pgmajfault kswapd_low_wmark_hit_quickly kswapd_high_wmark_hit_quickly;do
					b=`echo ${VM_STAT_L#*${a}:}`
					b=`echo ${b%% *}`
					eval "${a}_0=$b"
				done
				
				# 当前各项数据
				for c in pgpgin pgpgout pswpin pswpout pageoutrun allocstall pgmajfault kswapd_low_wmark_hit_quickly kswapd_high_wmark_hit_quickly;do
					d=`echo ${VM_STAT_10#*${c}:}`
					d=`echo ${d%% *}`
					eval "${c}_10=$d"
				done
				
				pgpgin=`expr $pgpgin_10 - $pgpgin_0`
				pgpgout=`expr $pgpgout_10 - $pgpgout_0`
				pswpin=`expr $pswpin_10 - $pswpin_0`
				pswpout=`expr $pswpout_10 - $pswpout_0`
				pageoutrun=`expr $pageoutrun_10 - $pageoutrun_0`
				allocstall=`expr $allocstall_10 - $allocstall_0`
				pgmajfault=`expr $pgmajfault_10 - $pgmajfault_0`
				kswapd_low_wmark_hit_quickly=`expr $kswapd_low_wmark_hit_quickly_10 - $kswapd_low_wmark_hit_quickly_0`
				kswapd_high_wmark_hit_quickly=`expr $kswapd_high_wmark_hit_quickly_10 - $kswapd_high_wmark_hit_quickly_0`
				
				if [[ $CacheSize -lt 32768 ]] && [[ $MemFree -lt $TotalMEM_8 ]];then
					msg="告警，原因是Free memory太小了."
					
				fi
				
				#if [[ $low_water_D -gt 10 ]] || [[ $high_water_D -gt 10 ]];then
				#	msg="告警，原因是kswapd在运行."
					
				#fi
				
				#if [[ $KMALLOC_4096_size -ge 204800 ]] || [[ $KMALLOC_2048_size -ge 102400 ]];then
					#msg="告警，原因是kmalloc-对应的slab太大了"
					
				#fi
	
				[[ "$msg" != "" ]] && /bin/bash /usr/local/i386/comm_repos/auto/insert_message.sh "(oom_monitor) $msg $MEM_INFO,$SLAB_INFO,pgpgin:${pgpgin},pgpgout:${pgpgout},pswpin:${pswpin},pswpout:${pswpout},pageoutrun:${pageoutrun},allocstall:${allocstall},pgmajfault:${pgmajfault}."
				
				echo $NOW_TIME > /tmp/monitor_slab.minute.log
				exit 0
			fi
		fi
	fi
	unset low_water_D high_water_D CacheSize MemFree KMALLOC_4096_size KMALLOC_2048_size CHECK_MEM
	
	[[ "$VM_STAT_10" != "" ]] && eval "VM_STAT_$time2='$VM_STAT_10'"

	sleep $SLEEP
done
