#!/bin/bash
#Date:2012-02-17
#Written by manifold.
#Readme:generate dns config for named.conf.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games

# 配置文件目录
CONFIG_DIR=/usr/local/named/etc/dns_acl
if [ ! -d $CONFIG_DIR ];then
	mkdir -p $CONFIG_DIR
fi

# 配置文件
BACKUP_DATE=`date "+%Y-%m-%d-%H-%M-%S"`
CONFIG_FILE=view_config.conf
if [ -f $CONFIG_DIR/$CONFIG_FILE ];then
	cd $CONFIG_DIR
	/bin/cp $CONFIG_FILE $CONFIG_FILE.$BACKUP_DATE
fi

# 定义生成配置文件的函数
function GENERATE_CONFIG {
DOMAIN_NAME=$1
SLAVE_SERVER=$2
KEY_FLAG=$3
ACL_FILE=$4
VIEW_ACL=`echo $ACL_FILE|awk -F '.' '{print $1}'`
(
cat <<EOF
include "$CONFIG_DIR/$ACL_FILE";
view "$VIEW_ACL" IN {
	match-clients { key "$KEY_FLAG"; uni_addr; };
	allow-transfer { key "$KEY_FLAG"; };
	server $SLAVE_SERVER { keys "$KEY_FLAG"; };
	zone "$DOMAIN_NAME" IN {
		type master;
		file "$CONFIG_DIR/$ACL_FILE";
	};
};
EOF
) >> $CONFIG_FILE
}

for FILE in `ls $CONFIG_DIR`
do
	GENERATE_CONFIG yy.com 119.97.153.229 unikey $FILE
done


