#!/bin/bash
# procscan v2.0.8, Copyleft, wusinuo@chinaduo.com, To scan procdures from /proc/[pid]/cmdline
# usage: bash procscan.sh [filterfilename] 2>/dev/null
export LANG=C

ff=/usr/local/i386/public_repos/initial_system/snmp/ext/procscan.filter
if [ "$1" != "" ]; then ff=$1; fi
if [ ! -e ${ff} ]; then echo "## Error: Filterfile $ff NOT found!"; exit ; fi


find /proc/[1-9][0-9][0-9]*/cmdline | awk -v filter=$ff ' 
BEGIN { 
	FSbak=FS;
	FS=",";
	idx0=1; idx1=1; idx2=1;
	while(getline < filter) {
		if($1 ~ "^#" || $1 == "") continue;
		# ==0, black-list
		if($2==0 || $2=="") blist[idx0++]=$1;
		# ==1, condition-list
		if($2==1) { clist[idx1]=$1; condition[idx1++]=$3; }
		# ==2, white-list
		if($2==2) wlist[idx2++]=$1;
	}
	FS=FSbak; 
#for(x in blist) print x,blist[x];
#for(x in clist) print x,clist[x],condition[x];
#for(x in wlist) print x,wlist[x];
}

function getdevip(dev) {
	if(dev=="") dev="eth0";
	c="/sbin/ifconfig " dev " | grep \"inet addr:\" | tr \"inet addr:\" \" \" "; 
	c | getline ipaddr; 
	split(ipaddr,a);
	return a[1]; 
}

function searchip() {
	c="/sbin/ifconfig | grep \"inet addr:\" | head -1 | tr \"inet addr:\" \" \" "; 
	c | getline ipaddr; 
	split(ipaddr,a);
	return a[1]; 
}


function output(addinfo) {
#	if(cmd3!="") print searchip() " " cmd3; 
#	else print searchip() " " cmd2; 
	print searchip() "," cmd1 "," cmd2 "," cmd3 "," cmdline (addinfo=="" ? "" : "," addinfo);
}

{
#debug message:
#print ">file:" $0;

	# get cmd
	cmdline="";
	c="cat " $0 "| tr \"\\000\" \" \"";
	c | getline cmdline
	if(cmdline=="") next;
	n=split(cmdline,a_cmd1," ");
	# cmd1: fullpath process name without parameter; 
	# cmd2: process name without fullpath and parameter; 
	# cmd3: alias name defined by the third field of filterfile
	cmd1=a_cmd1[1]; 
	n=split(cmd1,a_cmd2,"/");
	cmd2=a_cmd2[n];
	cmd3="";

#debug message:
#print ">>cmd:" cmd2 "," cmd1 "," cmdline;

	# check white-list
	for(i=1;i<idx2;i++) if(cmd1 ~ wlist[i]) { output(); next; } 

	# check condition-list
	pass1=0; pass2=0;
	for(i=1;i<idx1;i++) 
		if(cmd1 ~ clist[i]) {
			pass1=1;
			if (cmdline ~ condition[i]) { cmd3=condition[i]; pass2=1; break; } 
		}
	if(pass2==1) output(); 
	if(pass1==1) next;
	
	# check black-list
	for(i=1;i<idx0;i++) if(cmd1 ~ blist[i]) next; 

	# no define, output also
	output();
}'

# ---- end -----
