#!/bin/bash
#Written by manifold.
#Date:2011-03-04
#Readme:fetch smokeping data and insert to mysql.
#Change:2011-11-08
#Readme:修改date -u为date，不再使用utc时间的unix时间戳。
#Change:2012-08-28
#Readme:重新整理并启用。

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

BASENAME=`basename $0`
SHORT_NAME=fetch_smokeping_data

# stop run configure
if [ -f /root/stop_run_$SHORT_NAME ] || [ -f /root/stop_run_$BASENAME ] || [ -f /root/stop_run_all ];then
        exit 1
fi

# basic define
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v "inet addr:192.168"|grep -v "inet addr:172.16"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`

if [ "$IPADDR" = "" ];then
        IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi

COMM_DIR=/usr/local/i386/comm_repos
BACKUP_DATE=`date +%Y-%m-%d-%H-%M-%S`

# exclude list
cat $COMM_DIR/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR .*$SHORT_NAME" && exit 1

# mysql ip address
# MYSQL_ADDRESS=`cat /home/yuwanfu/.subversion/auth/svn.simple/* |grep https|grep -E "121.14.36.27|58.249.116.91"|awk -F : '{print $2}'|tr -d \/|head -n 1`
MYSQL_ADDRESS="121.14.36.27"

SMOKEPING_INFO () {
(
cat <<'EOF'
/var/lib/smokeping/BGP_and_Double_line/B28/B28-switch.rrd	BGP_B28	59.151.23.94

/var/lib/smokeping/BGP_and_Double_line/B28-IM/B28-IM-switch.rrd BGP_B28_IM 59.151.47.78

/var/lib/smokeping/BGP_and_Double_line/KeXueCheng/KeXueCheng-tel-199-132.rrd ShuangXian_Tel_KeXueCheng 121.14.199.132
/var/lib/smokeping/BGP_and_Double_line/KeXueCheng/KeXueCheng-cnc-248-29.rrd ShuangXian_Cnc_KeXueCheng 116.213.248.29

/var/lib/smokeping/BGP_and_Double_line/LuoYang/LuoYang-tel-199.rrd	ShuangXian_Tel_LuoYang	222.88.95.199
/var/lib/smokeping/BGP_and_Double_line/LuoYang/LuoYang-cnc-199.rrd	ShuangXian_Cnc_LuoYang	61.54.27.199

/var/lib/smokeping/BGP_and_Double_line/ShenZhen/ShenZhen-tel-245.rrd ShuangXian_Tel_ShenZhen 183.62.112.245
/var/lib/smokeping/BGP_and_Double_line/ShenZhen/ShenZhen-cnc-101.rrd ShuangXian_Cnc_ShenZhen 58.251.135.101

/var/lib/smokeping/BGP_and_Double_line/WuXiWeb/WuXiWeb-tel-175-226.rrd ShuangXian_Tel_WuXiWeb 58.215.175.226
/var/lib/smokeping/BGP_and_Double_line/WuXiWeb/WuXiWeb-cnc-65-2.rrd ShuangXian_Cnc_WuXiWeb 122.192.65.2

/var/lib/smokeping/BGP_and_Double_line/XiAn/xian-tel-35.rrd	ShuangXian_Tel_XiAn	113.142.1.35
/var/lib/smokeping/BGP_and_Double_line/XiAn/xian-cnc-3.rrd	ShuangXian_Cnc_XiAn	123.138.27.3

/var/lib/smokeping/BGP_and_Double_line/XiangGang/XiangGang-switch-65.rrd  BGP_XiangGang	175.100.201.65

/var/lib/smokeping/BGP_and_Double_line/YaTai/YaTai-tel-130.rrd	ShuangXian_Tel_YaTai	121.14.37.130
/var/lib/smokeping/BGP_and_Double_line/YaTai/YaTai-cnc-98.rrd	ShuangXian_Cnc_YaTai	58.249.117.98

/var/lib/smokeping/BGP_and_Double_line/YaTai-BGP/YaTai-BGP-133-35.rrd BGP_Yatai 120.132.133.35

/var/lib/smokeping/BGP_and_Double_line/YaTai-YuYin-BGP/YaTai-YuYin-switch-65.rrd BGP_Yatai_YuYin 120.132.152.65

/var/lib/smokeping/BGP_and_Double_line/ZhanJiang/zhanjiang-tel-102.rrd ShuangXian_Tel_ZhanJiang 121.10.139.102
/var/lib/smokeping/BGP_and_Double_line/ZhanJiang/zhanjiang-cnc-102.rrd ShuangXian_Cnc_ZhanJiang 112.91.31.102

/var/lib/smokeping/Double_Line/ShenZhenHuanYuanCheng/ShenZhenHuanYuanCheng-tel-211-100.rrd ShuangXian_Tel_ShenZhenHuanYuanCheng 119.147.211.100
/var/lib/smokeping/Double_Line/ShenZhenHuanYuanCheng/ShenZhenHuanYuanCheng-cnc-226-60.rrd ShuangXian_Cnc_ShenZhenHuanYuanCheng 112.95.226.60

/var/lib/smokeping/Double_Line/WuXi/WuXi-tel-46-10.rrd ShuangXian_Tel_WuXi 58.215.46.10
/var/lib/smokeping/Double_Line/WuXi/WuXi-cnc-159-20.rrd ShuangXian_Cnc_WuXi 112.81.159.10

/var/lib/smokeping/Multi_Line/ShaoXing/ShaoXing-tel-180-25.rrd MultiLine_Tel_ShaoXing 60.12.180.25
/var/lib/smokeping/Multi_Line/ShaoXing/ShaoXing-cm-69-217.rrd MultiLine_Cm_ShaoXing 111.1.69.217
/var/lib/smokeping/Multi_Line/ShaoXing/ShaoXing-cnc-180-6.rrd MultiLine_Cnc_ShaoXing 60.12.180.6

/var/lib/smokeping/Netcom/ChangChun/ChangChun-cnc-switch-129.rrd	Cnc_ChangChun	122.141.226.129
/var/lib/smokeping/Netcom/ChangChun2/ChangChun2-cnc-switch-65.rrd Cnc_ChangChun2 122.143.3.65
/var/lib/smokeping/Netcom/DaLian1/DaLian1-cnc-switch.rrd	Cnc_DaLian1	218.60.71.1

/var/lib/smokeping/Netcom/GuangZhou-YiDong/GuangZhou-YiDong-switch-1.rrd	YiDong_GuangZhou	120.197.88.1

/var/lib/smokeping/Netcom/JiLin/JiLin-cnc-1.rrd	Cnc_JiLin 122.141.244.1
/var/lib/smokeping/Netcom/JiLin2/JiLin2-cnc-switch-1.rrd	Cnc_JiLin2	218.27.136.1
/var/lib/smokeping/Netcom/JiLin3/JiLin3-cnc-switch.rrd Cnc_JiLin3 175.22.5.1

/var/lib/smokeping/Netcom/JiNan/JiNan-cnc-switch.rrd Cnc_JiNan 119.188.45.1
/var/lib/smokeping/Netcom/JiNan2/JiNan2-cnc-switch.rrd Cnc_JiNan2 119.188.71.129
/var/lib/smokeping/Netcom/JiNan3/JiNan3-cnc-switch.rrd Cnc_JiNan3 119.188.90.1

/var/lib/smokeping/Netcom/LuoYang/LuoYang-cnc-switch.rrd Cnc_LuoYang 182.118.126.129

/var/lib/smokeping/Netcom/QingDao/QingDao-cnc-switch-206-129.rrd Cnc_QingDao 119.167.206.129
/var/lib/smokeping/Netcom/QingDao2/QingDao2-cnc-switch-155-1.rrd Cnc_QingDao2 119.167.155.1

/var/lib/smokeping/Netcom/ShanDong-YiDong/ShanDong-YiDong-switch.rrd	YiDong_ShanDong	120.192.84.129
/var/lib/smokeping/Netcom/ShanXi-YiDong/ShanXi-YiDong-switch-247.rrd	YiDong_ShanXi	221.180.20.247

/var/lib/smokeping/Netcom/ShenYang3/ShenYang3-cnc-switch.rrd	Cnc_ShenYang3	124.95.146.1
/var/lib/smokeping/Netcom/ShenYangDaDong/ShenYangDaDong-cnc-144-1.rrd Cnc_ShenYangDaDong 124.95.144.1
/var/lib/smokeping/Netcom/ShenYangDaDong2/ShenYangDaDong2-cnc-switch-145-1.rrd  Cnc_ShenYangDaDong2 124.95.145.1
/var/lib/smokeping/Netcom/ShenYangGuangBoDaSha/ShenYangGuangBoDaSha-cnc-switch-180-2.rrd Cnc_ShenYangGuangBoDaSha 202.97.180.2
/var/lib/smokeping/Netcom/ShenYangHuaXiang/ShenYangHuaXiang-cnc-switch-58-129.rrd  Cnc_ShenYangHuaXiang 218.60.58.129

/var/lib/smokeping/Netcom/ShiJiazhuang/shijiazhuang-cnc-switch.rrd	Cnc_ShiJiaZhuang	61.55.172.1
/var/lib/smokeping/Netcom/ShiJiazhuang2/shijiazhuang2-cnc-switch-65.rrd Cnc_ShiJiaZhuang2 61.55.179.65
/var/lib/smokeping/Netcom/TaiYuan/TaiYuan-cnc-switch.rrd	Cnc_TaiYuan	221.204.188.1
/var/lib/smokeping/Netcom/TaiYuan2/taiyuan2-cnc-switch.rrd	Cnc_TaiYuan2	221.204.204.129
/var/lib/smokeping/Netcom/TaiYuan3/taiyuan3-cnc-switch.rrd Cnc_TaiYuan3 221.204.223.129
/var/lib/smokeping/Netcom/TaiYuan4/taiyuan4-cnc-switch-187-1.rrd Cnc_TaiYuan4 221.204.187.1
/var/lib/smokeping/Netcom/TaiYuanShiPin/TaiYuanShiPin-cnc-switch.rrd Cnc_TaiYuanShiPin 221.204.199.129

/var/lib/smokeping/Netcom/TianJin/TianJin-cnc-switch.rrd Cnc_TianJin 111.161.66.1

/var/lib/smokeping/Netcom/WuXi-YiDong/WuXi-YiDong-switch.rrd	YiDong_WuXi	112.4.191.1

/var/lib/smokeping/Netcom/XinZhou/XinZhou-cnc-switch-222-1.rrd Cnc_XinZhou 124.163.222.1

/var/lib/smokeping/Netcom/YaTai-JiaoYuWang/YaTaiJiaoYuWang-switch.rrd	JiaoYuWang_YaTai	101.4.56.81

/var/lib/smokeping/Netcom/ZhengZhou/zhengzhou-cnc-switch-36-129.rrd	Cnc_ZhengZhou	61.158.244.129
/var/lib/smokeping/Netcom/ZhengZhou2/zhengzhou2-cnc-switch-65.rrd	Cnc_ZhengZhou2	182.118.1.65
/var/lib/smokeping/Netcom/ZhengZhou3/zhengzhou3-cnc-switch-1.rrd Cnc_ZhengZhou3 182.118.8.1
/var/lib/smokeping/Netcom/ZiBo/ZiBo-cnc-switch-65.rrd	Cnc_ZiBo	222.134.66.65

/var/lib/smokeping/telecom_1/DeYang/DeYang-tel-switch-1.rrd Tel_DeYang 182.132.32.1

/var/lib/smokeping/telecom_1/HangZhou/HangZhou-tel-97-switch.rrd Tel_HangZhou 183.129.135.97
/var/lib/smokeping/telecom_1/HangZhou1/hangzhou1-tel-switch.rrd	Tel_HangZhou1	115.238.35.33
/var/lib/smokeping/telecom_1/HangZhou2/hangzhou2-tel-35-switch.rrd	Tel_HangZhou2	115.236.2.65

/var/lib/smokeping/telecom_1/HengYang/HengYang-tel-switch-1.rrd	Tel_HengYang	124.228.238.1

/var/lib/smokeping/telecom_1/HuangShi/HuangShi-tel-switch-1.rrd	Tel_HuangShi	111.178.146.1

/var/lib/smokeping/telecom_1/MeiShan/MeiShan-tel-switch-1.rrd	Tel_MeiShan	118.123.115.1
/var/lib/smokeping/telecom_1/NanChong/NanChong-tel-switch-191-129.rrd Tel_NanChong 61.188.191.129

/var/lib/smokeping/telecom_1/NingBo/NingBo-tel-switch-1.rrd	Tel_NingBo	115.238.170.1
/var/lib/smokeping/telecom_1/NingBo2/NingBo2-tel-switch-1.rrd	Tel_NingBo2	115.238.171.1

/var/lib/smokeping/telecom_1/PuTian/PuTian-tel-switch-1.rrd	Tel_PuTian	125.78.242.1
/var/lib/smokeping/telecom_1/ShanTou-10g/shantou-10g-tel-129.rrd	Tel_ShanTou10g	218.16.227.129
/var/lib/smokeping/telecom_1/ShanTou3/shantou-3-tel-170-1.rrd Tel_ShanTou3 121.14.170.1
/var/lib/smokeping/telecom_1/ShanTou64/shantou64-tel-switch.rrd	Tel_ShanTou64	121.11.64.2
/var/lib/smokeping/telecom_1/ShanTou65/shantou65-tel-switch.rrd	Tel_ShanTou65	121.11.65.130
/var/lib/smokeping/telecom_1/ShanTou71/shantou71-tel-226.rrd	Tel_ShanTou71	121.11.71.226
/var/lib/smokeping/telecom_1/ShunDe/shunde-tel-221-220.rrd	Tel_ShunDe	121.9.221.220

/var/lib/smokeping/telecom_1/WenZhou/WenZhou-tel-switch-118-193.rrd Tel_WenZhou 60.190.118.193
/var/lib/smokeping/telecom_1/WenZhou2/WenZhou2-tel-switch-246-129.rrd Tel_WenZhou2 122.228.246.129
/var/lib/smokeping/telecom_1/WenZhou3/WenZhou3-tel-switch-248-1.rrd Tel_WenZhou3 122.228.248.1

/var/lib/smokeping/telecom_1/WuHan/WuHan-tel-switch-153-129.rrd Tel_WuHan 119.97.153.129
/var/lib/smokeping/telecom_1/WuHan2/WuHan2-tel-switch-174-1.rrd Tel_WuHan2 119.97.174.1
/var/lib/smokeping/telecom_1/WuHan3/WuHan3-tel-switch-172-65.rrd Tel_WuHan3 119.97.172.65

/var/lib/smokeping/telecom_1/ZhenJiang/zhenjiang-tel-switch.rrd	Tel_ZhenJiang	222.186.49.1
/var/lib/smokeping/telecom_1/ZhenJiang2/zhenjiang2-tel-switch-54-130.rrd Tel_ZhenJiang2 222.186.54.130

/var/lib/smokeping/telecom_1/ZhuHai/ZhuHai-tel-switch-8-129.rrd	Tel_ZhuHai	183.61.8.129
/var/lib/smokeping/telecom_1/ZhuHai2/ZhuHai2-tel-switch-100-1.rrd	Tel_ZhuHai2	113.106.100.1
/var/lib/smokeping/telecom_1/ZhuHai3/ZhuHai3-tel-switch-2-129.rrd Tel_ZhuHai3 183.61.2.129

/var/lib/smokeping/telecom_1/chongqing/chongqing-tel-switch-193.rrd	Tel_ChongQing	119.84.84.193
/var/lib/smokeping/telecom_1/chongqing2/chongqing2-tel-switch-65.rrd	Tel_ChongQing2	219.153.55.65
/var/lib/smokeping/telecom_1/chongqing3/chongqing3-tel-switch-125-1.rrd Tel_ChongQing3 119.84.125.1

/var/lib/smokeping/telecom_2/ChangShu/ChangShu-tel-switch.rrd	Tel_ChangShu	61.155.170.1

/var/lib/smokeping/telecom_2/ChongQing4/ChongQing4-tel-switch.rrd	Tel_ChongQing4	119.84.120.1

/var/lib/smokeping/telecom_2/DongGuanDaLang/DongGuanDaLang-tel-switch.rrd	Tel_DongGuanDaLang	119.147.134.1

/var/lib/smokeping/telecom_2/ShangHaiBeiAi/ShangHaiBeiAi-tel-switch.rrd	Tel_ShangHaiBeiAi	222.73.184.210
/var/lib/smokeping/telecom_2/ShangHaiBeiAi2/ShangHaiBeiAi2-tel-switch.rrd	Tel_ShangHaiBeiAi2	222.73.183.225

/var/lib/smokeping/telecom_2/ShangHaiZhenRu/ShangHaiZhenRu-tel-switch.rrd	Tel_ShangHaiZhenRu	222.73.61.1
/var/lib/smokeping/telecom_2/ShangHaiZhenRu2/ShangHaiZhenRu2-tel-switch.rrd	Tel_ShangHaiZhenRu2	222.73.62.97
/var/lib/smokeping/telecom_2/ShangHaiZhenRu3/ShangHaiZhenRu3-tel-switch.rrd	Tel_ShangHaiZhenRu3	222.73.64.1

/var/lib/smokeping/telecom_2/XiaMenShiPin/XiaMenShiPin-tel-switch.rrd	Tel_XiaMenShiPin	117.25.157.129

/var/lib/smokeping/telecom_2/xiangfan/xiangfan-tel-switch-1.rrd	Tel_xiangfan	61.183.37.1

/var/lib/smokeping/QT/QT_Tel/ShangHai-Tel-204-86.rrd Tel_ShangHai_QT_61 61.172.204.86
/var/lib/smokeping/QT/QT_Tel/ShangHai-Tel-109-47.rrd Tel_ShangHai_QT_114 114.80.109.47
/var/lib/smokeping/QT/QT_Tel/ShangHai-Tel-72-121.rrd Tel_ShangHai_QT_180 180.153.72.121
/var/lib/smokeping/QT/QT_Cnc/ShangHai-Cnc-200-125.rrd Cnc_ShangHai_QT 112.64.200.125
/var/lib/smokeping/QT/QT_Cnc/ShenZhen-Cnc-142-11.rrd Cnc_ShenZhen_QT 112.90.142.11
/var/lib/smokeping/QT/QT_Cnc/TianJin-Cnc-200-198.rrd Cnc_TianJin_QT 125.39.54.198
EOF
)
}

# define insert alert function
WGET_LOG_FILE=/var/log/sysop_manager/smokeping.wget.log
OP_MYSQL () {
	# /usr/bin/mysql -u'sys_alert_user' -p'manifold_insert_tables' -h"$MYSQL_ADDRESS" crontab_script_monitor -e "$1"
	# CONTENT=`printf "$1"|base64 -w 0`
    CONTENT=`echo "$1"|base64 -w 0`
	wget --post-data "content=$CONTENT" --http-user=manifold --http-passwd=dw_manifold --output-document=$WGET_LOG_FILE --timeout=8 --tries=2 --quiet "http://121.14.36.27:63217/op_smokeping_data.php"
}

CREATE_ENTRY () {
	# QUERY_LINE=`OP_MYSQL "select count(*) from smokeping where source_ip_address='$IPADDR' and time like '$SQL_QUERY_DATE%' and period='$PERIOD';"|grep -v count`
	OP_MYSQL "select count(*) from smokeping where source_ip_address='$IPADDR' and time like '$SQL_QUERY_DATE%' and period='$PERIOD';"
	QUERY_LINE=`cat $WGET_LOG_FILE`
	#echo "select count(*) from smokeping where source_ip_address='$IPADDR' and time like '$SQL_QUERY_DATE%' and period='$PERIOD';"
	#echo "query_line:$QUERY_LINE"
	if [ "$QUERY_LINE" == "0" ];then
		OP_MYSQL "insert into smokeping (time,period,source_ip_address) values ('$SQL_QUERY_DATE_FULL','$PERIOD','$IPADDR');"
		#echo "insert into smokeping (period,source_ip_address) values ('$PERIOD','$IPADDR');"
	fi
}

# 参数1为loss或者是rtt
QUERY_TYPE="$1"

# 参数2为提交的查询时间段
QUERY_TIME="$2"

# 参数3为提交的更新时间，把这个时间分离出来是为了方便手工更新数据。
if [ -n "$3" ];then
	QUERY_DATE="$3"
	SQL_QUERY_DATE=`date --date "1 day ago $QUERY_DATE" "+%Y-%m-%d"`
	SQL_QUERY_DATE_FULL=`date --date "1 day ago $QUERY_DATE" "+%Y-%m-%d %T"`
	# date "+%Y-%m-%d"
	# 2011-11-08
fi

if [ "$QUERY_TYPE" = "" ] || [ "$QUERY_TIME" = "" ];then
	echo "Please input parameter."
	exit 1
elif [ "$QUERY_TIME" = "10minute" ];then
	START_TIME=`date --date "10 minute ago" +%s`
	END_TIME=`date +%s`
elif [ "$QUERY_TIME" = "yesterday_1930_2230" ];then
	START_TIME=`date --date "1 day ago $QUERY_DATE 19:30:00" +%s`
	END_TIME=`date --date "1 day ago $QUERY_DATE 22:30:00" +%s`
	PERIOD=1
	CREATE_ENTRY
elif [ "$QUERY_TIME" = "month_1930_2230" ];then
	START_TIME=`date --date "1 month ago $QUERY_DATE 19:30:00" +%s`
	END_TIME=`date --date "1 day ago $QUERY_DATE 22:30:00" +%s`
	PERIOD=0
	CREATE_ENTRY
fi

OP_TIME=0
# cat /dev/null > /tmp/fetch_smokeping_data.log
SMOKEPING_INFO|grep -v ^$|grep -v ^#|while read RRD_FILE COLUMN DESTINCT_IP_ADDRESS
do
	# echo "perl $COMM_DIR/smokeping/smokeping.pl $RRD_FILE $QUERY_TYPE $START_TIME $END_TIME"
	RESULT=`perl $COMM_DIR/smokeping/smokeping.pl $RRD_FILE $QUERY_TYPE $START_TIME $END_TIME`
	COLUMN=$COLUMN"_"$QUERY_TYPE
	DATA=`echo $RESULT|awk -F ';' '{print $2}'`
	if [ "$DATA" = "" ];then
		DATA="n"
	fi

	if [ "$OP_TIME" -eq 0 ];then
		TOTAL_SQL="$COLUMN=\"$DATA\""
	else
		TOTAL_SQL=`echo $TOTAL_SQL|sed 's/$/,'"${COLUMN}"'="'${DATA}'"/'`
	fi
	
	echo $TOTAL_SQL	> /tmp/fetch_smokeping_data.log
	OP_TIME=`expr $OP_TIME + 1`
	
done # > /tmp/fetch_smokeping_data.log 2>&1

TOTAL_SQL=`cat /tmp/fetch_smokeping_data.log|tail -n 1`
INSERT_TIME=`date +"%Y-%m-%d %T"`

if [ "$QUERY_TIME" = "10minute" ];then
	# echo insert_time:$INSERT_TIME
	# 如数据库无此记录，则插入一条（检测部分在下面进行）
	# QUERY_LINE=`OP_MYSQL "select count(*) from smokeping_monitor where source_ip_address='$IPADDR';"|grep -v count`
	OP_MYSQL "select count(*) from smokeping_monitor where source_ip_address='$IPADDR';"
	QUERY_LINE=`cat $WGET_LOG_FILE`
	if [ "$QUERY_LINE" -eq 0 ];then
		OP_MYSQL "insert into smokeping_monitor (source_ip_address) values ('$IPADDR');"
	fi
	OP_MYSQL "update smokeping_monitor set time='$INSERT_TIME',$TOTAL_SQL where source_ip_address='$IPADDR';"
	# echo "update smokeping_monitor set time="$INSERT_DATE",$TOTAL_SQL where source_ip_address='$IPADDR';"
	
elif [ "$QUERY_TIME" = "yesterday_1930_2230" ] || [ "$QUERY_TIME" = "month_1930_2230" ];then
	# 如数据库无此记录，则插入一条（检测部分在上面的CREATE_ENTRY函数实现）
	OP_MYSQL "update smokeping set time='$SQL_QUERY_DATE_FULL',$TOTAL_SQL where source_ip_address='$IPADDR' and time like '$SQL_QUERY_DATE%' and period='$PERIOD';"
	echo "update smokeping set $TOTAL_SQL where source_ip_address='$IPADDR' and time like '$SQL_QUERY_DATE%' and period='$PERIOD';"
	
else
	# OP_MYSQL "update smokeping set time='$SQL_QUERY_DATE_FULL',$COLUMN='$DATA',destinct_ip_address='$DESTINCT_IP_ADDRESS' where source_ip_address='$IPADDR' and period='$PERIOD';"
	echo "insert into smokeping_monitor (source_ip_address,$TOTAL_COLUMN) values ('$IPADDR',$TOTAL_DATA);"
	
fi

