#!/bin/bash
#Date:2010-08-18
#Written by manifold
#Readme:Install smokeping.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# update package repository
aptitude update

# install smokeping
aptitude install smokeping -y

# install apache
aptitude install apache2 -y

# configure apache
# part1
(
cat <<'EOF'
Listen 8

<IfModule mod_ssl.c>
    Listen 443
</IfModule>
EOF
) > /etc/apache2/ports.conf 

# part2
sed -i 's/:80/:8/' /etc/apache2/sites-enabled/000-default  

# part3
(
cat <<'EOF'
<Directory "/usr/lib/cgi-bin/">
AuthName admin-only
AuthType Basic
AuthUserFile /etc/apache2/mypasswd
require valid-user
</Directory>
EOF
) >> /etc/apache2/apache2.conf

# part4
htpasswd -c -b /etc/apache2/mypasswd dspeak i8ohmjnd9kblsk

# part5
/etc/init.d/apache2 restart


# update svn repository
su - yuwanfu -c "cd /usr/local/i386/comm_repos;svn update"

# copy config file
/bin/cp /usr/local/i386/comm_repos/smokeping/conf/config /etc/smokeping/config
/bin/cp /usr/local/i386/comm_repos/smokeping/conf/bgp_and_double_line /etc/smokeping/config.d/bgp_and_double_line
/bin/cp /usr/local/i386/comm_repos/smokeping/conf/double_line /etc/smokeping/config.d/double_line
/bin/cp /usr/local/i386/comm_repos/smokeping/conf/telecom /etc/smokeping/config.d/telecom
/bin/cp /usr/local/i386/comm_repos/smokeping/conf/telecom2 /etc/smokeping/config.d/telecom2
/bin/cp /usr/local/i386/comm_repos/smokeping/conf/netcom_and_others /etc/smokeping/config.d/netcom_and_others

# generate cgirul
sh /usr/local/i386/comm_repos/smokeping/generate_smokeping_cgirul.sh 

# restart smokeping
/etc/init.d/smokeping restart
