#!/bin/bash
# Written by wuhaiting
# Date 2012-12-10
# Readme 收集服务器硬件信息

PATH=/usr/local/sbin:/usr/local/bin:/usr/bin:/usr/sbin:/sbin:/bin
export LANG=C
export LC_ALL=C
PUBLIC_DIR=/usr/local/i386/public_repos
HARDWARE_INFO=/etc/hardware_info
HOSTINFO_FILE="/home/dspeak/yyms/hostinfo.ini"
COLLECT_LOG=/var/log/sysop_manager/collect_hardware_info.log
EXEC_DIR=$(dirname $0)

cat /etc/issue|grep -i "ubuntu" > /dev/null 2>&1 && LINUX_VERSION=Ubuntu_Server && OS_ID="8"
cat /etc/issue|grep -i "Debian" > /dev/null 2>&1 && LINUX_VERSION=Debian && OS_ID="14"
cat /etc/issue|grep -i "centos" > /dev/null 2>&1 && LINUX_VERSION=Centos && OS_ID="3"
cat /etc/issue|grep -i "Red Hat" > /dev/null 2>&1 && LINUX_VERSION=Redhat && OS_ID="1"

tmp_file1=`mktemp /tmp/tmp1.XXXX` || exit 1
tmp_file2=`mktemp /tmp/tmp2.XXXX`
tmp_file3=`mktemp /tmp/tmp3.XXXX`
tmp_file4=`mktemp /tmp/tmp3.XXXX`

function exit_func () {
    rm -f $tmp_file1 $tmp_file2 $tmp_file3 $tmp_file4 MegaSAS.log CmdTool.log > /dev/null 2>&1
    exit 0
}

trap 'exit_func;exit' 0 2 3 9 15

ns=$1
until [ -z $1 ];do
	case $1 in
		"ns")
			ns="ns"
			shift;;
		"rt")
			realtime="Official"
			shift;;
        "query")
            querycheck="query"
            shift;;
        *)
            shift;;
	esac
done

wget_log=/tmp/collect_hardware.info
INFO_SERVER_FILE="${EXEC_DIR}/info_server_ip.log"
[ -s $HOSTINFO_FILE ] && SERVER_ID=$(awk -F '=' '{if($0 ~ /server_id/){print $2;exit}}' $HOSTINFO_FILE)

IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
[[ "$IPADDR" == "" ]] && IPADDR=`/sbin/ifconfig|grep Bcast|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
mac=$(/sbin/ifconfig | grep -w "HWaddr" | awk '{print $NF}'| head -n1)
IPADDR_ALL=`/sbin/ifconfig|grep "inet addr"|awk '{print $2}'|awk -F ":" '{print $2}'|grep -v -E "^127\."|tr -s "\n" " "`
MOUNT_DATA=`cat /etc/mtab|awk '{print $2}'|grep data |tr -s "\n" " "`

INSERT_MYSQL () {
	/bin/bash /usr/local/i386/*/auto/insert_message.sh "collect_hardware_info_to_cmdb.sh" "$1"
}

function cpu_info () {
	CPU_INFO_FILE=/proc/cpuinfo
	cpu_num=`cat $CPU_INFO_FILE|grep "physical id"|sort -u|wc -l`
	cpu_processor=`cat $CPU_INFO_FILE|grep "^processor"|wc -l`
	cpu_fre=`grep -m1 -w "^model name" /proc/cpuinfo`;cpu_fre=`echo ${cpu_fre##*@}`
	cpu_model=`cat $CPU_INFO_FILE|grep -w "model name"|awk -F ":" '{print $2}'|sed -r "s/^[[:space:]]+//"|tail -n1`
	_cpu_model=`echo $cpu_model|awk '{printf("%s%s%s",$(NF-2),$(NF-1),$NF)}'`
	__cpu_model=$(grep -m1 -w "model name" /proc/cpuinfo | awk '{if($0 ~ /Xeon/){for(i=1;i<=NF;i++){if($i=="CPU"){print $(i+1)}}}else if($0 ~ /Core/){for(i=1;i<=NF;i++){if($i=="CPU"){print $(i-1)}}}}');
}

function mem_info () {
	system_mem=`cat /proc/meminfo|grep "^MemTotal"|awk '{print $(NF-1)/1024/1024 "GB"}'`
	physical_memory=`dmidecode |grep -v "^#" | sed -n -r '/^[[:space:]]+Size/p' | grep "MB"|awk '{if($2 > 200){print ($2/1024)}}'`
	physical_memory_all=`echo $physical_memory|awk '{i=0;sum=0;while(i<NF){i++;sum=sum+$i};print sum}'`
	physical_mem_type=`dmidecode |grep -v "^#"| sed -n -r '/^[[:space:]]+Size/p' | grep "MB"|awk '{if($2 > 200){print ($2/1024)}}'|sort -u| tr -s "\n" " "`
	for type in `echo $physical_mem_type`;do
		for type_num in `echo $physical_memory`;do
			if [ "$type_num" == "$type" ];then num=`expr $num + 1`;fi
		done
		physical_mem_type_info="$physical_mem_type_info ${type}GB*$num"
		unset num
	done
	for mem_index_num in $physical_mem_type_info;
	do
		physical_mem_num_index=`echo ${mem_index_num#*\*}`
		physical_mem_num="$physical_mem_num $physical_mem_num_index"
	done
	physical_mem_num=`echo $physical_mem_num | sed "s/^ //g"`
	unset
}

function ethernet_info () {
	which ethtool > /dev/null 2>&1
	[[ "$?" -ne 0 ]] && ([[ "$LINUX_VERSION" == "Ubuntu_Server" ]] || [[ "$LINUX_VERSION" == "Debian" ]]) && apt-get -y install ethtool > /dev/null 2>&1

	eth_num=`lspci|grep -cE "Ethernet controller:"`
	eth_num=`expr $eth_num - 1`

	for ethernet_num in `seq 0 $eth_num`;do
		ethtool -i eth${ethernet_num} > $tmp_file1
		if ls /proc/net/bonding/bond* >/dev/null 2>&1; then
			eth_mac=$(cat /proc/net/bonding/bond* | grep -E 'Interface:|HW addr:'| grep -A1 "Interface:.*eth${ethernet_num}"|grep -v 'Interface'| awk -F 'addr:' '{print $2}'| tr -d ' ')
		fi
		[ -z $eth_mac ] && eth_mac=`ifconfig eth${ethernet_num} | grep "HWaddr" | awk '{print $NF}'`
		ethernet_driver=`cat $tmp_file1 | awk -F ': ' '{if($1 ~ /driver/){print $2}}'`
		driver_version=`cat $tmp_file1 | awk -F ': ' '{if($1 ~ /^version/){print $2}}'`
		fw_version=`cat $tmp_file1 | awk -F ': ' '{if($1 ~ /^firmware-version/){print $2}}'`
		eth_speed=`ethtool eth${ethernet_num} | awk -F ': ' '{if($1 ~ /Speed/){print $2}}'`
		echo $eth_speed | grep -qi "unknown" && eth_speed="Unknown"
		eth_bus=`cat $tmp_file1 | awk '{if($0 ~ /bus-info/){print $2;exit}}'`;eth_bus=`echo ${eth_bus#*:}`
		eth_hard=`lspci|grep -E "Ethernet controller:" | grep "$eth_bus" | awk -F ':' '{gsub(/\(.*\)/,"",$NF);print $NF}'`
		eval "global_eth_info_${ethernet_num}='${eth_hard}&${eth_speed}&${fw_version}&${ethernet_driver}&${driver_version}&$eth_mac'"
		unset ethernet_driver driver_version fw_version eth_speed eth_bus eth_hard eth_mac
	done
}

function power_unit () {
	ipmi_fru_file=$1
	if [ "$manufacturer" == "Dell" ];then
		POWER_UNIT_NUM=`cat $ipmi_fru_file |grep -A1 -e "FRU Device Description.*PS [0-4]"|grep -cw "Board Mfg"`
	elif [ "$manufacturer" == "IBM" ];then
		POWER_UNIT_NUM=`cat $ipmi_fru_file |grep -A1 -e "FRU Device Description.*Power Supply [0-4]"|grep -cw "Board Mfg"`
	else
		POWER_UNIT_NUM=`dmidecode | awk -F ': ' '{if($0 ~ /Number Of Power Cords/){print $2}}'`
	fi
	if [[ "$POWER_UNIT_NUM" == "" ]] || [[ "$POWER_UNIT_NUM" == "0" ]] || [[ "$POWER_UNIT_NUM" == "Unspecified" ]];then
		POWER_UNIT_NUM=1
	fi
}

function os_info () {
	[[ "$LINUX_VERSION" == "Ubuntu_Server" ]] || [[ "$LINUX_VERSION" == "Debian" ]] && SYSTEM_VERSION=`lsb_release -a 2>&1 | awk -F ':\t' '{if($1 ~ /^Release/){print $2}}'`
	[[ "$LINUX_VERSION" == "Centos" ]] || [[ "$LINUX_VERSION" == "Redhat" ]] && SYSTEM_VERSION=`cat /etc/issue|head -n1|awk '{print $(NF-1)}'`

	LINUX_BIT=`getconf LONG_BIT`

	KERNEL_VERSION=`uname -r`
	if [[ "$LINUX_VERSION" == "Ubuntu_Server" ]] || [[ "$LINUX_VERSION" == "Debian" ]]; then
		KERNEL_VERSION=`echo $KERNEL_VERSION | awk -F "-" '{printf("%s-%s",$1,$2)}'`
	elif [[ "$LINUX_VERSION" == "Centos" ]] || [[ "$LINUX_VERSION" == "Redhat" ]];then
		KERNEL_VERSION=`echo $KERNEL_VERSION |awk -F '.' '{printf("%s.%s.%s",$1,$2,$3)}'`
	else
		KERNEL_VERSION="${KERNEL_VERSION%%-*}"
	fi

	SWAP_ZONE=`swapon -s|grep -v "Filename"|wc -l`
	IS_DATA_ZONE=`cat /etc/mtab|awk '{if($2 ~ /\/data/){print "yes"}}'|tail -n1`

}

function disk_info () {
	lspci|grep -E "RAID"|awk -F ':' '{gsub(/\(.*\)/,"",$NF);print $NF}' > $tmp_file1
	cat /dev/null > $tmp_file3

	if [ "`grep -qEw "MegaRAID SAS|MegaSAS|LSI Logic.*Logic Unknown device|LSI Logic.*Logic.*0079" $tmp_file1 && echo "MegaRAID"`" == "MegaRAID" ];then

		/bin/bash ${EXEC_DIR}/raid_megacli.sh > $tmp_file3
		[ "`grep -c "^physicaldrive" $tmp_file3`" -gt 0 ] && cat $tmp_file3 >> $tmp_file2
	fi
	if [ "`grep -qEw "Smart Array|Hewlett-Packard" $tmp_file1 && echo "Smart_Array"`" == "Smart_Array" ];then

		/bin/bash ${EXEC_DIR}/raid_hpacucli.sh > $tmp_file3
		[ "`grep -c "^physicaldrive" $tmp_file3`" -gt 0 ] && cat $tmp_file3 >> $tmp_file2
	fi
	if [ "`grep -qEw "AAC-RAID" $tmp_file1 && echo "AAC-RAID"`" == "AAC-RAID" ];then

		/bin/bash ${EXEC_DIR}/raid_arcconf.sh > $tmp_file3
		[ "`grep -c "^physicaldrive" $tmp_file3`" -gt 0 ] && cat $tmp_file3 >> $tmp_file2
	fi
	if [ "`grep -qEw "RocketRAID" $tmp_file1 && echo "RocketRAID"`" == "RocketRAID" ];then

		/bin/bash ${EXEC_DIR}/raid_Rocket.sh > $tmp_file3
		[ "`grep -c "^physicaldrive" $tmp_file3`" -gt 0 ] && cat $tmp_file3 >> $tmp_file2
	fi
	if [ "`grep -qEw "SuperTrak EX" $tmp_file1 && echo "SuperTrak"`" == "SuperTrak" ];then

		/bin/bash ${EXEC_DIR}/raid_cliib.sh > $tmp_file3
		[ "`grep -c "^physicaldrive" $tmp_file3`" -gt 0 ] && cat $tmp_file3 >> $tmp_file2
	fi

	if lspci | grep -q 'LSI Logi.*SAS.*Fusion-MPT';then

		/bin/bash ${EXEC_DIR}/raid_sasircu.sh > $tmp_file3
		[ "`grep -c "^physicaldrive" $tmp_file3`" -gt 0 ] && cat $tmp_file3 >> $tmp_file2
	fi

	if [[ "`lspci|grep -E -w "SCSI|SATA" | grep -qEw "Fusion-MPT" && echo "Fusion-MPT"`" == "Fusion-MPT" ]] && [[ "`grep -c "^physicaldrive" $tmp_file2`" -eq 0 ]];then

		/bin/bash ${EXEC_DIR}/hba_smartctl.sh > $tmp_file2
		/bin/bash ${EXEC_DIR}/hba_lsiutil.sh | grep -v "^accelerator" >> $tmp_file2

	else

		/bin/bash ${EXEC_DIR}/hba_smartctl.sh > $tmp_file3
		[ "`grep -c "^physicaldrive" $tmp_file3`" -gt 0 ] && cat $tmp_file3 >> $tmp_file2
	fi

	_PARTITION_DISK=`cat $tmp_file2`
}

function board_info () {
	> $tmp_file1
	for fru_id in 0 1;do
		ipmitool fru print $fru_id >> $tmp_file1 2>/dev/null
		[ $? -eq 0 ] && break
	done
	product_part_sn=`awk '{if($0 ~ /Product Part Number/){print $NF}}' $tmp_file1`
	if [ "`awk '{if($0 ~ /Product Asset Tag/){print $NF;exit}}' $tmp_file1`" == "DUOWAN" ];then
		manufacturer=`awk -F ':' '{if($0 ~ /Product Manufacturer/){gsub(" ","",$2);print $2;exit}}' $tmp_file1`
		product=`awk -F ':' '{if($0 ~ /Product Name/){gsub("^ ","",$2);print $2;exit}}' $tmp_file1`
		SN_NUMBER=`awk -F ':' '{if($0 ~ /Product Serial/){gsub(" ","",$2);print $2;exit}}' $tmp_file1`
	else
		manufacturer=`dmidecode -s system-manufacturer|grep -v "^#"|sed -e "s/ Inc\.//g" -e "s/,//g"`
		product=`dmidecode -s system-product-name|grep -v "^#"|sed -e "s/\-\[.*\]\-//" -e "s/xSeries High Volume Racks //g" -e "s/eserver //g"|tr -d ':'`
		SN_NUMBER=`dmidecode -s system-serial-number|grep -v "^#" | sed "s/ //g"`
	fi
	EX_SN=$(grep -i "${mac}" $PUBLIC_DIR/initial_system/hardware/exclude_sn.log 2>/dev/null| awk '{print $1}')
	[ ! -z $EX_SN ] && SN_NUMBER=$EX_SN
	echo $manufacturer | grep -iq "IBM" && [ ! -z "$product_part_sn" ] && SN_NUMBER="$product_part_sn-$SN_NUMBER"
	bios_version=`dmidecode -s bios-version |grep -v "^#"|sed -e "s/\-\[//g" -e "s/\]\-//g" -e "s/ .*//g"|tr -d "'"`
	bios_release_date=`dmidecode -s bios-release-date |grep -v "^#" | awk -F '/' '{a=$3/100;if(a < 1){$3="20"$3};gsub(" ","",$3);printf("%s/%s/%s",$1,$2,$3)}'`

}

function cloud_upload_os () {
	if grep -q "vm_type=1" $HOSTINFO_FILE ;then
		read PROXY_AGENT < /var/log/sysop_manager/repos_db_address.log
		BASE64=$(echo "http://cmdb.sysop.duowan.com:8088/webservice/vm/osReport.do?server_id=$SERVER_ID&os_id=$OS_ID&os_version=$SYSTEM_VERSION&os_bit=$LINUX_BIT" |base64 -w0)
		wget --http-user=manifold --http-passwd=dw_manifold --output-document="$tmp_file4" --timeout=8 --tries=3 --quiet "http://$PROXY_AGENT:63217/proxy_queue_api.php?GET_QUEUE=$BASE64"
	fi
}

/bin/bash /usr/local/i386/*/auto/unlock_process.sh "ipmitool" "300"
board_info
power_unit $tmp_file1
cpu_info
mem_info
os_info
ethernet_info
disk_info

echo "
Manufacturer    : $manufacturer
Product-name    : $product
serial-number   : $SN_NUMBER
CPU             : $cpu_model
Processor       : $cpu_processor
Physical_CPU    : $cpu_num
Physical_memory : $physical_mem_type_info
Array controller:
$(cat $tmp_file1)
Disk_info       :
$_PARTITION_DISK

Ethernet        : " > $tmp_file4
[ -n "$global_eth_info_0" ] && echo $global_eth_info_0 >> $tmp_file4
[ -n "$global_eth_info_1" ] && echo $global_eth_info_1 >> $tmp_file4
[ -n "$global_eth_info_2" ] && echo $global_eth_info_2 >> $tmp_file4
[ -n "$global_eth_info_3" ] && echo $global_eth_info_3 >> $tmp_file4
[ -n "$global_eth_info_4" ] && echo $global_eth_info_4 >> $tmp_file4
echo "
IP_Address      : $IPADDR_ALL
OS_info         : $LINUX_VERSION-$SYSTEM_VERSION($KERNEL_VERSION) $LINUX_BIT
System_memory   : $system_mem
" >> $tmp_file4

wall_time=`date "+%Y-%m-%d %H:%M:%S"`
wall_time_20=`date "+%Y-%m-%d" -d "10 days ago"`
cur_md5=$(md5sum $tmp_file4 |awk '{print $1}')
old_md5=$(md5sum $HARDWARE_INFO|awk '{print $1}')
IPADDR_SUFFIX="${IPADDR##*.}"
UPLOAD_TIME=$(expr $IPADDR_SUFFIX % 24)
if [ ! -z $realtime ] || [ "$querycheck" = "query" ]; then
	:
else
	if [ "$ns" = "ns" ]; then
		:
	elif [ "`date +%H`" -eq "$UPLOAD_TIME" ]; then
		sleep $((RANDOM%300))
	elif [ "$cur_md5" != "$old_md5" ]; then
		sleep $((RANDOM%150))
	else
		exit_func
	fi
fi

if	[ "$SERVER_ID" == "" ] || \
	[ "$querycheck" = "query" ] || \
	echo $product | grep -qiE 'KVM' || \
	grep -q "vm_type=1" $HOSTINFO_FILE || \
	echo $manufacturer | grep -qiE 'VMware|Xen' ;then
	cat $tmp_file4 > $HARDWARE_INFO
	echo "==========Warning: Virtual machine or no server_id===========" >> $HARDWARE_INFO
	cloud_upload_os
	exit_func
fi

#################################################################################
# 转化成json格式上报
(
cat << EOF
{
"server_id":"$SERVER_ID",
"ip":"$IPADDR",
"base":{"manufacturer":"$manufacturer","model":"$product","sn":"$SN_NUMBER"},
"main":{"cpu":{"model":"$__cpu_model","frequency":"$cpu_fre","num":"$cpu_num","logic_num":"$cpu_processor"},"mem":{"total":"$physical_memory_all","size":"$physical_mem_type","num":"$physical_mem_num"}},
"net":[
EOF
) > $tmp_file1

# 输出网卡json格式
now_ethernet_num=0
for ethernet_num in `seq 0 $eth_num`;do
	eval "ethernet_info_tmp=\$global_eth_info_${ethernet_num}"
	ethernet_hard=`echo $ethernet_info_tmp | awk -F '&' '{print $1}'`
	ethernet_speed=`echo $ethernet_info_tmp | awk -F '&' '{print $2}'`
	ethernet_fw=`echo $ethernet_info_tmp | awk -F '&' '{print $3}'`
	ethernet_driver=`echo $ethernet_info_tmp | awk -F '&' '{print $4}'`
	ethernet_driver_ver=`echo $ethernet_info_tmp | awk -F '&' '{print $5}'`
	ethernet_mac=`echo $ethernet_info_tmp | awk -F '&' '{print $6}'|tr -d ":"`
	now_ethernet_num=`expr $now_ethernet_num + 1`

	if [ "`expr $eth_num + 1`" -eq "$now_ethernet_num" ];then
		echo "{\"key\":\"$ethernet_mac\",\"model\":\"$ethernet_hard\",\"rate\":\"$ethernet_speed\",\"revision\":\"$ethernet_fw\",\"driver\":\"$ethernet_driver\",\"driver_revision\":\"$ethernet_driver_ver\"}"
	else
		echo "{\"key\":\"$ethernet_mac\",\"model\":\"$ethernet_hard\",\"rate\":\"$ethernet_speed\",\"revision\":\"$ethernet_fw\",\"driver\":\"$ethernet_driver\",\"driver_revision\":\"$ethernet_driver_ver\"},"
	fi
	unset ethernet_hard ethernet_speed ethernet_fw ethernet_driver ethernet_driver_ver ethernet_mac
done >> $tmp_file1
echo \
"],
\"storage\":{
\"raid\":[" >> $tmp_file1

# 输出阵列卡的json格式
total_array_num=`grep -c "^accelerator" $tmp_file2`
now_array_num=0
grep "^accelerator" $tmp_file2 |tr -d "(),"| while read ctrl_tag ctrl_index ctrl_cache ctrl_status ctrl_sn ctrl_model;do
	now_array_num=`expr $now_array_num + 1`
	ctrl_md5=`echo $ctrl_index$ctrl_sn$ctrl_model  | md5sum | cut -d " " -f 1`
	if [ "$now_array_num" -eq "$total_array_num" ];then
		echo "{\"key\":\"$ctrl_md5\",\"model\":\"$ctrl_model\",\"sn\":\"$ctrl_sn\",\"cache\":\"$ctrl_cache\"}"
	else
		echo "{\"key\":\"$ctrl_md5\",\"model\":\"$ctrl_model\",\"sn\":\"$ctrl_sn\",\"cache\":\"$ctrl_cache\"},"
	fi
done >> $tmp_file1
echo \
"],
\"disk\":[" >> $tmp_file1

# 输出硬盘的json格式
if [ "`grep -c "^physicaldrive" $tmp_file2`" -eq 0 ];then
	if [[ "`echo $manufacturer | grep -qiE 'VMware|Xen' && echo 0`" != "0" ]] && [[ "`echo $product | grep -qiE 'KVM' && echo 0`" != "0" ]];then
		fail_ctrl=`lspci|grep -Ew "RAID|SCSI|SATA"|awk -F ':' '{gsub(/\(.*\)/,"",$NF);print $NF}'| tr -s "\n" "@"`
		INSERT_MYSQL "collect_hardware_info: disk collect fail, raid_ctl:$fail_ctrl"
		python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py "id=10869&IP=$IPADDR&msg=Can't found Disk_Info,Accelerator:$fail_ctrl"
	fi
fi

now_ld_num=0
total_ld_num=`grep -c "^logicaldrive" $tmp_file2`
[ "$total_ld_num" -eq 0 ] && total_ld_num=1
grep "^logicaldrive" $tmp_file2 |tr -d "()," | while read ld_tag ld_index ld_volume ld_raid ld_status ld_pd_num sdmap_1;
do
	now_ld_num=`expr $now_ld_num + 1`
	if [ "$total_ld_num" -ne "$now_ld_num" ];then
		ld_start="$ld_tag $ld_index"
		ld_next=`grep "^$ld_tag" $tmp_file2 | grep -A1 "$ld_start" | grep -v "$ld_start"|head -n1`
		sed -n "/${ld_start}\>/,/${ld_next}/p" $tmp_file2 > $tmp_file3

		now_pd_num=0
		total_pd_num=`grep -c "^physicaldrive" $tmp_file3`
		if [ "$total_pd_num" == "0" ];then
			echo "{\"key\":\"$ld_index\",\"type\":\"$ld_raid\",\"capacity\":\"$ld_volume\",\"num\":\"$ld_pd_num\",\"hard_disk\":\"\"},"
			continue
		else
			echo "{\"key\":\"$ld_index\",\"type\":\"$ld_raid\",\"capacity\":\"$ld_volume\",\"num\":\"$ld_pd_num\",\"hard_disk\":["
		fi
		grep "^physicaldrive" $tmp_file3 |tr -d "()," | while read pd_tag pd_index pd_type pd_volume pd_status pd_sn pd_model sdmap;
		do
			now_pd_num=`expr $now_pd_num + 1`
			if [ "$now_pd_num" -eq "$total_pd_num" ];then
				echo "{\"key\":\"$pd_index\",\"capacity\":\"$pd_volume\",\"type\":\"$pd_type\",\"model\":\"$pd_model\",\"sn\":\"$pd_sn\"}"
			else
				echo "{\"key\":\"$pd_index\",\"capacity\":\"$pd_volume\",\"type\":\"$pd_type\",\"model\":\"$pd_model\",\"sn\":\"$pd_sn\"},"
			fi
		done
		echo "]},"
	else
		ld_start="$ld_tag $ld_index"
		ld_next=`grep "^$ld_tag" $tmp_file2 | grep -A1 "$ld_start" | grep -v "$ld_start"`
		sed -n "/${ld_start}\>/,/${ld_next}/p" $tmp_file2 > $tmp_file3

		now_pd_num=0
		total_pd_num=`grep -c "^physicaldrive" $tmp_file3`
		if [ "$total_pd_num" == "0" ];then
			echo "{\"key\":\"$ld_index\",\"type\":\"$ld_raid\",\"capacity\":\"$ld_volume\",\"num\":\"$ld_pd_num\",\"hard_disk\":\"\"}"
			continue
		else
			echo "{\"key\":\"$ld_index\",\"type\":\"$ld_raid\",\"capacity\":\"$ld_volume\",\"num\":\"$ld_pd_num\",\"hard_disk\":["
		fi
		grep "^physicaldrive" $tmp_file3 |tr -d "()," | while read pd_tag pd_index pd_type pd_volume pd_status pd_sn pd_model sdmap;
		do
			now_pd_num=`expr $now_pd_num + 1`
			if [ "$now_pd_num" -eq "$total_pd_num" ];then
				echo "{\"key\":\"$pd_index\",\"capacity\":\"$pd_volume\",\"type\":\"$pd_type\",\"model\":\"$pd_model\",\"sn\":\"$pd_sn\"}"
			else
				echo "{\"key\":\"$pd_index\",\"capacity\":\"$pd_volume\",\"type\":\"$pd_type\",\"model\":\"$pd_model\",\"sn\":\"$pd_sn\"},"
			fi
		done
		echo "]}"
	fi
done >> $tmp_file1

(
cat << EOF
]
},
"motherboard":{"bios_release_date":"$bios_release_date","bios_revision":"$bios_version","remote_control_card":"","supplies_num":"$POWER_UNIT_NUM"},
"operation_system":{"system":"$LINUX_VERSION","version":"$SYSTEM_VERSION","kernel":"$KERNEL_VERSION","median":"$LINUX_BIT"}
}
EOF
) >> $tmp_file1

data=`cat $tmp_file1`
cat $tmp_file1

##########################################################
#随机选择一个点上报数据。

IPADDR_ISP=`awk '{for(i=1;i<=NF;i++){if($i ~ /"'$IPADDR'"/){print $(i+2)}}}' /home/dspeak/yyms/hostinfo | tr -d "}],"`
sort -R $INFO_SERVER_FILE > /dev/null 2>&1
if [ $? -eq 0 ];then
	#用isp类型来优先选择服务器上报
	for random_ip in `cat $INFO_SERVER_FILE | grep "^$IPADDR_ISP"| awk '{print $2}'|sort -R`
	do
		echo "$wall_time============================$random_ip================================"
		wget -d --post-data "data=$data&server_id=$SERVER_ID&ip=$IPADDR" --timeout=8 --tries=2 "http://$random_ip:10025/collection${realtime}?" -O $wget_log
		cat $wget_log;echo -e "\n"
		post_data=`awk '{for(i=1;i<=NF;i++){if($i ~ /"success"/){gsub("}","",$(i+1));if($(i+1) == "true"){print "0"}else{print "1"};exit}}}' $wget_log`
		if [ "$post_data" == "0" ];then
			cat $tmp_file4 > $HARDWARE_INFO
			wget_post=YES
			#INSERT_MYSQL "collect_hardware_info_success,$SERVER_ID,$IPADDR"
			break;
		fi
	done

	#选择其他isp的服务器上报
	if [ "$wget_post" != "YES" ];then
		unset random_ip post_data
		for random_ip in `cat $INFO_SERVER_FILE | grep -vE "^$IPADDR_ISP|^$|^#"| awk '{print $2}'|sort -R`
		do
			echo "$wall_time============================$random_ip================================"
			wget -d --post-data "data=$data&server_id=$SERVER_ID&ip=$IPADDR" --timeout=8 --tries=2 "http://$random_ip:10025/collection${realtime}?" -O $wget_log
			cat $wget_log;echo -e "\n"
			post_data=`awk '{for(i=1;i<=NF;i++){if($i ~ /"success"/){gsub("}","",$(i+1));if($(i+1) == "true"){print "0"}else{print "1"};exit}}}' $wget_log`
			if [ "$post_data" == "0" ];then
				cat $tmp_file4 > $HARDWARE_INFO
				wget_post=success
				#INSERT_MYSQL "collect_hardware_info_success,$SERVER_ID,$IPADDR"
				break;
			fi
		done
		if [ "$wget_post" != "success" ];then
			INSERT_MYSQL "collect_hardware_info fail."
			python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py "id=10869&IP=$IPADDR&msg=Hardware info upload fail"
		fi
	fi
else
	# 有些老的OS发行版，sort不支持-R参数，轮询ip发送
	for random_ip in `cat $INFO_SERVER_FILE | grep -vE "^$|^#"| awk '{print $2}'`
	do
		echo "$wall_time============================$random_ip================================"
		wget -d --post-data "data=$data&server_id=$SERVER_ID&ip=$IPADDR" --timeout=8 --tries=2 "http://$random_ip:10025/collection${realtime}?" -O $wget_log
		cat $wget_log;echo -e "\n"
		post_data=`awk '{for(i=1;i<=NF;i++){if($i ~ /"success"/){gsub("}","",$(i+1));if($(i+1) == "true"){print "0"}else{print "1"};exit}}}' $wget_log`
		if [ "$post_data" == "0" ];then
			cat $tmp_file4 > $HARDWARE_INFO
			wget_post=success
			#INSERT_MYSQL "collect_hardware_info_success,$SERVER_ID,$IPADDR"
			break;
		fi
	done
	if [ "$wget_post" != "success" ];then
		INSERT_MYSQL "collect_hardware_info fail."
		python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py "id=10869&IP=$IPADDR&msg=Hardware info upload fail"
	fi
fi
[[ "`grep -wq "^$wall_time_20" $COLLECT_LOG && echo 0`" == "0" ]] && sed -i "1,/^$wall_time_20/d" $COLLECT_LOG

rm -rf $tmp_file1 $tmp_file2 $tmp_file3 $tmp_file4 $wget_log MegaSAS.log CmdTool.log
