#!bin/bash
# Date 2013-04-05
# Written by wuhaiting
# 阵列卡安装包

PATH=/usr/local/sbin:/usr/local/bin:/usr/bin:/usr/sbin:/sbin:/bin
export LANG=C
arch_bit=$(getconf LONG_BIT)

# check linux version
cat /etc/issue|grep -i -E "CentOS|Red" >/dev/null 2>&1 && LINUX_VERSION="centos"
cat /etc/issue|grep -i -E "Ubuntu|Debian" >/dev/null 2>&1 && LINUX_VERSION="ubuntu"
SYSTEM_VERSION=`getconf LONG_BIT`
if [ "$LINUX_VERSION" = "" ] || [ "$SYSTEM_VERSION" == "" ];then exit 1;fi

which lspci >/dev/null 2>&1 || exit 1

# wget function
wget_action () {
	wget --http-user=manifold --http-passwd=dw_manifold --output-document=$1 --timeout=$2 --tries=$3 "http://$4:63217/$5"
}

if [ "`lspci|grep -E -w "RAID"|grep -E -w "MegaRAID SAS|MegaSAS" > /dev/null && echo "MegaRAID"`" == "MegaRAID" ];then
	if [ ! -f /usr/sbin/megacli ];then
		if [ "$LINUX_VERSION" == "ubuntu" ];then
			if [ "$arch_bit" = "64" ];then
				mega_pack="megacli_8.07.14-1_amd64.deb"
			elif [ "$arch_bit" = "32" ];then
				mega_pack="megacli_8.07.14-1_i386.deb"
			fi
			wget_action /tmp/$mega_pack 8 2 manager.repos.yy.duowan.com package/$mega_pack
			[ $? -eq 0 ] && dpkg -i /tmp/${mega_pack}
			rm -f /tmp/${mega_pack}

		elif [ "$LINUX_VERSION" == "centos" ];then
			wget_action /tmp/MegaCli-8.07.07-1.noarch.rpm 8 2 manager.repos.yy.duowan.com package/MegaCli-8.07.14-1.noarch.rpm
			if [ "$?" -eq 0 ];then
				cd /tmp
				rpm -ivh MegaCli-8.07.07-1.noarch.rpm
			fi
			if [ -x /opt/MegaRAID/MegaCli/MegaCli64 ]; then
				ln -fs /opt/MegaRAID/MegaCli/MegaCli64 /usr/sbin/megacli
			elif [ -x /opt/MegaRAID/MegaCli/MegaCli ]; then
				ln -fs /opt/MegaRAID/MegaCli/MegaCli /usr/sbin/megacli
			fi
			cd - && rm -f /tmp/MegaCli* /tmp/lib_utils*
		fi
	fi
elif [ "`lspci|grep -E -w "RAID"|grep -Ew "Smart Array|Hewlett-Packard" > /dev/null && echo "Smart_Array"`" == "Smart_Array" ];then
	if [ ! -f /usr/sbin/hpacucli ] || [ -f /usr/sbin/hpssacli ];then
		if [ "$LINUX_VERSION" == "ubuntu" ];then
			cd /tmp && aptitude -y download hpacucli hpssacli;dpkg -i *.deb ;rm -rf *.deb ;cd -
		elif [ "$LINUX_VERSION" == "centos" ];then
			for pks in hpacucli-9.40-12.0.x86_64.rpm hpssacli-1.60-17.0.x86_64.rpm;
			do
				wget_action /tmp/${pks} 8 2 manager.repos.yy.duowan.com package/${pks}
				[[ "$?" -eq 0 ]] && rpm -i /tmp/${pks}
				rm -f /tmp/${pks}
			done
		fi
	fi
elif [ "`lspci|grep -E -w "RAID"|grep -qEw "AAC-RAID" && echo "AAC-RAID"`" == "AAC-RAID" ];then
	if [ ! -x /usr/sbin/arcconf ];then
		if [ "$LINUX_VERSION" == "ubuntu" ];then
			cd /tmp/ && aptitude -y download arcconf;dpkg -i arcconf* ;rm -rf arcconf* ;cd -
		elif [ "$LINUX_VERSION" == "centos" ];then
			wget_action /tmp/arcconf-7.31.18856-2.x86_64.rpm 8 2 manager.repos.yy.duowan.com package/arcconf-7.31.18856-2.x86_64.rpm
			[[ "$?" -eq 0 ]] && rpm -i /tmp/arcconf-7.31.18856-2.x86_64.rpm
			rm -f /tmp/arcconf-7.31.18856-2.x86_64.rpm
		fi
	fi
elif [ "`lspci|grep -E -w "RAID"|grep -qEw "SuperTrak EX" && echo "SuperTrak"`" == "SuperTrak" ];then
	which expect
	if [ $? -ne 0 ];then
		if [ "$LINUX_VERSION" == "ubuntu" ];then
			apt-get -y install expect;
		elif [ "$LINUX_VERSION" == "centos" ];then
			yum -y install expect;
		fi
	fi
	if [ ! -x /usr/sbin/cliib ];then
		wget_action /tmp/cliib-3.15.tar.gz2 8 2 manager.repos.yy.duowan.com package/cliib-3.15.tar.gz2
		cd /tmp;
		tar jxf cliib-3.15.tar.gz2
		[ ! -d /usr/local/lib ] && mkdir /usr/local/lib/
		mv /tmp/webpampro /usr/local/lib/.
		mv /tmp/cliib /usr/sbin/.
		rm -f /tmp/cliib-3.15.tar.gz2
	fi
elif lspci | grep -q 'LSI Logi.*SAS2.*Fusion-MPT SAS-2';then
	wget_action /tmp/sas2ircu.noarch.noos.tar.gz 8 2 manager.repos.yy.duowan.com package/sas2ircu.noarch.noos.tar.gz
	cd /tmp;
	tar zxf sas2ircu.noarch.noos.tar.gz
	chmod 755 sas2ircu
	mv sas2ircu /usr/sbin/.
	rm -f sas2ircu.noarch.noos.tar.gz
	cd -
elif [ "`lspci|grep -E -w "SCSI|SATA" | grep -qEw "Fusion-MPT" && echo "Fusion-MPT"`" == "Fusion-MPT" ];then
	if [ ! -x /usr/sbin/lsiutil ];then
		if [ "$LINUX_VERSION" == "ubuntu" ];then
            apt-get -y install libcap-ng0
			cd /tmp;
			aptitude -y download lsiutil
			dpkg -i lsiutil*
			rm -f lsiutil*
			cd -
		elif [ "$LINUX_VERSION" = "centos" ]; then
			if [ "$arch_bit" = "64" ]; then
				wget_action /tmp/lsiutil 8 2 manager.repos.yy.duowan.com package/lsiutil.x86_64
			else
				wget_action /tmp/lsiutil 8 2 manager.repos.yy.duowan.com package/lsiutil.x86_32
			fi
			mv /tmp/lsiutil /usr/sbin/lsiutil
			chmod 755 /usr/sbin/lsiutil
		fi
	fi
fi

which smartctl > /dev/null 2>&1
[ $? -eq 0 ] && exit 0
if [ "$LINUX_VERSION" == "ubuntu" ];then
	cd /tmp;aptitude download smartmontools > /dev/null 2>&1;dpkg -i smartmontools*;rm -f /etc/rc2.d/S20smartmontools /tmp/smartmontools*;cd -
    apt-get -y install libcap-ng0
elif [ "$LINUX_VERSION" == "centos" ];then
	if [ "`cat /etc/issue | grep -q "5\." && echo 5`" == "5" ];then
		wget http://mirror.centos.org/centos/5/os/i386/CentOS/smartmontools-5.38-3.el5.i386.rpm
		[[ "$?" -eq 0 ]] && rpm -i smartmontools-5.38-3.el5.i386.rpm
	else
		yum -y install smartmontools
	fi
fi

