#!/bin/bash
#DATA:2012-09-13
#Written by wuhaiting.
#README:monitor hardware. fan,tempture,memory,disk,accelerator

source /usr/local/i386/*/auto/function.sh

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
DISK_TMP_FILE=`mktemp /tmp/disk_status.XXXX`
TMP_FILE1=`mktemp /tmp/tmp.XXXX`  || exit 1
TMP_FILE2=`mktemp /tmp/tmp.XXXX`

SYSTEM_VERSION=`getconf LONG_BIT`
if [ "$LINUX_VERSION" = "" ] || [ "$SYSTEM_VERSION" == "" ];then exit 1;fi

# basic define
BASENAME=`basename $0`
SHORT_NAME=mon_hardware
LOG_DIR=/var/log/sysop_manager
LOG_MARK=$LOG_DIR/hardware.mark
LOG_FILE=/var/log/hardware.log

# stop run configure
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 1
fi

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
PUBLIC_DIR=/usr/local/i386/public_repos
INSERT_MSG_DIR=`ls /usr/local/i386/*/auto/insert_message.sh`

# get ip address
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi
KERNEL_VERSION=$(uname -r)
# exclude list
cat /usr/local/i386/*/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

# check os if visual machine, XEN ,openVZ , UML
if [[ -f /proc/vz ]] || [[ -d /proc/xen ]];then IS_VISUAL=YES;fi

# define insert alert function
# $2=warning־platform档$2=error yyms
wall_time=`date "+%Y%m%d %H:%M:%S"`

INSERT_MYSQL () {
	if [ "`echo $IPADDR|grep -E "^172\.|^192\.|^10\." >/dev/null && echo 0`" == "0" ];then
	    MSG="$IPADDR  $1"
	else
	    MSG=$1
	fi

	echo -e "$wall_time $1\n$3" >> $LOG_FILE
	echo "$MSG"
	echo $2 >> $TMP_FILE1

	#yyms
	cat $PUBLIC_DIR/initial_system/monitor/hardware_exclude_ip.log|grep -v "^#"|grep "$IPADDR" >/dev/null 2>&1 && return 1
	/bin/bash $INSERT_MSG_DIR "$BASENAME" "$MSG"
	HARDWARE_TYPE=`echo $2|grep "error"|awk -F ":" '{print $2}'`
	if [ "$HARDWARE_TYPE" != "" ];then
		case $HARDWARE_TYPE in
			"disk")
				id=10588
				sid=74604;;
			"memory")
				id=10590
				sid=74606;;
			"unknow")
				id=10592
				sid=74608;;
		esac
		if [[ "$id" != "" ]] && [[ "$sid" != "" ]];then
			#python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py $id $sid 0 "$MSG"
			#echo $id $sid 0 $MSG
			:
		fi
	fi
}

# wget function
wget_action () {
	wget --http-user=manifold --http-passwd=dw_manifold --output-document=$1 --timeout=$2 --tries=$3 "http://$4:63217/$5"
}

DMIDECODE_DIR=`which dmidecode`
MANUFACTURER=`$DMIDECODE_DIR -s system-manufacturer|grep -m1 -v "^#"`
RAID_DEVICE=`lspci|grep -E -w "RAID|SCSI|SATA"`

function hard_disk_check () {
    for DIR in `cat /etc/mtab |grep ^/dev |awk '{print $2}'`
    do
        TEMP_FILE=`mktemp -p $DIR`
        if [ "$?" -ne 0 ];then
            INSERT_MYSQL "Hardware check:readonly,partition:$DIR" "error:disk"
        else
            rm -f $TEMP_FILE $TMP_FILE2
        fi
    done

	# пӲ̹
	if [ ! -z "$RAID_DEVICE" ];then
	# LSI MegaRaid array
		if [ "`lspci|grep -E -w "RAID|SCSI"|grep -E -w "MegaRAID SAS|MegaSAS" > /dev/null && echo "MegaRAID"`" == "MegaRAID" ];then
			if [ ! -f /usr/sbin/megacli ];then
				if [ "$LINUX_VERSION" == "ubuntu" ];then
					cd /tmp && aptitude -y download megacli ;dpkg -i megacli* ;rm -rf megacli* ;cd -
				elif [ "$LINUX_VERSION" == "centos" ];then
					wget_action /tmp/megacli-8.00.29.tar.bz2 8 2 121.14.36.27 package/megacli-8.00.29.tar.bz2
					[[ "$?" -eq 0 ]] && cd /tmp && tar jxf megacli-8.00.29.tar.bz2 && rpm -i lib_utils-1.00-08.noarch.rpm && rpm -i megacli-8.00.29-1.i386.rpm
					[[ -x /opt/MegaRAID/MegaCli/MegaCli64 ]] && ln -s /opt/MegaRAID/MegaCli/MegaCli64 /usr/sbin/megacli
					cd - && rm -f /tmp/megacli.* /tmp/lib_utils.*
				fi
				[[ ! -f /usr/sbin/megacli ]] && return 1
			fi
			# ӲraidǷ⡢ǷлֻǳȡпӲ״̬ϢпִС
			ARRAY_MEMORY=`/usr/sbin/megacli -AdpAllInfo -aALL|grep "Memory Size"|awk '{print $NF}'|tr -d MB|head -n 1`
			/usr/sbin/megacli -cfgdsply -aall > $TMP_FILE1 2>&1
			DISK_STATUS=$(grep -E "^State|^Firmware state:|Failure Count:"  $TMP_FILE1 | \
						grep -v -w -E "0|Optimal|Online, Spun Up|Online, Spun down|Online, Transition")
			if [ "$DISK_STATUS" != "" ];then
				echo $DISK_STATUS|grep -q "Unconfigured(good)"
				if [ "$?" -eq 0 ];then
					INSERT_MYSQL "Hardware check: Some Disk (unconfigure[good]),Contact dw_wuhaiting. "
				else
					INSERT_MYSQL "Hardware check: Some Disks or Raid have error." "error:disk" "$DISK_STATUS"
				fi
			fi
			unset DISK_STATUS
			awk '{if($0 ~ /^Slot Number:*/){a=$NF}else if($0 ~ /^Media Error Count:*/){b=$NF;if(b != 0){printf("%s:Media_Error_Count:%s\n",a,b)}}}' $TMP_FILE1 > $TMP_FILE2
			for a in `cat $TMP_FILE2`;do
				b_new=`cat $TMP_FILE2|grep "$a"|awk -F ":" '{print $3}'`
				b_old=`cat $LOG_MARK|grep "$a"|tail -n1|awk -F ":" '{print $3}'`
				sed -i "/megacli $a/d" $LOG_MARK
				echo "megacli $a" >> $LOG_MARK
				if [[ "$b_new" -gt 100 ]];then
					INSERT_MYSQL "Hardware check: Some Disks or Raid have error." "error:disk" "$a"
				fi
			done
			unset DISK_STATUS a b_new b_old
			DISK_STATUS=`/usr/sbin/megacli -AdpAllInfo -aALL|grep -A 8 "Device Present"|grep -E "Degraded|Offline|Critical Disks|Failed Disks"|grep -v -w "0"`
			[[ -n $DISK_STATUS ]] && INSERT_MYSQL "Hardware check: Some Disks or Raid have error." "error:disk" "$DISK_STATUS"
			# ָ澯ȫ̫ˣʱ
			DISK_POLICY=$(grep -w -E "Current Cache Policy:" $TMP_FILE1 |grep -v "WriteBack, Read")
			[[ "$ARRAY_MEMORY" != "" ]] && [[ $ARRAY_MEMORY -gt 0 ]] && [[ -n $DISK_POLICY ]] && INSERT_MYSQL "Hardware check: disk policy abnormal, it will affect I/O or safety." "warning:disk" "$DISK_POLICY"
			BATTERY_REPLACE=`/usr/sbin/megacli -adpbbucmd -aall|grep -E "Battery Replacement required|Remaining Capacity Low"|grep -v -w "No"`
			[[ -n $BATTERY_REPLACE ]] && INSERT_MYSQL "Hardware check: Battery error." "error:disk" "$BATTERY_REPLACE"
			rm MegaSAS.log
			return 0

		elif [ "`lspci|grep -E -w "RAID|SCSI"|grep -Ew "Smart Array|Hewlett-Packard" > /dev/null && echo "Smart_Array"`" == "Smart_Array" ];then
			hp_pks="hpacucli"
			/usr/sbin/${hp_pks} ctrl all show config > $TMP_FILE2
			if grep -q 'APPLICATION UPGRADE' $TMP_FILE2 && \
				[ -x /usr/sbin/hpssacli ];then
				hp_pks="hpssacli"
				/usr/sbin/${hp_pks} ctrl all show config > $TMP_FILE2
			fi

			DISK_STATUS=$(grep -E "physicaldrive|logicaldrive" $TMP_FILE2 |grep -v "OK")
			[[ -n $DISK_STATUS ]] && INSERT_MYSQL "Hardware check: Some Disks or Raid have error." "error:disk" "$DISK_STATUS"

			/usr/sbin/${hp_pks} ctrl all show status 2>/dev/null > $TMP_FILE2
			ARRAY_STATUS=$(grep -E "Controller Status:|PROBLEM DETECTED" $TMP_FILE2|grep -v "OK")
			[[ -n $ARRAY_STATUS ]] && INSERT_MYSQL "Hardware check: Array controller have some error." "error:disk" "$ARRAY_STATUS"
			BATTERY_REPLACE=$(grep -iE "Battery|Capacitor" $TMP_FILE2|grep -v "OK")
			[ ! -z "$BATTERY_REPLACE" ] && INSERT_MYSQL "Hardware check: Battery error." "error:disk" "$BATTERY_REPLACE"
		else
			# Use smartmontools to monitor disk status,which use disk's S.M.A.R.T table
			if [ ! -x /usr/sbin/smartctl ];then
				if [ "$LINUX_VERSION" == "ubuntu" ];then
					cd /tmp;aptitude download smartmontools > /dev/null 2>&1;dpkg -i smartmontools*;rm -f /etc/rc2.d/S20smartmontools /tmp/smartmontools*;cd -
				elif [ "$LINUX_VERSION" == "centos" ];then
					if [ "`lsb_release -a|grep "Release"|awk -F ":" '{print $2}'|awk -F "." '{print $1}'`" == "5" ];then
						wget http://mirror.centos.org/centos/5/os/i386/CentOS/smartmontools-5.38-3.el5.i386.rpm
						[[ "$?" -eq 0 ]] && rpm -i smartmontools-5.38-3.el5.i386.rpm
					else
						yum -y install smartmontools
					fi
				fi
				[[ ! -x /usr/sbin/smartctl ]] && return 1
			fi
			for a in /dev/sd[a-z] /dev/sd[a-z][a-z] ;do
				DISK_BASENAME=`basename $a`
				smartctl -a $a > $DISK_TMP_FILE
				cat $DISK_TMP_FILE |grep "does not support SMART" > /dev/null 2>&1 && continue
				DISK_STATUS=$(cat $DISK_TMP_FILE |grep -E "SMART Health Status|grown defect list|Non-medium error|SMART.*test result:|Error Count:"|awk -F ":" '{print $2}'|awk '{print $1}')
				set -- $DISK_STATUS
				# SAS DISK: SMART Health Status: OK    SATA disk: SMART overall-health self-assessment test result: PASSED
				[[ "$1" != "" ]] && if [ "$1" == "OK" ];then :;elif [ "$1" == "PASSED" ];then :;else
					INSERT_MYSQL "Hardware check: $a SMART status Fail, check!" "error:disk"
				fi
				sed -i "/smartctl $DISK_BASENAME SMART status:.*/d" $LOG_MARK
				echo "smartctl $DISK_BASENAME SMART status: $1" >> $LOG_MARK
				# Elements in grown defect list: 0 (normal)
				G_LIST=`grep "smartctl $DISK_BASENAME grown_defect_list" $LOG_MARK|tail -n1|awk -F ":" '{print $NF}'`
				[ "$2" != "" ] && [ $2 -gt 100 ] && INSERT_MYSQL "Hardware check: $a grown_defect_list: $2, check!" "error:disk"
				sed -i "/smartctl $DISK_BASENAME grown_defect_list:.*/d" $LOG_MARK
				echo "smartctl $DISK_BASENAME grown_defect_list: $2" >> $LOG_MARK
				# Non-medium error count: 0
				MEDIUM_ERROR=`grep "$DISK_BASENAME none_medium_error" $LOG_MARK|tail -n1|awk -F ":" '{print $NF}'`
				#[[ "$3" != "" ]] && [[ "$MEDIUM_ERROR" != "" ]] && [[ $3 -ne $MEDIUM_ERROR ]] && INSERT_MYSQL "Hardware check: $a none_medium_error $3 not equal old value $MEDIUM_ERROR" "warning:disk"
				sed -i "/smartctl $DISK_BASENAME none_medium_error:.*/d" $LOG_MARK
				echo "smartctl $DISK_BASENAME none_medium_error: $3" >> $LOG_MARK
				# Error counter log:
				# Errors Corrected by           Total   Correction     Gigabytes    Total
                # ECC          rereads/    errors   algorithm      processed    uncorrected
                # fast | delayed   rewrites  corrected  invocations   [10^9 bytes]  errors
                # read:    3647480     0         0   3647480    3647480          2.280           0
                # write:      0        0         0         0          0        413.131           0
                # verify:      61       0         0        61         61          0.000           0
				unset DISK_STATUS
				DISK_STATUS=`cat $DISK_TMP_FILE |grep -E "read:|write:|verify:"|awk '{print $NF}'`
				set -- $DISK_STATUS
				READ_ERROR=`grep "smartctl $DISK_BASENAME read uncorrected_error" $LOG_MARK|tail -n1|awk -F ":" '{print $NF}'`
				[[ "$1" != "" ]] && [[ "$1" != "0" ]] && [[ "$READ_ERROR" != "" ]] && [[ $READ_ERROR -ne $1 ]] && INSERT_MYSQL "Hardware check: $a READ uncorrected_error $1" "warning:disk"
				sed -i "/smartctl $DISK_BASENAME read uncorrected_error.*/d" $LOG_MARK
				echo "smartctl $DISK_BASENAME read uncorrected_error: $1" >> $LOG_MARK

				WRITE_ERROR=`grep "smartctl $DISK_BASENAME write/seek uncorrected_error" $LOG_MARK|tail -n1|awk -F ":" '{print $NF}'`
				[[ "$2" != "" ]] && [[ "$2" != "0" ]] && [[ "$WRITE_ERROR" != "" ]] && [[ $WRITE_ERROR -ne $2 ]] && INSERT_MYSQL "Hardware check: $a WRITE uncorrected_error $2" "warning:disk"
				sed -i "/smartctl $DISK_BASENAME write\/seek uncorrected_error.*/d" $LOG_MARK
				echo "smartctl $DISK_BASENAME write/seek uncorrected_error: $2" >> $LOG_MARK
			done
		fi
	fi

}

log_read_write () {
	FILE=$1;BASENAME_FILE=`basename $1`;MASK=$2
	if [ -f $FILE ];then
		wall_hour="${wall_time#* }"
		wall_hour="${wall_hour%%:*}"
		OLD_LINE_NUM=`cat $LOG_MARK|grep "$MASK"|tail -n1|awk -F ":" '{print $NF}'`
		END_LINE_NUM=`cat $FILE|wc -l`
		eval "sed -i "/$MASK.*/d" $LOG_MARK"
		echo "$MASK $END_LINE_NUM" >> $LOG_MARK
		if [ "$OLD_LINE_NUM" == "" ] || [ $OLD_LINE_NUM -gt $END_LINE_NUM ];then
			OLD_LINE_NUM=0
		fi
		OLD_LINE_NUM=`expr $OLD_LINE_NUM + 1`
		eval "sed -n '$OLD_LINE_NUM,$END_LINE_NUM p' $FILE |grep -E \"$HARDWARE_MASK\"|grep -v -E \"$V_MASK\"|sort -nu > $DISK_TMP_FILE"
		RESULT=`cat $DISK_TMP_FILE|grep -v "^#"|wc -l`
		if [ "$RESULT" != "0" ];then
			while read entry;do
				if [ "`echo $entry |grep -q -r "EDAC MC.*CE row.*channel.*DIMM.*error" && echo 0`" == "0" ];then
					[ "$global_mem_ecc" = "yes" ] && break
					ECC_ERROR=`grep "mem_ecc_error:" $LOG_MARK |tail -n1|awk -F ":" '{print $NF}'`
					((ECC_ERROR+=1))
					sed -i "/mem_ecc_error:.*/d" $LOG_MARK
					echo "mem_ecc_error: $ECC_ERROR" >> $LOG_MARK
					global_mem_ecc=yes
					echo "error:memory" >> $TMP_FILE1
					if [ "$ECC_ERROR" -ge 9 ]; then
						INSERT_MYSQL "Hardware check: memory Uncorrectable ECC" "error:memory"
						break;
					fi

				elif [ "`echo $entry |grep -qE -r "end_request.*I/O.*error.*dev.*sector|Medium Error" && echo 0`" == "0" ];then
					[ "$global_disk_error" = "yes" ] && break
					# alert more than 10 times that will send to center
					DISK_MAYBE_ERROR=`grep "disk_maybe_error:" $LOG_MARK |tail -n1|awk -F ":" '{print $NF}'`
					((DISK_MAYBE_ERROR+=1))
					sed -i "/disk_maybe_error:.*/d" $LOG_MARK
					echo "disk_maybe_error: $DISK_MAYBE_ERROR" >> $LOG_MARK
					global_disk_error=yes
					if [ "$DISK_MAYBE_ERROR" -ge 9 ]; then
						INSERT_MYSQL "Hardware check: Some Disks maybe have problem." "error:disk"
						break
					fi

				else
					INSERT_MYSQL "Hardware check: system [$BASENAME_FILE]log found $RESULT error!" "error:unknow";break;
				fi
			done < $DISK_TMP_FILE
		fi
		for set_zero in "disk_maybe_error" "mem_ecc_error"; do
			if [ "$wall_hour" -eq 23 ];then
				grep -w "$set_zero" $LOG_MARK
				eval "sed -i "/$set_zero.*/d" $LOG_MARK"
			fi
		done
		[[ -s $DISK_TMP_FILE ]] && cat $DISK_TMP_FILE|tail -n100 >> $LOG_FILE
	fi
}

# ϵͳ/var/log־ҪĹؼ
function log_prase () {
	# ϵͳ־вӲ̴־,ubuntu messagessyslogerror,centos kernmessages
	# Error Dectect and Corrected (EDAC)ԶصӲģ顣ubuntu910ں˱ȽϾãûi7core_edac
	# HARDWARE_MASK ־Ĺؼƥ
	HARDWARE_MASK="Medium Error|I/O error|Device offline|Unrecovered read error|EXT*-fs error|EDAC"
	V_MASK="EDAC.*Ver:|Giving out device|EDAC.*Driver loaded|EDAC.*Removed device|fd=|Connection refused|postfix\/|sbridge.*Seeking for"
	if [ "$LINUX_VERSION" == "ubuntu" ];then
		log_read_write "/var/log/syslog" "ubuntu_syslog_last_check_line:"
		log_read_write "/var/log/messages" "ubuntu_messages_last_check_line:"
		log_read_write "/var/log/kern.log" "ubuntu_kern_log_last_check_line:"
		log_read_write "/var/log/dmesg" "ubuntu_dmesg_last_check_line:"
	elif [ "$LINUX_VERSION" == "centos" ];then
		log_read_write "/var/log/messages" "centos_messages_last_check_line:"
		log_read_write "/var/log/kern" "centos_kern_last_check_line:"
		log_read_write "/var/log/dmesg" "centos_dmesg_last_check_line:"
	fi
}

function ipmi_log_prase () {
	echo $KERNEL_VERSION | grep -q '3.5.0' && return 0
	OLD_IPMI_NUM=`cat $LOG_MARK|grep "ipmi log last_check_line:"|tail -n1|awk -F ":" '{print $NF}'`
	ipmitool sel list > $DISK_TMP_FILE 2>/dev/null
	NOW_IPMI_NUM=`cat $DISK_TMP_FILE |wc -l`
	[[ $NOW_IPMI_NUM -gt 300 ]] && ipmitool sel clear >/dev/null 2>&1
	cat $LOG_MARK|grep "ipmi log last_check_line" >/dev/null 2>&1 || ret=yes
	sed -i "/ipmi log last_check_line/d" $LOG_MARK
	echo "ipmi log last_check_line: $NOW_IPMI_NUM" >> $LOG_MARK
	[[ "$ret" == "yes" ]] && return 1
	if [[ "$OLD_IPMI_NUM" == "" ]] && [[ $OLD_IPMI_NUM -gt $NOW_IPMI_NUM ]];then
		# reset LINE NUM
		OLD_IPMI_NUM=0
	fi
	OLD_IPMI_NUM=`expr $OLD_IPMI_NUM + 1`
	eval "sed -ni '$OLD_IPMI_NUM,$NOW_IPMI_NUM p' $DISK_TMP_FILE"
	IPMI_ERROR=`cat $DISK_TMP_FILE|grep -v -E "System Event|Times.*tamp|Power State"|awk -F "|" '{printf("%s,%s\n",$4,$5)}'|sort -u`
	IPMI_RAW_ERROR=`cat $DISK_TMP_FILE|grep -v -E "System Event|Times.*tamp|Power State"`
	echo $IPMI_ERROR|grep -E "Memory.*Uncorrectable|Memory.*Configuration Error|Memory.* Correctable ECC" > /dev/null 2>&1
	if [ "$?" -eq 0 ];then
		INSERT_MYSQL "Hardware check: memory Uncorrectable ECC" "error:memory" "$IPMI_ERROR"
		echo "$IPMI_RAW_ERROR" >> $LOG_FILE
	elif [ "$IPMI_ERROR" != "" ];then
		INSERT_MYSQL "Hardware check: BMC $IPMI_ERROR" "warning:unknow"
		echo "$IPMI_RAW_ERROR" >> $LOG_FILE
	fi
	WALL_TIME=`date "+%m/%d/%Y %H:%M:%S"`
	ipmitool sel time set "$WALL_TIME" >/dev/null 2>&1
}

function memory_check () {
	system_memory=`cat /proc/meminfo |grep -w "MemTotal:"|awk '{print $2}'`
	system_memory=`expr $system_memory / 1024 / 1024`
	physical_memory=`dmidecode | sed -n -r '/^[[:space:]]+Size/p' | grep "MB"|awk '{print $2}'`
	physical_memory=`echo $physical_memory|awk '{i=0;sum=0;while(i<NF){i++;sum=sum+$i};print(int(sum/1024))}'`
	dif_value=`expr $physical_memory - $system_memory`
	if [ $dif_value -gt 1 -a $physical_memory -lt 16 ];then
		INSERT_MYSQL "Hardware check: physical_memory $physical_memory G not equal System_memory $system_memory G" "error:memory"
		return
	fi
	if [ $dif_value -gt 2 ] && [ $physical_memory -ge 16 ] && [ $physical_memory -le 50 ];then
		INSERT_MYSQL "Hardware check: physical_memory $physical_memory G not equal System_memory $system_memory G" "error:memory"
		return
	fi
	if [ $dif_value -gt 3 ] && [ $physical_memory -gt 50 ];then
		INSERT_MYSQL "Hardware check: physical_memory $physical_memory G not equal System_memory $system_memory G" "error:memory"
		return
	fi
}

# main
[[ ! -f $LOG_FILE ]] && touch $LOG_FILE
[[ ! -f $LOG_MARK ]] && touch $LOG_MARK

/bin/bash /usr/local/i386/*/auto/unlock_process.sh "ipmitool" "300"

# ڴ
if [ "$IS_VISUAL" != "YES" ];then
	memory_check
fi
# Ӳ̼
hard_disk_check
# ־Ϣ
log_prase
# BMC ־鿴
ls -l /dev/ipmi* >/dev/null 2>&1
[[ "$?" -eq 0 ]] && ipmi_log_prase
for ipmi_pid in $(pidof ipmievd);do
	kill -9 $ipmi_pid
done

# ־ռѹ̼

rm -rf /var/log/hardware_error/ > /dev/null 2>&1
mkdir -p /var/log/hardware_error
type_error_collect=$(grep 'error:' $TMP_FILE1|awk -F ':' '{print $2}'|sort -u)
for a_type in $type_error_collect;do
	if [ "$a_type" == "disk" ];then
		if [ "`lspci|grep -E -w "RAID|SCSI"|grep -E -w "MegaRAID SAS|MegaSAS" > /dev/null && echo "MegaRAID"`" == "MegaRAID" ];then
			echo -e "\n==================================================================\n" >> /var/log/hardware_error/disk.log
			/usr/sbin/megacli -cfgdsply -aall >> /var/log/hardware_error/disk.log
			echo -e "\n==================================================================\n" >> /var/log/hardware_error/disk.log
			/usr/sbin/megacli -AdpAllInfo -aALL >> /var/log/hardware_error/disk.log
			echo -e "\n==================================================================\n" >> /var/log/hardware_error/disk.log
			/usr/sbin/megacli -pdlist -aall >> /var/log/hardware_error/disk.log
			echo -e "\n==================================================================\n" >> /var/log/hardware_error/disk.log
			/usr/sbin/megacli -ldinfo -lall -aall >> /var/log/hardware_error/disk.log
		elif [ "`lspci|grep -E -w "RAID|SCSI"|grep -w "Smart Array" > /dev/null && echo "Smart_Array"`" == "Smart_Array" ];then
			/usr/sbin/hpacucli ctrl all show config >> /var/log/hardware_error/disk.log
			/usr/sbin/hpacucli ctrl all show status >> /var/log/hardware_error/disk.log
		else
			for b in /dev/sd[a-z] /dev/sd[a-z][a-z];do
				echo "================== $b =====================" >> /var/log/hardware_error/disk.log
				smartctl -a $b >> /var/log/hardware_error/disk.log
			done
		fi

		[[ -s /etc/hardware_info ]] && cat /etc/hardware_info|grep -v "IP_Address" > /var/log/hardware_error/hardware_info.log
		echo -e "\n======================== Dmidecode info =========================\n" >> /var/log/hardware_error/hardware_info.log
		dmidecode >> /var/log/hardware_error/hardware_info.log
	elif [ "$a_type" == "memory" ];then
		echo $KERNEL_VERSION | grep -q '3.5.0' || \
		ipmitool sel list 0 >> /var/log/hardware_error/ipmi.log
		echo "=================== system_memory ==================" >> /var/log/hardware_error/memory.log
		cat /proc/meminfo >> /var/log/hardware_error/memory.log

		echo "=================== hardware_memory ==================" >> /var/log/hardware_error/memory.log
		dmidecode | sed -n -r '/^[[:space:]]+Size/p' >> /var/log/hardware_error/memory.log

		mce_error=$(mcelog --client)
		if [ "x${mce_error}" != "x" ];then
			echo "=================== mcelog --client ==================" >> /var/log/hardware_error/mcelog_error.log
			echo "=================== $wall_time =========" >> /var/log/hardware_error/mcelog_error.log
			printf "$mce_error" >> /var/log/hardware_error/mcelog_error.log
			[ -s /var/log/mcelog ] && tail -n 2000 /var/log/mcelog > /var/log/hardware_error/mcelog
		fi


		[[ -s /etc/hardware_info ]] && cat /etc/hardware_info|grep -v "IP_Address" > /var/log/hardware_error/hardware_info.log
		echo -e "\n======================== Dmidecode info =========================\n" >> /var/log/hardware_error/hardware_info.log
		dmidecode >> /var/log/hardware_error/hardware_info.log
	fi
done

if [  "x${type_error_collect}" != "x" ];then
	[[ -f /var/log/hardware_error.tar.gz ]] && rm -f /var/log/hardware_error.tar.gz
	tail -n100 $LOG_FILE > /var/log/hardware_error/error.log
	cd /var/log && tar zcf hardware_error.tar.gz hardware_error/ > /dev/null 2>&1

	SERVERID=$(split_tag "server_id" $HOSTFILE "=")
	if [ "x${SERVERID}" != "x" ];then
		LOG_SERVER=$(select_log_ip)
		curl -m 5 --retry 1 -u api_invoke_user:nyZCiVxxRiOSw \
		-T /var/log/hardware_error.tar.gz \
		"http://${LOG_SERVER}:6080/hardware_error_${SERVERID}.tar.gz"

		[ "$?" -ne 0 ] && rsync --port=8730 /var/log/hardware_error.tar.gz \
			${LOG_SERVER}::hardware_error_log/hardware_error_${SERVERID}.tar.gz
	fi
fi


rm -rf $DISK_TMP_FILE $TMP_FILE1 $TMP_FILE2 /var/log/hardware_error/
exit 0
