#!/bin/bash
#DATA:2012-09-13
#Written by wuhaiting.
#README:monitor hardware. fan,tempture,memory,disk,accelerator

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
DISK_TMP_FILE=`mktemp /tmp/disk_status.XXXX`
DISK_TMP_FILE1=`mktemp /tmp/disk_status.XXXX`
DISK_TMP_FILE2=`mktemp /tmp/disk_status.XXXX`

# check linux version
cat /etc/issue|grep -i -E "CentOS|Red" >/dev/null 2>&1 && LINUX_VERSION="centos"
cat /etc/issue|grep -i -E "Ubuntu|Debian" >/dev/null 2>&1 && LINUX_VERSION="ubuntu"
SYSTEM_VERSION=`getconf LONG_BIT`
if [ "$LINUX_VERSION" = "" ] || [ "$SYSTEM_VERSION" == "" ];then exit 1;fi

# basic define
BASENAME=`basename $0`
SHORT_NAME=mon_hardware
LOG_DIR=/var/log/sysop_manager

# repository path
REPOS_NAME=comm_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
PUBLIC_DIR=/usr/local/i386/public_repos
INSERT_MSG_DIR=`ls /usr/local/i386/*/auto/insert_message.sh`

# get ip address 
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi 

# exclude list
cat /usr/local/i386/*/initial_system/exclude_list.log|grep -v ^# | grep "^$IPADDR[[:space:]]\+[[:alnum:] ]*$SHORT_NAME" && exit 1

INSERT_MYSQL () {
	echo $1
}

# wget function
wget_action () {
	wget --http-user=manifold --http-passwd=dw_manifold --output-document=$1 --timeout=$2 --tries=$3 "http://$4:63217/$5"
}

DMIDECODE_DIR=`which dmidecode`
MANUFACTURER=`$DMIDECODE_DIR -s system-manufacturer`
RAID_DEVICE=`lspci|grep -E -w "RAID|SCSI|SATA"`

function hard_disk_check () {
    for DIR in `cat /etc/mtab |grep ^/dev |awk '{print $2}'`
    do
        TEMP_FILE=`mktemp -p $DIR`
        if [ "$?" -ne 0 ];then
            INSERT_MYSQL "Hardware check:readonly,partition:$DIR" "error:disk"
        else
            rm -f $TEMP_FILE
        fi  
    done
	
	# 从阵列卡检查硬盘故障
	if [ ! -z "$RAID_DEVICE" ];then
	# LSI MegaRaid array 
		if [ "`lspci|grep -E -w "RAID|SCSI"|grep -E -w "MegaRAID SAS|MegaSAS" > /dev/null && echo "MegaRAID"`" == "MegaRAID" ];then
			if [ ! -f /usr/sbin/megacli ];then
				if [ "$LINUX_VERSION" == "ubuntu" ];then
					cd /tmp && aptitude -y download megacli ;dpkg -i megacli* ;rm -rf megacli* ;cd -
				elif [ "$LINUX_VERSION" == "centos" ];then
					wget_action /tmp/megacli-8.00.29.tar.bz2 8 2 121.14.36.27 package/megacli-8.00.29.tar.bz2
					[[ "$?" -eq 0 ]] && cd /tmp && tar jxf megacli-8.00.29.tar.bz2 && rpm -i lib_utils-1.00-08.noarch.rpm && rpm -i megacli-8.00.29-1.i386.rpm
					[[ -x /opt/MegaRAID/MegaCli/MegaCli64 ]] && ln -s /opt/MegaRAID/MegaCli/MegaCli64 /usr/sbin/megacli
					cd - && rm -f /tmp/megacli.* /tmp/lib_utils.*
				fi
				[[ ! -f /usr/sbin/megacli ]] && return 1
			fi
			
			/usr/sbin/megacli -ldpdinfo -aall > $DISK_TMP_FILE
			cat $DISK_TMP_FILE|awk -F '[ :]' '{
				if($0 ~ /^Virtual Drive/){
					a=$4;
				}else if($0 ~ /^RAID Level.*/){
					b=$(NF-4);
					c=$(NF-3);
				}else if($0 ~ /^Size/){
					d=$(NF-1)" "$NF;
				}else if($0 ~ /^State/){
					e=$NF;
					if(e == "Optimal"){
						e="OK";
					}else{
						e="Fail";
					};
				}else if($0 ~ /^Number Of Drives/){
					f=$NF;
				}else if($0 ~ /^Span Depth/){
					g=$NF;
					if(g > 1){
						printf("logicaldrive %s (%s, RAID %s+%s, %s)\n",a,d,b,c,e);
					}else{
						printf("logicaldrive %s (%s, RAID %s, %s)\n",a,d,b,e);
					}
				}
			}'|sed -e "s/Primary-//g" -e "s/Secondary-//g"|tr -d "," > $DISK_TMP_FILE1

			/usr/sbin/megacli -pdLIST -aall > $DISK_TMP_FILE
			cat $DISK_TMP_FILE|awk -F '[ :]' '{
				if($0 ~ /^Slot Number/){
					h=$NF;
				}else if($0 ~ /^Drive.*postion/){
					i=$6;
				}else if($0 ~ /^Media Error Count/){
					j=$NF;
				}else if($0 ~ /^Predictive Failure Count/){
					l=$NF;
				}else if($0 ~ /^PD Type/){
					n=$NF;
				}else if($0 ~ /^Raw Size:/){
					m=$4" "$5;
				}else if($0 ~ /^Firmware state/){
					o=$4$5$6;
					if(o != "Online,SpunUp" && o != "Online,Spundown" && o != "Hotspare,SpunUp" && o != "Rebuild"){
						o="Fail";
					}else {
						if(o != "Rebuild"){
							o="OK";
						}
					}
					if(j != "0" || l != "0"){
						j="Fail";
					}else{
						j="OK";
					}
					if(o == "Fail" || j == "Fail"){
						o="Fail"
					}
					printf("\tphysicaldrive 1I:%s:%s (%s, %s, %s)\n",i,h,n,m,o);
				} 
			}'|sed -e "s/Primary-//g" -e "s/Secondary-//g"|tr -d "," > $DISK_TMP_FILE2
			cat $DISK_TMP_FILE1|grep -v -E "^$|^#"|while read entry;do
				echo $entry
				ld_num=`echo $entry|awk '{print $2}'`
				cat $DISK_TMP_FILE2|grep ":$ld_num:"
			done
					
			#cat $DISK_TMP_FILE1
			#cat $DISK_TMP_FILE2
			return 0
		
		elif [ "`lspci|grep -E -w "RAID|SCSI"|grep -Ew "Smart Array|Hewlett-Packard" > /dev/null && echo "Smart_Array"`" == "Smart_Array" ];then
			if [ ! -f /usr/sbin/hpacucli ];then
				if [ "$LINUX_VERSION" == "ubuntu" ];then
					cd /tmp && apt-get update >/dev/null;aptitude -y download hpacucli;dpkg -i hpacucli* ;rm -rf hpacucli* ;cd -
				elif [ "$LINUX_VERSION" == "centos" ];then
					wget_action /tmp/hpacucli-8.75-12.0.noarch.rpm 8 2 121.14.36.27 package/hpacucli-8.75-12.0.noarch.rpm
					[[ "$?" -eq 0 ]] && rpm -i /tmp/hpacucli-8.75-12.0.noarch.rpm
					rm -f /tmp/hpacucli-8.75-12.0.noarch.rpm
					
					if [ ! -f /usr/sbin/hpacucli ];then
						wget_action /tmp/hpacucli-9.30-15.0.x86_64.rpm 8 2 121.14.36.27 package/hpacucli-9.30-15.0.x86_64.rpm
						[[ "$?" -eq 0 ]] && rpm -i /tmp/hpacucli-9.30-15.0.x86_64.rpm
					fi
				fi
				[[ ! -f /usr/sbin/hpacucli ]] && return 1
			fi
			/usr/sbin/hpacucli ctrl all show config|grep -E "logicaldrive|physicaldrive"|sed -e "s/port.*I:box.*:bay.[0-9],//g" -e "s/^[[:space:]]*//g"|awk '{if($0 ~ /^physicaldrive/){printf("\t%s\n",$0)}else{print $0}}'
		else
			# Use smartmontools to monitor disk status,which use disk's S.M.A.R.T table
			if [ ! -x /usr/sbin/smartctl ];then
				if [ "$LINUX_VERSION" == "ubuntu" ];then
					cd /tmp;aptitude download smartmontools > /dev/null 2>&1;dpkg -i smartmontools*;rm -f /etc/rc2.d/S20smartmontools /tmp/smartmontools*;cd -
				elif [ "$LINUX_VERSION" == "centos" ];then
					if [ "`lsb_release -a|grep "Release"|awk -F ":" '{print $2}'|awk -F "." '{print $1}'`" == "5" ];then
						wget http://mirror.centos.org/centos/5/os/i386/CentOS/smartmontools-5.38-3.el5.i386.rpm
						[[ "$?" -eq 0 ]] && rpm -i smartmontools-5.38-3.el5.i386.rpm
					else
						yum -y install smartmontools
					fi
				fi
				[[ ! -x /usr/sbin/smartctl ]] && return 1
			fi
			fdisk -l 2>/dev/null|grep -w "Disk /dev/.*:"|grep -v "MB"|awk '{printf("%s %s%s\n",$2,$3,$4)}'|sort > $DISK_TMP_FILE2
			which lsiutil > /dev/null 2>&1
			if [[ "$?" -ne 0 ]] && [[ "$LINUX_VERSION" == "ubuntu" ]];then
				apt-get -y --force-yes install lsiutil > /dev/null 2>&1
			fi
			which lsiutil > /dev/null 2>&1
			if [ "$?" -eq 0 ];then
				lsiutil -p1 -a8,0 > $DISK_TMP_FILE
				LSI_DISK_NUM=`cat $DISK_TMP_FILE|grep -E "PhysDisk|Disk"|wc -l`
				FDISK_DISK_NUM=`cat $DISK_TMP_FILE2|wc -l`

				if [ "$FDISK_DISK_NUM" != "$LSI_DISK_NUM" ];then
					lsiutil -p1 -a21,1,0,0 > $DISK_TMP_FILE
					cat $DISK_TMP_FILE|awk '{
						if($0 ~ /^Volume.*is.*Bus/){
							a=$5;
							b=$(NF-1)$NF;
						}else if($0 ~ /Volume State:/){
							c=$3;
							if(c == "optimal,"){
								c="OK"
							}else{
								c="Fail"
							}
						}else if($0 ~ /Volume Size/){
							d=$3;
							if(b == "(IntegratedMirroring)"){
								printf("logicaldrive %s (%s GB, RAID 1, %s)\n",a,int(d/1024),c);
							}else{
								printf("logicaldrive %s (%s GB, RAID 0, %s)\n",a,int(d/1024),c);
							}
						}
					}' > $DISK_TMP_FILE1
					
					lsiutil -p1 -a21,2,0,0 > $DISK_TMP_FILE
					cat $DISK_TMP_FILE|awk '{
						if($0 ~ /PhysDisk.*is.*Bus.*Target/){
							a=$2;
							b=$5;
						}else if($0 ~ /PhysDisk State:/){
							c=$NF;
							if(c != "online"){
								c="Fail";
							}else{
								c="OK"
							}
						}else if($0 ~ /PhysDisk Size/){
							d=$3;
							printf("\tphysicaldrive 1I:%s:%s (SAS, %s GB, %s)\n",b,a,int(d/1024),c);
						}
					}' > $DISK_TMP_FILE2
					
					cat $DISK_TMP_FILE1|grep -v -E "^$|^#"|while read entry;do
						echo $entry
						ld_num=`echo $entry|awk '{print $2}'`
						cat $DISK_TMP_FILE2|grep ":$ld_num:"
					done
				else
					cat /dev/null > $DISK_TMP_FILE1
					for a in `ls /dev/sd?`;do
						smartctl -a $a > $DISK_TMP_FILE
						cat $DISK_TMP_FILE |grep "does not support SMART" > /dev/null 2>&1 && continue
						cat $DISK_TMP_FILE|awk '{
							if($0 ~ /^Serial/){
								a=$NF;
							}else if($0 ~ /Transport protocol:/){
								b=$NF;
							}else if($0 ~ /^ATA Standard/){
								b="SATA"
							}else if($0 ~ /^SMART Health Status/ || $0 ~ /^SMART.*test result:/){
								c=$NF;
								if(c == "OK" || c == "PASSED"){
									c="OK"
								}else{
									c="Fail"
								}
								printf("%s, %s, physicaldrive SN:%s\n",b,c,a);
							}
						}' >> $DISK_TMP_FILE1
					done
					paste -d " " $DISK_TMP_FILE2 $DISK_TMP_FILE1
				fi
			else
				cat /dev/null > $DISK_TMP_FILE1
				for a in `ls /dev/sd?`;do
					smartctl -a $a > $DISK_TMP_FILE
					cat $DISK_TMP_FILE |grep "does not support SMART" > /dev/null 2>&1 && continue
					cat $DISK_TMP_FILE|awk '{
						if($0 ~ /^Serial/){
							a=$NF;
						}else if($0 ~ /Transport protocol:/){
							b=$NF;
						}else if($0 ~ /^ATA Standard/){
								b="SATA"
						}else if($0 ~ /^SMART Health Status/ || $0 ~ /^SMART.*test result:/){
							c=$NF;
							if(c == "OK" || c == "PASSED"){
								c="OK"
							}else{
								c="Fail"
							}
							printf("%s, %s, physicaldrive SN:%s\n",b,c,a);
						}
					}' >> $DISK_TMP_FILE1
				done
				paste -d " " $DISK_TMP_FILE2 $DISK_TMP_FILE1
			fi
		fi
	fi
	
}

# 硬盘检测
hard_disk_check


rm -f $DISK_TMP_FILE $DISK_TMP_FILE1 $DISK_TMP_FILE2 CmdTool.log  MegaSAS.log
exit 0
