#!/bin/bash

if [ "$#" -lt 2 ] 
then
	echo "Usage: $(basename $0) action(backup|remove) file|dir"
	exit
fi

TIME_STAMP=$(date +%F)
BACKUP_DIR=/data/backup/bizop_web_$TIME_STAMP

ACTION=$1
if [ "$ACTION" != "backup" ] && [ "$ACTION" != "remove" ];then
	echo 'Action illegal'
	echo "aaRESULT=1"
	exit
fi

if ! [ -d "$BACKUP_DIR" ] && [ "$ACTION" == "backup" ];then
	mkdir -p $BACKUP_DIR
fi

shift

for FILE in $*
do
	if [ -e "$FILE" ];then
		# 防止动到跟分区
		[ "$FILE" == "/" ] && continue
		[ "$ACTION" == "backup" ] && mv -v $FILE $BACKUP_DIR 
		[ "$ACTION" == "remove" ] && rm -v -rf $FILE 
	else
		echo "$FILE not exist"
	fi
done
echo "aaRESULT=0"
