#!/bin/bash

# this script is used by bizop.sysop.duowan.com ,

# not for yydeploy.sysop.duowan.com

# the only one difference is no ##INSTRALL_PATH## support

set +H

export PATH="/usr/bin:/bin:/sbin:/usr/sbin"

export LANG=C

mainConfFile=/data/pkg/public-scripts/conf/main.conf

commFuncFile=/data/pkg/public-scripts/func/common.sh

privateFuncFile=/data/pkg/public-scripts/bin/functions.sh

source $mainConfFile && source $commFuncFile && source $privateFuncFile



function replace_pattern {

   local fileList=${*:?$FUNCNAME [ERR ] | file list is NULL}

   local groupId isp eth0Ip ctlIp cncIp eduIp mobIp bgpIp allIp firstIp secondIp

   local areaId cityId idcId ispcode

   local rList pattern value i j x

   for i in $fileList ; do

       if [ ! -f $i ] ; then

           echo "Err! file $i not exist"

           aaRESULT=1 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT
       fi

   done

   for i in $fileList ; do

       x=$(readlink -e $i)

       if [ -z "$x" ] ; then

             echo "Err! file [$i] point to an invalid path"

             aaRESULT=1 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT

       elif [ "$x" != "$i" ] ; then # is a symbol link

            info_log "$i ==> $x"

            newFileList="$newFileList $x"
       else
            newFileList="$newFileList $i"
       fi

   done

   if [ -z "$newFileList" ] ; then

        err_log "no valid file found , replace pattern failed"

        aaRESULT=1 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT
   fi

   groupId=$(get_pri_groupId $HOST_INFO_FILE) || { echo "get primary group id failed" ; aaRESULT=1 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT ; }

   areaId=$(get_area_id $HOST_INFO_FILE)      || { echo "get area id failed" ; aaRESULT=1 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT ; }

   cityId=$(get_city_id $HOST_INFO_FILE)      || { echo "get city id failed" ; aaRESULT=1 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT ; }

   idcId=$(get_idc_id $HOST_INFO_FILE)        || { echo "get idc id failed" ; aaRESULT=1 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT ; }

   isp=$(get_host_isp $HOST_INFO_FILE)        || { echo "get isp failed" ; aaRESULT=1 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT ; }

   # add isp-code for V4

   case $isp in

     'CTL') ispcode=1   ;;

     'CNC') ispcode=2   ;;

     'EDU') ispcode=8   ;;

     'MOB') ispcode=32  ;; 

     'HK')  ispcode=128 ;;

     'BRA') ispcode=256 ;;
 
     'BGP') ispcode=64  ;;

     'WBN') ispcode=16  ;;

    'CNII') ispcode=4   ;;

    'DUAL') ispcode=3   ;;
   
        *)  ispcode=0   ;;
   esac



   # get host info

   ctlIp=$(get_ip_by_isp $HOST_INFO_FILE "CTL")
   
   cncIp=$(get_ip_by_isp $HOST_INFO_FILE "CNC")
   
   bgpIp=$(get_ip_by_isp $HOST_INFO_FILE "BGP")
   
   eduIp=$(get_ip_by_isp $HOST_INFO_FILE "EDU")
   
   mobIp=$(get_ip_by_isp $HOST_INFO_FILE "MOB")
   
   eth0Ip=$(get_local_ip "eth0" | head -1)
   
   allIp=$(get_all_ip)
   
   firstIp=$(get_first_ip)
   
   secondIp=$(get_second_ip)
   
   installPath="$PKG_HOME_DIR/$pkg-$ver"

   # create key:value array for each pattern

   declare -a rList

   rList+=(

           "##PRI_GROUP_ID##:$groupId"

           "##AREA_ID##:$areaId"
           
           "##CITY_ID##:$cityId"
           
           "##IDC_ID##:$idcId"
           
           "##ISP##:$isp"
           
           "##ISP_CODE##:$ispcode"
           
           "##CTL_IP##:$ctlIp"
           
           "##CNC_IP##:$cncIp"
           
           "##BGP_IP##:$bgpIp"
           
           "##EDU_IP##:$eduIp"
           
           "##MOB_IP##:$mobIp"
           
           "##ETH0_IP##:$eth0Ip"
           
           "##ALL_IP##:$allIp"
           
           "##FIRST_IP##:$firstIp"
           
           "##SECOND_IP##:$secondIp"
   )

   info_log ""

   for i in $newFileList ; do

       cp -af $i ${i}${REPLACE_BAK_SUFFIX} && \

       for j in "${rList[@]}" ; do

             pattern=$(echo "$j" | awk -F ':' '{print $1}')

             value=$(echo "$j" | awk -F ':' '{print $2}')

             if ! sed -r -i -e "s!$pattern!$value!g" $i  ; then

                err_log "replace $pattern = [$value] for file $i failed"

                aaRESULT=1 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT ;  
             fi
       done 

       if [ "$(md5sum $i ${i}.bak | awk '{print $1}' | sort -u | wc -w)" -eq 1 ] ; then

            #info_log "[not changed] [$i]" 

            rm -f ${i}.bak
       else
            info_log "[changed] [$i]"
       fi

   done

   info_log ""

   aaRESULT=0 ; echo "aaRESULT=$aaRESULT"; return $aaRESULT ;

   return
}

replace_pattern $*
