#!/bin/bash

# FILENAME     : stop_rsync.bash
# DESCRIPTION  : stop rsync by presetting pid file.
# AUTHOR       : Juliam
# CREATED DATE : 2013-12-20
# LAST MODIFIED: 2013-12-20

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

if [ "$(whoami)" != "root" ]
then
        echo "----- MUST be run by root! ------"
        exit 1
fi

RSYNC_CONF=/tmp/rsync_bizop.conf
USER_F=/tmp/rsync_bizop.user
PID_F=/tmp/rsync_bizop.pid
LOCK_F=/tmp/rsync_bizop.lock
LOG_F=/tmp/rsync_bizop.log
[ ! -f "$PID_F" ] && { echo "PID file not exist.";exit 0; }
echo "STOPPING rsync daemon from pid $(cat $PID_F)."
kill -9 $(cat $PID_F)
ps -p $(cat $PID_F) > /dev/null && { echo "FAILE."; exit 1; } || echo "DONE." 

echo "CLEANNING trash file."
rm -fv $RSYNC_CONF $RSYNC_CONF $USER_F $PID_F $LOCK_F $LOG_F
echo "FINISHED."
