#!/bin/bash
# NAME            : $0 
# Ver             : 0.4
# Author          : boblin(linbobo@chinaduo.com)
# LastModified by : boblin(linbobo@chinaduo.com)
# LastModified    : 2013-11-29
# Summary         : temparory iptables script for WCG !!!

# doBlock : false -- only record attacker ip
# doBlock : dry-run -- only record attacker ip and display iptables command
# doBlock : true -- record attacker ip and block attacker ip 

mode=$1

doBlock='true'

#threshold=100

while true ; do

      mkdir -p /data/temp/wcg/ &>/dev/null

      ts=$(date +'%Y-%m-%d_%H%M')

      ipFile="/data/temp/wcg/attacker_ip.$ts"

      logFile="/data/temp/wcg/iptables.$ts"

      source /data/bizop/public-scripts/bin/tool/private/temp/wcg/main.conf

      : ${threshold:=100}

      echo "#$(date +'%F %T')| threshold=$threshold" >> $logFile

      suspect_list=$(ss -ntu | awk '{print $6}' | cut -d ':' -f 1 | sort |uniq -c |sort -rn | awk -v x=$threshold '$1 > x' )

      suspect_ip=$(echo "$suspect_list" | awk '{print $2}')
      
      our_ip=$(egrep -v '^#|^[[:space:]]*$' /data/bizop/public-scripts/bin/tool/private/temp/wcg/our_ip.txt | sed 's/,/\n/g' )
      
      if [ -z "$our_ip" ] ; then
      
            echo "FATAL ! no our ip defined , exit immediately"
       
            exit 1
      else
            echo "found $(echo "$our_ip" | wc -l) our ip , continue to work"
      fi
      
      # filter out attacker ip
      
      attacker_ip=$(join -v 1 <(echo "$suspect_ip" |sort -u) <(echo "$our_ip" |sort -u))

      attacker_list=$(for i in $attacker_ip ; do  grep $i <<< "$suspect_list" |awk '{print $2,$1}' ; done)

      # record
      
      echo "$attacker_list" > $ipFile
      
      if [ -n "$attacker_ip" ] ; then

            # send alarm

            #python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_int.py 11245 1

            echo "#$(date +'%F %T')| found $(echo "$attacker_ip" | wc -w) attacker !" >> $logFile

            if [ "$doBlock" = "false" ] ; then
            
                 echo "#$(date +'%F %T')| doBlock == false , only output attacker ip , no block action will be taked  , quit now" >> $logFile
            
                 exit 0
            
            elif [ "$doBlock" = "dry-run" ] ; then
            
                 echo "#$(date +'%F %T')| doBlock == dry-run , only output iptables commands , no block action will be taked " >> $logFile
            
                 for i in $attacker_ip ; do
                 
                     echo "#$(date +'%F %T')| iptables -I INPUT 3 -s $i -j DROP" >> $logFile

                 done
      
            elif [ "$doBlock" = "true" ] ; then
      
                 echo "#$(date +'%F %T')| doBlock == true , begin to block attacker ip" >> $logFile
      
                 for i in $attacker_ip ; do

                     if ! iptables -nvL | grep -q $i ; then

                         cmd="iptables -I INPUT 3 -s $i -j DROP"

                         echo "$(date +'%F %T')| $cmd" >> $logFile
      
                         iptables -I INPUT 3 -s $i -j DROP
                    else
                         echo "$(date +'%F %T')| $i already in blacklist , no need to add to iptables" >> $logFile
                    fi
      
                 done  
            fi
      else
            echo "no attacker found"
      fi

      # truncate the  iptables table , and wait for the re-sync

      if [ "$(date +'%H%M')" = '0000' ] ; then

           iptables -F
      fi

      if [ "$mode" = "" ] ; then

           exit 

      elif [ "$mode" = "daemon" ] ; then

           sleep 60
      fi
done
