#!/bin/bash

#Create by linrunjin 2013/07/02

E_WRONG_ARGS=6
E_SOURCE_NOT_EXIST=7
E_DST_FILE_EXIST=8
E_DSTDIR_NOT_EXIST=9


function untar {
	# going to auto untar
	cd "$DEST_FILE"
	if tar tf $SOURCE_FILE
	then
		tar xvzf $SOURCE_FILE
		echo "untar success"
		echo "aaRESULT=0"
		return
	fi
}

if [ "$#" -ne 4 ]
then
	echo "Usage $(basename $0) source destination untar parseconfig"
	exit $E_WRONG_ARGS
fi

SOURCE_FILE="/tmp/$1"
DEST_FILE="$2"
UNTAR="$3"
PARSE_CONFIG="$4"

if [ ! -f "$SOURCE_FILE" ]
then
	echo "source file $1 not exist!";
	exit $E_SOURCE_NOT_EXIST
fi

if [ -f "$DEST_FILE" ]
then
	echo "$DEST_FILE is a file not a directroy"
	exit 1
fi

if [ ! -d "$DEST_FILE" ]
then
	echo "DIR $2 not exist! going to Create it";
	mkdir -p $2 && echo "$2 Create success!"
fi

if [ -f "$2/$1" ]
then
	scr_sum=$(md5sum $SOURCE_FILE | cut -d' ' -f1)
	dst_sum=$(md5sum $2/$1 | cut -d' ' -f1)
	if [ "$scr_sum" == "$dst_sum" ]
	then
		echo "source and dest file md5 match"
		echo "aaRESULT=0"
		[[ "$UNTAR" -eq 1 ]] && untar
	else
		echo "$2/$1 file exist! going to backup!"
		mv -v "$2/$1" "$2/$1.bak_$(date +%F_%T)" && cp -av /tmp/$1 $2
		echo "aaRESULT=0"
		[[ "$UNTAR" -eq 1 ]] && untar
	fi
else
	cp -av /tmp/$1 $2
	echo "copy success"
	echo "aaRESULT=0"
	[[ "$UNTAR" -eq 1 ]] && untar
fi

if [ "$PARSE_CONFIG" -eq 1 ]
then
	if [ -d "$2/$1" ]
	then
		echo "$2/$1 is directory ,not support parse config"
		echo "aaRESULT=1"
	elif [ -f "$2/$1" ]
	then
		echo "going to parse file $2/$1"
		/bin/bash /data/bizop/public-scripts/bin/replace_pattern.sh $2/$1
		if [ "$?" -eq 0 ]
		then
			echo "parse succeed !"
			echo "aaRESULT=0"
		else
			echo "parse failed !"
			echo "aaRESULT=1"
		fi
	else
		echo "$2/$1 not exist"
		echo "aaRESULT=1"
	fi
else
	echo "no need to prase config , all done"
	echo "aaRESULT=0"
fi
