import socket
import os,signal
import threading
import SocketServer
import traceback
import shlex
import time
from subprocess import Popen, PIPE

def call(cmd_str):
  try:
    args = shlex.split(cmd_str)
    if len(args) == 0:
      restr = '\r\n\r\n'
      return restr

    pp = Popen(args, stdout=PIPE,stderr=PIPE)

    start_ts = int(time.time())
    while pp.poll() is None and (int(time.time()) - start_ts) < 11:
      #print pp.pid,'sleep 1',pp.returncode
      time.sleep(1)

    if pp.poll() == None: # child is not exit yet!
      #print 'kill ',pp.pid
      os.kill(pp.pid, signal.SIGTERM)
      os.kill(pp.pid, signal.SIGKILL)
      pp.wait()
      return '\r\n\r\n'

    restr,errstr= pp.communicate()
    restrjson = eval(restr);
    data = restrjson["data"];
    for d in data.keys():
      if cmp(data[d],"") is 0:
        data[d] = "NULL";
    restr = str(restrjson).replace("'","\"") + '\r\n\r\n'
    return restr
  except:
    print traceback.print_exc()
    restr = '\r\n\r\n'
    return restr

def get_port(start_port):
  try:
    max_port = start_port + 200
    for port in range(start_port, max_port):
      s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
      s.settimeout(1)
      try:
        s.connect(('127.0.0.1',port))
      except Exception:
        print 'port %d can use' % port
        return port
      s.close()
  except:
    print traceback.print_exc()
    print "get_port error"

def save_port(port):
  try:
    filename = "/home/dspeak/yyms/yyms_agent_2_d/assist/port"
    d = os.path.dirname(filename)
    if(not os.path.exists(d)):
      os.makedirs(d) 
    f = open(filename, 'wb')
    f.write(str(port))
    f.close()
  except:
    print traceback.print_exc()
    print "save_port error"

class ThreadedTCPRequestHandler(SocketServer.BaseRequestHandler):

  def handle(self):
    try:
      cmd_str = self.request.recv(1024)
      self.request.send(call(cmd_str))
    except:
      print 'call error'
      print traceback.print_exc()
      self.request.send('error\r\n\r\n')

class ThreadedTCPServer(SocketServer.ThreadingMixIn, SocketServer.TCPServer):
  pass

if __name__ == "__main__":
  # Port 0 means to select an arbitrary unused port
  port = get_port(13798)
  save_port(port)
  
  HOST, PORT = "127.0.0.1", port
  server = ThreadedTCPServer((HOST, PORT), ThreadedTCPRequestHandler)

  # Start a thread with the server -- that thread will then start one
  # more thread for each request
  server_thread = threading.Thread(target=server.serve_forever)
  # Exit the server thread when the main thread terminates
  server_thread.setDaemon(True)
  server_thread.start()
  
  server.serve_forever()
  #print "Server loop running in thread:", server_thread.getName()

