from channel_logger import Logger
import channel_util
import socket
import os
import threading
import SocketServer
    
class ThreadedTCPRequestHandler(SocketServer.BaseRequestHandler):

  def check_request_ip(self):
    try:
      ip,port = self.client_address
      if ip in channel_util.white_ip_list:
        Logger.logger.info('ip allow:%s'%ip)
        return True
      else:
        Logger.logger.info('ip refuse:%s'%ip)
        return False
    except:
      Logger.logger.exception('')
      return False
  def handle(self):
    reload(channel_util)
    if not self.check_request_ip():
      return;
    try:
      cmd_str = self.request.recv(10240)
      cmd_str = cmd_str.strip()
      Logger.logger.info('recv cmd src:%s'%cmd_str)
      ret,text = channel_util.verify_cmd(cmd_str)
      #ret,text = True,cmd_str
      Logger.logger.info('recv cmd:%s'%text)
      if ret:
        self.request.send('''{"code":0,"msg":"success"}''')
        channel_util.process(text)
        Logger.logger.info('deal cmd end')
      else:
        Logger.logger.info('verify_cmd failed')
        #self.request.send('not deal')
        pass
    except:
      #self.request.send('error\r\n\r\n')
      Logger.logger.exception('')

class ThreadedTCPServer(SocketServer.ThreadingMixIn, SocketServer.TCPServer):
  pass

if __name__ == "__main__":
  ThreadedTCPServer.allow_reuse_address = True
  port = channel_util.get_port()
  channel_util.save_port(port)
  server = ThreadedTCPServer(("", port), ThreadedTCPRequestHandler)
  import fcntl 
  flags = fcntl.fcntl(server.socket, fcntl.F_GETFD)
  fcntl.fcntl(server.socket, fcntl.F_SETFD, flags | fcntl.FD_CLOEXEC)
  server_thread = threading.Thread(target=server.serve_forever)
  server_thread.setDaemon(True)
  server_thread.start()
  server.serve_forever()
  

