
import redis 
import time
import sys
import random
import traceback
import thread
import logging
import logging.config
import ConfigParser
from get_local_ip import *

class LoggerC:
  def __init__(self):
    self.logger = None
    logging.config.fileConfig("/home/dspeak/yyms/yyms_agent_2_d/cron/trans_log.conf")
    self.logger = logging.getLogger('root')
  
Logger = LoggerC()

class RedisCache:
  def __init__(self):
    self.datanodes = []
    
  def set_dn_conn(self,key_pre):
    guid = get_guid2()
    ips = get_conf_center_ips()
    self.datanodes = []
    for item in ips:
      try:
        (host,port) = item
        config_conn = redis.Redis(host=host, port=port,socket_timeout=3)
        key = ""
        if key_pre == "yyms_alarmnodes_":
          key = "yyms_alarmnodes"
        else:
          key = "%s%s" % (key_pre,guid)
        ips_str = str(config_conn.get(key))
        lines = ips_str.split(',')
        for line in lines:
          words = line.split(':')
          if len(words) == 2:
            self.datanodes.append((words[0],int(words[1])))
          else:
            Logger.logger.info('get nodes failed,from %s'%str(item))
            self.datanodes = []
            
        if len(self.datanodes) > 0:
          break;
      except:
        Logger.logger.exception('')
        pass;
    if len(self.datanodes) == 0:
      Logger.logger.info('set datanodes failed')
      return False
    else:
      Logger.logger.info('%s:%s'%(key_pre,str(self.datanodes)))
      return True
  
  def push_data(self,datas,key):
    if len(self.datanodes) == 0:
      Logger.logger.info("no %s nodes"%key)
      return -1;
    for dns in self.datanodes:
      try:
        (host,port) = dns
        conn = redis.Redis(host=host, port=port,socket_timeout=3)
        pipe = conn.pipeline()
        for data in datas:
          rkey = ""
          if data.has_key("pid") and key == 'merged':
            rkey = 'proc'
          elif key == 'alarm' and data['key'] == "script_get_data_failed":
            rkey = 'alarm_self'
          else:
            rkey = key
          pipe.rpush(rkey,data)
          #print "%s|%s"%(rkey,data)
        pipe.execute()
      except:
        Logger.logger.exception('')
        pass;


class Transfer :
  def __init__(self,filenamelist,tagname,confkey,datakey):
    self.cur_ts = 0
    self.seq = 0
    self.pre_seq = 0
    self.file_name_list = filenamelist
    self.tag_name = tagname
    self.conf_key = confkey
    self.data_key = datakey
    self.redis = RedisCache()
    self.sleep_time = 3
    self.max_sleep_time = 10
    self.timer = 100
   
  def time_to_getConfig(self):
    self.timer += 1
    if self.timer > 100:
      self.timer = 1
      return True
    else:
      return False
    
  def set_to_getConfig(self):
    self.timer = 100
    
  def reset_sleep_time(self):
    self.sleep_time = 3
    
  def get_sleep_time(self):
    ti = self.sleep_time 
    self.sleep_time = 2*self.sleep_time
    if self.sleep_time > self.max_sleep_time:
      self.sleep_time = self.max_sleep_time
    return ti
    
  def save_ts(self):
    try:
      f = open(self.tag_name, 'w')
      tag = "%s %s %s"%(self.cur_ts,self.seq,self.pre_seq)
      f.write(tag)
      f.close()
    except:
      Logger.logger.exception('')
      pass;
    
  def load_ts(self):
    try:
      f = open(self.tag_name, 'r')
      strs = str(f.read())
      strl = strs.split()
      if len(strl) == 3:
        self.cur_ts = int(strl[0])
        self.seq = int(strl[1])
        self.pre_seq = int(strl[2])
      elif len(strl) == 2:
        self.cur_ts = int(strl[0])
        self.seq = int(strl[1])
        self.pre_seq = 0
      elif len(strl) == 1:
        self.cur_ts = int(strl[0])
        self.seq = 0
        self.pre_seq = 0
      f.close()
    except:
      self.cur_ts = 0
      self.seq = 0
      self.pre_seq = 0
      Logger.logger.exception('')
      pass;

  def read_pre(self):
    read_files = []
    read_files.append(self.file_name_list[1])

    for i in range(1,10):
      try:
        lines = None
        pre_file = open(self.file_name_list[i],'rb')
        first_line = eval(pre_file.readline())
        first_ts = first_line['ts']
        if first_ts >= self.cur_ts:
          read_files.append(self.file_name_list[i+1])
          pre_file.close()
        else:
          pre_file.close()
          break;
      except:
        Logger.logger.exception('')
    
    Logger.logger.info('pre files:%s'%str(read_files))

    for filename in read_files:
      try:
        pre_file = open(filename,'rb')
        Logger.logger.info(filename)
        lines = pre_file.readlines()
        records = self.read_line(lines)
        self.push_records(records)
        pre_file.close()
      except:
        Logger.logger.exception('')
    
  def read_line(self,lines):
    if lines is None:
      return None
    records = []
    cur_ts = 0
    cur_seq = 0
    guid = get_guid2()
    for line in lines:
      send_tag = False
      
      jstr = ""
      try:
        jstr = eval(line)
        cur_ts = jstr['ts']
      except:
        Logger.logger.exception('')
        continue;
            
      if cur_ts > self.cur_ts:
        send_tag = True
      elif cur_ts == self.cur_ts:
        cur_seq += 1
        if cur_seq > self.pre_seq:
          self.pre_seq = cur_seq
          send_tag = True
        else:
          continue;
      else:
        pass;
      
      if send_tag:
        try:
          data = jstr['da']
          if not data.has_key('guid'):
            data['guid'] = guid
          records.append(data)
          self.reset_sleep_time()
        except:
          Logger.logger.exception('')
          pass
    return records

  def push_records(self,records):
    if records is None or len(records) == 0:
      return -1;
    else:
      return self.redis.push_data(records,self.data_key)
     
  def transfer(self):
    lines = None
    first_line_str = ''
    cur_file = None
    try:
      cur_file = open(self.file_name_list[0],'rb')
      first_line_str = cur_file.readline()
      if len(first_line_str) > 0:
        first_line = eval(first_line_str)
        first_ts = first_line['ts']
        if first_ts >= self.cur_ts:
          self.read_pre()
        cur_file.seek(0)
      lines = cur_file.readlines()
      if lines is None:
        return;
    except:
      Logger.logger.exception('')
      Logger.logger.info(first_line_str)
      return;
    #Logger.logger.info('after pre,data type:%s'%(self.data_key))
    
    cur_ts = 0
    cur_seq = 0
    last_ts = 0
    records = []
    guid = get_guid2()
    for line in lines:
      jstr = ""
      try:
        if len(line) == 0:
          continue;
        jstr = eval(line.strip())
        cur_ts = jstr['ts']
      except:
        Logger.logger.exception('')
        continue;
      send_tag = False
      if cur_ts == self.cur_ts:
        cur_seq += 1
        if cur_seq > self.seq:
          self.seq = cur_seq
          send_tag = True
        else:
          continue;
      if cur_ts > self.cur_ts:
        send_tag = True
        if cur_ts == last_ts:
          cur_seq += 1
        elif cur_ts > last_ts:
          cur_seq = 1
      if send_tag:
        try:
          data = jstr['da']
          if not data.has_key('guid'):
            data['guid'] = guid
          records.append(data)
          self.reset_sleep_time()
        except:
          Logger.logger.exception('')
          pass
      last_ts = cur_ts;

    #Logger.logger.info('try records num:%s,data type:%s'%(len(records),self.data_key))
    self.push_records(records)
    if cur_ts > self.cur_ts:
      self.cur_ts = cur_ts
      self.seq = cur_seq
    cur_file.close()
    Logger.logger.info('records num:%s,last tag:%s,data type:%s'%(len(records),"%s %s %s"%(self.cur_ts,self.seq,self.pre_seq),self.data_key))
    
  def run(self):
    while(True):
      try:
        self.load_ts()
        
        if self.time_to_getConfig():
          Logger.logger.info('try to get datanode')
          if not self.redis.set_dn_conn(self.conf_key):
            Logger.logger.info('no datanode and sleep')
            self.set_to_getConfig()
            time.sleep(self.max_sleep_time)
            continue;
          
        self.transfer()
        self.save_ts()
        time.sleep(self.get_sleep_time())
      except:
        Logger.logger.exception('')
        time.sleep(self.max_sleep_time)
        pass
      
def trans_alarm_data():
  file_name = "/home/dspeak/yyms/yyms_agent_2_d/build/alarm_data/alarm_data.log"
  filenamelist = []
  filenamelist.append(file_name)
  for i in range(1,11):
    filenamelist.append("%s.%s"%(file_name,i))

  tagname = '/home/dspeak/yyms/yyms_agent_2_d/assist/alarm_data'
  conf_key = 'yyms_alarmnodes_'
  data_key = 'alarm'
  alarm_trans = Transfer(filenamelist,tagname,conf_key,data_key)
  alarm_trans.run()

def trans_merged_data():
  file_name = "/home/dspeak/yyms/yyms_agent_2_d/build/merged_data/merged_data.log"
  filenamelist = []
  filenamelist.append(file_name)
  for i in range(1,11):
    filenamelist.append("%s.%s"%(file_name,i))

  tagname = '/home/dspeak/yyms/yyms_agent_2_d/assist/merged_data'
  conf_key = 'yyms_datanodes_'
  data_key = 'merged'
  merged_trans = Transfer(filenamelist,tagname,conf_key,data_key)
  merged_trans.run()

def trans_proc_data():
    filenamelist = [
'/home/dspeak/yyms/yyms_agent_2_d/build/proc_data/proc_data.log',
]
    tagname = '/home/dspeak/yyms/yyms_agent_2_d/assist/proc_data'
   # alarm_trans = Transfer(filenamelist,tagname,ip,port,key)
   # alarm_trans.run()

if __name__ == '__main__':
  try:
    Logger.logger.info('transfer start') 
    thread.start_new_thread(trans_alarm_data,())
    thread.start_new_thread(trans_merged_data,())
    #thread.start_new_thread(trans_proc_data,())
  except:
    print traceback.print_exc()
  while True:
    time.sleep(1000)
  pass
