import os,sys
import socket
import pprint
from subprocess import Popen, PIPE
from get_local_ip import *
from except_deal import *
pp = pprint.PrettyPrinter(indent=4)

class Proc:
  def __init__(self):
    self.__sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM, 0)
    self.__sock.settimeout(1)
    self.__buffer_size = 10240;

  def __del__(self):
    self.__sock.close()

  def connect(self, port):
    self.__sock.connect(("127.0.0.1", port))

  def send_and_recv(self, cmd):
    self.__sock.send(cmd)

    total_data=[]
    while True:
      data = self.__sock.recv(self.__buffer_size)
      if not data: break
      total_data.append(data)
      if data.endswith("\r\n\r\n"): break;
    ret = ''.join(total_data)
    ret = ret.strip()    
    return ret

  def get_all(self):
    return self.send_and_recv("agent get all\r\n")

def deal_json(rstr):
  jstr = eval(rstr)
  pid = int(jstr['proc']['pid'])
  pname = jstr['proc']['pname']
  uri_num = len(jstr['stat']['uri'])
  return pname,pid,uri_num

def main():
  ip = get_default_ip()
  fp = open("/home/dspeak/yyms/yyms_agent_2_d/assist/proc_port", 'r')
  port_str = fp.read()
  fp.close()
  port_set = eval(port_str)
  
  report_str = ""
  for port in port_set:
    port = long(port);
    proc = Proc();
    proc.connect(port);
    rstr = proc.get_all()
    pname,pid,uri_num = deal_json(rstr)
    report_str += '''{"mid":"20020","ip":"%s","pname":"%s","pid":%s,"uri_num":%s}\n'''%(ip,pname,pid,uri_num)
    
  #print report_str
  push_redis_test("test",report_str)

if __name__ == '__main__':
  main()

