import os, sys,re,time
import urllib2
import redis
import time
import sys
import traceback
import subprocess
from subprocess import Popen, PIPE
from get_local_ip import *
from op_auto_proc_list import *

# ps
# etime     ELAPSEDelapsed time since the process was started, in the form [[dd-]hh:]mm:ss.
# ps -e -o stime,time,etime,pid,cmd | grep -v '\['
# ps -e -o etime,cmd | grep -v '\['

g_auto_discovery_file = "/home/dspeak/yyms/proc_auto_discovery"

def get_guid2():
  filename = "/home/dspeak/yyms/uuid"
  f = open(filename, 'r')
  guid = ''
  guid = f.read()
  f.close()
  guid = guid.strip()
  return guid

class PsList:
    __etime_pattern = re.compile(
        r"((?P<dd>\d+)-){0,1}((?P<hh>\d\d):){0,1}(?P<mm>\d\d):(?P<ss>\d\d)")
    __etime = 60*60*24
    __exclude_pnames = ['ssh', 'sshd', 'sshd:', 'scp', '-bash', 'sh','bash',
        'ps', 'cat', 'md5sum', 'rsync', 'grep', 'more', 'tail', 'head','vim','vi','python']
    def call(self, etime_flag=True):
        pslist = []
        try:
            lines = self.__call_sh()
        except:
            print traceback.print_exc()
            return None

        for line in lines[1:]:
            line = line.strip()
            if line == "": continue
            try:
                etime,seconds,cmd, cmd_words = self.__line_split(line)
                if(etime_flag):
                    if(seconds < self.__etime): continue
                if(not self.__cmd_filter(cmd_words)): continue
                pslist.append((etime,seconds,cmd, cmd_words))
            except:
                print line
                print traceback.print_exc()
                continue
        return pslist

    def __find_cmd(self, line, s):
        i = line.find(s) + len(s)
        return line[i:].strip()

    def __etime_to_seconds(self, etime):
        etime = etime.strip()
        m = self.__etime_pattern.search(etime)
        days = 0
        hours = 0
        minutes = 0
        seconds = 0
        if(m):
            dd = m.group("dd")
            if(dd): days = long(dd)
            hh = m.group("hh")
            if(hh): hours = long(hh)
            mm = m.group("mm")
            if(mm): minutes = long(mm)
            ss = m.group("ss")
            if(ss): seconds = long(ss)
        return days * 86400 + hours * 3600 + minutes * 60 + seconds

    def __line_split(self, line):
        tmp_list = line.split()
        etime = tmp_list[0]
        seconds = self.__etime_to_seconds(etime)
        cmd  = self.__find_cmd(line, " ")
        cmd_words = self.__cmd_split(cmd)
        return ( etime, seconds, cmd, cmd_words)

    def __cmd_filter(self, words):
        if(len(words) < 1): return False
        for name in self.__exclude_pnames:
            if(words[0].lower() == name): return False
        return True
    
    def __cmd_split(self, cmd):
        words = []
        temp_words = cmd.split(' ')
        proc_words = temp_words[0].split("/")
        words.append(proc_words[len(proc_words)-1])
        words += temp_words[1:]
        return filter (lambda a: a != "", words)


    def __call_sh(self):
        f = Popen(['sh','op_auto_find_proc.sh'], stdout=PIPE)
        out = f.stdout.read()
        return out.split('\n')

class AutoDiscovery:
    __ad_dict = {}
    __regex_dict = {}

    def __init__(self):
        for regex_pname in regex_pname_list:
            p = re.compile(regex_pname, re.IGNORECASE)
            self.__regex_dict[regex_pname] = p

    def run(self):

        self.__load()

        ps = PsList()
        ps_list = ps.call(True)
        for ps in ps_list:
            etime, seconds, cmd, cmd_words = ps
            ret = self.__search(cmd_words)
            if(ret):
                self.__ad_dict[ret] = "# %s %s %s" % (etime, seconds, cmd)
        self.__save()
        self.__alarm()
        pass

    def __search(self, cmd_words):
        for word in cmd_words:
            for regex_pname in regex_pname_list:
                p = self.__regex_dict[regex_pname]
                if(p.search(word)):
                    return regex_pname
        return None

    def __save(self):
        d = os.path.dirname(g_auto_discovery_file)
        if(not os.path.exists(d)):
            os.makedirs(d)
        f = open(g_auto_discovery_file, 'w')
        for k, v in self.__ad_dict.items():
            f.write("%s %s\n" % (k, v))
        f.close()
        pass

    def __alarm(self):
        cur_dict = {}
        ps = PsList()
        cur_ps_list = ps.call(False)
        for ps in cur_ps_list:
            etime,seconds,cmd, cmd_words = ps
            ret = self.__search(cmd_words)
            if(ret):
                cur_dict[ret] = "# %s %s %s" % (etime, seconds, cmd)
        alarm_pnames = []
        for k, v in self.__ad_dict.items():
            if(not cur_dict.has_key(k)):
                alarm_pnames.append(k)

        lost_list = ''.join(alarm_pnames)
        ip = get_default_ip()
        ts = long(time.time())
        jsonstr = '''{'mid':'%d',
        'hid':'%s',
        'key':'%s',
        'data':'%s',
        'units':'%s',
        'timestamp':'%s',
        'ip':'%s',
        'big_item_name':'%s',
        'guid':'%s'
        }'''% (90009, ip, '_proc_does_not_exist', lost_list, '', ts, ip,'_proc_does_not_exist',get_guid2())
        #sys.path.append('/usr/local/i386/public_repos/initial_system/snmp/ext/cron2')
        #from get_local_ip import *
        #print center_node_ip
        if len(alarm_pnames) > 0:
            print jsonstr
            #from get_local_ip import center_node_ip
            center_node_ip = ["58.215.46.84","121.14.37.138","61.152.250.210"]
            for ip in center_node_ip:
                try:
                    redis.Redis(ip, 44944, db=0, socket_timeout=2).rpush('op_alarm_q', jsonstr)
                except:
                    print traceback.print_exc()
            #r.rpush('yyms_alarm_z', jsonstr)
        pass

    def __load(self):
        if(not os.path.exists(g_auto_discovery_file)):
            return True
        try:
            f = open(g_auto_discovery_file, 'r')
            lines = f.readlines()
            for line in lines:
                regex_name = ""
                comment = ""
                line = line.strip()
                regex_name = line
                i = line.find(" ")
                if(i != -1):
                    regex_name = line[0:i].strip()
                    comment = line[i:].strip()
                #print regex_name, comment
                self.__ad_dict[regex_name] = comment

        except:
            print traceback.print_exc()
            return False
        return True

def main():
    ad = AutoDiscovery()
    ad.run()

if __name__ == "__main__":
    main()

