import sys
import binascii
from pyDes import *

try:
    import hashlib
    def md5_digest(txt):
        m = hashlib.md5()
        m.update(txt)
        return m.digest()
except:
    import md5
    def md5_digest(txt):
        m = md5.new()
        m.update(txt)
        return m.digest()
    
#from Crypto.Cipher import AES
#http://www.voidspace.org.uk/python/modules.shtml#pycrypto
#aes_pad = lambda s: s + (16 - len(s) % 16) * '\0'
#aes_encode = lambda c, s: binascii.b2a_hex(c.encrypt(aes_pad(s))).upper()
#aes_decode = lambda c, e: c.decrypt(binascii.a2b_hex(e)).rstrip('\0')
    
#class ChannelAuth:
    #def __init__(self, mkey, host_guid):
        #assert len(mkey) == 16
        #assert len(host_guid) == 36
        #self._mkey = mkey
        #self._host_guid = host_guid
        #self._key = md5_digest(self._mkey + self._host_guid)
        #self._cipher = AES.new(self._key)
        #pass
        
    #def encrypt(self, plaintxt):        
        #return aes_encode(self._cipher, plaintxt)
        
    #def decrypt(self, ciphertxt):
        #return aes_decode(self._cipher, ciphertxt)
    
class TempChannelAuth:
    def __init__(self, mkey, host_guid):
        assert len(mkey) == 16
        assert len(host_guid) == 36
        self._mkey = mkey
        self._host_guid = host_guid
        pass
        
    def encrypt(self, plaintxt):        
        return binascii.b2a_base64(plaintxt).strip()
        
    def decrypt(self, ciphertxt):
        return binascii.a2b_base64(ciphertxt)
            
class SimpleChannelAuth:
    def __init__(self, mkey, host_guid):
        assert len(mkey) == 16
        assert len(host_guid) == 36
        self._mkey = mkey
        self._host_guid = host_guid
        self.des = triple_des(self._host_guid[0:24], CBC, self._mkey[0:8])
        pass
        
    def encrypt(self, plaintxt):
        return binascii.b2a_hex(self.des.encrypt(plaintxt, padmode=PAD_PKCS5))
        
    def decrypt(self, ciphertxt):
        return self.des.decrypt(binascii.a2b_hex(ciphertxt), padmode=PAD_PKCS5)
    
from unittest import TestCase
class AesTest(TestCase):
    def setUp(self):
        #self._ca = ChannelAuth("1234567890123456", "bff4efee-60ef-4a07-8adf-673f6b8a41ec")
        self._ca = SimpleChannelAuth("1234567890123456", "bff4efee-60ef-4a07-8adf-673f6b8a41ec")
        pass
        
    def tearDown(self):
        pass
        
    def testExample(self):
        #timestamp|guid|plaintext
        plain = '''1306121299|bff4efee-60ef-4a07-8adf-673f6b8a41ec|{"key":"value"}'''
        encoded = self._ca.encrypt(plain)
        print encoded
        #self.assertEquals(encoded, "F3D59A08B19521AFA880BED45496F43EBC83D0FC46B7027232D5177034EC9B151A17A13AC1451F2195AB5FB212359A048158A1C561E3C58414302D500173439D")
        decoded = self._ca.decrypt(encoded)
        print decoded
        self.assertEquals(decoded, plain)
                
from optparse import OptionParser
if '__main__' == __name__:
    import unittest
    unittest.main()
