import os,sys,re,time
import redis
import traceback
from get_local_ip import *
from util import *

def check_reg(istr):
  try:
    try:
      re = init_redis()
      jstr = eval(istr)
      for item in jstr["result"]:
        for key in item:
          if item[key].find("moreConfig") is not -1:
            push_redis('alarm',alarm_reg_multi_match(item,key))
    except:
      print traceback.print_exc()
      push_redis('alarm',alarm_error_reg(item))
  except:
    print traceback.print_exc()
    
def check_proc(miss_reg):
  if len(miss_reg) == 0:
    return
  try:
    re = init_redis()
    ip = get_default_ip()
    tm = int(time.time())
    for miss in miss_reg:
      #push_redis('alarm',alarm_check_proc(ip,tm,miss))
      push_redis_test('test',alarm_check_proc(ip,tm,miss))
  except:
    print traceback.print_exc()

def check_port(port,alarm_tag=True):
  try:
    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM, 0)
    sock.settimeout(1)
    try:
      sock.connect(("127.0.0.1", port))
    except socket.error, msg:
      sock.close()
      sock = None
      #push_redis('alarm',alarm_port_refused(port))
      if alarm_tag:
        push_redis_test('test',alarm_port_refused(port))
      return;
    sock.close()
  except:
    print traceback.print_exc()
    
def check_PyCrypto():
  try:
    try:
      import sys
      sys.path.append(r"/home/dspeak/yyms/pylibs")
      from Crypto.Cipher import AES
    except:
      #push_redis('alarm',alarm_PyCrypto())
      push_redis_test('test',alarm_PyCrypto())
      print alarm_PyCryto()
      pass
  except:
    print traceback.print_exc()
  
def send_get_config_timeout(config_ip):
  try:
    push_redis('alarm_self',alarm_get_config_timeout(config_ip))
  except:
    print traceback.print_exc()

def alarm_port_refused(port):
  ip = get_default_ip()
  tm = int(time.time())
  mid = 20091
  alarm_str = '''{'mid':'%s','hid':'%s','ip':'%s','key':'%s','timestamp':'%s','data':'%s','units':'','msg':'yyms self monitor, port refused %s','level':'3'}'''%(mid,ip,ip,'yyms_port_refused',tm,port,port)
  print alarm_str
  return alarm_str
    
def alarm_PyCrypto():
  ip = get_default_ip()
  tm = int(time.time())
  mid = 20092
  alarm_str = '''{'mid':'%s','hid':'%s','ip':'%s','key':'%s','timestamp':'%s','data':'0','units':'','msg':'yyms self monitor, PyCrypto import error','level':'3'}'''%(mid,ip,ip,'yyms_PyCrypto_import_error',tm)
  print alarm_str
  return alarm_str
    
def alarm_127():
  ip = get_default_ip()
  tm = int(time.time())
  mid = 20093
  alarm_str = '''{'mid':'%s','hid':'%s','ip':'%s','key':'%s','timestamp':'%s','data':'0','units':'','msg':'no ifconfig 127.0.0.1','level':'3'}'''%(mid,ip,ip,'no_ifconfig_127_0_0_1',tm)
  print alarm_str
  return alarm_str

def alarm_get_config_timeout(config_ip):
  ip = get_default_ip()
  tm = int(time.time())
  mid = 20090
  alarm_str = '''{'mid':'%s','hid':'%s','ip':'%s','key':'%s','timestamp':'%s','data':'','units':'','msg':'get config failed from %s','level':'3'}'''%(mid,ip,ip,'get_config_timeout',tm,config_ip)
  print alarm_str
  return alarm_str
    
def alarm_check_proc(ip,tm,item):
  mid = 20100
  alarm_str = '''{'mid':'%s','hid':'%s','ip':'%s','key':'%s','item_name':'%s','big_item_name':'%s','timestamp':'%s','data':'','units':'','msg':'','level':'3'}'''%(mid,ip,ip,'proc_not_run','proc_not_run',ascii_to_str(item),tm)
  print alarm_str
  return alarm_str

def alarm_error_reg(istr):
  ip = get_default_ip()
  tm = int(time.time())
  mid = 20098
  alarm_str = '''{'mid':'%s','hid':'%s','ip':'%s','key':'%s','timestamp':'%s','data':'','units':'','msg':'','level':'2'}'''%(mid,ip,ip,'yyms_agent_register_error',tm)
  print alarm_str
  return alarm_str

def alarm_reg_multi_match(item,key):
  ip = get_default_ip()
  tm = int(time.time())
  mid = 20099
  alarm_str = '''{'mid':'%s','hid':'%s','ip':'%s','key':'%s','item_name':'%s','timestamp':'%s','data':'','units':'','msg':'','level':'3'}'''%(mid,ip,ip,'reg_error_moreConfig',key,tm)
  print alarm_str
  return alarm_str

def push_redis_test(rkey,msg):
  guid = get_guid2()
  for pair in [('121.14.46.243',63790)]:
    (ip,port) = pair
    try:
      re = redis.Redis(ip, port, db=0,socket_timeout=3)
      re.publish(rkey,msg)
      re.connection.disconnect()
    except:
      print traceback.print_exc()

def push_redis(rkey,msg):
  guid = get_guid2()
  ips = get_conf_center_ips()
  datanodes = []
  for item in ips:
    try:
      (host,port) = item
      config_conn = redis.Redis(host=host, port=port)
      key = "yyms_alarmnodes"
      ips_str = str(config_conn.get(key))
      lines = ips_str.split(',')
      for line in lines:
        words = line.split(':')
        if len(words) == 2:
          datanodes.append((words[0],int(words[1])))
        else:
          print 'get nodes failed,from %s'
          datanodes = []
      if len(datanodes) > 0:
        break;
    except:
      print traceback.print_exc()
      pass;
  if len(datanodes) == 0:
    print 'set datanodes failed'
  random.shuffle(datanodes)
  for pair in datanodes:
    (ip,port) = pair
    try:
      re = redis.Redis(ip, port, db=0,socket_timeout=3)
      re.rpush(rkey,msg)
    except:
      print traceback.print_exc()

def main():
  istr = '''
{
   "result" :
      [
         {
            "linkd_d" : "haveConfig"
         },
         {
            "slave_session_media" : "haveConfig"
         },
         {
            "slave_session_signal" : "moreConfig"
         },
         {
            "lbsd_d" : "haveConfig"
         }
      ],
   "state" : "success"
}
'''
  #check_reg(istr)

if __name__ == "__main__":
  #main()
  push_redis_test("test","test msg")
  



