#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os, re,random
from subprocess import Popen, PIPE
from cnc_ip_range import in_cnc

p = re.compile("inet\s+addr:(?P<ip>\d+.\d+.\d+.\d+)\s+Bcast:", re.DOTALL | re.IGNORECASE)
center_node_ip = ["58.215.46.84","101.226.185.69","121.10.26.167"]
center_node_ip_4 = ["58.215.46.84","101.226.185.69","121.10.26.167"]
center_node_ip_5 = ["122.97.254.84","140.207.209.69","221.5.104.103"]
center_node_ip_10 = ["10.20.176.4","10.20.0.13","10.20.81.233"]
center_node_full_ip_list = ["58.215.46.84","101.226.185.69","121.10.26.167",
                       "122.97.254.84","140.207.209.69","221.5.104.103",
                       "10.20.176.4","10.20.0.13","10.20.81.233"]

def get_local_ip():
    ips = []
    if os.name == "posix":
        pp = Popen(['/sbin/ifconfig'], stdout=PIPE)
        lines = pp.stdout.read();
        m = p.search(lines)
        ms = re.findall(p, lines)
        for m in ms:
            ips.append(m)
    else:
        ips = ["10.0.0.1", "121.14.39.154", "58.249.117.122"]
    return ips

def get_local_public_ip():
    localips = get_local_ip()
    ips = []
    for ip in localips:
        if(ip.startswith("10.")
            or ip.startswith("172.16.")
            or ip.startswith("192.168.")
            or ip.startswith("127.0.0.1") ):
            continue
        else:
            ips.append(ip)
    return ips;

def get_default_ip():
    ips = get_local_public_ip()
    for ip in ips:
        if(not in_cnc(ip)):
            return ip;
    if(len(ips) > 0):
        return ips[0]

def set_conf_ip():
    ips_0 = ["113.106.100.63:8080","113.106.100.63:10088"]
    ips_1 = ["58.249.117.107:30000","113.200.75.169:30000"]
    config_ip = ""
    random.shuffle(ips_0)
    random.shuffle(ips_1)
    try:
        hf = open("/home/dspeak/yyms/hostinfo", 'r')
        hstr = hf.read()
        json = eval(hstr)
        isp_type = json["ips"][0]["isp"]
    except:
        isp_type == 4
        
    if isp_type == 4:
        config_ip = ips_0[0]
    elif isp_type == 5:
        config_ip = ips_1[0]
    else:
        config_ip = ips_0[0]
        
    f = open("/home/dspeak/yyms/yyms_agent_2_d/assist/config_ip", 'wb')
    f.write(config_ip)
    f.close()

def get_conf_ip():
  f = open("/home/dspeak/yyms/yyms_agent_2_d/assist/config_ip", 'r')
  ip = f.read()
  f.close()
  #print ip
  return ip

def get_conf_center_ips():
  ips = []
  for ip in center_node_ip:
    ips.append((ip,60001))
  random.shuffle(ips)
  return ips

def get_conf_center_ips_4():
  ips = []
  for ip in center_node_ip_4:
    ips.append((ip,60001))
  random.shuffle(ips)
  return ips

def get_conf_center_ips_5():
  ips = []
  for ip in center_node_ip_5:
    ips.append((ip,60001))
  random.shuffle(ips)
  return ips

def get_conf_center_ips_10():
  ips = []
  for ip in center_node_ip_10:
    ips.append((ip,60001))
  random.shuffle(ips)
  return ips

def get_guid2():
  filename = "/home/dspeak/yyms/uuid"
  f = open(filename, 'r')
  guid = ''
  guid = f.read()
  f.close()
  guid = guid.strip()
  return guid

def get_random_exe(i=2):
  num = random.randint(1, i)
  if num == 1:
    return True
  else:
    return False
    
if __name__ == '__main__':
    print get_default_ip()
