# -*- coding: utf-8 -*-
import time
import random
import os, sys
sys.path.insert(0, "/home/dspeak/yyms/yymp/yymp_pylibs/yymp_common")
from hostinfo import HostInfo
import proxy_module
import urllib2
import socket
import traceback

is_inner_machine = False
def get_page(url):
    req = urllib2.Request(url)
    try:
        resp = urllib2.urlopen(req)
        body = resp.read()
        resp.close();
        return body;
    except urllib2.URLError, e:
        return None

def write(filepath, data):
    f = open(filepath, 'w')
    f.write(data)
    f.close()

def get_isp_url(uri_path, isp_type):    
    from get_local_ip import center_node_ip_4, center_node_ip_5,center_node_ip_10,center_node_full_ip_list
    ips = []
    center_node_ip_list = []
    if isp_type == 4:
        center_node_ip_list = center_node_ip_4
    elif isp_type == 5:
        center_node_ip_list = center_node_ip_5
    elif isp_type == 10:
        center_node_ip_list = center_node_ip_10
    else:
        center_node_ip_list = center_node_full_ip_list
    for ip in center_node_ip_list:
        local_ip_list = HostInfo.get_local_ip_list()		
        for lip in local_ip_list:
            ips.append('''http://%s:40100%s?ip=%s''' % (ip, uri_path, lip))
    return ips

def http_pure_heartbeat(obj):    
    global is_inner_machine
    ip_list = get_isp_url("/pure_heartbeat", HostInfo.select_isp(obj,is_inner_machine))
    random.shuffle(ip_list)
    for url in ip_list:
        try:
            print "http_pure_heartbeat = %s" % (url)
            ret = get_page(url)
            time.sleep(5)
        except:
            print traceback.print_exc()
            pass

def http_get_hostinfo(ip_list):
    # 对 ip 列表做随机，均衡请求
    random.shuffle(ip_list)
    for url in ip_list:
        try:
            ret = get_page(url)
            print url
            print "%s" % ret
            obj = eval(ret)
            if(obj):
                print "http_get_hostinfo %s" % (url)
                if HostInfo.update_hostinfo(ret):
                    print "HostInfo.update_hostinfo(ret) ok"
                    return obj
        except:
            print traceback.print_exc()
    return None

def get_hostinfo():   
    # 随机等待一个时间，避免全网请求过于集中
    global is_inner_machine
    time.sleep(random.choice([0, 0.15, 0.20, 0.25, 0.30, 0.35, 0.40]))
    oldobj = HostInfo.get_hostinfo() 
    # 如果已知本机 isp, 使用合适的 isp 来获取中心节点 ip list
    # 如果取不到列表，继续尝试其它 isp ip list 
    isp_type = HostInfo.select_isp(oldobj,is_inner_machine)
    ip_list = get_isp_url("/heartbeat", isp_type)
    print ip_list	
    ret = http_get_hostinfo(ip_list)
    
    if(not ret):
        ip_list_all = get_isp_url("/heartbeat", 0)
        ip_list_again =  list(set(ip_list_all).difference(set(ip_list)))
        ret = http_get_hostinfo(ip_list_again)
    
    return ret

def main():
    global is_inner_machine
    proxys = []
    if proxy_module.is_inner_machine():
        is_inner_machine = True
        proxys = proxy_module.get_proxy_info()
        for proxy in proxys:
            proxy_module.proxy_init(proxy["ip"], proxy["port"])
            socket.setdefaulttimeout(5)
            obj = get_hostinfo()
            if obj:
                time.sleep(90)
                http_pure_heartbeat(obj)
                break
    else:
        socket.setdefaulttimeout(5)
        obj = get_hostinfo()
        if obj:
            time.sleep(90)
            http_pure_heartbeat(obj)
    os.system("python ./get_room_ips.py")
        
# 每三分钟，crontab 调用一次
if __name__ == "__main__":
    main()

