import os,sys
import socket
import pprint
from subprocess import Popen, PIPE
pp = pprint.PrettyPrinter(indent=4)

class Proc:
  def __init__(self):
    self.__sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM, 0)
    self.__sock.settimeout(1)
    self.__buffer_size = 10240;

  def __del__(self):
    self.__sock.close()

  def connect(self, port):
    self.__sock.connect(("127.0.0.1", port))



  def send_and_recv(self, cmd):
    self.__sock.send(cmd)

    total_data=[]
    while True:
      data = self.__sock.recv(self.__buffer_size)
      if not data: break
      total_data.append(data)
      if data.endswith("\r\n\r\n"): break;
    ret = ''.join(total_data)
    ret = ret.strip()    
    return ret

  def get_all(self):
    return self.send_and_recv("agent get all\r\n")

  def get_clear(self):
    return self.send_and_recv("agent get clear\r\n")

  def str2obj(self, jsonstr):
    return eval(jsonstr)    
  
  def get_proc(self):
    ret = self.send_and_recv("agent get proc")
    return eval(ret)

  def get_dep(self):
    ret = self.send_and_recv("agent get dep")
    return eval(ret)

def get_cpu(pid):
  ps = []
  pp = Popen(['sh','/home/dspeak/yyms/yyms_agent_2_d/script/getPercentCpuOfProcess.sh',str(pid)], stdout=PIPE)
  line = pp.stdout.read()
  return line

def get_mem(pid):
  ps = []
  pp = Popen(['sh','/home/dspeak/yyms/yyms_agent_2_d/script/getMemOfProcess.sh',str(pid)], stdout=PIPE)
  line = pp.stdout.read()
  return line

def deal_json_s(str,name):
  jstr = eval(str)
  pname = jstr['proc']['pname']
  if pname is name:
    return True
  else:
    return False

def deal_json_pid(str,name):
  try:
    jstr = eval(str)
    pname = jstr['proc']['pname']
    pid = jstr['proc']['pid']
    time = jstr['proc']['time']
    if pname is name:
      return True,pid,time
    else:
      return False,0,0
  except:
    print 'deal_json_pid error'
    return False,0,0


def deal_json(rstr,src_list):
  jstr = eval(rstr)
  pid = jstr['proc']['pid']
  pname = jstr['proc']['pname']
  pver = jstr['proc']['pver']
  time = jstr['proc']['time']

  if jstr['proc'].has_key('user'):
    users = jstr['proc']['user']
  else:
    users = 0
  if jstr['proc'].has_key('queue'):
    queue = jstr['proc']['queue']
  else:
    queue = 0

  total_req = 0
  total_time_cost = 0
  max_time = 0
  for item in jstr['stat']['uri']:
    total_req += item['counter64']
    total_time_cost += item['time_cost']
    time = item['max_time']
    if time > max_time:
      max_time = time

  req_avg_time = 0.0;
  if total_req is not 0:
    req_avg_time = total_time_cost*1.0
    req_avg_time /= total_req;
    total_req = total_req/(10*1.0);
    
  cpu = get_cpu(pid)
  mem = get_mem(pid)
  ret_str = '''{
"data":{
"pid":"%s",
"pname":"%s",
"pver":"%s",
"time":"%s",
"users":"%s",
"req":"%s",
"avgtime":"%s",
"maxtime":"%s",
"queue":"%s",
"cpu":"%s",
"mem":"%s"
},
"msg":
%s

 } '''%(pid,pname,pver,time,users,total_req,req_avg_time,max_time,queue,cpu,mem,rstr)

  ret_str = ret_str.replace('\t','')
  ret_str = ret_str.replace('\r','')
  ret_str = ret_str.replace('\n','')
  ret_str = ret_str.replace(',}','}')
  ret_str = ret_str.replace(',]',']')
  return ret_str
  

def main():
  if(len(sys.argv) < 3):
    print("usage: python pstat.py port \"...\"");
  port = long(sys.argv[1]);
  proc = Proc();
  proc.connect(port);
  rstr = proc.get_clear()
  retstr = deal_json(rstr,sys.argv[2])
  print retstr

if __name__ == '__main__':
  main()

