#!/bin/bash
#Date:2011-05-19
#Written by manifold.
#Change:repository update script.
#Change:2012-06-20
#Readme:change get local revision's method.
#Change:2012-07-05
#Readme:add some log to jiji.sh.log.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
export LANG=C

# basic define
BASENAME=`basename $0`
SHORT_NAME=repository

# detect run or not.
if [ -f $LOG_DIR/stop_run_$SHORT_NAME ] || [ -f $LOG_DIR/stop_run_$BASENAME ] || [ -f $LOG_DIR/stop_run_all ];then
        exit 0
fi

# repository path
REPOS_NAME=public_repos
COMM_DIR=/usr/local/i386/$REPOS_NAME
LOG_DIR=/var/log/sysop_manager

# get ip address 
IPADDR=`/sbin/ifconfig|grep Bcast|grep -v "inet addr:192.168"|grep -v "inet addr:172.16"|head -n 1|awk '{print $2}'|awk -F : '{print $2}'`
if [ "$IPADDR" = "" ];then
    IPADDR=`/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}'`
fi 

# exclude list
cat $COMM_DIR/exclude_list.log|grep -v ^# | grep "^$IPADDR .*$SHORT_NAME" > /dev/null 2>&1 && exit 1


# log function
function print_log {
   echo "$(date +'%F %T') | $*"
}


# 判断远程版本文件的时间是否没更新（半小时没更新就告警出来）
CHANGE_TIME=`stat $LOG_DIR/$REPOS_NAME.revision.1.log|awk '{if($1=="Change:") print $2,$3}'|awk -F '.' '{print $1}'`
CHANGE_TIME_STRING=`date --date "$CHANGE_TIME" +%s`
CURRENT_TIME_STRING=`date +%s`
CALC=`expr $CURRENT_TIME_STRING - $CHANGE_TIME_STRING`
if [ "$CALC" -gt "1800" ];then
	print_log "file $LOG_DIR/$REPOS_NAME.revision.1.log not update more than 1800s" >> $LOG_DIR/jiji.sh.log
	echo 1
	exit 1
fi


# 判断/etc/hosts内是否无manager.repos.yy.duowan.com的条目
cat /etc/hosts|grep manager.repos.yy.duowan.com
if [ "$?" -ne 0 ];then
	print_log "/etc/hosts have no manager.repos.yy.duowan.com entry" >> $LOG_DIR/jiji.sh.log
	echo 1
	exit 1
fi


# 获取本地版本
get_local_revision () {
	LOCAL_REVISION=`cat /usr/local/i386/$REPOS_NAME/.svn/entries|grep https:// -B1|grep -v https`
	echo $LOCAL_REVISION|grep "^[0-9]*$" > /dev/null 2>&1
	GREP_RESULT="$?"
	if [ "$LOCAL_REVISION" = "" ] || [ "$GREP_RESULT" -ne 0 ];then
		LOCAL_REVISION=`svn info /usr/local/i386/$REPOS_NAME|awk -F ': ' '{if($1~/Last Changed Rev/) print $2}'`
		if [ "$LOCAL_REVISION" = "" ];then
			LOCAL_REVISION=`export LC_ALL=en_US.UTF-8;svn info /usr/local/i386/$REPOS_NAME|awk -F ': ' '{if($1~/Last Changed Rev/) print $2}'`
			if [ "$LOCAL_REVISION" = "" ];then
				SVN_INFO_LINE=`export LANG=C;svn info /usr/local/i386/$REPOS_NAME|wc -l`
				if [ "$SVN_INFO_LINE" -eq 8 ];then
					LOCAL_REVISION=`export LANG=C;svn info /usr/local/i386/$REPOS_NAME|awk -F ': ' '{if($1~/Revision/) print $2}'`
					LOCAL_REVISION=$(($LOCAL_REVISION-1))
				fi
			fi
		fi
	fi
}
get_local_revision


# 获取远端版本
if [ -s $LOG_DIR/$REPOS_NAME.revision.1.log ];then
	REMOTE_REVISION=`cat $LOG_DIR/$REPOS_NAME.revision.1.log`
else
	REMOTE_REVISION=`cat $LOG_DIR/$REPOS_NAME.revision.2.log`
fi

# 若本地或远端版本为空，直接告警
if [ "$LOCAL_REVISION" = "" ] || [ "$REMOTE_REVISION" = "" ];then
	MONITOR_REVISION_LINE=`cat $LOG_DIR/monitor_revision.log|wc -l`
	if [ "$MONITOR_REVISION_LINE" -gt 5 ];then
		print_log "LOCAL_REVISION:$LOCAL_REVISION or REMOTE_REVISION:$REMOTE_REVISION null,MONITOR_REVISION_LINE:$MONITOR_REVISION_LINE" >> $LOG_DIR/jiji.sh.log
		> $LOG_DIR/monitor_revision.log
		echo 1
		exit 1
	else
		echo 1 >> $LOG_DIR/monitor_revision.log
		echo 0
		exit 0
	fi
else
	# 版本差异大于5个版本，告警
	> $LOG_DIR/monitor_revision.log
	CALC=`expr $REMOTE_REVISION - $LOCAL_REVISION`
	if [ "$CALC" -gt 5 ];then
		print_log "REMOTE_REVISION:$REMOTE_REVISION,LOCAL_REVISION:$LOCAL_REVISION,more than five revision" >> $LOG_DIR/jiji.sh.log
		echo 1
		exit 1
	else
		echo 0
		exit 0
	fi
fi
