#!/bin/bash

# simple survival check for cmdb,suc,deploy,tools platform

function do_alarm {

   python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py "$1" "$2" "$3" "$4"

   return
}

privateIp='inet +addr: *(127\.|192\.168\.|10\.|172\.(1[6-9]|2[0-9]|3[0-1])\.)'

ip=$(ifconfig |grep 'inet addr' | egrep -v "$privateIp" |awk -F '[ :]+' '{print $4}' | head -n 1)

list='http://cmdb1.sysop.duowan.com/survival.jsp
http://cmdb2.sysop.duowan.com/survival.jsp
http://cmdb3.sysop.duowan.com/survival.jsp
http://dcm1.sysop.duowan.com/survival.jsp
http://dcm2.sysop.duowan.com/survival.jsp
http://dcm3.sysop.duowan.com/survival.jsp
http://yydeploy1.sysop.duowan.com/survival.jsp
http://yydeploy2.sysop.duowan.com/survival.jsp
http://yydeploy3.sysop.duowan.com/survival.jsp
http://yydeploy4.sysop.duowan.com/survival.jsp
http://tools1.sysop.duowan.com/survival.jsp
http://tools2.sysop.duowan.com/survival.jsp
http://tools3.sysop.duowan.com/survival.jsp
http://tools4.sysop.duowan.com/survival.jsp
http://suc1.sysop.duowan.com/survival.jsp
http://suc2.sysop.duowan.com/survival.jsp
http://suc3.sysop.duowan.com/survival.jsp
http://suc4.sysop.duowan.com/survival.jsp'


for i in $list ; do

    pattern='http://([^/]+)/.*'

    if [[ $i =~ $pattern ]] ; then

          host=${BASH_REMATCH[1]}

          x=$(curl --retry 3 --max-time 20 $i 2>/dev/null)

          if [ "$x" != "1" ] ; then

               do_alarm 11073 75433 0 "check survival from $ip to $host failed" 2>/dev/null
          else
              echo "check survival from $ip to $host ok : [$x]"
          fi
    else
          continue
    fi
done
