#!/bin/bash

source /data/pkg/public-scripts/func/common.sh

source /data/pkg/public-scripts/func/common-log.sh

source /data/pkg/public-scripts/func/misc.sh

# backup all 

pkgCronConf=$(ls /data/services/*/admin/crontab.conf)

for i in $pkgCronConf ; do

   if [ ! -f  ${i}.good ] ; then

         log "$(cp -v $i ${i}.good)"
    else
         log "$i already backuped"
    fi

    pkgVer=$(echo $i | awk -F '/' '{print $4}')

    log "prepare to remove report entry from /etc/crontab for $pkgVer"

    sed -i -r -e "/^# +\/data\/services\/$pkgVer resource report/d" -e "/\/data\/services\/$pkgVer\/admin\/report.sh/d" /etc/crontab 

    [ $? -eq 0 ] && log "succeed" || log "failed"

    log "prepare to remove report entry from admin/crontab.conf for $pkgVer"
  
    sed -i -r -e "/^# +\/data\/services\/$pkgVer resource report/d" -e "/\/data\/services\/$pkgVer\/admin\/report.sh/d" $i

    [ $? -eq 0 ] && log "succeed" || log "failed"

    # confirm
  
    log "[/etc/crontab] : $(grep $pkgVer /etc/crontab | grep report.sh || echo '<deleted succeed>')"

    log "[admin/crontab.conf] : $(grep report.sh $i || echo '<deleted succeed>')"

    log "[admin/crontab.conf.good] : $(grep report.sh ${i}.good || echo '<not exist before>')"

    log ""

done
