#!/bin/bash

# usage : recover pkg report cron for /etc/crontab & admin/crontab.conf

source /data/pkg/public-scripts/func/common.sh

source /data/pkg/public-scripts/func/common-log.sh

source /data/pkg/public-scripts/func/misc.sh

# backup all 

pkgCronConf=$(ls /data/services/*/admin/crontab.conf)

for i in $pkgCronConf ; do

   if [ -f ${i}.good ] ; then

         log "$(cp -v ${i}.good $i)"
    else
         elog "$pkgVer backup crontab.conf.good not exist"

         elog ""

         continue 
    fi

    pkgVer=$(echo $i | awk -F '/' '{print $4}')

    instanceStatus=$(cat /data/services/$pkgVer/admin/instance.status | awk '{print $4}')

    if [ "$instanceStatus" = "stop" ] ; then

         log "$pkgVer is stopped , no need to recover cron entry for /etc/crontab"

         log "just recover admin/crontab.conf"

         log ""

         continue
    else
         log "prepare to recover report entry for /etc/crontab for $pkgVer"
     
         if egrep -q "^# +/data/services/$pkgVer resource report" /etc/crontab ; then

              log "report comment entry already recovered"
         else
              egrep "^# +/data/services/$pkgVer resource report" $i >> /etc/crontab
         fi

         if egrep -q "/data/services/$pkgVer/admin/report.sh" /etc/crontab ; then

              log "report entry already recovered"
         else
              egrep "/data/services/$pkgVer/admin/report.sh" $i >> /etc/crontab
         fi
     
         # confirm
       
         log "[/etc/crontab] : $(grep $pkgVer /etc/crontab | grep report.sh || echo '<recover failed>')"
     
         log "[admin/crontab.conf] : $(grep report.sh $i || echo '<recover failed>')"
     
         log "[admin/crontab.conf.good] : $(grep report.sh ${i}.good || echo '<not exist before>')"
     
         log ""

    fi

done
