#!/bin/bash

# get file from main fileserver for yydeploy

function print_log {

   local line

   while read line ; do

      echo "$(date +'%F %T')| $line"

   done < <(echo "$*")

   return
}

function do_alarm {

   python /usr/local/i386/public_repos/initial_system/snmp/ext/yymp/yymp_report_script/yymp_report_alarm.py "$1" "$2" "$3" "$4"

   return
} 

(
    pre=0

    fid='10024'
    
    sid='72230'
    
    user='yydeploy'

    module='yydeploy'
    
    rsyncSvr='113.106.100.74'

	#excludeDir='./tools/'
    
	localDstDir=$(readlink /data/yydeploy/fileManager)

    : ${localDstDir:=/data/yydeploy/fileManager}	

    pwdFile='/data/sh/yydeploy/rsync.pwd'
    
    getLockFailMsg="can NOT get lock for yydeploy file sync . cmd is [$0 $*]"

    dirReadonlyMsg="local dir $localDstDir not exist or not writable"

    passwdFailMsg="create rsync password file $pwdFile failed"

    rsyncFailMsg="rsync from rsync://$user@$rsyncSvr/$module to $localDstDir failed"

    maxLogSize=524288000

    logFile='/data/sh/yydeploy/new_yydeploy_file_sync.log'

    logSize=$(stat --format='%s' $logFile 2>/dev/null)

    : ${logSize:=0}

    if [ $logSize -gt $maxLogSize ] ; then

         mv $logFile $logFile.bak

         touch $logFile

         print_log "[INFO] | logfile size exceed $((10#${maxLogSize}/1024/1024)) MBytes , truncated"  >> $logFile
    else
         print_log "[INFO] |  " >> $logFile

         print_log "[INFO] | Ok! logfile size ($((10#${logSize}/1024/1024)) MByte) not exceed $((10#${maxLogSize}/1024/1024)) MBytes" >> $logFile
    fi

    {
        flock --nonblock 200 || { print_log "[ERR ] | $getLockFailMsg" ; do_alarm $fid $sid $pre "$getLockFailMsg" ; exit 1; } 

        print_log "[INFO] | get lock succeed"
        
        print_log "[INFO] | begin to sync from  rsync://$user@$rsyncSvr/$module to $localDstDir"
    
        if [ ! -w $localDstDir ] ; then
    
            # do alarm

            print_log "[ERR ] | $dirReadonlyMsg"

            print_log "[INFO] | send alarm"
    
            do_alarm $fid $sid $pre "$dirReadonlyMsg"
        fi
        
        if [ ! -f rsync.pwd ] ; then
        
            echo 'YYDeploy12!@456' > $pwdFile || { print_log "[ERR ] | $passwdFailMsg" ; do_alarm $fid $sid $pre "$passwdFailMsg" ; exit 1; }
        fi
        
        chmod -c 400 $pwdFile 
    		 
        # don't use --delete option automatically !!!
		
		# when 74 down and file server switch to 139 , and then 74 go back ,

        # option "--delete" will make this script _delete_ all new pkgs !!!!
    
        # If you want to clear the garbage file , run "$0 clear" manually ( make sure no sync is running !!!) 

		if [ "$1" = "clear" ] ;then

			  #rsync -avz --timeout=60  --contimeout=5 --delete --password-file=$pwdFile rsync://$user@$rsyncSvr/$module/'dw_*' $localDstDir

			  rsync -avz --timeout=60  --contimeout=5 --delete --password-file=$pwdFile rsync://$user@$rsyncSvr/$module $localDstDir
	    else
              #rsync -avz --timeout=60  --contimeout=5 --password-file=$pwdFile rsync://$user@$rsyncSvr/$module/'dw_*' $localDstDir

			  #rsync -avz --timeout=60  --contimeout=5 --password-file=$pwdFile rsync://$user@$rsyncSvr/$module/tools/tools_file $localDstDir/tools/

              rsync -avz --timeout=60  --contimeout=5 --password-file=$pwdFile rsync://$user@$rsyncSvr/$module $localDstDir
        fi			  
        
        if [ $? -ne 0 ] ; then
        
            # do alarm

            print_log "[ERR ] $rsyncFailMsg"

            print_log "[INFO] send alarm"
        
            do_alarm $fid $sid $pre "$rsyncFailMsg"
        fi

        print_log "[INFO] | --end--"
        
        echo "---------------------------------------------------------------------------------------------------------"

    } >> $logFile 2>&1

    exit
   
) 200>/data/sh/yydeploy/new_yydeploy_file_sync.lock
