function pidof {

    export LC_ALL=C

    export LANG=C

    export PATH=/usr/bin:/bin:/sbin:/usr/sbin
    
    local name="$*"

    local pids

    # strip all options

    name=$(echo "$name" | sed -r 's/(-x|-s|-o|-c) //g')

    # only one pname  is allowed

    if [ "${name// }" != "$name" ] ; then

        return 1
    fi

    if [ -z "$name" ] ; then

       return 1
    fi

    pids=$(ps -e --no-headers -opid,cmd |awk '$2 !~ /^\[/' |awk '{print $1,$2}' |sed -r 's/ (.*)\/(.*)/ \2/g' |awk -v x="$name" '($2 == x || $2 == x":") {print $1}')

    if [ -z "$pids" ] ; then

       # try /proc/pid/exe

       pids=$(ls -l /proc/[0-9]*/exe  2>/dev/null | grep "/$name$" | awk '{print $9}' | awk -F '/' '{print $3}' | sort -u)	
   fi

   if [ -z "$pids" ] ; then

        return 1
   else
        echo "$pids"

        return 0
   fi
    
}
