#!/bin/bash

# pre-format data

tr '\t' ' ' < proc-data.txt | sed -r 's/,[^ ]//' | grep -v 'D:\\' | tr '\t' ' ' | awk 'NF == 3' | tr -d '\r' > proc-data

# output all the pkg-ed instance count

pkgedInstances=$(grep -F '/data/services/' proc-data -c)

echo "01-pkg-ed instance : $pkgedInstances"

allInstances="$(wc -l < proc-data)"

echo "02-all instances  : $allInstances"

echo "03-pkged-instance ratio : $(echo "scale=2; $pkgedInstances *100 / $allInstances" | bc)"

allProcNumber=$(awk '{print $2}' proc-data |sort -u | wc -l)

echo "04-all procs (include whitelist) : $allProcNumber"

nonPkgedProcs=$(grep -v '/data/services/' proc-data | awk '{print $2}' | sort -u |wc -l)

echo "05-non-pkged-procs (include whitelist) : $nonPkgedProcs"

whitelistProcFile=/data/pkg/public-scripts/conf/proc.whitelist

grep '^\[RE\]' -v /data/pkg/public-scripts/conf/proc.whitelist > plain-whitelist

nonPkgedProcInPlainWhitelist=$(

while read i ; do 

     grep -x $i plain-whitelist; 

done <<< "$(grep -v '/data/services/' proc-data | awk '{print $2}' | sort -u)")

grep '^\[RE\]' /data/pkg/public-scripts/conf/proc.whitelist | sed 's/^\[RE\]//' > regex-whitelist

nonPkgedProcInRegexWhitelist=$(

while read i ; do

    while read regex ; do

              egrep $regex <<< "$i"

              [ $? -eq 0 ] && break

    done < regex-whitelist

done <<< "$(grep -v '/data/services/' proc-data | awk '{print $2}' | sort -u)")

whitelistProc=$(echo "$nonPkgedProcInRegexWhitelist" "$nonPkgedProcInPlainWhitelist" | wc -l)

echo "07-all whitelist proc : $(echo $whitelistProc)"

nonPkgedNonWhitelistProcs=$(join -v1  <(grep -v '/data/services/' proc-data | awk '{print $2}' | sort -u) <(echo -e "$nonPkgedProcInRegexWhitelist\n$nonPkgedProcInPlainWhitelist" | sort -u))

echo "08-pkged procs (no whitelist) : $(echo "scale=2 ; (1-(($nonPkgedProcs-$whitelistProc)/($allProcNumber-$whitelistProc)))*100" |bc)"

echo -e "09-all non-whitelist-non-pkged-procs : $(echo $nonPkgedNonWhitelistProcs | wc -w)"

echo --------------

echo "$nonPkgedNonWhitelistProcs"
