#!/bin/bash
# NAME            : $0 
# Ver             : 3.1
# Author          : boblin(linbobo@chinaduo.com)
# LastModified by : boblin(linbobo@chinaduo.com)
# LastModified    : 2015-1-14
# Summary         : report local running proc info and listen ports info
# Changelog       : add collect_listen_ports.sh call

set +H

shopt -s expand_aliases

export LC_ALL=C

export LANG=C

export PATH=/usr/bin:/bin:/sbin:/usr/sbin

source /data/pkg/public-scripts/conf/main.conf

source /data/pkg/public-scripts/conf/cmdb.conf

source /data/pkg/public-scripts/func/misc.sh

source /data/pkg/public-scripts/bin/mypidof.sh

chmod a+x /data/pkg/public-scripts/bin/*.sh

#(/bin/bash /data/pkg/public-scripts/bin/installed-pkg.sh) &


#----------------#
# main procedure #
#----------------#

(

    flock --nonblock 200 || exit 1

    #rm -f /tmp/no-pkg-cfgId

    (
       [ -f /tmp/no-pkg-cfgId ] && exit 
       
       if  ! which curl  &>/dev/null ;  then
   
            aptitude -v -y install curl
       fi	  
   	  
       source /data/pkg/public-scripts/conf/main.conf
   
       source /data/pkg/public-scripts/func/common.sh
   
       source /data/pkg/public-scripts/bin/functions.sh
   
       ip=$(get_first_ip)
   
       instanceDirs=$(find /data/services -maxdepth 2 -type f -name 'init.conf' | xargs -i dirname {} )
   
       for i  in  $instanceDirs ; do      
   
           if [ ! -e $i/admin/pkg.cfgId ] ; then
   	
   	   curl  "http://countmq.sysop.duowan.com/?name=yydeploy-pkg-cfgId&opt=put&auth=yysec123456&charset=utf-8&data=$ip:$i" &>/dev/null
   			  
              echo "$ip  $i" > /tmp/no-pkg-cfgId
           fi			  
      done
   
    )

    #-------------------------------------------------------------------#
    # temp code -- report listen port info to security.sysop.duowan.com #
    #-------------------------------------------------------------------#
  
    if [ $(date +%M) == "00" ] && [ $(date +%H) == "00" ] ; then

         ( sleep $((10#$RANDOM % 600))

           bash /data/pkg/public-scripts/bin/security/collect_listen_ports.sh 

         ) &
    fi


    #--------------------------------------#
    # temp code -- detect cmdb report node #
    #--------------------------------------#

    if [ $(date +'%M') == "00" ] || [ "$1" = "force" ] ; then
    
       mkdir -p /data/pkg/public-scripts/data/cache &>/dev/null
    
	   x=$(choose_good_ip $(get_domain_iplist $CMDB_DOMAIN))
    
       if [ -n "$x" ] ; then
    
          echo $x >/data/pkg/public-scripts/data/cache/cmdb.iplist
       fi
    fi


) 200>/data/pkg/public-scripts/data/.proc-report.lock && \

rm /data/pkg/public-scripts/data/.proc-report.lock
