#!/bin/bash
# NAME            : $0 
# Ver             : 1.0
# Author          : boblin(linbobo@chinaduo.com)
# LastModified by : boblin(linbobo@chinaduo.com)
# LastModified    : 2012-11-07 19:19
# Summary         : report no pkg proc cpu/mem usage . pkg-ed proc's  cpu/mem are reported automatically

# changelog       : disabled by boblin on 2014-07-08 00:00

# crontab control area , quit when finished

exit

set +H

export LC_ALL=C

export LANG=C

export PATH=/usr/bin:/bin:/sbin:/usr/sbin

# crontab control

#if [ "$1" = "del-cron" ] ; then
#
#     sudo sed -r -i '/\/data\/pkg\/public-scripts\/bin\/report_no_pkg_proc_resouce\.sh/d' /etc/crontab
#
#     exit 0
#
#elif [ "$1" = "add-cron" ] ; then
#
#     if ! egrep -q '^ *\*\/2 +\* +\* +\* +\* +root +\/bin\/bash +\/data\/pkg\/public-scripts\/bin\/report_no_pkg_proc_resouce\.sh +&>\/dev\/null' /etc/crontab ; then
#
#        sudo sed -r -i '/\/data\/pkg\/public-scripts\/bin\/report_no_pkg_proc_resouce\.sh/d' /etc/crontab && \
#
#        sudo bash -c "echo '# /data/pkg/public-scripts/bin/report_no_pkg_proc_resouce.sh' >> /etc/crontab" && \
#
#        sudo bash -c "echo '*/2 * * * * root /bin/bash /data/pkg/public-scripts/bin/report_no_pkg_proc_resouce.sh &>/dev/null' >> /etc/crontab"
#     fi
#
#     exit
#
#elif [ "$1" = "show-cron" ] ; then
#
#     egrep '\/data\/pkg\/public-scripts\/bin\/report_no_pkg_proc_resouce\.sh' /etc/crontab
#
#     exit
#fi

# global functions

function print_log {

   local line

   while read line ; do

      echo "$(date +'%F %T')| $line"

   done < <(echo "$*")

   return
}

# global paramaters

cpuId=105

memId=106

prog=$(basename $0)

maxRptPerProc=1

maxLogSize=5242880

noPkgProcInfoFile="$(dirname $0)/../conf/no_pkg_proc_list"

normalList=$(egrep -v '^\[RE\]' $noPkgProcInfoFile | awk 'NF == 2')

regexList=$(egrep '^\[RE\]' $noPkgProcInfoFile | awk 'NF == 2' | sed 's/^\[RE\] *//')

logFile="$(dirname $0)/../data/report_no_pkg_proc_resource.log"

reportPy='/home/dspeak/yyms/yymp/yymp_report_script/yymp_report.py'

cpuCoreNum=$(cat /proc/cpuinfo | egrep '^processor[[:space:]]*:' -c)

maxCpuUsage=$(( 10#${cpuCoreNum} * 100 ))

# load my pidof function

source $(dirname $0)/mypidof.sh

(
    flock --nonblock 200 || exit 1

    # log file control area
    
    logSize=$(stat --format='%s' $logFile 2>/dev/null)
    
    : ${logSize:=0}
    
    if [ $logSize -gt $maxLogSize ] ; then
    
         mv $logFile $logFile.bak
    
         touch $logFile
    
         print_log "[INFO] | logfile size exceed $((10#${maxLogSize}/1024/1024)) MBytes , truncated"  >> $logFile
    else
         print_log "[INFO] |" >> $logFile
    
         print_log "[INFO] | Ok! logfile size ($((10#${logSize}/1024/1024)) MByte) not exceed $((10#${maxLogSize}/1024/1024)) MBytes" >> $logFile
    fi

    # process the normal partition of given list by waynewang

    while read proc pname ; do

       # check whether the proc is pkg-ed , max report num : 20
    
       list=$(pidof $proc | tail -n $maxRptPerProc)

       for i in $list ; do

           if sudo readlink /proc/$i/exe | grep -F '/data/services/' -q  ; then

                # the process corresponding to this pid is pkg-ed

                print_log "[ERR ] | pid [$i] for $proc is pkg-ed , skip !" >> $logFile

                list=$(echo "$list" | xargs -n 1 | grep -x -v $i | xargs)
           else
                print_log "[INFO] | pid [$i] is NOT pkg-ed" >> $logFile   
           fi

       done
    
       if [ -n "$list" ] ; then

            print_log "[INFO] | OK! found $proc" >> $logFile

            ps -l $list >> $logFile

            unset pidArg

            # gen pid list for 'pidstat' command's option '-p'

            for i in $list ; do
       
               pidArg="$pidArg -p $i"
       
            done

            # run pidstat to get cpu usage

            print_log "[INFO] |" >> $logFile
       
            print_log "[INFO] | Ok! prepare to run pidstat (interval=1 / count=10) for 10 seconds for all $proc" >> $logFile
       
            result=$(pidstat -u $pidArg 1 2)

            # sanity check

            invalidResult=$(awk -v _max=$maxCpuUsage '$6 >= _max' <<< "$result")

            if [ -n "$invalidResult" ] ; then

                 print_log "[ERR ] | found invalid cpu usage data (>$maxCpuUsage)" >> $logFile

                 print_log "$invalidResult" >> $logFile

                 print_log "[INFO] | try again" >> $logFile

                 result=$(pidstat -u $pidArg 1 2)

                 invalidResult=$(awk -v _max=$maxCpuUsage '$6 >= _max' <<< "$result")

                 if [ -n "$invalidResult" ]  ; then

                      print_log "[ERR ] | foud invalid cpu usage data again (>$maxCpuUsage)" >> $logFile

                      print_log "$invalidResult" >> $logFile

                      print_log "[ERR ] | quit now" >> $logFile

                      exit 1
                 else 
                      print_log "[INFO] | the data is good this time , continue" >> $logFile
                 fi     
            else
                 print_log "[INFO] all cpu usage data is good (<$maxCpuUsage) , continue" >> $logFile
            fi
                        
            print_log "$result" >> $logFile

            for i in $list ; do
      

                # step 1 - get cpu usage from pidstat's result & report to YYMS-2

                cpuUsage=$(echo "$result" | egrep '^Average:'  | awk -v _pid=$i '$2 == _pid {print $6}') 

                true ${cpuUsage:=0}

                print_log "[INFO] | pid=$i usage=$cpuUsage pname=$pname id=$cpuId" >> $logFile

                python $reportPy "id=${cpuId}&value=${cpuUsage}&pname=${pname}&pid=${i}" >> $logFile 2>&1


                # step 2 - get mem usage (Bytes) from /proc/pid/status & report to YYMS-2
       
                memUsage=$(cat /proc/$i/status | grep '^VmRSS' | awk '{printf "%.0f\n", $2*1024}')

                true ${memUsage:=0}

                print_log "[INFO] | pid=$i usage=$memUsage pname=$pname id=$memId" >> $logFile

                python $reportPy "id=${memId}&value=${memUsage}&pname=${pname}&pid=${i}" >> $logFile 2>&1


            done
    
       else      
            print_log "[INFO] | no un-pkged $proc found , skip" >> $logFile
    
            continue
       fi
    
    done <<< "$normalList"
    
    # process the regex partition of given list by waynewang
    
    while read pattern pname ; do
    
        list=$(ps --no-headers -e -o pid,cmd | awk -v x="$pattern" '$2 ~ x {print $1}')
    
        if [ -n "$list" ] ; then
    
            print_log "[INFO] | -------------------- found proc for pattern [$pattern] --------------------" >> $logFile
    
            ps -l $list >> $logFile
    
            for i in $list ; do

               # gen pid list for 'pidstat' command's '-p' option

               pidArg="$pidArg -p $i"

            done

            print_log "[INFO] |" >> $logFile

            print_log "[INFO] | prepare to run pidstat (interval=1 / count=10) for 10 seconds for all $pattern" >> $logFile

            result=$(pidstat -u $pidArg 1 2)

            print_log "[INFO] | $result" >> $logFile

            for i in $list ; do


                # step 1 - get cpu usage from result & report to YYMS-2

                cpuUsage=$(echo "$result" | egrep '^Average:' | awk -v _pid=$i '$2 == _pid {print $6}')

                true ${cpuUsage:=0}

                print_log "[INFO] | pid=$i usage=$cpuUsage pname=$pname id=$cpuId" >> $logFile

                python $reportPy "id=${cpuId}&value=${cpuUsage}&pname=${pname}&pid=${i}" >> $logFile 2>&1


                # step2 2- get mem usage (Bytes) & report to YYMS-2

                memUsage=$(cat /proc/$i/status | grep '^VmRSS' | awk '{printf "%.0f\n", $2*1024}')

                true ${memUsage:=0}

                print_log "[INFO] | pid=$i usage=$memUsage pname=$pname id=$memId" >> $logFile

                python $reportPy "id=${memId}&value=${memUsage}&pname=${pname}&pid=${i}" >> $logFile 2>&1


            done

       else
            print_log "[INFO] | no proc found match pattern [$pattern] , skip" >> $logFile
    
            continue
       fi
    
    done <<< "$regexList"
    
) 200>/data/pkg/public-scripts/data/.report_no_pkg_proc_resource.lock && \

rm /data/pkg/public-scripts/data/.report_no_pkg_proc_resource.lock
