#!/bin/bash
# NAME            : $0 
# Ver             : 0.5
# Author          : boblin(linbobo@chinaduo.com)
# LastModified by : boblin(linbobo@chinaduo.com)
# LastModified    : 2012-04-23 21:22
# Summary         : duowan pkg release system background scripts 

export LANG=C

export LC_ALL=C


#echo "$0 $*" > /tmp/tar.tmp.$$ 

(

if [ $# -lt 5 ] || [ $# -gt 6 ] ; then

     echo "{'code':1,'message':'语法错误! tar.sh <srcdir> <dstdir> <pkg> <ver> <platform> [<maxMB>]'}"
 
     exit 1
else
     srcDir=$1
 
     dstDir=$2

     pkg=$3

     ver=$4

     platform=$5

     maxSize=${6:-100}

     # force to integer

     maxSize=$(printf "%.0f" $maxSize) 

     if [ "${dstDir#.}" != "$dstDir" ] ; then

        echo "{'code':1,'message':'错误! 目标目录 $dstDir 必须是全路径格式'}"

        exit 1
     fi 

     if [ -d "$srcDir" ] && [ -r "$srcDir" ] && [ -x "$srcDir" ] ; then
  
         if [ -d "$dstDir" ] && [ -w "$dstDir" ] && [ -x "$dstDir" ] ; then

              # extra job (check mandatory directory)

              for dir in bin conf lib data log  ; do

                  if [ ! -d $srcDir/$dir ] ; then

                        echo "{'code':1,'message':'错误! 基础目录 $srcDir/$dir 不存在'}"

                        exit 1
                  fi

              done                  

              # find file

              x=$(find "$srcDir" -type f | xargs -n1 | grep -xv "${srcDir%\/}/init.conf")

              if [ -z "$x" ] ; then

                   echo "{'code':2,'message':'错误! 源目录 $srcDir 下没有找到任何文件'}"

                   exit 1
              fi 
     
              tmpDir=/data/tmp/$pkg-$ver

              rm -fr $tmpDir &>/dev/null

              mkdir -p $tmpDir || { echo "{'code':1,'message':'错误! 创建临时目录 $tmpDir 失败'}" ; exit 1; }

              cp -a $srcDir/* $tmpDir 

			  # remove testDoc/ dir under tmp dir , it shouldn't be included in pkg

              rm -fr $tmpDir/testDoc

              # prepare to tar , first change file perm under bin/

              cd $tmpDir/bin && chmod 755 *

              cd $(dirname $tmpDir) && tar -zcf $dstDir/$pkg-$ver-$platform.tar.gz $pkg-$ver

              size=$(( $(stat --format='%s' $dstDir/$pkg-$ver-$platform.tar.gz) / 1024 / 1024 ))

              if [ $size -gt $maxSize ] ; then

                 rm -f $dstDir/$pkg-$ver-$platform.tar.gz

                 rm -fr $tmpDir 

                 echo "{'code':1,'message':'错误! 生成的 TAR 包大小 (${size}MB) 超过 ${maxSize}MB'}"

                 exit 1
              fi

              md5=$(md5sum $dstDir/$pkg-$ver-$platform.tar.gz|awk '{print $1}')

              rm -fr $tmpDir 
   
              echo "{'code':0,'message':'$md5'}"

              exit 0
         else 
              echo "{'code':1,'message':'错误! 目标目录 $dstDir 不存在或者权限被拒绝'}"

              exit 1
         fi

     else
          echo "{'code':1,'message':'错误! 源目录 $srcDir 不存在或者权限被拒绝'}"
     
          exit 1
     fi
fi

) 2>&1 | tee /data/sh/yydeploy/tar.sh.log
