#!/bin/bash
# NAME            : $0 
# Ver             : 0.1
# Author          : boblin(linbobo@chinaduo.com)
# LastModified by : boblin(linbobo@chinaduo.com)
# LastModified    : 2012-04-01 13:28
# Summary         : extract files ( tar/tar.gz/bzip2/tar.bz2/zip/jar/war ) 

if [ $# -ne 1 ] ; then

     echo "{'code':1,'message':'Err! unzip.sh </path-to-file>'}"

     exit 1

elif egrep -q '[[:space:]]' <<< "$1" ; then

     #echo "{'code':1,'message':'Err! filename contain space'}"

     echo "{'code':1,'message':'错误! 文件名含有空格'}"
     
     exit 1

elif [ -d "$1" ] ; then

     #echo "{'code':1,'message':'Err! $1 is a directory'}"

     echo "{'code':1,'message':'错误! $1 是一个目录'}"

     exit 1

elif [ ! -f "$1" ] ; then

     #echo "{'code':1,'message':'Err! file $1 not exist'}"

     echo "{'code':1,'message':'错误! 文件 $1 不存在'}"

     exit 1

elif [ ! -r "$1" ] ; then

     #echo "{'code':1,'message':'Err! file $1 no read permission'}"

     echo "{'code':1,'message':'错误! 文件 $1 没有读权限'}"
 
     exit 1
fi

dstDir=$(dirname "$1")

file=$(basename "$1")

cd $dstDir

if [ ! -w "$dstDir" ] ; then

     #echo "{'code':1,'message':'Err! dir $dstDir not write permission'}"

     echo "{'code':1,'message':'错误! 目标目录 $dstDir 没有写权限'}"

     exit 1

elif file "$file" | egrep -q '( tar +archive)| (bzip2 +compressed +data)| (gzip +compressed +data)' ; then

     if tar -xf "$file" &>/dev/null ; then

          #echo "{'code':0,'message':'Ok! succeed'}"

          echo "{'code':0,'message':'tar 解压缩成功'}"

          exit 0
     else
          #echo "{'code':1,'message':'un-tar file failed'}"     

          echo "{'code':1,'message':'错误! tar 解压缩失败'}"     

          exit 1
     fi           

elif file $1 | egrep -q ' Zip +archive +data' ; then

     if ! which unzip &>/dev/null ; then

        #aptitude -y install unzip &>/dev/null || { echo "{'code':1,'message':'Err! install unzip deb failed'}"; exit 1; }

        aptitude -y install unzip &>/dev/null || { echo "{'code':1,'message':'错误! 安装 unzip deb 包失败'}"; exit 1; }
     fi

     if unzip -o "$file" &>/dev/null ; then

          #echo "{'code':0,'message':'Ok! succeed'}"

          echo "{'code':0,'message':'unzip 解压缩成功'}"

          exit 0
     else
          #echo "{'code':1,'message':'Err! un-zip file failed'}"

          echo "{'code':1,'message':'错误! unzip 解压缩失败'}"

          exit 1
     fi

else     
     #echo "{'code':1,'message':'Err! unsupport type ( only tar|gzip|bzip2|zip|jar|war )'}"

     echo "{'code':1,'message':'错误! 仅支持 TAR , GZIP , BZ2 , ZIP , JAR , WAR 类型'}"

     exit 1
fi
