#!/usr/bin/env python
# -*- coding: utf-8 -*-
import json
import sys


def is_validated(filename):
    try:
        with open(filename, 'r') as f:
            data = f.read()
        json.loads(data)
        return True
    except OSError:
        return None
    except ValueError:
        return None


if __name__ == '__main__':
    if len(sys.argv) < 2:
        sys.stdout.write('filename is required\n')
        sys.exit(1)
    name = sys.argv[1]
    if is_validated(name):
        sys.stdout.write('0\n')
    else:
        sys.stdout.write('1\n')
