#!/bin/bash

# NAME            : $0 
# Ver             : 0.2
# Author          : boblin(linbobo@chinaduo.com)
# LastModified by : boblin(linbobo@chinaduo.com)
# LastModified    : 2015-05-26
# Summary         : un-register from new daemon when stop proc
# Changelog       : when pid file not foud under $INSTALL_PATH , try /data/backup/<path-to-file> instead

(

  if [ -n "$1" ] && [ "$1" -gt 0 ] ; then

       dstPidFile1="$INSTALL_PATH/admin/cache/s2s/$1"
 
       dstPidFile2="/data/backup/${INSTALL_PATH#/*/*/}/admin/cache/s2s/$1"  
 
       echo "$(date +'%F %T') s2skill begin caller=[$(ps --no-headers -olstart,pid,ppid,cmd $PPID)]"
 
       echo "$(date +'%F %T') try file $dstPidFile1"
 
       python /data/pkg/public-scripts/bin/extra/s2skiller.py $dstPidFile1
 
       rc=$?
 
       if [ $rc -ne 0 ] ; then
 
 		   # try another location
 
 	       echo "$(date +'%F %T') un-reg file $dstPidFile1 failed , rc=$rc"
 
           echo "$(date +'%F %T') try file $dstPidFile2"
 
           python /data/pkg/public-scripts/bin/extra/s2skiller.py $dstPidFile2
 
           rc=$?
       fi
 
	   if [ $rc -ne 0 ] ; then
		   
		    if [ -f $dstPidFile1 ] || [ -f $dstPidFile2 ] ; then  # pid file exist , but un-reg failed
 
                 str="id=12359&sid=78519&pre=1&alarm_level=2&alarm_type=2&msg='$INSTALL_PATH un-reg failed'"
 
                 python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py "$str"
            else
                 echo "$(date +'%F %T') no pid file found for $INSTALL_PATH , ignore it"				
            fi	 
       else
            echo "$(date +'%F %T') s2skill return code = 0 , un-reg succeed" 
       fi
       
       exit
  else
      echo "$(date +'%F %T') Err! invalid pid [$1] for $(basename $0)"

      exit 1

  fi	

) >> $INSTALL_PATH/admin/cache/s2s/cleanup.log 2>&1 
