#!/bin/bash

source /data/pkg/public-scripts/func/common.sh

function get_nic_driver_type {

   local x=${1:?$FUNCNAME Err! nic name MUST be gived}

   trim $(ethtool -i "$x" | grep '^driver:' | awk -F ':' '{print $2}') 

   return
}


function get_nic_driver_ver {

   trim $(ethtool -i eth0 | grep '^version:' | awk -F ':' '{print $2}')
 
} 


function is_igb_driver {

   local nic=${1:?$FUNCNAME Err! nic name MUST be gived}

   local x

   x=$(get_nic_driver_type $nic)

   if [ "$x" = "igb" ] ; then

        return 0
   else
        return 1
   fi
}


function is_igb_mqueue_enable {

   local nic=${1:?$FUNCNAME Err! nic name MUST be gived}

   is_igb_driver $nic || return 0  # not igb driver

   if [ $(cat /proc/interrupts | grep -w $nic | wc -l) -le 8 ] ; then

        return 1
   else
        return 0
   fi
}


function get_nic_ring_buffer {

   local nic=${1:?$FUNCNAME Err! nic name MUST be gived}

   ethtool -g $nic | sed -n '/Current hardware settings:/,$p' | grep '^[RT]X:' | tr -d '[\t ]'

   return
}


function set_nic_ring_rx_buffer {

   local x=${1:?$FUNCNAME Err! ring buffer number MUST be gived}

   ethtool -G eth0 rx $x tx $x

   return

}
