#!/bin/bash

source /data/pkg/public-scripts/func/common.sh

function get_host_by_name {

   local x=${1:?$FUNCNAME Err! domain-name must be gived}

   local ip

   ip=$(egrep -v '^#|^[[:space:]]*$' /etc/hosts | awk  -v name="$x" '$2 == name {print $1}' | sort -u)

   if [ -z "$ip" ] ; then

        return 1
   else
        echo "$ip"
   fi
}


function check_hosts_by_name_and_ip {

   local x=${1:?$FUNCNAME Err! domain-name must be gived}

   local y=${2:?$FUNCNAME Err! ip must be gived}

   local entry

   entry=$(egrep -v '^#|^[[:space:]]*$' /etc/hosts  | awk -v name="$x" -v ip="$y" '$2 == name && $1==ip' | sort -u)

   if [ -z "$entry" ] ; then

        return 1
   else
        return 0
   fi
}


function check_hosts_batchly {

  local ip name rest

  local badHosts

  while read ip name rest ; do

     if ! check_hosts_by_name_and_ip $name $ip ; then

          badHosts="$badHosts $name"
     fi

  done <<< "$*"

  if [ $(echo $badHosts | wc -w) -gt 0 ] ; then

       echo $badHosts

       return 1
  else
       return 0
  fi

}


function set_hosts {

   local x=${1:?$FUNCNAME Err! domain-name must be gived}

   local y=${2:?$FUNCNAME Err! ip must be gived}

   local entry

   sed -r -i".bak" "/^[1-9]+.*[[:space:]]+$x/d"  /etc/hosts && echo "$y $x" >> /etc/hosts

   return
}


function set_hosts_batchly {

  local ip name rest

  while read ip name rest ; do

     set_hosts $name $ip

  done <<< "$*"

}


function is_virtual_host {

   vmType=$(grep '^vm_type' /home/dspeak/yyms/hostinfo.ini | awk -F '=' '{print $2}')

   if [ "$vmType" = "1" ] ; then

        return 0  
   else
        return 1
   fi

}



function get_host_status {

   egrep '^[[:space:]]*status=' /home/dspeak/yyms/hostinfo.ini | awk -F '=' '{print $2}'

   return
}
