#!/bin/bash

source /data/pkg/public-scripts/func/common.sh

function get_kernel_para {

   local x rc=0

   for i in $* ; do

       x=$(sysctl $i 2>/dev/null | cut -d '=' -f 2- | sed -r 's/^ +//') 

       rc+=$?

       if [ $# -eq 1 ] ; then

            echo $x
       else
            echo "$i=\"$x\""
       fi
            
   done

   return $rc
}


function set_kernel_para {

   local para value rc=0

   while read para value ; do

         if ! sysctl -w $para="$value" &>/dev/null ; then

            echo "$para"

            rc=1
         fi

   done < <(echo "$*")

   return $rc

}


function set_kernel_para_by_file {

   local file=${1:?$FUNCNAME Err! filename must be gived}

   if [ -f "$file" ] && [ -r "$file" ] ; then

       while read para value ; do
    
             if ! sysctl -w $para="$value" &>/dev/null ; then
    
                echo "$para"
    
                rc=1
             fi
    
       done <$file

   else
        echo "$file permission denied" >&2

        return 1
   fi

   return $rc

}



function get_rmem_max {

   sysctl net.core.rmem_max | awk '{print $NF}'

   return
}


function get_wmem_max {

   sysctl net.core.wmem_max | awk '{print $NF}'

   return
}


function get_sys_tx_queue_len {

   cat  /sys/class/net/eth0/tx_queue_len

   return
}


function check_sys_tx_queue_len {

   local x=${1:?$FUNCNAME Err! value must be gived}   

   if [ $(get_sys_tx_queue_len) -ne $x ] ; then

          return 1
   else
          return
   fi
}


function set_sys_tx_queue_len {

   local x=${1:?$FUNCNAME Err! value must be gived}

   if is_positive_integer $x ; then

        echo "$x" > /sys/class/net/eth0/tx_queue_len
   else
        echo "Err! $x not a positive integer" >&2
   fi

   return
}


function is_module_loaded {

   local x=${1:?$FUNCNAME Err! module name must be gived}

   local result

   result=$(lsmod | tail -n +2 | awk -v name="$x" '$1 == name')

   if [ -z "$result" ] ; then

         return 1
   else
         return 0
   fi
}


