function sys_uptime {

   awk '{printf "%.0f\n",$1}'  /proc/uptime
}


function is_test_debug_proc {

   local proc=${1:?$FUNCNAME [ERR ] | proc is NULL}

   if echo "$proc" | egrep -q '[-_.](test|debug)(_d)?$' ; then
   
        return 0
 
   elif echo "$proc" | egrep -q '[-_.]?(test|debug)[-_.]' ; then

        return 0 

   elif echo "$proc" | egrep -q '[-_.](test|debug)[0-9]+' ; then
   
        return 0
 
   elif echo "$proc" | egrep -q '^(test|debug)([0-9]+)?[-_]?' ; then
   
        return 0
 
   elif echo "$proc" | egrep -q '^(test|debug)([[:punct:]]+|$)' ; then
   
        return 0
   else
        return 1 
   fi

}


function get_domain_iplist {

   local domain=${1:?$FUNCNAME [ERR ] | domain is NULL}

   # find best cmdb report node

   local ipList

   cmdbIpList=$(dig +short +time=2 "$domain" A | egrep '^([0-9]{1,3}\.){3}([0-9]{1,3})$' | xargs)

   echo "$cmdbIpList"

   return

}

function choose_good_ip {

   local ipList=$*

   local fpingResult

   local chosenIp

   fpingResult=$(fping -T 2 -c 5 -a -A -e $ipList 2>&1) 

   chosenIp=$(echo "$fpingResult" | awk -F '[ ,:/=%]+' '$7 == 0 {print $1,$(NF-1)}' |sort -k2,2n | awk '{print $1}' | xargs)

   if [ -n "$chosenIp" ] ; then

        echo $chosenIp

        return 0
   else
        return 1
   fi
}

function kmg_to_bytes {

  # only support integer

  if [ "$1" = "${1//[a-zA-Z]}" ]; then

       echo $1
  else
       case $1 in

         [0-9]*[kK] ) echo $(( 10#${1/[kK]} * 1024 )) ;;
    
         [0-9]*[mM] ) echo $(( 10#${1//[mM]} * 1024 * 1024 )) ;;
    
         [0-9]*[gG] ) echo $(( 10#${1//[gG]} * 1024 * 1024 * 1024)) ;;
    
         [0-9]*[bB] ) echo ${1//[bB]} ;;
    
         [0-9]*[a-zA-Z]) echo "invalid unit" >&2 ; return 1 ;;

         *) echo "invalid unit" >&2 ; return 1

        esac
   fi

   return
}


function get_local_dns {

   local x

   x=$(egrep '^[[:space:]]*nameserver[[:space:]]+([0-9]+\.){3}[0-9]+[[:space:]]*$' /etc/resolv.conf 2>/dev/null)

   [ -n "$x" ] && echo "$x"  || return 1

}
