#!/bin/bash

export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin

grep -w "vm_debug" /proc/cmdline && \
    { echo 'Cmdline openstack debug!';exit 1; }

grep -qiE 'centos|red' /etc/issue && LINUX_VERSION="centos"
grep -qiE 'ubuntu|debian' /etc/issue && LINUX_VERSION="ubuntu"

# check if resize partition success or not
root_uuid=$(awk -F '=| ' '{for(i=1;i<=NF;i++){if($i == "UUID"){print $(i+1)}}}' /proc/cmdline)
root_partition=$(blkid -o full| grep -i "${root_uuid}"|awk -F ':' '{print $1}')


[ "x${root_partition}" = "x" ] && \
    { echo 'Can not found root partition !';exit 1; }

echo -n "Ready to resize filesystem "

resize2fs $root_partition > /dev/null 2>&1

echo -e "\t\t[ OK ]"

echo -n "Rebuild initramfs "
touch /etc/growroot-disabled
if [ "$LINUX_VERSION" = "ubuntu" ];then
    update-initramfs -u > /dev/null 2>&1
elif [ "$LINUX_VERSION" = "centos" ];then
    dracut -f > /dev/null 2>&1
fi
echo -e "\t\t\t[ OK ]"

rm -f $0
exit 0
