#!/bin/bash
ip=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep ip|awk -F"=" '{print $2}'`
user=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep user|awk -F"=" '{print $2}'`
pass=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep password|awk -F"=" '{print $2}'`
port=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep port|awk -F"=" '{print $2}'`
part=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep io_device|awk -F"=" '{print $2}'`
lock_time=`mysql   -h$ip -P$port -u$user -p$pass  -e "show full  processlist"|grep Locked|awk '{print $6}'|head  -1`
lock_thread=`mysql -h$ip -P$port -u$user -p$pass  -e "show full  processlist"|grep Locked|wc -l`
memory_size=`mysql -h$ip -P$port -u$user -p$pass    information_schema  -e "select round(sum(DATA_LENGTH+INDEX_LENGTH)/1024/1024)  from tables where engine='memory'"|tail -1`
select=`mysql -h$ip -P$port -u$user -p$pass    -e "show global status like '%com_select%'"|tail -1|awk '{print $2}'`
update=`mysql -h$ip -P$port -u$user -p$pass    -e "show global status like '%com_update%'"|tail -1|awk '{print $2}'`
insert=`mysql -h$ip -P$port -u$user -p$pass    -e "show global status like '%com_insert%'"|tail -1|awk '{print $2}'`
delete=`mysql -h$ip -P$port -u$user -p$pass    -e "show global status like '%com_delete%'"|tail -1|awk '{print $2}'`
io=`iostat -x 1 3| grep  $part|sed -n '3,1p'|awk '{print $NF}'`
if [ -z $io ]
   then
     io=0
fi

mysqlcpu=` top -c -b -d 3 -n 1|grep mysql|grep -v $port|head -1|awk '{print $9}'`
mysqladmin -h$ip -P$port -u$user -p$pass  ping >/etc/snmp/ext/alive.txt 2>&1
alive=`cat /etc/snmp/ext/alive.txt`
if [ "${alive}" != "mysqld is alive" ]
   then
      alive_flag="1"
else
      alive_flag="0"
fi

if [ -z $lock_time ] 
   then
     lock_time=0 
     lock_thread=0
fi      
echo "{\"data\":{\"alive\":\"$alive_flag\",\"lock_time\":\"$lock_time\",\"lock_thread\":\"$lock_thread\",\"memory_size\":\"$memory_size\",\"io\":\"$io\",\"mysqlcpu\":\"$mysqlcpu\",\"select\":\"$select\",\"update\":\"$update\",\"insert\":\"$insert\",\"delete\":\"$delete\"},\"msg\":{\"alarm\":\"\"}}" 
