#!/bin/bash
ip=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep ip|awk -F"=" '{print $2}'`
user=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep user|awk -F"=" '{print $2}'`
pass=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep password|awk -F"=" '{print $2}'`
port=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep port|awk -F"=" '{print $2}'`
part=`cat /etc/snmp/yyms_agent_db_scripts/db.conf|grep io_device|awk -F"=" '{print $2}'`
memory_size=`mysql -h$ip -P$port -u$user -p$pass    information_schema  -e "select round(sum(DATA_LENGTH+INDEX_LENGTH))  from tables where engine='memory'"|tail -1`
io=`iostat -d -x $part 1 1|tail -n 2|head -n 1|awk '{print $NF}'`
if [ -z $io ]
   then
     io=0
fi

mysqlcpu=` top -c -b -d 3 -n 1|grep mysql|grep -v $port|head -1|awk '{print $9}'`
echo "{\"data\":{\"memory_size\":\"$memory_size\",\"io\":\"$io\",\"mysqlcpu\":\"$mysqlcpu\"},\"msg\":{\"alarm\":\"\"}}" 
