#!/bin/bash
program_count=`ps -ef|grep $0|grep -v grep|wc -l`
if [ "$program_count" -gt "3" ]
  then
     exit
else
ip=`cat $1|grep ^ip|awk -F"=" '{print $2}'`
user=`cat $1|grep ^user|awk -F"=" '{print $2}'`
pass=`cat $1|grep ^password|awk -F"=" '{print $2}'`
port=`cat $1|grep ^port|awk -F"=" '{print $2}'`
part=`cat $1|grep ^io_device|awk -F"=" '{print $2}'`
important_level=`cat $1|grep ^important_level|awk -F"=" '{print $2}'`
hour=`date +%H`
if [ -z $important_level ]
 then
 important_level=1
fi

if [ $important_level -eq 0 ]
  then
    if [ $hour -ge 22 -o $hour -lt 8 ]
    then
       alive_flag="0"
 echo "{\"data\":{\"alive\":\"$alive_flag\"},\"msg\":{\"alarm\":\"\"}}" 
    exit
    fi
fi  

mysqladmin -h$ip -P$port -u$user -p$pass   ping >/etc/snmp/ext/alive_$port.txt 2>&1
alive=`cat /etc/snmp/ext/alive_$port.txt`
if [ "${alive}" != "mysqld is alive" ]
   then
      alive_flag="1"
else         
      alive_flag="0"
fi

echo "{\"data\":{\"alive\":\"$alive_flag\"},\"msg\":{\"alarm\":\"\"}}" 
fi
