#!/bin/bash
program_count=`ps -ef|grep $0|grep -v grep|wc -l`
date_log=`date +%Y-%m-%d' '%H:%M:%S`
 
if [ "$program_count" -gt "3" ]
  then
     exit
fi
 
important_level=`cat $1|grep ^important_level|awk -F"=" '{print $2}'`
hour=`date +%H`
if [ -z $important_level ]
      then
      important_level=1
fi
    
if [ $important_level -eq 0 ]
          then
             if [ $hour -ge 22 -o $hour -lt 8 ]
                then
                exit
             fi
fi  
 
ip=`cat $1|grep ^ip|awk -F"=" '{print $2}'`
user=`cat $1|grep ^user|awk -F"=" '{print $2}'`
pass=`cat $1|grep ^password|awk -F"=" '{print $2}'`
port=`cat $1|grep ^port|awk -F"=" '{print $2}'`
part=`cat $1|grep ^io_device|awk -F"=" '{print $2}'`
max_conn=`mysql   -h$ip -P$port -u$user -p$pass -N information_schema  -A  -e "show global variables like 'max_connections'"|awk '{print $2}'
`
conn_per=`mysql   -h$ip -P$port -u$user -p$pass -N information_schema  -A  -e "select ceil((VARIABLE_VALUE/ $max_conn ) *100)  from GLOBAL_STATUS   where VARIABLE_NAME='THREADS_CONNECTED';"`
conn_abort=`mysql -h$ip -P$port -u$user -p$pass -N information_schema -A  -e "select VARIABLE_VALUE  from GLOBAL_STATUS where VARIABLE_NAME='ABORTED_CONNECTS'"`
conn_curr=`mysql -h$ip -P$port -u$user -p$pass -N information_schema -A  -e "select VARIABLE_VALUE  from GLOBAL_STATUS where VARIABLE_NAME='Threads_connected'"`
 
echo "{\"data\":{\"max_conn\":\"$max_conn\",\"conn_per\":\"$conn_per\",\"conn_abort\":\"$conn_abort\",\"conn_curr\":\"$conn_curr\"},\"msg\":{\"alarm\":\"\"}}"
