#!/bin/bash
program_count=`ps -ef|grep $0|grep -v grep|wc -l`
date_log=`date +%Y-%m-%d' '%H:%M:%S`
 
if [ "$program_count" -gt "3" ]
  then
     exit
fi
 

important_level=`cat $1|grep ^important_level|awk -F"=" '{print $2}'`
hour=`date +%H`
if [ -z $important_level ]
      then
      important_level=1
fi
    
if [ $important_level -eq 0 ]
          then
             if [ $hour -ge 22 -o $hour -lt 8 ]
                then
                exit
             fi
fi  
 
ip=`cat $1|grep ^ip|awk -F"=" '{print $2}'`
user=`cat $1|grep ^user|awk -F"=" '{print $2}'`
pass=`cat $1|grep ^password|awk -F"=" '{print $2}'`
port=`cat $1|grep ^port|awk -F"=" '{print $2}'`
part=`cat $1|grep ^io_device|awk -F"=" '{print $2}'`
ddllog=`mysql -h$ip -P$port -u$user -p$pass -N information_schema -A  -e "select sum(VARIABLE_VALUE) from GLOBAL_STATUS where VARIABLE_NAME like 'com_drop_index' or VARIABLE_NAME like 'com_drop_table' or VARIABLE_NAME like 'com_drop_db' or VARIABLE_NAME like 'COM_ALTER_TABLE'  or variable_name like 'COM_ALTER_DB' or variable_name like 'Com_truncate'"`
 
 
 
echo "{\"data\":{\"ddllog\":\"$ddllog\"},\"msg\":{\"alarm\":\"\"}}" 
 
echo ${port}" "${date_log}" ""{\"data\":{\"ddllog\":\"$ddllog\"},\"msg\":{\"alarm\":\"\"}}">>/etc/snmp/ext/mysql_ddl.log
