#!/bin/bash
date1=`date +%Y-%m-%d' '%H:%M:%S`   
program_count=`ps -ef|grep $0|grep -v grep|wc -l`
if [ "$program_count" -gt "3" ]
  then
     exit
else
	ip=`cat $1|grep ^ip|awk -F"=" '{print $2}'`
	user=`cat $1|grep ^user|awk -F"=" '{print $2}'`
	pass=`cat $1|grep ^password|awk -F"=" '{print $2}'`
	port=`cat $1|grep ^port|awk -F"=" '{print $2}'`
	memory_size=`mysql -h$ip -P$port -u$user -p$pass  -A    information_schema  -e "select round(sum(DATA_LENGTH+INDEX_LENGTH))  from tables where engine='memory'"|tail -1`
	conf_mem=`mysql -h$ip -P$port -u$user -p$pass -N  -A    information_schema  -e "show global variables like 'max_heap_table_size'"|awk '{print $2}'`
	memory_ratio=`mysql -h$ip -P$port -u$user -p$pass -N  -A    information_schema  -e "select round($memory_size/$conf_mem)"`
	echo $date1" mysql engine memory:"$memory_size" memory_ratio:"$memory_ratio>>/etc/snmp/ext/${port}_engine_memory.log
	echo "{\"data\":{\"memory_size\":\"$memory_size\",\"memory_ratio\":\"$memory_ratio\"},\"msg\":{\"alarm\":\"\"}}" 
fi
