#!/bin/bash
error_date=`date  +%y%m%d`
program_count=`ps -ef|grep $0|grep -v grep|wc -l`
if [ "$program_count" -gt "3" ]
  then
     exit
fi
ip=`cat $1|grep ^ip|awk -F"=" '{print $2}'`
user=`cat $1|grep ^user|awk -F"=" '{print $2}'`
pass=`cat $1|grep ^password|awk -F"=" '{print $2}'`
port=`cat $1|grep ^port|awk -F"=" '{print $2}'`
part=`cat $1|grep ^io_device|awk -F"=" '{print $2}'`

hour=`date +%H`
if [ -z $important_level ]
 then
 important_level=1
fi

if [ $important_level -eq 0 ]
  then
    if [ $hour -ge 22 -o $hour -lt 8 ]
    then
             restarted_count=0 
             errortable_count='-1'
echo "{\"data\":{\"errortable_count\":\"$errortable_count\",\"restarted_count\":\"$restarted_count\"},\"msg\":{\"alarm\":\"\"}}"
    exit
    fi
fi  

errorlog=`mysql -u$user -p$pass -N -A -P$port      -h$ip   information_schema    -e "select VARIABLE_VALUE from GLOBAL_VARIABLES where VARIABLE_NAME='LOG_ERROR';"`
if [ -f $errorlog ]
        then
             error_log_size=`du -k $errorlog|awk '{print $1}'`
             if [ ${error_log_size} -gt 1000000 ]
                   then
			errortable_count="-2"
		        echo "{\"data\":{\"errortable_count\":\"$errortable_count\",\"restarted_count\":\"$restarted_count\"},\"msg\":{\"alarm\":\"\"}}"
		        exit
             fi
             
             errortable_count=`tail -100  $errorlog| grep -Ei "\[ERROR\]"|grep -i table|grep -vi maatkit|grep ${error_date}|wc -l`
             restarted_count=`grep "restarted" $errorlog|wc -l`
					   curdate=`date +%s`                                   
					   passdate=`expr $curdate - 600`                                      
					   if [ ! -f /etc/snmp/ext/restarted_count_$port.log ]                                     
					     then                                                           
					     echo  $restarted_count>/etc/snmp/ext/restarted_count_$port.log                           
					     touch -d "`date -d @$passdate`" /etc/snmp/ext/restarted_count_$port.log
					     restarted_count=0               
					                                                                    
					   else                                                             
					     restarted_count_old=`head -1 /etc/snmp/ext/restarted_count_$port.log`  
					       if [ $restarted_count -eq 0 ] ;then
					         echo "{\"data\":{\"errortable_count\":\"$errortable_count\",\"restarted_count\":\"$restarted_count\"},\"msg\":{\"alarm\":\"\"}}"
                   exit               
					       elif [ $restarted_count -gt $restarted_count_old ]                   
					         then                                                       
					         echo  $restarted_count>/etc/snmp/ext/restarted_count_$port.log                       
					         echo "{\"data\":{\"errortable_count\":\"$errortable_count\",\"restarted_count\":\"$restarted_count\"},\"msg\":{\"alarm\":\"\"}}"                                          
					         exit                                                       
					       elif [ $restarted_count -eq $restarted_count_old ]                 
					         then                                                       
					            modifytime=`find /etc/snmp/ext/restarted_count_$port.log -printf %T@`          
					            modifytime_int=`echo $modifytime|awk -F. '{print $1+0}'`
					            timeinterval=`expr $curdate - $modifytime_int`          
					            if [ $timeinterval -lt 400 ]                            
					              then                                                  
					              echo "{\"data\":{\"errortable_count\":\"$errortable_count\",\"restarted_count\":\"$restarted_count\"},\"msg\":{\"alarm\":\"\"}}"                                                                               
					              exit                                                  
					            else
					            restarted_count=0                                                          
					            fi                                                  
				          fi                                                           
					                                                                    
					   fi                                                               
					                                                       
                              
             else
             restarted_count=0 
             errortable_count='-1'
fi
echo "{\"data\":{\"errortable_count\":\"$errortable_count\",\"restarted_count\":\"$restarted_count\"},\"msg\":{\"alarm\":\"\"}}"
