#!/bin/bash
date_log=`date +%Y-%m-%d' '%H:%M:%S`
program_count=`ps -ef|grep $0|grep -v grep|wc -l`
if [ "$program_count" -gt "3" ]
  then
     exit
fi
 
ip=`cat $1|grep ^ip|awk -F"=" '{print $2}'`
user=`cat $1|grep ^user|awk -F"=" '{print $2}'`
pass=`cat $1|grep ^password|awk -F"=" '{print $2}'`
port=`cat $1|grep ^port|awk -F"=" '{print $2}'`
part=`cat $1|grep ^io_device|awk -F"=" '{print $2}'`
 
innodb_read=`mysql   -h$ip -P$port -u$user -p$pass -N information_schema  -A  -e "select a.VARIABLE_VALUE-b.VARIABLE_VALUE-c.VARIABLE_VALUE  from GLOBAL_STATUS a,GLOBAL_STATUS b,GLOBAL_STATUS c  where a.VARIABLE_NAME='INNODB_ROWS_READ' and b.VARIABLE_NAME='INNODB_ROWS_DELETED' and c.VARIABLE_NAME='INNODB_ROWS_UPDATED';"`
innodb_delete=`mysql -h$ip -P$port -u$user -p$pass -N information_schema -A  -e "select VARIABLE_VALUE  from GLOBAL_STATUS where VARIABLE_NAME='INNODB_ROWS_DELETED'"`
innodb_insert=`mysql -h$ip -P$port -u$user -p$pass -N information_schema -A  -e "select VARIABLE_VALUE  from GLOBAL_STATUS where VARIABLE_NAME='INNODB_ROWS_INSERTED'"`
innodb_update=`mysql -h$ip -P$port -u$user -p$pass -N information_schema -A  -e "select VARIABLE_VALUE  from GLOBAL_STATUS where VARIABLE_NAME='INNODB_ROWS_UPDATED'"`
 
echo "{\"data\":{\"innodb_read\":\"$innodb_read\",\"innodb_delete\":\"$innodb_delete\",\"innodb_insert\":\"$innodb_insert\",\"innodb_update\":\"$innodb_update\",},\"msg\":{\"alarm\":\"\"}}" 

