#!/bin/bash
program_count=`ps -ef|grep $0|grep -v grep|wc -l`
if [ "$program_count" -gt "3" ]
  then
     exit
else
ip=`cat $1|grep ^ip|awk -F"=" '{print $2}'`
user=`cat $1|grep ^user|awk -F"=" '{print $2}'`
pass=`cat $1|grep ^password|awk -F"=" '{print $2}'`
port=`cat $1|grep ^port|awk -F"=" '{print $2}'`
part=`cat $1|grep ^io_device|awk -F"=" '{print $2}'`
memory_size=`mysql -h$ip -P$port -u$user -p$pass -A    information_schema  -e "select round(sum(DATA_LENGTH+INDEX_LENGTH))  from tables where engine='memory'"|tail -1`
io=`iostat -d -x $part 1 1|tail -n 2|head -n 1|awk '{print $NF}'`
if [ -z $io ]
   then
     io=0
fi

mysqlcpu=` top -c -b -d 3 -n 1|grep mysql|grep -v $port|head -1|awk '{print $9}'`
echo "{\"data\":{\"memory_size\":\"$memory_size\",\"io\":\"$io\",\"mysqlcpu\":\"$mysqlcpu\"},\"msg\":{\"alarm\":\"\"}}" 
fi
