#!/bin/bash
program_count=`ps -ef|grep $0|grep -v grep|wc -l`
if [ "$program_count" -gt "10" ]
  then
     exit
else
ip=`cat $1|grep ^ip|awk -F"=" '{print $2}'`
user=`cat $1|grep ^user|awk -F"=" '{print $2}'`
pass=`cat $1|grep ^password|awk -F"=" '{print $2}'`
port=`cat $1|grep ^port|awk -F"=" '{print $2}'`
part=`cat $1|grep ^io_device|awk -F"=" '{print $2}'`

important_level=`cat $1|grep ^important_level|awk -F"=" '{print $2}'`
hour=`date +%H`
if [ -z $important_level ]
 then
 important_level=1
fi

if [ $important_level -eq 0 ]
  then
    if [ $hour -ge 22 -o $hour -lt 8 ]
    then
       slavetime=0
       slave_io_flag=0
       slave_sql_flag=0
       slave_hang_flag=0
 echo "{\"data\":{\"slavetime\":\"$slavetime\",\"slave_io_flag\":\"$slave_io_flag\",\"slave_sql_flag\":\"$slave_sql_flag\",\"slave_hang_flag\":\"$slave_hang_flag\"},\"msg\":{\"alarm\":\"\"}}" 
        exit
    fi
fi  

slave_hang_flag=0
showslave_count=`ps -ef|grep $port|grep "show slave status"|grep -v grep|wc -l`
#check if slave is hang ,added by lww 2012-05-21
if [ "$showslave_count" -gt "4" ]
  then
       slavetime=0
       slave_io_flag=0
       slave_sql_flag=0
       slave_hang_flag=1
   echo "{\"data\":{\"slavetime\":\"$slavetime\",\"slave_io_flag\":\"$slave_io_flag\",\"slave_sql_flag\":\"$slave_sql_flag\",\"slave_hang_flag\":\"$slave_hang_flag\"},\"msg\":{\"alarm\":\"\"}}" 
      exit  
fi

file=${port}_slave_flag.txt
touch /etc/snmp/ext/$file
slave_flag=`cat /etc/snmp/ext/$file`
#disable warning if db at backup
if [ "$slave_flag" = "1" ]
   then
       slavetime=0
       slave_io_flag=0
       slave_sql_flag=0
else
slavetime=`mysql -u$user -p$pass -A      -P$port      -h$ip      -e "show slave status \G"|grep Seconds_Behind_Master|awk '{print $2}'`
if [ -z $slavetime ]
   then
      sleep 2
      slavetime=`mysql -u$user -p$pass -A      -P$port      -h$ip      -e "show slave status \G"|grep Seconds_Behind_Master|awk '{print $2}'`
    if [ -z $slavetime ]
    then
      slavetime="1000000"
    fi
fi
slave_io_flag=`mysql -u$user -p$pass -A  -P$port      -h$ip      -e "show slave status \G"|grep "Slave_IO_Running"|awk '{print $2}'`
slave_sql_flag=`mysql -u$user -p$pass -A -P$port      -h$ip      -e "show slave status \G"|grep "Slave_SQL_Running"|awk '{print $2}'`
if [ "${slavetime}" = "NULL" ]
  then
       sleep 2
      slavetime=`mysql -u$user -p$pass -A      -P$port      -h$ip      -e "show slave status \G"|grep Seconds_Behind_Master|awk '{print $2}'`
    if [ -z $slavetime ]
    then
      slavetime="1000000"
    fi
fi

if [ "${slave_io_flag}" != "Yes" ]
   then
      slave_io_flag='1'
else
         slave_io_flag='0'
fi

if [ "${slave_sql_flag}" != "Yes" ]
   then
      slave_sql_flag='1'
else
        slave_sql_flag='0'
fi
fi
#echo "{\"data\":{\"slavetime\":\"$slavetime\",\"slave_io_flag\":\"$slave_io_flag\",\"slave_sql_flag\":\"$slave_sql_flag\"},\"msg\":{\"alarm\":\"\"}}"
 echo "{\"data\":{\"slavetime\":\"$slavetime\",\"slave_io_flag\":\"$slave_io_flag\",\"slave_sql_flag\":\"$slave_sql_flag\",\"slave_hang_flag\":\"$slave_hang_flag\"},\"msg\":{\"alarm\":\"\"}}" 
       
fi
