#!/bin/bash
## nginx_status v1.0 for YYMS, Copyleft by SearockWu
## usage: nginx_status.sh [ host [port] ]

export LANG=C

hisfile=/tmp/nginx_his.txt
tmpfile=/tmp/nginx_status.tmp
host=localhost
port=80

if [ "$1" != "" ]; then
	host=$1
fi
if [ "$2" != "" ]; then
	port=$2
fi

cur_time=`date +%s`
wget -q -O $tmpfile "http://$host:$port/nginx_status" 2>&1 > /dev/null
cur_req=`grep -E '^[ 0-9]+$' $tmpfile | awk 'END { if($3 ~ /^[0-9]+$/) print $3; else print 0; }'`

if [ -f $hisfile ] ; then
	his_time=`tail -1 $hisfile|awk 'END { if($1 ~ /^1[0-9]+$/) print $1 ; else print 0 ; }'`
	his_req=`tail -1 $hisfile|awk 'END { if($2 ~ /^[0-9]+$/) print $2 ; else print 0 ; }'`
else
	his_time=0
	his_req=0
fi

delta_time=`expr $cur_time - $his_time`
delta_req=`expr $cur_req - $his_req`
rps=`expr $delta_req / $delta_time`
echo $cur_time $cur_req >> $hisfile

# debug mesg
#echo $cur_time : $cur_req : $his_time : $his_req : $delta_time : $delta_req : $rps

## output
## {"segname":{"key":"value","key":"value",...},"segname":{"key":"value",...}}\r\n\r\n
echo '{"data":{"host":"'$host'","port":"'$port'","request":"'$cur_req'","rps":"'$rps'"},"msg":{"msg":"nginx_status"}}'

exit
