#! /bin/bash
MONITOR_DIR=(/data/parsebinlog/udb1 /data/parsebinlog/udb2 /data/parsebinlog/udb3 /data/parsebinlog/udb4)
cd /data/parsebinlog

result=(0 0 0 0)

for ((i=0;i<${#MONITOR_DIR[@]};i++))
do 
	latest_file_no=`ls -lrt ${MONITOR_DIR[i]}/relay-*| tail -n 1 | awk '{print $9}' | awk -F- '{print $2}' | sed 's/^0\+//'`
	no_in_process=`cat ${MONITOR_DIR[i]}/relay_info.ini | grep "relay_file" | awk -F= '{print $2}' | awk -F- '{print $2}' | sed 's/^0\+//'`

	size_delta=0

	if [ -z ${latest_file_no} ]
	then
		latest_file_no=0
	fi

	if [ -z ${no_in_process} ]
        then
                no_in_process=0
        fi

	if [ ${latest_file_no} -gt ${no_in_process} ]
	then
		total_size=0
		for ((j=${no_in_process};j<${latest_file_no};j++))
		do
			index=`printf %06d ${j}`
			if [ -f ${MONITOR_DIR[i]}/relay-${index} ]
			then
				file_size=`ls -lrt ${MONITOR_DIR[i]}/relay-${index} | awk '{print $5}'`
			else
				file_size=0
			fi

			total_size=`expr ${file_size} + ${total_size}`
		done

		size_in_process=`cat ${MONITOR_DIR[i]}/relay_info.ini | grep "file_pos" | awk -F= '{print $2}'`

		index=`printf %06d ${latest_file_no}`
		size_in_total=`ls -lrt ${MONITOR_DIR[i]}/relay-${index}| awk '{print $5}'`

		size_in_process=`expr ${size_in_total} - ${size_in_process}`

		size_delta=`expr ${size_in_process} + ${total_size}`
	fi

	if [ ${latest_file_no} -eq ${no_in_process} ]
	then
		size_in_process=`cat ${MONITOR_DIR[i]}/relay_info.ini | grep "file_pos" | awk -F= '{print $2}'`
		size_in_total=`ls -lrt ${MONITOR_DIR[i]}/relay-*| tail -n 1 | awk '{print $5}'`
		size_delta=`expr ${size_in_total} - ${size_in_process}`
	fi

	if [ ${latest_file_no} -lt ${no_in_process} ]
	then
    		size_delta=-1
    	fi

	result[${i}]=${size_delta}
done

echo "{"data":{"parser1_lag":"${result[0]}","parser2_lag":"${result[1]}","parser3_lag":"${result[2]}","parser4_lag":"${result[3]}"},"msg":{""}}"
