import os,sys
#sys.path.append("/home/dspeak/yyms/yymp/yymp_cron_script")
#import pstat2
import socket
import pprint
from subprocess import Popen, PIPE
import traceback
import logging
import logging.config

class Proc:
  def __init__(self):
    self.__sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM, 0)
    self.__sock.settimeout(1)
    self.__buffer_size = 10240;
    
  def __del__(self):
    self.__sock.close()

  def connect(self, port):
    self.__sock.connect(("127.0.0.1", port))

  def send_and_recv(self, cmd):
    self.__sock.send(cmd)

    total_data=[]
    while True:
      data = self.__sock.recv(self.__buffer_size)
      if not data: break
      total_data.append(data)
      if data.rfind("\r\n\r\n") is not -1: 
        break;
    ret = ''.join(total_data)
    ret = ret.strip()    
    if ret.endswith('>'):
      ret = ret[:len(ret)-1]
    return ret

  def get_all(self):
    return self.send_and_recv("agent get all\r\n")

  def get_clear(self):
    return self.send_and_recv("agent get clear\r\n")

  def str2obj(self, jsonstr):
    return eval(jsonstr)    
  
  def get_proc(self):
    ret = self.send_and_recv("agent get proc")
    return eval(ret)

  def get_dep(self):
    ret = self.send_and_recv("agent get dep")
    return eval(ret)

def get_cpu(pid):
  ps = []
  pp = Popen(['sh','/home/dspeak/yyms/yyms_agent_2_d/script/getPercentCpuOfProcess.sh',str(pid)], stdout=PIPE)
  line = pp.stdout.read()
  return line

def get_mem(pid):
  ps = []
  pp = Popen(['sh','/home/dspeak/yyms/yyms_agent_2_d/script/getMemOfProcess.sh',str(pid)], stdout=PIPE)
  line = pp.stdout.read()
  return line

def deal_json_s(str,name):
  jstr = eval(str)
  pname = jstr['proc']['pname']
  if pname is name:
    return True
  else:
    return False

def deal_json_pid(str,name):
  try:
    jstr = eval(str)
    pname = jstr['proc']['pname']
    pid = jstr['proc']['pid']
    time = jstr['proc']['time']
    if pname is name:
      return True,pid,time
    else:
      return False,0,0
  except:
    print 'deal_json_pid error'
    return False,0,0

def is_ignore_uri(uri):
    ignore_uri_list = ['| 11', '145| 50', '146| 50', "  0|  0"]
    for ignore_uri in ignore_uri_list:
        if uri.endswith(ignore_uri):
            return True
    return False

def deal_json(rstr):
  logger = None
  try:
    logging.config.fileConfig("/home/dspeak/yyms/yyms_agent_2_d/script/pstat_log.conf")
    logger = logging.getLogger('root')
  except:
    print traceback.print_exc()
    pass
 
  rstr = rstr.replace('\t','')
  rstr = rstr.replace('\r','')
  rstr = rstr.replace('\n','')
  rstr = rstr.replace(',}','}')
  rstr = rstr.replace(',]',']')
    
  jstr = eval(rstr)
  pid = jstr['proc']['pid']
  pname = jstr['proc']['pname']
  pver = jstr['proc']['pver']
  time = jstr['proc']['time']

  if jstr['proc'].has_key('user'):
    users = jstr['proc']['user']
  else:
    users = 0
  if jstr['proc'].has_key('queue'):
    queue = jstr['proc']['queue']
  elif jstr['stat'].has_key('queue'):
    queue = jstr['stat']['queue']['queue']
  else:
    queue = 0

  total_req = 0
  total_time_cost = 0
  max_time = 0
  for item in jstr['stat']['uri']:
    if(is_ignore_uri(item['uri'])):
        continue
    total_req += item['counter64']
    total_time_cost += item['time_cost']
    mtime = item['max_time']
    if time > max_time:
      max_time = mtime
    try:
      #syslog.syslog(syslog.LOG_USER|syslog.LOG_DEBUG, '''yyms {\"pid\":%s,\"uri\":\"%s\",\"counter64\":%s,\"time_cost\":%s,\"max_time\":%s} \n'''%(pid,item['uri'],item['counter64'],item['time_cost'],item['max_time']))
      #logger.info(''' {\"pid\":%s,\"uri\":\"%s\",\"counter64\":%s,\"time_cost\":%s,\"max_time\":%s}'''%(pid,item['uri'],item['counter64'],item['time_cost'],item['max_time']))
    except:
      print "write error"
      pass;

  req_avg_time = 0.0;
  if total_req is not 0:
    req_avg_time = total_time_cost*1.0
    req_avg_time /= total_req;
    total_req = total_req/(10*1.0);
    
  cpu = get_cpu(pid)
  cpu = cpu.replace('\n','')
  mem = get_mem(pid)
  mem = mem.replace('\n','')
  ret_str = '''{"data":{"pid":"%s","pname":"%s","pver":"%s","time":"%s","users":"%s","req":"%s","avgtime":"%s","maxtime":"%s","queue":"%s","cpu":"%s","mem":"%s"},"msg":%s}'''%(pid,pname,pver,time,users,total_req,req_avg_time,max_time,queue,cpu,mem,rstr)
 
  return ret_str
  

def main():
  if(len(sys.argv) < 2):
    print("usage: python pstat.py port \"...\"");
  port = long(sys.argv[1]);
  proc = Proc();
  proc.connect(port);
  rstr = proc.get_all()
  retstr = deal_json(rstr)
  print retstr
  '''
  try:
    retstr = pstat2.deal_json(rstr, port)
    pstat2.agent_transfer(retstr)
  except:
    pass
  '''

if __name__ == '__main__':
  main()

