#!/bin/bash

host=127.0.0.1
if [ $# -eq 1 ];then
	host=$1
fi
tmpfile=/tmp/redissinfo.`date +%s`
/data1/redis-cli -h $host info > $tmpfile
echo -n "{\"data\":{"
grep "used_memory:" $tmpfile|awk -F: '{printf("\"%s\":\"%d\"", $1, $2)}'
grep "used_memory_rss:" $tmpfile|awk -F: '{printf(",\"%s\":\"%d\"", $1, $2)}'
grep "total_commands_processed:" $tmpfile|awk -F: '{printf(",\"total_cmds_proc\":\"%d\"", $2)}'
grep "keyspace_hits:" $tmpfile|awk -F: '{printf(",\"%s\":\"%d\"", $1, $2)}'
grep "keyspace_misses:" $tmpfile|awk -F: '{printf(",\"%s\":\"%d\"", $1, $2)}'
grep "vm_stats_swapped_objects:" $tmpfile|awk -F: '{printf(",\"vm_swp_obj\":\"%d\"", $2)}'
grep "vm_stats_swappin_count:" $tmpfile|awk -F: '{printf(",\"vm_swp_in\":\"%d\"", $2)}'
grep "vm_stats_swappout_count:" $tmpfile|awk -F: '{printf(",\"vm_swp_out\":\"%d\"", $2)}'
db0=`grep "^db0:" $tmpfile`
if [ -z $db0 ];then
	echo -n ",\"db0\":\"0\""
else
	echo $db0|perl -lne 'printf(",\"%s\":\"%d\"", $1, $2) if ~ /(.+):keys=(\d+)/'
fi
db1=`grep "^db1:" $tmpfile`
if [ -z $db1 ];then
    echo -n ",\"db1\":\"0\""
else
    echo $db1|perl -lne 'printf(",\"%s\":\"%d\"", $1, $2) if ~ /(.+):keys=(\d+)/'
fi
db2=`grep "^db2:" $tmpfile`
if [ -z $db2 ];then
    echo -n ",\"db2\":\"0\""
else
    echo $db2|perl -lne 'printf(",\"%s\":\"%d\"", $1, $2) if ~ /(.+):keys=(\d+)/'
fi
db3=`grep "^db3:" $tmpfile`
if [ -z $db3 ];then
    echo -n ",\"db3\":\"0\""
else
    echo $db3|perl -lne 'printf(",\"%s\":\"%d\"", $1, $2) if ~ /(.+):keys=(\d+)/'
fi
echo "},\"msg\":{}}"
rm -f $tmpfile

