﻿#-------------------------------------------------------------------------------
# Purpose:
#
# Author:      asu
#
# Created:     29/02/2012
# Copyright:   (c) asu 2012
# Licence:     <your licence>
#-------------------------------------------------------------------------------
#!/usr/bin/env python

# -*- coding: utf8 -*-
import MySQLdb
import os
import smtplib
import string
import shutil
import time

from email.message import Message
from email import Encoders
from email.MIMEBase import MIMEBase
from email.MIMEMultipart import MIMEMultipart
from email.MIMEText import MIMEText
from email.Utils import formatdate

class YyMail:
    def __init__(self, smtp, usr, pwd):
        self.__smtp = smtp;
        self.__usr = usr;
        self.__pwd = pwd;
        pass

    def __del__(self):
        self.__smtp.close();

    def login(self):
        self.__smtp = smtplib.SMTP(self.__smtp)
        self.__smtp.login(self.__usr, self.__pwd)
        pass

    def send_mail(self, from_addr, to_addr, subject, text):
        body = string.join((
            "From: %s" % from_addr,
            "To: %s" % to_addr,
            "Subject: %s" % subject,
            "",
            ""
            ), "\r\n")
        self.__smtp.sendmail(from_addr, [to_addr], body)
        pass

    def send_mail_and_attachment(self, from_addr, to_addrs, subject, text, s):
        message = s
        msg = MIMEMultipart()
        msg["From"] = from_addr
        msg["To"] = ",".join(to_addrs)
        msg["Subject"] = subject;
        msg['Date']    = formatdate(localtime=True)
        msg.attach(MIMEText(message,'plain', 'utf-8'))
        try:
            self.__smtp.sendmail(from_addr, to_addrs, msg.as_string())
        except Exception, e:
            errorMsg = "Unable to send email. Error: %s" % str(e)
        pass
    pass

    def send_mime_txt_mail(self, from_addr, to_addrs, subject, text):
        msg = Message()
        msg["From"] = from_addr
        msg["To"] = ",".join(to_addrs)
        msg["Subject"] = subject;
        msg['Date']    = formatdate(localtime=True)
        msg.set_payload(text);
        try:
            self.__smtp.sendmail(from_addr, to_addrs, msg.as_string())
        except Exception, e:
            errorMsg = "Unable to send email. Error: %s" % str(e)
        pass
    pass

def getExpiredSession():
    expiredSession = [];
    sql = "select distinct(m.session_id),mr.operator,mr.reason,mr.end from monitor_quick_shield m left join monitor_session mr on mr.session_id=m.session_id where mr.begin < now() and now() < mr.end and mr.end > DATE_ADD(now(), INTERVAL 12 HOUR) and  mr.end < DATE_ADD(now(), INTERVAL 24 HOUR) and m.session_id <> 0"
    conn = MySQLdb.connect(host="yymsconfigdb.yy.duowan.com",user="op_yyms_web",passwd="Tv35Rx6+",db="yyms_config",port=6209,charset='utf8');
    c=conn.cursor()
    c.execute(sql)
    numrows = int(c.rowcount)
    if numrows <= 0 :
        return expiredSession;
    shield_result = c.fetchall();
    for row in shield_result:
                session = {};
                session['session_id'] = row[0];
                session['operator'] = row[1];
                session['reason'] = row[2];
                session['end'] = row[3];
                expiredSession.append(session);
    return expiredSession;

def sendExpiredSessionMail(expiredSession):
    if len(expiredSession) < 0 :
        return ;
    sendUsers = {};
    for session in expiredSession :
        operator = session['operator'];
        if not sendUsers.has_key(operator):
            sendUsers[operator] = [];
        sendUsers[operator].append(session);
    for operator, sessions in sendUsers.items() :
        sendMail(operator, sessions);

def sendMail(account, sessions):
    content = "";
    account = account.replace('dw_', '');
    account += "@chinaduo.com";
    for session in sessions :
        content += u"屏蔽 [%s] 即将于 %s 过期，如要续期，请登录yyms后点击此链接进行续期 : http://yyms.sysop.duowan.com/templatedv!renewal.action?sessionId=%s \n" % (session['reason'], session['end'], session['session_id']);
    yy_mail = YyMail("mail.chinaduo.com", "wangxichun@chinaduo.com", "52xiuxiu")
    yy_mail.login()
    to_addrs = [account];
    yy_mail.send_mime_txt_mail(u"wangxichun@chinaduo.com", to_addrs,
        u"[屏蔽取消通知]报警屏蔽即将过期",
        content
    );
    pass

def markRunlog(filepath):
    fp     =  open(filepath, "w+");
    fp.close;

def main() :
    sendExpiredSessionMail(getExpiredSession());

main();
markRunlog("/data/log/quick_shield_run.log");
