#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os, re,random
from subprocess import Popen, PIPE
from cnc_ip_range import in_cnc

p = re.compile("inet\s+addr:(?P<ip>\d+.\d+.\d+.\d+)\s+Bcast:", re.DOTALL | re.IGNORECASE)

config_ip = ''
def get_local_ip():
    ips = []
    if os.name == "posix":
        # CentOS 直接 ifconfig 竟然找不到!
        pp = Popen(['/sbin/ifconfig'], stdout=PIPE)
        lines = pp.stdout.read();
        m = p.search(lines)
        ms = re.findall(p, lines)
        for m in ms:
            ips.append(m)
    else:
        # 本地测试用
        ips = ["10.0.0.1", "121.14.39.154", "58.249.117.122"]
    return ips

def get_local_public_ip():
    localips = get_local_ip()
    ips = []
    for ip in localips:
        if(ip.startswith("10.")
            or ip.startswith("172.16.")
            or ip.startswith("192.168.")
            or ip.startswith("127.0.0.1") ):
            continue
        else:
            ips.append(ip)
    return ips;

def get_default_ip():
    ips = get_local_public_ip()
    for ip in ips:
        if(not in_cnc(ip)):
            return ip;
    if(len(ips) > 0):
        return ips[0]

def set_conf_ip():
    ips = ["121.9.221.53:8080","121.9.220.27:8080","222.186.49.44:8080"]
    random.shuffle(ips)
    f = open("/home/dspeak/yyms/yyms_agent_2_d/assist/config_ip", 'wb')
    f.write(ips[0])
    f.close()

def get_conf_ip():
  f = open("/home/dspeak/yyms/yyms_agent_2_d/assist/config_ip", 'r')
  ip = f.read()
  f.close()
  #print ip
  return ip

def get_random_exe():
  num = random.randint(1, 2)
  if num == 1:
    return True
  else:
    return False
    
if __name__ == '__main__':
    print get_default_ip()
