#!/bin/bash
#Written by wuhaiting.
#Date 2013-05-15

export PATH=/usr/kerberos/sbin:/usr/kerberos/bin:/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin:/root/bin
export LANG=C
BASENAME=$0
if [ -f commonFunction.sh ];then
	source commonFunction.sh
else
	source /usr/local/i386/public_repos/initial_system/snmp/ext/tools_system/commonFunction.sh
fi
IPADDR=$(getSingleIp)

tmp_file=`mktemp`
if [ $? -ne 0 ];then
	echo -e "Result\t$IPADDR\t根分区只读或没有空间"
	msg="根分区只读或没有空间"
	printResult "51" "$msg"
	exit 51
fi
rm -f $tmp_file

if [ -s para.config ];then
	apply_role=`awk -F '=' '{if($1 ~ /apply_role/){print $2}}' para.config |sort -u`
	apply_user=`awk -F '=' '{if($1 ~ /cur_user/){gsub("dw_","",$2);print $2}}' para.config |sort -u`
else
	apply_role=$1
	if [ "X${apply_role}" = "X" ];then
		echo -e "\033[32;40;1m$BASENAME [comm_repos|webdep|db_repos|pure_db_repos|ext_repos]\033[0m"
		exit 1
	fi
fi

if [ "X${apply_user}" != "X" ];then
	grep -qw "$apply_user" /usr/local/i386/public_repos/initial_system/user/sysop_admin.log
	if [ $? -ne 0 ] && [ -s /usr/local/i386/public_repos/initial_system/user/sysop_admin.log ];then
		echo -e "Result\t$IPADDR\t非运维人员禁止修改角色"
		msg="非运维人员禁止修改角色"
		printResult "51" "$msg"
		exit 51
	fi
fi

cat /etc/issue|grep -qiE "CentOS|Red" && LINUX_VERSION="centos"
cat /etc/issue|grep -qiE "Ubuntu" && LINUX_VERSION="ubuntu"
cur_role=`ls /usr/local/i386/|grep 'repos'|grep -v 'public'`

case $apply_role in
	1|comm_repos)
		run_user=yuwanfu
		user_id=2197
		username=clientupdatea276c728eccbae78089bcc08e0658cae
		password=e40a3775ad30455352775a4a144704c7
		keey_user="yuwanfu wuhaiting"
		change_role=comm_repos;;
	2|webdep)
		run_user=yuwanfu
		user_id=2197
		username=89a0edcpeccaa27ebce7apqa27atcp6c728bce7
		password=e80cueccaa27eb80cbnqe780cfb848e04
		keey_user="yuwanfu wuhaiting"
		change_role=webdep;;
	3|db_repos)
		run_user=yuwanfu
		user_id=2197
		username=db_repos89a0edce7aBNPcp6c72anmUTRaa27eb7
		password=b80cNBQHfb848EP4e80cu8IQL27eMRusd87d
		keey_user="yuwanfu wuhaiting zhongjianhui lanzhaobao"
		change_role=db_repos;;
	4|pure_db_repos)
		run_user=zhongjianhui
		user_id=2226
		username=pure_db_reposc2an9a0e7mUdpdfsdaUdY8eb7
		password=b80cRusd8NBQHfb8mUds642UdpdfsdaeM7d
		keey_user="yuwanfu wuhaiting zhongjianhui lanzhaobao"
		change_role=pure_db_repos;;
	5|ext_repos)
		run_user=yuwanfu
		user_id=2197
		username=ext_repos911bc19bea0c678797dc00e5
		password=5dff6d0a84726ba4ab9499fba628ab
		keey_user="yuwanfu wuhaiting"
		change_role=ext_repos;;
    6|dns_repos)
        run_user=yuwanfu
        user_id=2197
        username=dnsreposNPcp6c757e5e07edc95ceda027
        password=2a35eNPcpnPcckn259aYhkp50aY3ceM254
        keey_user="yuwanfu wuhaiting"
        change_role=dns_repos;;

	*)
		change_role=unknow;;
esac

if [ "$cur_role" == "$change_role" ];then
	echo -e "Result\t$IPADDR\t服务器已经是$change_role，无需转换"
	msg="服务器已经是$change_role，无需转换"
	printResult "0" "$msg"
	exit 0
elif [ "${change_role}" = "unknow" ];then
	echo -e "Result\t$IPADDR\trole error"
	msg="role error"
	printResult "51" "$msg"
	exit 51
fi

KEY_PRINT () {
(
cat <<'EOF'
yuwanfu--------ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAAAgQDG+6HbrgWtZSZvyAxeQ9GKuNFpJpQvrPkEQRnvuRw9ElFj4lUpPbGElK/t0gVEIyc2pUBPJ5+gjE6XiQNswFim1XQL2Fcb0KGUXZ4njdl/Y9NMv4NpgSu9ptXWTEJFGokqxmDT6+p1X80S/h690GNyfAzT7Y7rVx7STDmapJAV0w==
zhongjianhui--------ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAAAgQDIz6Gp2k7HMVxiO5ZNOaXFrZ7EJg/dQ+7jbkYRorywV0TxVyMBhaSlfUxlJjCJ0i66KMAk8sQT9czPdHmBdpf0xB9FAtsnQWtDCO8cquEnbq3dfP4Kq3H/8HPDvNLU/5R/7zjmxcLKdiYM9ei+crjljczJUCHnwAnwMneFRBUamQ==
EOF
)
}

# check user and group is exist or not
grep -qw "^execute" /etc/group || groupadd execute
grep -qw "^segroup" /etc/group || groupadd segroup

id $run_user > /dev/null 2>&1
if [ $? -ne 0 ];then
	sed -i "/^$run_user/d" /etc/group
	sed -i "/^$run_user/d" /etc/group-
	groupadd -g $user_id $run_user > /dev/null 2>&1
	useradd -s /bin/bash -m -g $user_id -u $user_id $run_user > /dev/null 2>&1
	mkdir -p /home/$run_user/.ssh
	KEY_PRINT | grep -w "$run_user"|awk -F '--------' '{print $2}' > /home/$run_user/.ssh/authorized_keys
	chmod 600 /home/$run_user/.ssh/authorized_keys
	chmod 700 /home/$run_user/.ssh
	chown -R $run_user:$run_user /home/$run_user

	[ "$run_user" == "yuwanfu" ] && usermod -G segroup,$run_user $run_user
	[ "$run_user" == "zhongjianhui" ] && usermod -G execute,$run_user $run_user
fi

if [ "$LINUX_VERSION" = "ubuntu" ];then
	dpkg -l|grep -q "^ii .*subversion"
	if [ "$?" -ne 0 ];then
		aptitude -y install subversion
	fi
else
	rpm -qa|grep subversion
	if [ "$?" -ne 0 ];then
		yum -y install subversion
	fi
fi

[ ! -d /usr/local/i386 ] && mkdir -p /usr/local/i386
chown -R $run_user:$run_user /usr/local/i386

mkdir -p /home/$run_user/.subversion
echo -e "[groups]\n[global]\nhttp-timeout = 15\nstore-plaintext-passwords = yes\nssl-authority-files = /etc/ssl/yy-cacert.pem" > /home/$run_user/.subversion/servers
chown -R $run_user:$run_user /home/$run_user/.subversion

[ ! -d /etc/ssl ] && mkdir -p /etc/ssl
if [ ! -s /etc/ssl/yy-cacert.pem ];then
(
cat <<'EOF'
Certificate:
    Data:
        Version: 3 (0x2)
        Serial Number:
            f2:6e:9d:79:63:e9:c9:8c
        Signature Algorithm: sha1WithRSAEncryption
        Issuer: C=CN, ST=GD, L=GZ, O=DUOWAN, OU=YY, CN=ca.yy.duowan.com
        Validity
            Not Before: Dec 17 09:30:59 2011 GMT
            Not After : Dec  9 09:30:59 2041 GMT
        Subject: C=CN, ST=GD, L=GZ, O=DUOWAN, OU=YY, CN=ca.yy.duowan.com
        Subject Public Key Info:
            Public Key Algorithm: rsaEncryption
                Public-Key: (2048 bit)
                Modulus:
                    00:dd:b5:b3:ac:2e:48:20:b7:df:74:c5:3b:8c:c4:
                    31:33:cc:24:a0:a2:78:0d:69:65:2a:10:21:a7:9e:
                    eb:3d:64:6a:ee:ce:93:7d:7b:4f:7a:d7:e0:da:a3:
                    0d:da:57:54:95:99:f9:a2:ef:84:93:01:d9:3f:08:
                    66:0a:64:af:73:4b:2b:a4:b5:b9:b8:28:8d:08:0f:
                    45:fd:28:dd:d7:61:75:3f:0c:fe:87:a9:07:7a:0d:
                    ce:a9:22:b6:8c:13:45:10:e4:82:f6:63:65:b7:d9:
                    89:9c:e8:87:70:bd:6d:4c:df:0b:51:89:55:6a:3b:
                    76:b0:4e:9d:03:e1:c9:a9:e0:39:60:09:32:71:3c:
                    f7:24:9b:63:4f:6f:79:e4:f5:ac:6f:b9:6e:6c:6e:
                    41:57:d6:6f:42:2c:4b:23:21:a6:35:3f:ae:fe:52:
                    07:51:8f:4a:62:4a:78:b0:48:29:f5:f0:6b:b7:47:
                    59:13:f4:45:ca:2f:af:1c:f1:bb:48:b8:8a:c9:dd:
                    f7:aa:37:42:d2:9f:9a:b1:3c:63:12:89:f2:ae:aa:
                    f5:47:14:19:07:b3:7b:40:51:c1:3b:8a:6c:0c:77:
                    02:b5:72:b4:29:84:b9:87:00:9c:4c:1c:91:46:9f:
                    7f:7d:24:c6:88:a0:41:4b:4a:f3:40:53:54:82:d0:
                    78:ef
                Exponent: 65537 (0x10001)
        X509v3 extensions:
            X509v3 Subject Key Identifier:
                CE:04:9A:F3:50:E1:D9:2E:32:9E:9B:78:09:A9:52:DF:B5:B8:32:A7
            X509v3 Authority Key Identifier:
                keyid:CE:04:9A:F3:50:E1:D9:2E:32:9E:9B:78:09:A9:52:DF:B5:B8:32:A7

            X509v3 Basic Constraints:
                CA:TRUE
    Signature Algorithm: sha1WithRSAEncryption
        cf:87:b0:24:95:74:fd:ff:90:5a:bb:2a:47:19:fc:48:b1:e7:
        97:e4:65:3d:bf:08:7d:4f:43:f2:03:7f:6d:93:5c:b7:c8:11:
        43:d3:48:df:cb:d4:74:48:96:03:16:80:d5:85:aa:e7:6f:8e:
        e3:f4:b9:d1:c5:89:30:ea:46:2b:ca:fd:5f:c2:b4:47:80:0a:
        a5:4d:0d:b8:72:d7:d5:e6:3f:a2:9a:02:71:e7:71:33:f5:0a:
        f9:44:72:33:39:fd:af:55:2e:12:5e:99:a0:d7:cf:27:64:a8:
        f9:1d:62:7e:98:c5:fd:97:6a:b3:aa:7a:4d:d8:22:f2:56:b6:
        51:45:68:9b:b1:2d:a2:98:b7:28:bc:78:d0:78:c9:66:27:c7:
        8e:ba:21:b7:3f:35:b2:43:95:57:d0:74:d0:d2:d0:80:11:75:
        98:a0:2b:9b:34:fb:d1:e3:f8:91:e1:a0:b1:e4:76:2a:9e:14:
        46:af:16:79:d7:d8:de:13:fe:c0:4a:be:0e:e3:e7:aa:19:3b:
        05:ec:3b:dc:f6:ff:e8:3a:77:59:7d:7c:d7:ef:82:e0:81:53:
        ac:82:60:ce:68:3a:d2:e5:a0:96:d1:94:91:f8:3b:f6:74:9b:
        05:b1:40:60:cd:bd:4f:cb:e5:7f:bf:cd:22:a0:4b:14:1a:c0:
        cf:72:65:34
-----BEGIN CERTIFICATE-----
MIIDkzCCAnugAwIBAgIJAPJunXlj6cmMMA0GCSqGSIb3DQEBBQUAMGAxCzAJBgNV
BAYTAkNOMQswCQYDVQQIDAJHRDELMAkGA1UEBwwCR1oxDzANBgNVBAoMBkRVT1dB
TjELMAkGA1UECwwCWVkxGTAXBgNVBAMMEGNhLnl5LmR1b3dhbi5jb20wHhcNMTEx
MjE3MDkzMDU5WhcNNDExMjA5MDkzMDU5WjBgMQswCQYDVQQGEwJDTjELMAkGA1UE
CAwCR0QxCzAJBgNVBAcMAkdaMQ8wDQYDVQQKDAZEVU9XQU4xCzAJBgNVBAsMAllZ
MRkwFwYDVQQDDBBjYS55eS5kdW93YW4uY29tMIIBIjANBgkqhkiG9w0BAQEFAAOC
AQ8AMIIBCgKCAQEA3bWzrC5IILffdMU7jMQxM8wkoKJ4DWllKhAhp57rPWRq7s6T
fXtPetfg2qMN2ldUlZn5ou+EkwHZPwhmCmSvc0srpLW5uCiNCA9F/Sjd12F1Pwz+
h6kHeg3OqSK2jBNFEOSC9mNlt9mJnOiHcL1tTN8LUYlVajt2sE6dA+HJqeA5YAky
cTz3JJtjT2955PWsb7lubG5BV9ZvQixLIyGmNT+u/lIHUY9KYkp4sEgp9fBrt0dZ
E/RFyi+vHPG7SLiKyd33qjdC0p+asTxjEonyrqr1RxQZB7N7QFHBO4psDHcCtXK0
KYS5hwCcTByRRp9/fSTGiKBBS0rzQFNUgtB47wIDAQABo1AwTjAdBgNVHQ4EFgQU
zgSa81Dh2S4ynpt4CalS37W4MqcwHwYDVR0jBBgwFoAUzgSa81Dh2S4ynpt4CalS
37W4MqcwDAYDVR0TBAUwAwEB/zANBgkqhkiG9w0BAQUFAAOCAQEAz4ewJJV0/f+Q
WrsqRxn8SLHnl+RlPb8IfU9D8gN/bZNct8gRQ9NI38vUdEiWAxaA1YWq52+O4/S5
0cWJMOpGK8r9X8K0R4AKpU0NuHLX1eY/opoCcedxM/UK+URyMzn9r1UuEl6ZoNfP
J2So+R1ifpjF/Zdqs6p6Tdgi8la2UUVom7Etopi3KLx40HjJZifHjrohtz81skOV
V9B00NLQgBF1mKArmzT70eP4keGgseR2Kp4URq8WedfY3hP+wEq+DuPnqhk7Bew7
3Pb/6Dp3WX181++C4IFTrIJgzmg60uWgltGUkfg79nSbBbFAYM29T8vlf7/NIqBL
FBrAz3JlNA==
-----END CERTIFICATE-----
EOF
) > /etc/ssl/yy-cacert.pem
fi

for MYSQL_ADDRESS in "121.14.36.27" "58.215.46.20" "183.57.81.221";
do
	sed -i "/manager.repos.yy.duowan.com/d" /etc/hosts
	echo "$MYSQL_ADDRESS manager.repos.yy.duowan.com" >> /etc/hosts

	su - $run_user -c "cd /usr/local/i386 ; svn co https://manager.repos.yy.duowan.com:63579/svn/$change_role --username=$username --password=$password >/dev/null 2>&1"
	[ $? -eq 0 ] && break
done

if [[ -f /usr/local/i386/$change_role/auto/base_config.sh ]] && [[ -f /usr/local/i386/$change_role/initial_system/dispatcher.content ]];then
	echo -e "Result\t$IPADDR\t服务器已转换为$change_role"
	chmod -R 755 /usr/local/i386/$change_role/
	pkill -9 -f sysop_manager.sh
else
	echo -e "Result\t$IPADDR\t服务器角色转换失败，请联系吴海庭"
	msg="服务器角色转换失败，请联系吴海庭"
	printResult "51" "$msg"
	exit 51
fi

if [ "$change_role" == "comm_repos" ];then
	useradd -s /bin/bash -d /home/dspeak -m dspeak > /dev/null 2>&1
	mkdir -p /home/dspeak/.ssh
	#echo "ssh-rsa AAAAB3NzaC1yc2EAAAABIwAAAIEA7NtU7UFJ0EtWvPo/3tV/8Iia3HBhn9/O2wbfeCKZTmZtv4gc/Q6VtnmGmUvqbLqYRbT00QFLsc1QXRx3lJvKZfLaCpniIHhdeBUTVPgRq0TZF7AxGiRS1AZQv/EAvG1tRqs7q5QhyUIO9ZBbmm+ax93K/W0qDnpGb2oKopQHmus=" > /home/dspeak/.ssh/authorized_keys
	#chmod 700 /home/dspeak/.ssh
	#chmod 600 /home/dspeak/.ssh/authorized_keys
	#chown -R dspeak:dspeak /home/dspeak

	# 创建应用系统所需目录
	mkdir -p /home/dspeak/release/bin
    mkdir -p /home/dspeak/yyms/proc_info
	mkdir -p /data/yy/log
	nologin_file=`which nologin`
	chsh dspeak -s $nologin_file

	pkill -9 -f iptables
	mkdir -p /home/dspeak/iptables
	chown dspeak:dspeak -R /home/dspeak/iptables
	/bin/cp /usr/local/i386/$change_role/initial_system/iptables/iptables.sh /home/dspeak/iptables/iptables.sh
	iptables -t raw -F > /dev/null
	iptables -t raw -L > /dev/null

	echo 1qazxcv > /etc/rsync.scr
	chmod 600 /etc/rsync.scr
elif [[ "$change_role" == "db_repos" ]] || [[ "$change_role" == "pure_db_repos" ]];then
	/bin/bash /usr/local/i386/$change_role/auto/monitor_user_privileges.sh adduser lanzhaobao > /dev/null 2>&1
elif [ "$change_role" == "ext_repos" ];then
	rm -f /etc/rsync.scr
elif [ "${change_role}" == "dns_repos" ];then
    echo root:manifold|/usr/sbin/chpasswd
fi

for del_dir in `ls /usr/local/i386| grep -vwE "$change_role|public_repos"`
do
	[ "$del_dir" != "" ] && rm -rf /usr/local/i386/$del_dir
done

/bin/bash -c "/bin/bash /usr/local/i386/$change_role/auto/base_config.sh nosign > /dev/null 2>&1 &"
/bin/bash -c "/bin/bash /usr/local/i386/$change_role/auto/etc_snmp.sh > /dev/null 2>&1 &"
/bin/bash -c "/bin/bash /usr/local/i386/$change_role/auto/mon_secure.sh > /dev/null 2>&1 &"
/bin/bash -c "/bin/bash /usr/local/i386/$change_role/initial_system/motd/generate_motd.sh > /dev/null 2>&1 &"

msg="成功"
printResult "0" "$msg"
exit 0

