#!/bin/bash
#Date:2012-10-24
#Written by manifold.
#Readme:crontab任务管理工具。


source commonFunction.sh


# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

                         
# 主脚本

# 参数获取

parseParameter || exit $?


# 所需参数检查：（参数相关格式检查基本全部通过函数operateCrontab的功能实现）
# 1、crontab操作类型：add,del,show
# 2、crontab操作对象：具体的/etc/crontab条目拆分

# 操作类型
CRONTAB_ACTION=$( echo "$PARA_ACTION" | awk '{if($1=="add" || $1=="del" || $1=="show") print $1}' )

if [ "$CRONTAB_ACTION" != "$PARA_ACTION" ] || [ -z "$CRONTAB_ACTION" ] ; then

    code=102 ; msg="$SCRIPT_NAME [ERR ] | PARA_ACTION value error."
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 运行时间：分
if [ -z "$PARA_MINUTE" ]; then

    code=103 ; msg="$SCRIPT_NAME [ERR ] | PARA_MINUTE value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 运行时间：时
if [ -z "$PARA_HOUR" ]; then

    code=104 ; msg="$SCRIPT_NAME [ERR ] | PARA_HOUR value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 运行时间：日
if [ -z "$PARA_DATE" ]; then

    code=105 ; msg="$SCRIPT_NAME [ERR ] | PARA_DATE value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 运行时间：月
if [ -z "$PARA_MONTH" ]; then

    code=106 ; msg="$SCRIPT_NAME [ERR ] | PARA_MONTH value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 运行时间：周
if [ -z "$PARA_WEEK" ]; then

    code=107 ; msg="$SCRIPT_NAME [ERR ] | PARA_WEEK value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 运行用户
if [ -z "$PARA_RUN_USER" ]; then

    code=108 ; msg="$SCRIPT_NAME [ERR ] | PARA_RUN_USER value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 运行脚本
if [ -z "$PARA_RUN_SCRIPT" ]; then

    code=109 ; msg="$SCRIPT_NAME [ERR ] | PARA_RUN_SCRIPT value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


PARA_CRONTAB_ENTRY="$PARA_MINUTE $PARA_HOUR $PARA_DATE $PARA_MONTH $PARA_WEEK $PARA_RUN_USER $PARA_RUN_SCRIPT"

# /etc/crontab操作
operateCrontab "$CRONTAB_ACTION" "$PARA_CRONTAB_ENTRY" || exit $?


# 最后的信息返回

code=0; msg="$SCRIPT_NAME [INFO ] | successful."

printResult "$code" "$msg"

exit $code

