#!/bin/bash
#Date:2012-09-28
#Written by manifold.
#Readme:检查linkd_d进程掉线人数情况。
#Change:2012-11-02
#Readme:改用中心机控制的方式去执行。


source commonFunction.sh


# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

                         
# 主脚本

# 参数获取

parseParameter || exit $?


# 所需参数检查

# 过滤对应时间的日志

if [ -z "$PARA_SEARCH_TIME" ]; then

    code=102 ; msg="$SCRIPT_NAME [ERR ] | PARA_SEARCH_TIME value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
else

    # 时间合法性检查：1、是个合法的正整数；2、时间不会大于24小时
    PARA_SEARCH_HOUR=$(echo $PARA_SEARCH_TIME|awk -F ':' '{print $1}')
    PARA_SEARCH_MINUTE=$(echo $PARA_SEARCH_TIME|awk -F ':' '{print $2}')
    if ! ( checkIsPositiveIntegerOrNot $PARA_SEARCH_HOUR ) || [ "$PARA_SEARCH_HOUR" -ge "24" ] || ! ( checkIsPositiveIntegerOrNot $PARA_SEARCH_MINUTE ) || [ "$PARA_SEARCH_MINUTE" -ge "60" ]; then
        
        code=103; msg="$SCRIPT_NAME [ERR ] | PARA_SEARCH_TIME must be a valid hour:minute."

        printResult "$code" "$msg" 

        exit $code
       
    else
    
        if [ "$PARA_SEARCH_HOUR" -lt 10 ];then
        
            PARA_SEARCH_HOUR="0$PARA_SEARCH_HOUR"
            
        fi
    
    fi
    
fi


# 需进行处理的对应IP地址

if [ -z "$PARA_SEARCH_IP" ]; then

    code=104 ; msg="$SCRIPT_NAME [ERR ] | PARA_SEARCH_IP value is null"
    
    printResult "$code" "$msg"
    
    exit $code

fi



# 时间格式定义

# 月格式定义
MON_STRING=$(date "+%b")


# 日格式定义（若小于10号，日志里面会多一个空格）
# Sep  3 05:20:17
# Sep 28 05:20:17

if [ $(date "+%d") -lt 10 ] ; then

    # By default, date pads numeric fields with zeroes.  The following optional flags may follow ‘%’:
    # -      (hyphen) do not pad the field
    DATE_STRING=" $(date "+%-d")"
    
else

    DATE_STRING="$(date "+%d")"
    
fi


# 分别登录每台服务器进行日志收集

# linkd_d日志文件路径定义
LINKD_LOG_FILE=/data/yy/log/linkd_d/linkd_d.log

echo -e "$PARA_SEARCH_IP" | while read LOGIN_IP_ADDRESS
do

    FILE_NAME=$(mktemp)

    function printScript {
        cat <<EOF
#!/bin/bash

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# 判断是否存在linkd_d日志
if [ ! -f $LINKD_LOG_FILE ] ; then

    exit
    
else

    for OFFLINE_TIME in \$(cat $LINKD_LOG_FILE | egrep "^$MON_STRING $DATE_STRING $PARA_SEARCH_HOUR:$PARA_SEARCH_MINUTE:" | awk -F '[ :]+' '{if(\$9~/OFFLINE/) print \$3":"\$4}' | sort | uniq -c | sort -nr | head -n 3 | awk '{print \$2}')
    do
    
        # cat $LINKD_LOG_FILE | egrep "^$MON_STRING $DATE_STRING $OFFLINE_TIME:" | awk -F '[ :]+' '{if($9~/OFFLINE/) print $11}' | sort | uniq -c | sort -nr | head -n 10 | sed -r 's/^[ ]+/LINKD_INFO\\t'"${IP_ADDR}"'\\t/g' | sed -r 's/[ ]+/\\t/g' 
        cat $LINKD_LOG_FILE | egrep "^$MON_STRING $DATE_STRING \$OFFLINE_TIME:" | awk -F '[ :]+' '{if(\$9~/OFFLINE/) print \$11}' | sed -r 's/(.*)/'"${LOGIN_IP_ADDRESS}"' '"\$OFFLINE_TIME"' \1/g'
    
    done
    
fi
EOF
    }
    
    printScript > $FILE_NAME
    /home/yuwanfu/scp_channel_tools_system -P32200 -f -S $FILE_NAME -D $LOGIN_IP_ADDRESS:/tmp
    rm -f $FILE_NAME
    
    BASE64_STRING=$( echo "/bin/bash $FILE_NAME ; rm -f $FILE_NAME" | base64 -w 0 )
    /home/yuwanfu/ssh_channel_tools_system -h "$LOGIN_IP_ADDRESS" -u root -c "$BASE64_STRING" 
    
done | egrep ^[[:digit:]]+\. | sort | uniq -c | sort -nr | head -n 10 | sed -r 's/^[ ]+/LINKD_INFO\\t'"${IP_ADDR}"'\\t/g' | sed -r 's/[ ]+/\\t/g' | sed -r 's/(.*)\\t(.*)/\1\\t\2/g'


# 最后的信息返回
code=0; msg="$SCRIPT_NAME [INFO ] | successful."

printResult "$code" "$msg"

exit $code
