#!/bin/bash
#Date:2012-10-23
#Written by manifold.
#Readme:磁盘空间清理工具。
#Change:2013-01-03
#Readme:新增V4机器日志清理策略。
#Change:2014-06-30
#Readme:新增网站事业部log清理策略。
#Change:2014-07-20
#Readme:细化磁盘清理规则。
#Change:2015-05-30
#Readme:改用于UDB业务的日志清理。


source commonFunction.sh


# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

                         
# 主脚本

# 清理相关文件


# /var/log目录清理
for LOG_FILE in /var/log/messages /var/log/syslog /var/log/user.log /var/log/debug /var/log/kern.log /var/log/daemon.log ; do

    > $LOG_FILE
    
    rm -fr $LOG_FILE\.*

done


# sysop_manager日志清理
> /var/log/sysop_manager/sysop_manager.log


# /data/weblog/dm 目录的清理（只适用于 UDB 机器）
find /data/weblog/dm -name "data.dat*" -type f -mtime +1 -exec rm -f {} \;


# 清理后返回空间占用信息，供参照获取结果
for PARTITION in $(cat /etc/mtab |grep ^/dev |awk '{print $2}');do

    DISK_SPACE=$(df -lh|grep -w "$PARTITION"$|awk '{print $NF,$(NF-1)}')
    
    [[ -z "$DISK_SPACE_STRING" ]] && DISK_SPACE_STRING="${DISK_SPACE}" || DISK_SPACE_STRING="$DISK_SPACE_STRING,${DISK_SPACE}"

done

echo "DISK_SPACE\t$IP_ADDR\t$DISK_SPACE_STRING"



# 最后的信息返回

code=0; msg="$SCRIPT_NAME [INFO ] | successful."

printResult "$code" "$msg"

exit $code

