#!/bin/bash
#Date:2012-10-12
#Written by manifold.
#Readme:告警信息过滤处理。


source commonFunction.sh


# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

                         
# 主脚本

# 参数获取

parseParameter || exit $?

# 所需参数检查：
# 1、告警内容（禁止为空）
# 2、过滤的关键字（禁止为空） --  再细分为精确匹配和模糊匹配（默认为模糊匹配）
# 3、是否提取IP（默认提取IP，可以选择只提取相应的告警条目）

# 告警内容

if [ -z "$PARA_ALERT_INFO" ]; then

    code=102 ; msg="$SCRIPT_NAME [ERR ] | PARA_ALERT_INFO value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi

# 过滤的关键字

if [ -z "$PARA_KEYWORD" ]; then

    code=103 ; msg="$SCRIPT_NAME [ERR ] | PARA_KEYWORD value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 采集数据

# PARA_KEYWORD_MATCH默认为空，若是精准匹配，则为-w
PARA_KEYWORD_MATCH=${PARA_KEYWORD_MATCH:=""}

# PARA_GET_IP默认为提取IP
PARA_GET_IP=${PARA_GET_IP:="yes"}

if [ "$PARA_GET_IP" = "yes" ];then

    echo -e "$PARA_ALERT_INFO" | grep $PARA_KEYWORD_MATCH "$PARA_KEYWORD" | awk '{print $2}' | while read ENTRY
    do
    
        echo "GREP_INFO\t$IP_ADDR\t$ENTRY"
        
    done
    
else

    echo -e "$PARA_ALERT_INFO" | grep $PARA_KEYWORD_MATCH "$PARA_KEYWORD" | while read ENTRY
    do
    
        echo "GREP_INFO\t$IP_ADDR\t$ENTRY"
        
    done

fi


# 最后的信息返回

code=0; msg="$SCRIPT_NAME [INFO ] | successful."

printResult "$code" "$msg"

exit $code

