#!/bin/bash
#Date:2012-09-19
#Written by manifold.
#Readme:install package.

source commonFunction.sh

# 基础变量定义
MYPID=$$

# 脚本名称定义
SCRIPT_NAME=$(basename $0)

# 禁止在非ubuntu系统上运行
RUN_SYSTEM="ubuntu"
checkOs $RUN_SYSTEM || { code=100; msg="$SCRIPT_NAME [ERR ] | this script only can be run on $RUN_SYSTEM"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

# 参数获取
parseParameter || exit $?

# 所需参数检查
if [ -z $PARA_PACKAGE_NAME ]; then

    code=104 ; msg="$SCRIPT_NAME [ERR ] | package name is null"
    
    printResult
    
    exit $code
    
fi

# 主程序
PARA_PACKAGE_NAME=$(echo $PARA_PACKAGE_NAME|sed 's/,/ /g')
aptitude -y install $PARA_PACKAGE_NAME

dpkg -l|grep -w $PARA_PACKAGE_NAME || { code=105 ; msg="$SCRIPT_NAME [ERR ] | install package $PARA_PACKAGE_NAME error"

                                        printResult "$code" "$msg"

                                        exit $code; }

code=0 ; msg="$SCRIPT_NAME [INFO] | install package successful"

printResult "$code" "$msg"

exit $code


