#!/bin/bash
#Date:2012-09-28
#Written by manifold.
#Readme:mtr tool.


source commonFunction.sh


# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

                         
# 主脚本

# 检查是否有安装mtr软件包
checkPackageExistOrNot mtr || { code=102; msg="$SCRIPT_NAME [ERR ] | no mtr package,please install first."
    
                                printResult "$code" "$msg" 
                                
                                exit $code ; }


# 参数获取

parseParameter || exit $?

# 所需参数检查

# 探测次数（若不填，默认为5）

PARA_TIMES=${PARA_TIMES:="5"}

# 目标IP

if [ -z "$PARA_TARGET_IPS" ]; then

    code=104 ; msg="$SCRIPT_NAME [ERR ] | PARA_TARGET_IPS value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 采集数据

# 遍历mtr所有IP地址

for PARA_TARGET_IP in $(echo -e $PARA_TARGET_IPS) ; do

    MTR_TEMP_FILE=$(mktemp)

    WGET_TEMP_FILE=$(mktemp)

    mtr --report -c $PARA_TIMES -n $PARA_TARGET_IP | grep -v HOST > $MTR_TEMP_FILE

    
    # 判断结果文件是否为空
    if [ $(cat $MTR_TEMP_FILE|wc -l) -eq 0 ];then
    
        code=105 ; msg="$SCRIPT_NAME [ERR ] | trace failed."
        
        printResult "$code" "$msg"
        
        exit $code
        
    fi
    
    
    cat $MTR_TEMP_FILE | while read ENTRY

    do

        TRACE_IP=$(echo "$ENTRY" | awk '{print $2}')
        
        wgetAction 121.14.36.27 nali.php $WGET_TEMP_FILE "ip=$TRACE_IP"
        
        TRACE_IP_AREA_INFO=$(cat $WGET_TEMP_FILE|sed -r 's/ +/-/g')
        
        TRACE_IP_AREA_INFO=${TRACE_IP_AREA_INFO:="信息查询失败"}
        
        echo "TRACE_INFO\t$ENTRY" | \
        
        sed -r 's/ ([[:digit:]]+\.[[:digit:]]+\.[[:digit:]]+\.[[:digit:]]+|\?\?\?) +/ '"${IP_ADDR}"' '"${PARA_TARGET_IP}"' '"${TRACE_IP_AREA_INFO}"' /g' | \
        
        sed -r 's/ +/\\t/g'
        
    done

    echo "TRACE_INFO\t<br>"
   
    rm -f $MTR_TEMP_FILE

    rm -f $WGET_TEMP_FILE

done


# 最后的信息返回

code=0; msg="$SCRIPT_NAME [INFO ] | successful."

printResult "$code" "$msg"

exit $code

