#!/bin/bash
#Date:2012-10-19
#Written by manifold.
#Readme:关机/重启工具。


source commonFunction.sh


# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

                         
# 主脚本

# 参数获取

parseParameter || exit $?

# 所需参数检查：
# 1、操作类型（关机/重启）

if [[ "$PARA_REBOOT" == "" ]] && [[ "$PARA_HALT" == "" ]]; then

    code=102 ; msg="$SCRIPT_NAME [ERR ] | PARA_REBOOT/PARA_HALT value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi


# 判断操作类型

if [ "$PARA_REBOOT" == "1" ];then

    sync
    reboot

elif [ "$PARA_HALT" == "1" ];then

    sync
    halt
    
else

    code=103 ; msg="$SCRIPT_NAME [ERR ] | PARA_REBOOT/PARA_HALT value error."
    
    printResult "$code" "$msg"
    
    exit $code

fi


# 最后的信息返回

code=0; msg="$SCRIPT_NAME [INFO ] | successful."

printResult "$code" "$msg"

exit $code

