#!/bin/bash
#Date:2013-06-21
#Written by manifold.
#Readme:监控 pay.duowna.com ，若发现某IP 1分钟内访问超过100次，丢到防火墙里面去。


export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin


# 定义日志路径信息
LOG_DIR=/data/yy/log/nginx
LOG_FILE=$LOG_DIR/pay.access_monitor.log

# 获取1分钟前的 log 进行分析
LAST_MINUTE=$(date --date "1 minute ago" "+%d/%b/%Y:%H:%M")
LAST_MINUTE_GREP=$(echo $LAST_MINUTE|sed -e 's/\//\\\//g')

# 定义触发值
TRIGGER_VALUE=180

# 定义防火墙路径信息
IPTABLES_DIR=/usr/local/virus/iptables
IPTABLES_DENY_PAY_IP_LIST=$IPTABLES_DIR/iptables.deny.pay.ip.list
IPTABLES_ADD_FILE=$IPTABLES_DIR/iptables.add
IPTABLES_SCRIPT=$IPTABLES_DIR/iptables.sh

# 将第一个字段IP地址去从统计，将访问量>=100次的IP地址抽出来，IP地址抽出来后，将原 logfile 清空
DENY_IP_LIST=$(cat $LOG_FILE | awk '/'"${LAST_MINUTE_GREP}"'/ {a[$1]++} END {for(i in a) if(a[i]>='"${TRIGGER_VALUE}"') print a[i],i}')
> $LOG_FILE
echo "$DENY_IP_LIST" | awk '{print $2}' > $IPTABLES_DENY_PAY_IP_LIST
if ! grep $IPTABLES_DENY_PAY_IP_LIST $IPTABLES_ADD_FILE ; then
    # 若禁止变量转义，需用 ' 引起来
	# cat <<'EOF' >> $IPTABLES_ADD_FILE
    cat <<EOF >> $IPTABLES_ADD_FILE
for DENY_IP in \$( cat $IPTABLES_DENY_PAY_IP_LIST ) ; do
    iptables -A INPUT -p tcp -s \$DENY_IP --dport 80 -j DROP
done
EOF
fi

# 刷新防火墙规则并写log
SCRIPT_NAME=$(basename $0)
EXECUTE_INFO_LOG=$LOG_DIR/$SCRIPT_NAME.execute.info.log

# 判断 IPTABLES_DENY_PAY_IP_LIST 是否有变更，有变更则刷新防火墙
IPTABLES_DENY_PAY_IP_LIST_MD5_FILE=$IPTABLES_DENY_PAY_IP_LIST.md5
[ ! -s $IPTABLES_DENY_PAY_IP_LIST_MD5_FILE ] && md5sum $IPTABLES_DENY_PAY_IP_LIST | awk '{print $1}' > $IPTABLES_DENY_PAY_IP_LIST_MD5_FILE
IPTABLES_DENY_PAY_IP_LIST_OLD_MD5=$(cat $IPTABLES_DENY_PAY_IP_LIST_MD5_FILE)
IPTABLES_DENY_PAY_IP_LIST_NEW_MD5=$(md5sum $IPTABLES_DENY_PAY_IP_LIST | awk '{print $1}')
[ "$IPTABLES_DENY_PAY_IP_LIST_OLD_MD5" != "$IPTABLES_DENY_PAY_IP_LIST_NEW_MD5" ] && /bin/bash $IPTABLES_SCRIPT && { \
    cat <<EOF >> $EXECUTE_INFO_LOG
TIME:$(date "+%Y-%m-%d %T") CONTENT:$(echo "iptables deny all these ips to access port 80 as follow:")
$(echo "$DENY_IP_LIST")

EOF
}
