#!/bin/bash
#Date:2013-02-19
#Written by manifold.
#Readme:监控 com.duowan.pay.schedule.job.udb.ReadMobileChangeTopic 运行情况，发现挂死时自动重启。
#Change:2013-02-27
#Readme:新增监控 com.duowan.pay.schedule.job.udb.ReadSmsCommandQueue 运行情况，发现挂死时自动重启。


export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin


if [ -z "$1" ];then
    echo "please input parameter."
    exit
fi


if [ "$1" == "monitor" ];then
    for log in /data/yy/log/pay/udb_mobile_change_topic.log /data/yy/log/pay/read_udb_sms_queue.log
    do
        tail -n 100 $log | grep -q "The Consumer is closed" && ERROR_LINE=1
    done
    if [ "$ERROR_LINE" == "1" ];then
        python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report.py "id=10871&value=1"
    else
        python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report.py "id=10871&value=0"
    fi
fi


MONITOR_PROCESS="$1"

if [ "$MONITOR_PROCESS" == "ReadMobileChangeTopic" ];then


    LOG_FILE=/data/yy/log/pay/udb_mobile_change_topic.log

    TIME_LOG_FILE=/data/yy/log/pay/monitor_udb_mobile_change_topic.time
    cat $TIME_LOG_FILE | grep -E "[0-9]{4}\-[0-9]{1,2}\-[0-9]{1,2} [0-9]{1,2}:[0-9]{2}:[0-9]{2}"
    if [ "$?" -ne 0 ] || [ ! -s $TIME_LOG_FILE ];then
        tail -n 1 $LOG_FILE | awk -F ',' '{print $1}' | sed 's/\[//' | grep -E "[0-9]{4}\-[0-9]{1,2}\-[0-9]{1,2} [0-9]{1,2}:[0-9]{2}:[0-9]{2}" > $TIME_LOG_FILE
        if [ ! -s $TIME_LOG_FILE ];then
            # 避免出现空时间戳的情况，同时因为日志有缓存再打印的机制，这里sleep 30s后再重试一次
            sleep 30
            tail -n 1 $LOG_FILE | awk -F ',' '{print $1}' | sed 's/\[//' | grep -E "[0-9]{4}\-[0-9]{1,2}\-[0-9]{1,2} [0-9]{1,2}:[0-9]{2}:[0-9]{2}" > $TIME_LOG_FILE
        fi
    fi

    LAST_LOG_DATE_STRING=$(tail -n 1 $LOG_FILE | awk -F ',' '{print $1}' | sed 's/\[//')
    LAST_DATE=$(echo $LAST_LOG_DATE_STRING | awk '{print $1}')
    LAST_TIME=$(echo $LAST_LOG_DATE_STRING | awk '{print $2}')

    EXECUTE_LOG_FILE=/data/yy/log/pay/monitor_udb_mobile_change_topic.execute

    cat $TIME_LOG_FILE | while read FORMER_DATE FORMER_TIME
    do
        ERROR_MESSAGE="The Consumer is closed"
        LINE=$(tac $LOG_FILE | sed 's/\[//;s/\]//' | sed -n -r '/^[[:digit:]][[:digit:]][[:digit:]][[:digit:]]-[[:digit:]][[:digit:]]-[[:digit:]][[:digit:]]/p' | awk -F '[ ,]' '{if($1>=FORMER_DATE && $2>=FORMER_TIME) print; else exit;} END { if(LAST_DATE>=FORMER_DATE && LAST_TIME>=FORMER_TIME) {print LAST_DATE,LAST_TIME> TIME_LOG_FILE;}}' FORMER_DATE="$FORMER_DATE" FORMER_TIME="$FORMER_TIME" LAST_DATE="$LAST_DATE" LAST_TIME="$LAST_TIME" TIME_LOG_FILE="$TIME_LOG_FILE" | grep "$ERROR_MESSAGE" | wc -l)
        # 若发现有异常日志，直接重启进程
        if [ "$LINE" -gt 0 ];then
            PROCESS_NAME=com.duowan.pay.schedule.job.udb.ReadMobileChangeTopic
            ps aux | grep -v grep | grep "$PROCESS_NAME" | awk '{print $2}' | xargs kill -9
            /bin/bash /data/app/pay-schedule/shell/readMobileChangeQueue.sh
            echo "$LAST_DATE $LAST_TIME line:$LINE,execute restart script now" >> $EXECUTE_LOG_FILE
        fi
    done

    
elif [ "$MONITOR_PROCESS" == "ReadSmsCommandQueue" ];then


    LOG_FILE=/data/yy/log/pay/read_udb_sms_queue.log

    TIME_LOG_FILE=/data/yy/log/pay/monitor_udb_sms_command_queue.time
    cat $TIME_LOG_FILE | grep -E "[0-9]{4}\-[0-9]{1,2}\-[0-9]{1,2} [0-9]{1,2}:[0-9]{2}:[0-9]{2}"
    if [ "$?" -ne 0 ] || [ ! -s $TIME_LOG_FILE ];then
        tail -n 1 $LOG_FILE | awk -F ',' '{print $1}' | sed 's/\[//' | grep -E "[0-9]{4}\-[0-9]{1,2}\-[0-9]{1,2} [0-9]{1,2}:[0-9]{2}:[0-9]{2}" > $TIME_LOG_FILE
        if [ ! -s $TIME_LOG_FILE ];then
            # 避免出现空时间戳的情况，同时因为日志有缓存再打印的机制，这里sleep 30s后再重试一次
            sleep 30
            tail -n 1 $LOG_FILE | awk -F ',' '{print $1}' | sed 's/\[//' | grep -E "[0-9]{4}\-[0-9]{1,2}\-[0-9]{1,2} [0-9]{1,2}:[0-9]{2}:[0-9]{2}" > $TIME_LOG_FILE
        fi
    fi

    LAST_LOG_DATE_STRING=$(tail -n 1 $LOG_FILE | awk -F ',' '{print $1}' | sed 's/\[//')
    LAST_DATE=$(echo $LAST_LOG_DATE_STRING | awk '{print $1}')
    LAST_TIME=$(echo $LAST_LOG_DATE_STRING | awk '{print $2}')

    EXECUTE_LOG_FILE=/data/yy/log/pay/monitor_udb_sms_command_queue.execute

    cat $TIME_LOG_FILE | while read FORMER_DATE FORMER_TIME
    do
        ERROR_MESSAGE="The Consumer is closed"
        LINE=$(tac $LOG_FILE | sed 's/\[//;s/\]//' | sed -n -r '/^[[:digit:]][[:digit:]][[:digit:]][[:digit:]]-[[:digit:]][[:digit:]]-[[:digit:]][[:digit:]]/p' | awk -F '[ ,]' '{if($1>=FORMER_DATE && $2>=FORMER_TIME) print; else exit;} END { if(LAST_DATE>=FORMER_DATE && LAST_TIME>=FORMER_TIME) {print LAST_DATE,LAST_TIME> TIME_LOG_FILE;}}' FORMER_DATE="$FORMER_DATE" FORMER_TIME="$FORMER_TIME" LAST_DATE="$LAST_DATE" LAST_TIME="$LAST_TIME" TIME_LOG_FILE="$TIME_LOG_FILE" | grep "$ERROR_MESSAGE" | wc -l)
        # 若发现有异常日志，直接重启进程
        if [ "$LINE" -gt 0 ];then
            PROCESS_NAME=com.duowan.pay.schedule.job.udb.ReadSmsCommandQueue
            ps aux | grep -v grep | grep "$PROCESS_NAME" | awk '{print $2}' | xargs kill -9
            /bin/bash /data/app/pay-schedule/shell/readSmsCommandQueue.sh
            echo "$LAST_DATE $LAST_TIME line:$LINE,execute restart script now" >> $EXECUTE_LOG_FILE
        fi
    done

    
fi




