#!/bin/bash
#Date:2012-09-25
#Written by manifold.
#Readme:scan disk info.

source commonFunction.sh

# IP地址获取
IP_ADDR=$(getSingleIp)

# 基础变量定义
MYPID=$$

# 脚本名称定义
SCRIPT_NAME=$(basename $0)

# 禁止在非ubuntu系统上运行
RUN_SYSTEM="ubuntu"
checkOs $RUN_SYSTEM || { code=100; msg="$SCRIPT_NAME [ERR ] | this script only can be run on $RUN_SYSTEM"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

# 参数获取
parseParameter || exit $?

# 所需参数检查
if [ -z "$PARA_THRESHOLD" ]; then

    code=102 ; msg="$SCRIPT_NAME [ERR ] | PARA_THRESHOLD value is null"
    
    printResult "$code" "$msg"
    
    exit $code
    
fi

# 循环取出分区相关数据
for PARTITION in $(cat /etc/mtab |grep ^/dev |awk '{print $2}');do


    # 获取磁盘空间信息
    DISK_SPACE=$(df -lh|grep -w "$PARTITION"$|tr -d \%|awk '{print $NF,$(NF-1)}'|awk '{if($2>'"${PARA_THRESHOLD}"') print}')
    
    if [ "$DISK_SPACE" != "" ];then
    
        DISK_SPACE_STRING=$(echo "$DISK_SPACE"|sed -r 's/ +/\\t/g')
        echo "DISK_SPACE\t$IP_ADDR\t$DISK_SPACE_STRING%"
        
    fi

    
    # 判断磁盘是否readonly状态
    TEMP_FILE=$(mktemp -p $PARTITION) && { rm -f $TEMP_FILE ; echo "DISK_STATUS\t$IP_ADDR\t$PARTITION\tok" ; } || echo "DISK_STATUS\t$IP_ADDR\t$PARTITION\treadonly"
  
   
done


# 最后的信息返回
code=0 ; msg="success"

printResult "$code" "$msg"

exit $code

