#!/bin/bash
#Date:2012-10-27
#Written by manifold.
#Readme:进程信息扫描工具。


source commonFunction.sh


# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

                         
# 参数获取
parseParameter || exit $?


# 所需参数检查

# 进程名称
# PARA_PROCESS_NAME
if [ -z "$PARA_PROCESS_NAME" ];then

    code=102; msg="$SCRIPT_NAME [ERR ] | PARA_PROCESS_NAME value is null."

    printResult "$code" "$msg" 

    exit $code
    
fi


# 所需信息项：
# Process: named, User: bind, CPU: 0.9%, RAM: 15.1%, Start: 2012-11-01 15:30, CPU Time: 45 min

# 判断进程数据是否为空
if ! pidof "$PARA_PROCESS_NAME"; then

    code=103; msg="$SCRIPT_NAME [ERR ] | PROCESS:$PARA_PROCESS_NAME not found."

    printResult "$code" "$msg"

    exit $code
    
fi


# 获取进程信息
# while read PROCESS_PID ; do
for PROCESS_PID in $( pidof "$PARA_PROCESS_NAME" ) ; do


    PROCESS_INFO=$( ps aux | grep -v -E "$0|grep" | awk '{if($2=='"${PROCESS_PID}"') print }' )

    PROCESS_JIFFIES=$( cat /proc/$PROCESS_PID/stat | cut -d" " -f22 )

    PROCESS_UPTIME=$( grep btime /proc/stat | cut -d" " -f2 )

    PROCESS_START_SEC=$(( $PROCESS_UPTIME + $PROCESS_JIFFIES / 100 ))

    PROCESS_START_TIME=$( date -d "1970-1-1 UTC $PROCESS_START_SEC seconds" +"%Y-%m-%d %T" )


    # 运行用户、CPU、内存
    PROCESS_INFO_USER=$( echo "$PROCESS_INFO" | awk '{print $1}' )

    PROCESS_INFO_CPU=$( echo "$PROCESS_INFO" | awk '{print $3}' )

    PROCESS_INFO_MEM=$( echo "$PROCESS_INFO" | awk '{print $4}' )


    # 运行时间
    PROCESS_INFO_CPU_TIME=$( echo "$PROCESS_INFO" | awk '{print $10}' )

    PROCESS_INFO_CPU_HOURS=$( echo "$PROCESS_INFO_CPU_TIME" | awk -F ':' '{print $1}' )

    PROCESS_INFO_CPU_MIN=$( echo "$PROCESS_INFO_CPU_TIME" | awk -F ':' '{print $2}' )

    # 部分服务器没装BC，替换一下命令
    # PROCESS_INFO_CPU_TIME=$( echo "scale=0; (${PROCESS_INFO_CPU_HOURS} * 60) + ${PROCESS_INFO_CPU_MIN}" | bc -l )
    PROCESS_INFO_CPU_TIME=$(( $PROCESS_INFO_CPU_HOURS * 60 + $PROCESS_INFO_CPU_MIN ))


    # 结果反馈
    PROCESS_INFO="Process: $PARA_PROCESS_NAME, Pid: $PROCESS_PID, User: $PROCESS_INFO_USER, CPU: $PROCESS_INFO_CPU%, RAM: $PROCESS_INFO_MEM%, Start: $PROCESS_START_TIME, CPU Time: $PROCESS_INFO_CPU_TIME min"
    
    echo "PROCESS_INFO\t$IP_ADDR\t$PROCESS_INFO"

    
# done <<< $( pidof "$PARA_PROCESS_NAME" )
done


# 最后的信息返回
code=0 ; msg="success"

printResult "$code" "$msg"

exit $code
