#!/bin/bash
#Date:2012-10-22
#Written by manifold.
#Readme:服务器硬件信息查看。


source commonFunction.sh


# 禁止以非root用户运行此脚本
RUN_USER="root"
checkUser $RUN_USER || { code=101; msg="$SCRIPT_NAME [ERR ] | only $RUN_USER can run this script"
    
                         printResult "$code" "$msg" 
                         
                         exit $code ; }

                         
# 主脚本

# 参数获取

parseParameter || exit $?


# 参数获取

# OS -- PARA_OS

if [ -n "$PARA_OS" ];then

    OS_LONG_BIT=$(getOsLongBit)
    
    KERNEL_INFO=$(getKernelInfo)
    
    getOsDescription | sed -r 's/(.*)/SERVER_INFO\\t'"${IP_ADDR}"'\\tosInfo:\1,osLongBit:'"${OS_LONG_BIT}"',kernelInfo:'"${KERNEL_INFO}"'/g'

fi


# 序列号

if [ -n "$PARA_SERIAL_NUMBER" ];then

    PARA_SERIAL_NUMBER=$(dmidecode | grep "System Information" -A 10 | awk -F '[ :]' '{if($1~"Serial") print $4}')
    
    echo "SERVER_INFO\\t${IP_ADDR}\\tserialNum:${PARA_SERIAL_NUMBER}"

fi


# CPU -- PARA_CPU

if [ -n "$PARA_CPU" ];then

    cat /proc/cpuinfo | grep 'model name' | head -n 1 | \
    
    sed -r 's/(.*)[[:space:]]+:[[:space:]]+(.*)/\2/g ; s/[[:space:]]+/ /g ; s/(.*)/SERVER_INFO\\t'"${IP_ADDR}"'\\tcpuInfo:\1/g' 

fi


# 内存 -- PARA_MEM

if [ -n "$PARA_MEM" ];then

    for INFO_TYPE in MemTotal MemFree SwapTotal SwapFree ; do
    
        INFO=$( cat /proc/meminfo | grep "$INFO_TYPE" | awk -F '[: ]+' '{print $2,$3}' )
        
        VARIABLE_NAME=$( stringToUpper "$(echo $INFO_TYPE)" )
        
        eval "$VARIABLE_NAME=\"$INFO\""
        
        # 检测MEM_INFO是否为空，若为空，首次赋值；若非空，拼接信息
        
        [[ -z "$MEM_INFO" ]] && MEM_INFO="${INFO_TYPE}:${!VARIABLE_NAME}" || MEM_INFO="$MEM_INFO,${INFO_TYPE}:${!VARIABLE_NAME}"
        
    done
    
    # 获取内存条及插槽信息
    TOTAL_BANK_NUM=$( dmidecode | sed -n -r '/^[[:space:]]+Size/p' | wc -l )
    
    USED_BANK_NUM=$( dmidecode | sed -n -r '/^[[:space:]]+Size/p' | grep "MB" | wc -l )
    
    MEM_BANK_INFO=$( dmidecode | sed -n -r '/^[[:space:]]+Size/p' | grep "MB" | sort | uniq -c | awk '{print $3,$4"*"$1}' | tr '\n' ',' | sed -r 's/(.*),/\1/g' )
    
    FREE_BANK_NUM=$( dmidecode | sed -n -r '/^[[:space:]]+Size/p' | grep "No Module Installed" | wc -l )
    
    echo "MEM_INFO\t$IP_ADDR\t$TOTAL_BANK_NUM\t$USED_BANK_NUM\t$FREE_BANK_NUM\t$MEM_BANK_INFO\t${MEM_INFO}"

fi


# 网卡 -- PARA_NETWORK_INFO

if [ -n "$PARA_NETWORK_INFO" ];then

    # 网卡速率获取
    
    NETWORK_SPEED=$( ethtool eth0 | awk '{if($1~/Speed/) print $2}' )
    
    # 获取网卡信息、去重（\后面不能有空格）
    
    lspci | awk -F 'Ethernet controller:' '{$1="";if($0!="" && $0!=line) print;line=$0}' | \
    
    sed -r 's/^[[:space:]]{1,}//g ; s#(.*)#SERVER_INFO\\t'"${IP_ADDR}"'\\tnetworkInfo:\1,speed:'"${NETWORK_SPEED}"'#g'

fi


# 最后的信息返回

code=0; msg="$SCRIPT_NAME [INFO ] | successful."

printResult "$code" "$msg"

exit $code

