import urllib2
import time
import re
import socket
import os
import traceback
import xml.dom.minidom

from subprocess import Popen, PIPE
from pstat import *
from get_local_ip import *
from find_proc_data import *
from except_deal import *
script_path='/home/dspeak/yyms/yyms_agent_2_d/script/'
group_id = 0
item_id = 0

def get_found_proc():
  re_list = []
  try:
    file = open("/home/dspeak/yyms/yyms_agent_2_d/etc/yyms.app.xml", 'r')
    lines = file.readlines()
    txt = '<group_list>'
    for line in lines:
      if line.find("<group ") is not -1 or line.find("</group>") is not -1:
        txt += line 
    txt += '</group_list>'
    xmldoc = xml.dom.minidom.parseString(txt)
    root = xmldoc.documentElement
    for item in root.getElementsByTagName('group'):
      if item.getAttribute('type').find('PROC_COMMON') is not -1:
        re_list.append(item.getAttribute('regular_expression'))
  except:
    print traceback.print_exc()
    pass;
  print re_list
  return re_list

def get_page(url):
  socket.setdefaulttimeout(10)
  url = url.replace(' ','+')
  req = urllib2.Request(url)
  try:
    resp = urllib2.urlopen(req)
  except urllib2.URLError, e:
    print e
    pass
  else:
    body = resp.read()
    resp.close();
    return body;
  return None

def get_proc_list():
  ps = []
  pp = Popen(['sh','find_proc_common.sh'], stdout=PIPE)
  lines = pp.stdout.read()
  plist = lines.split('\n')
  return plist

def get_proc_data_list():
  ps = []
  pp = Popen(['sh','find_proc_data.sh'], stdout=PIPE)
  lines = pp.stdout.read()
  lists = lines.split('\n')
  filer = set()
  for item in lists:
    if len(item) > 0:
      filer.add(item)
  return filer

def ascii_to_str(astr):
  strlist = astr.split()
  pstr = ''
  try:
    for num in strlist:
      pstr += chr(int(num))
  except:
    return astr
  return pstr

def math_proc(psg,pattern):
  pattern = ascii_to_str(pattern)
  regex=ur"%s" %pattern
  if re.search(regex, psg):
    return True
  else:
    return False

def get_found_s(item,proc_data_ex):
  found = []
  for proclist in proc_data_ex:
    (pid,name,stime,port) = proclist
    if name.find(item['full_name']) is not -1:
      found.append((pid,item['full_name'],stime,port))
  if len(found) is not 0:
    return found 

  name = item['short_name']
  bport = item['begin_port']
  eport = item['end_port']
  num = item['num']
  count = 0
  #print '''name=%s,bport=%d,eport=%d,num=%d'''%(name,bport,eport,num)
  for port in range(bport,eport):
    try:
      proc = Proc();
      proc.connect(port);
      str = proc.get_all()
      (ret,pid,stime) = deal_json_pid(str,name)
      if ret :
        #print '''test port %d succ'''%port
        count += 1
        found.append((pid,item['full_name'],stime,port))
        #print '''test port %d succ more'''%port
        if count is num:
          break;
    except:
      #print traceback.print_exc()
      continue;
  return found

def get_group_id():
  global group_id
  group_id = group_id + 1
  return group_id
def get_item_id():
  global item_id
  item_id = item_id + 1
  return item_id

def get_guid():
  filename = "/home/dspeak/yyms/uuid"
  f = open(filename, 'r')
  guid = ''
  guid = f.read()
  f.close()
  guid = guid.strip()
  return guid

class GetConfig:
  def __init__(self):
    self.__type = ''
    self.__found_proc = set()
    self.__filename = "/home/dspeak/yyms/yyms_agent_2_d/etc/yyms.app.xml"
    self.__fill_set = set()
    self.__found_proc_data_ex = get_proc_data_list_ex()

  def __del__(self):
    pass

  def get_proc_instance(self,item):
    instance_list = []
    if self.__type.find('PROC_DATA') is not -1:
      found_list = get_found_s(item,self.__found_proc_data_ex)
      for found in found_list:
        (pid,fullname,stime,port) = found
        instance_list.append((pid,fullname,stime,port))
        self.__found_proc.add(fullname)
    else:
      ps = get_proc_list()
      result = set()
      for psg in ps:
        if math_proc(psg,item['regular_expression']):
          psg.strip()
          result.add(psg)
      count = 0
      for re in result:
        rel = re.split()
        time_str = "%s %s %s %s %s" % (rel[1],rel[2],rel[3],rel[4],rel[5])
        start_time = int(time.mktime(time.strptime(time_str, "%a %b %d %H:%M:%S %Y")))
        pass_tag = False
        for found_proc in self.__found_proc:
          if rel[6].find(found_proc) is not -1:
            pass_tag = True
            break;
        if pass_tag is False:
          has_match = False
          for item in self.__fill_set:
            (item_pid,item_name,item_start_time) = item
            #print '%s %s %s %s'%(rel[0],item_pid,rel[6].replace('./',''),item_name )
            if rel[0] == item_pid and rel[6].replace('./','').find(item_name) is not -1 :
              stime = int(item_start_time)
              if stime == start_time or start_time - stime == 1 or stime - start_time == 1 :
                has_match = True
                print "start_time same %s %s %s"%(item_name,start_time,stime)
                instance_list.append((rel[0],rel[6].replace('./',''),stime))
              else:
                print "start_time not same %s %s %s"%(item_name,start_time,stime)
          if has_match is False:
            instance_list.append((rel[0],rel[6].replace('./',''),start_time))
    return instance_list

  def load_group_str(self,item,proc_instance = None):
    group_str = ''
    if self.__type == 'PROC_COMMON':
      hash_str = """%s,%s,%s,%s,%s,%s"""%(item["name"],self.__type,proc_instance[0],proc_instance[1],proc_instance[2],item["time_out"])
      hash_id = hash(hash_str)
      group_str = """<group id="%d" name="%s" type="%s" pid="%s" start_time="%s" timeout="%d" step="%d" rrd_path="/home/dspeak/yyms/yyms_agent_2_d/build/rrd/" regular_expression="%s">\n""" % (hash_id,item["name"],self.__type,proc_instance[0],proc_instance[2],item["time_out"],10,item["regular_expression"])
    elif self.__type.find('PROC_DATA') is not -1:
      print proc_instance
      (pid,fullname,stime,port) = proc_instance
      hash_str = """%s,%s,%s,%s,%s,%d,%d """%(item["name"],self.__type,pid,fullname,stime,port,item["time_out"])
      hash_id = hash(hash_str)
      group_str = """<group id="%d" name="%s" type="%s" pid="%s" fullname="%s" start_time="%s" port="%d" timeout="%d" step="%d" rrd_path="/home/dspeak/yyms/yyms_agent_2_d/build/rrd/" regular_expression="%s">\n""" % (hash_id,item["name"],self.__type,pid,fullname,stime,port,item["time_out"],10,item["regular_expression"])
    elif self.__type.find('SYS') is not -1 or self.__type.find('PURE_ALARM') is not -1:
      hash_str = """%s,%s,%s,%s"""%(item["name"],self.__type,item["time_out"],item["run_interval"])
      hash_id = hash(hash_str)
      step = int(item["run_interval"])
      if step < 60:
        step = 60
      group_str = """<group id="%d" name="%s" type="%s" timeout="%d" step="%d" rrd_path="/home/dspeak/yyms/yyms_agent_2_d/build/rrd/">\n""" % (hash_id,item["name"],self.__type,item["time_out"],step)
    else:
      print 'unkown type'
      print item
    return group_str
  
  def load_script(self,item):
    script = ''
    if self.__type.find('PROC_DATA') is not -1:
      script='''  <script><![CDATA[%s %s%s %s]]></script>\n'''% ("python",script_path,"pstat.py $port",item["opt"])
    else:
      if item["src_path"].endswith(".py"):
        script='''  <script><![CDATA[%s %s%s %s]]></script>\n'''% ("python",script_path,item["src_path"],item["opt"])
      else:
        script='''  <script><![CDATA[%s %s%s %s]]></script>\n'''% ("sh",script_path,item["src_path"],item["opt"])
    return script
  
  def load_rra(self,item):
    if self.__type.find('PROC_DATA') is not -1:
      return '''  <rra CF="AVERAGE" xff="0.1" steps="6" rows="1440"/>
  <rra CF="MAX" xff="0.1" steps="6" rows="1440"/>\n'''
    elif self.__type.find('PROC_COMMON') is not -1:
      return '''  <rra CF="AVERAGE" xff="0.1" steps="6" rows="1440"/>\n'''
    else:
      return '''  <rra CF="AVERAGE" xff="0.1" steps="5" rows="1440"/>\n'''

  def load_alarm(self,sub_item):
    alarm_id_list = ''
    alarm_list = ''
    for alarm in sub_item["triggerConfigList"]:
      alarm_str = """  <alarm id="%d" name="%s"  expression="%s" type="%s" level="%s"/>\n""" % (alarm["id"], alarm["name"],alarm["expression"], alarm["type"],alarm['fail_level'])
      tmp = '''<alarm id="%s"/>'''%(alarm["id"])
      alarm_id_list += tmp
      alarm_list += alarm_str
    return alarm_list,alarm_id_list
      
  def load_item(self,item,sub_item,alarm_id_list):
    item_str = """  <item id="%d" name="%s" cf="%s" dstype="%s" min="%s" max="%s" unit="%s" heartbeat="%s"> %s </item>\n""" % (get_item_id(),sub_item["name"],sub_item["merge_type"],sub_item["dstype"],sub_item["min_value"],sub_item["max_value"],sub_item["unit"],2*int(item["run_interval"]),alarm_id_list)
    return item_str
  
  def load_group(self,item,instance):
    group = ''
    group += self.load_group_str(item,instance)
    group += self.load_script(item)
    item_str = ''
    alarm_list = ''
    for sub_item in item["smallItemList"]:
      (alarm_list_tmp,alarm_id_list) = self.load_alarm(sub_item)
      #print alarm_id_list
      alarm_list += alarm_list_tmp
      item_str += self.load_item(item,sub_item,alarm_id_list)
    group += item_str
    group += self.load_rra(item)
    group += "</group>\n"
    #print group
    return group,alarm_list
    
  def load_all(self,jstr):
    group_list=''
    alarm_list=''
    for item in jstr["result"]["itemList"]:
      if item['src_type'].find('PROC_DATA') is not -1:
        continue;#shutdown proc data
        #self.__type = item['src_type']
        self.__type = 'PROC_DATA_PRECISION'
        instance_list = self.get_proc_instance(item)
        for instance in instance_list:
          if instance is not None:
            (group,alarm) = self.load_group(item,instance)
            group_list += group
            alarm_list += alarm
    for item in jstr["result"]["itemList"]:
      if item['src_type'].find('PROC_DATA') is not -1:
        continue;
      if item['src_type'] == 'ZABBIX':
        self.__type = 'PURE_ALARM'
      elif item['src_type'] == 'COMMON':
        self.__type = 'SYS_NEED'
      else:
        self.__type = item['src_type']
      if item['src_type'] == 'PROC_COMMON':
        instance_list = self.get_proc_instance(item)
        for instance in instance_list:
          if instance is not None:
            (group,alarm) = self.load_group(item,instance)
            group_list += group
            alarm_list += alarm
          
      else:
        (group,alarm) = self.load_group(item,None)
        group_list += group
        alarm_list += alarm
    return group_list,alarm_list

  def get_group_alarm(self):
    url = '''http://%s/rest/getDeviceMonitor.action?param={"guid":"%s","type":"ALL"}'''%(get_conf_ip(),get_guid())
    print url
    rstr = get_page(url)
    print len(rstr)
    jstr = eval(rstr)
    return self.load_all(jstr)


  def update(self):
    self.load_proc_in_conf()
    
    conf = '<yyms ver="0.1">\n'
    conf += '<host id="%s"/>\n\n'%get_default_ip()

    group_conf = '<group_list>\n'  
    alarm_conf = '<alarm_list>\n'
    output_conf = '<output_list>\n'

    (groups,alarms) = self.get_group_alarm()
    group_conf += groups
    alarm_conf += alarms

    group_conf += '</group_list>\n\n'
    alarm_conf += '</alarm_list>\n\n'

    output_conf += '''  <redis id="1" name="" type="alarm" host="121.9.221.56" port="6379" timeout="10000" key="yyms_alarm_z_test"/>\n'''
    output_conf += '''  <redis id="2" name="" type="merged_data" host="121.9.221.56" port="6379" timeout="10000" key="yyms_sample_test"/>\n'''
    output_conf += '</output_list>\n\n'

    read_conf_interval = '<read_conf_interval step="60"/>\n'
    assist_conf = '<assist conn_timeout="50" send_timeout="50"/>\n'
    get_data_fail_alarm = '<get_data_fail_alarm id="100099" key="script_get_data_failed" type="other" exp="" level="1"/>\n'
    conf += group_conf
    conf += alarm_conf
    conf += output_conf
    conf += read_conf_interval 
    conf += assist_conf
    conf += get_data_fail_alarm

    conf += '</yyms>\n'

    #print conf

    d = os.path.dirname(self.__filename)
    if(not os.path.exists(d)):
      os.makedirs(d) 
    f = open(self.__filename, 'wb')
    f.write(conf)
    f.close()

  def load_proc_in_conf(self):
    '''to deal with the starttime of common proc'''
    try:
      file = open("/home/dspeak/yyms/yyms_agent_2_d/etc/yyms.app.xml", 'r')
      lines = file.readlines()
      txt = '<group_list>'
      for line in lines:
        if line.find("<group ") is not -1 or line.find("</group>") is not -1:
          txt += line 
      txt += '</group_list>'
      xmldoc = xml.dom.minidom.parseString(txt)
      root = xmldoc.documentElement
      for item in root.getElementsByTagName('group'):
        if item.getAttribute('type') == 'PROC_COMMON':
          self.__fill_set.add((item.getAttribute('pid'),item.getAttribute('name'), item.getAttribute('start_time')))
      #print self.__fill_set

    except:
      print traceback.print_exc()
      pass;
if __name__ == "__main__":
  try:
    get = GetConfig() 
    get.update()
  except:
    print 'load conf failed.'
    print traceback.print_exc()
