#!/bin/bash
#Date:2013-06-04
#Written by manifold.
#Readme:monitor redis status.

export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

SCRIPT_NAME=$( basename $0 )
CURRENT_TIME=$( date "+%Y-%m-%d %T" )

function printHelp () {
    echo
    echo "Usage: /bin/bash $0 ALARM_ID ALARM_WAY REDIS_PORT MONITOR_TYPE."
    echo
}

function reportAlarm () {
    /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py $1 $2 $3 $4
}


[ "$#" -lt 4 ] && { printHelp; exit 1; }

ALARM_ID="$1"
ALARM_WAY="$2"
REDIS_PORT="$3"
MONITOR_TYPE="$4"


REDIS_BIN_DIR=/usr/local/redis/bin
[ ! -f $REDIS_BIN_DIR/redis-cli ] && { reportAlarm $ALARM_ID $ALARM_WAY 1 "no redis-cli command." ; exit 1 ; }

REDIS_LOG_DIR=/data/weblog/redis
[ ! -d $REDIS_LOG_DIR ] && mkdir -p $REDIS_LOG_DIR


case "$MONITOR_TYPE" in

    "sync")
        if $REDIS_BIN_DIR/redis-cli -p $REDIS_PORT info | sed -r 's/(.*)/'"${CURRENT_TIME}"' \1/g' | grep "master_link.*down" >> $REDIS_LOG_DIR/$SCRIPT_NAME.log ; then 
            LAST_SECOND=$( $REDIS_BIN_DIR/redis-cli -p $REDIS_PORT info | grep -w master_link_down_since_seconds | awk -F ':' '{print $2}' | sed -r 's/\r//g' )
            # slave 同步延时超过 $THRESHOLD_VALUE 则告警
            THRESHOLD_VALUE=300
            [ "$LAST_SECOND" -gt "$THRESHOLD_VALUE" ] && \
            echo "$CURRENT_TIME send alarm because of sync delay more than $THRESHOLD_VALUE second" >> $REDIS_LOG_DIR/$SCRIPT_NAME.log && \
            reportAlarm $ALARM_ID $ALARM_WAY 1 "redis master/slave sync failed,port $REDIS_PORT,sync delay $THRESHOLD_VALUE second."
        fi
        ;;
    *)
        echo
        echo "Unknown monitor type: $MONITOR_TYPE"
        printHelp
        exit 1
        ;;
        
esac

