#!/usr/bin/env lua
-- by chengguifeng
-- 2013-4-23

--[[
usage:
    1. id pname msg

    2. "k=v&k=v&k=v"
    
    3. id sid pre msg
       pre 设置此次为预警，因为同一sid预警与告警原来是通过阀值处理，纯告警无法区分，所以加 pre 字段， 1：预警， 0：告警
]]

logger = require("get_logger")

require("string_ex")
require("table_ex")

function parse_report_alarm_arg(...)       
    t = {}

    num_arg = #arg       
    if 1 == num_arg then       
        if nil == string.find(arg[1], "&") then
            logger:error("invalid input format")
            os.exit()
        end
 
        kv_table = string_ex.split(arg[1], "&")
        for i, kv in ipairs(kv_table) do
            if kv:find("=") then
                k_v = string_ex.split(kv, "=")
                k, v = string_ex.trim(k_v[1]), string_ex.trim(k_v[2])
                if (k == "id") or (k == "sid") or (k == "alarm") or (k == "pre") then
                    if nil == tonumber(v) then
                        logger:error("cannot id/sid/alarm/pre value to int")
                        os.exit()
                    end
                end
                t[k] = tonumber(v)
            else
                logger:error("invalid input format")
                os.exit()
            end
        end         
        t["alarm"] = 1
        if (nil == t["id"]) or (nil == t["msg"]) then
            logger:error("must has 'id' and 'msg' key")
            os.exit()
        end
    elseif 3 == num_arg then
        if nil == tonumber(arg[1]) then
            logger:error("cannot convert id to int")
            os.exit()
        end
               
        t["id"] = tonumber(arg[1])
        t["alarm"] = 1
        t["pname"] = arg[2]
        t["msg"] = arg[3]
    elseif 4 == num_arg then
        if (nil == tonumber(arg[1])) or (nil == tonumber(arg[2])) or (nil == tonumber(arg[3])) then
            logger:error("cannot id/sid/pre value to int")
            os.exit()
        end

        t["id"] = tonumber(arg[1])
        t["sid"] = tonumber(arg[2])
        t["pre"] = tonumber(arg[3]) 
        t["alarm"] = 1        
        t["msg"] = arg[4]
    else 
        logger:error("invalid num of params")
        os.exit()
    end

    t = table_ex.to_string(t)
    return t
end
