#!/usr/bin/env lua
-- by chengguifeng
-- 2013-4-23

--[[
usage:
    param format: "k=v&k=v&k=v"
]]

logger = require("get_logger")

require("string_ex")
require("table_ex")

function cut_arg(params)
    t = {}
    has_id = false
    hase_value = false
    
    kv_table = string_ex.split(params, "&")
    for i, kv in ipairs(kv_table) do        
        if kv:find("=") then
           k_v = string_ex.split(kv, "=")
           k, v = string_ex.trim(k_v[1]), string_ex.trim(k_v[2])  
           if "id" == k then
               has_id = true              

               if nil == tonumber(v) then
                   logger:error("cannot conver id to int")
                   os.exit()
               end
              
               t[k] = tonumber(v)                                                 
           elseif "value" == k then
               has_value = true
               
               if nil == tonumber(v) then        
                   logger:error("cannot conver value to int")
                   os.exit()
               end
               
               t[k] = v + 0.0               
           else
               t[k] = v
           end
        else
            logger:error("invalid input format")
            os.exit()           
        end   
    end

    if has_id and has_value then
        return t
    else
        logger:error("must has 'id' and 'value' key")
        os.exit()
    end
end

function parse_report_arg(params)
    if type(params) ~= "string" then
        logger:error("only string is supported")
        os.exit()
    end

    kv = {}   
  
    kv = cut_arg(params)

    kv["ts"] = os.time()
    kv["step"] = 60
    kv["min"] = "-100"

    if nil == kv["max"] then
        kv["max"] = "1.84467440737e+19"
    end

    if nil == kv["dst"] then
        dst = "GAUGE"
    else
        dst = kv["dst"]:upper()
    end

    if (dst ~= "GAUGE") and (dst ~= "COUNTER") then
       dst = "GAUGE"
    end

    kv["dst"] = dst
 
    kv = table_ex.to_string(kv)
    return "["..kv.."]"
end
