#!/usr/bin/env lua
-- by chengguifeng
-- 2013-4-23

--[[
usage:
     "k=v&k=v|k=v&k=v"
]]

logger = require("get_logger")

require("string_ex")
require("table_ex")

function cut_arg(params)
    t = {}
    
    kv_table = string_ex.split(params, "&")
    for i, kv in ipairs(kv_table) do
        if kv:find("=") then
            k_v = string_ex.split(kv, "=")
            k, v = string_ex.trim(k_v[1]), string_ex.trim(k_v[2])
            if k == "id" then
                if nil == tonumber(v) then
                    logger:error("cannot conver id to int")                   
                    os.exit()
                end
                
                t[k] = tonumber(v)
            elseif k == "value" then
                if nil == tonumber(v) then
                    logger:error("cannot conver value to int") 
                    os.exit()
                end

                t[k] = v + 0.0
            elseif k == "pid" then
                if nil == tonumber(v) then
                    logger:error("cannot conver pid to int") 
                    os.exit()
                end
                t[k] = tonumber(v)
            elseif k == "port" then
                if nil == tonumber(v) then
                    logger:error("cannot conver port to int") 
                    os.exit()
                end
                t[k] = tonumber(v)
            else              
                t[k] = v
            end
        else
            logger:error("invalid input format")
            os.exit()
        end
    end   
    
    t["ts"] = os.time()
    t["step"] = 60
    t["min"] = "0"

    if nil == t["max"] then
        t["max"] = "1.84467440737e+19"
    end

    if nil == t["dst"] then
        dst = "GAUGE"
    else
        dst = t["dst"]:upper()
    end

    if (dst ~= "GAUGE") and (dst ~= "COUNTER") then
       dst = "GAUGE"
    end

    t["dst"] = dst
    
    t = table_ex.to_string(t)

    return t       
end

function parse_report_multi_arg(params)       
    if type(params) ~= "string" then
        logger:error("only string is supported")
        os.exit()
    end 
    
    local str = str
    local kv_table = string_ex.split(params, "|")
    for i, kv in ipairs(kv_table) do
        t = cut_arg(kv)
        if nil == str then
            str = t
        else
            str = str..", "..t
        end
    end

    return "["..str.."]"
end
