-- modified from http://lua-users.org/wiki/TableUtils

module("table_ex", package.seeall)

function val_to_str ( v )
  if "string" == type(v) then 
    return '"' .. v .. '"'
  else 
    return v
  end
end

function key_to_str ( k )
  return '"' .. k .. '"'
end

function to_string( tbl )
  local result, done = {}, {}

  for k, v in ipairs( tbl ) do
    table.insert( result, val_to_str(v) )
    done[ k ] = true
  end

  for k, v in pairs( tbl ) do
    if not done[ k ] then
      table.insert( result,
        key_to_str( k ) .. ": " .. val_to_str(v) )
    end
  end

  return "{" .. table.concat( result, ", " ) .. "}"
end
