#!/usr/bin/env lua
-- by chengguifeng
-- 2013-4-23

--[[
  get_scripts_path() must be called at the head of the scripts, otherwise, lua scripts
  cannot find other lua commponents
]]

lua_scripts_path = get_scripts_path()
common_path = lua_scripts_path.."common/?.lua;"
logger_path = lua_scripts_path.."common/logging/?.lua;"
package.path = common_path..logger_path..package.path

logger = require("get_logger")

require("parse_report_multi_arg")

file = io.open("/proc/stat", "r")
line = file:read()
user_n, nice_n, system_n, idle_n, iowait_n, irq_n, softirq_n = string.match(line, "(%d+)%s(%d+)%s(%d+)%s(%d+)%s(%d+)%s(%d+)%s(%d+)")
user_n = user_n % 2^32
io.close(file)

param = string.format("id=13&value=%d&max=4800&dst=COUNTER|id=12&value=%d&max=4800&dst=COUNTER|id=11&value=%d&max=4800&dst=COUNTER", user_n, system_n, nice_n)
data = parse_report_multi_arg(param)

rc, ret_str = send_data(data)
if false == rc then
    logger:error(ret_str)
end

file_p = io.open("/tmp/cpu_prev", "r")
if nil ~= file_p then
    line = file_p:read()
    if line ~= nil then
        user_p, nice_p, system_p, idle_p, iowait_p, irq_p, softirq_p = string.match(line, "(%d+)%s(%d+)%s(%d+)%s(%d+)%s(%d+)%s(%d+)%s(%d+)")
        io.close(file_p)
        util_p = user_p + nice_p + system_p + irq_p + softirq_p
        util_n = user_n + nice_n + system_n + irq_n + softirq_n
        total_p = util_p + idle_p + iowait_p
        total_n = util_n + idle_n + iowait_n
        util = (util_n - util_p) * 100.0 / (total_n - total_p)

        param = string.format("id=12022&value=%f&dst=GAUGE", util)
        data = parse_report_multi_arg(param)
        rc, ret_str = send_data(data)
        if false == rc then
            logger:error(ret_str)
        end
    end
end

file_tmp = io.open("/tmp/cpu_prev", "w")
cpu_str = user_n.." "..nice_n.." "..system_n.." "..idle_n.." "..iowait_n.." "..irq_n.." "..softirq_n
file_tmp:write(cpu_str)
io.close(file_tmp)


