#!/usr/bin/env lua
-- by chengguifeng
-- 2013-4-23

--[[
  get_scripts_path must be called at the head of the scripts, otherwise, lua scripts
  cannot find other lua commponents
]]
lua_scripts_path = get_scripts_path()
common_path = lua_scripts_path.."common/?.lua;"
logger_path = lua_scripts_path.."common/logging/?.lua;"
package.path = common_path..logger_path..package.path

logger = require("get_logger")

require("parse_report_multi_arg")
require("parse_report_alarm_arg")

num_var = 5

file = io.open("/proc/meminfo", "r")

line = file:read()
while line and (num_var > 0) do  
    if line:match("MemTotal:") then
        mem_total = string.match(line, "%d+") * 1024 -- byte
        num_var = num_var - 1
    elseif line:match("MemFree:") then
        mem_free = string.match(line, "%d+") * 1024
        num_var = num_var - 1
    elseif line:match("Buffers:") then
        buffers = string.match(line, "%d+") * 1024
        num_var = num_var - 1 
    elseif line:match("^Cached:") then
        cached = string.match(line, "%d+") * 1024
        num_var = num_var - 1
    elseif line:match("SwapTotal:") then
        swap_total = string.match(line, "%d+") * 1024
        num_var = num_var - 1
    end
    line = file:read()
end

io.close(file)

sum = mem_free + buffers + cached
param = string.format("id=14&value=%d|id=15&value=%d|id=16&value=%d|id=17&value=%d|id=11087&value=%d|id=2939&value=%d", buffers, cached, mem_free, sum, swap_total, mem_total)
data = parse_report_multi_arg(param)

rc, ret_str = send_data(data)
if false == rc then
    logger:error(ret_str)
end
