#!/usr/bin/env lua
-- by chengguifeng
-- 2013-4-23

--[[
  get_scripts_path must be called at the head of the scripts, otherwise, lua scripts
  cannot find other lua commponents
]]
lua_scripts_path = get_scripts_path()
common_path = lua_scripts_path.."common/?.lua;"
logger_path = lua_scripts_path.."common/logging/?.lua;"
package.path = common_path..logger_path..package.path

logger = require("get_logger")

require("parse_report_arg")

file = io.open("/proc/net/snmp", "r")

tcp_data_name = {}
tcp_data = {}

line = file:read()
while line  do
    if line:match("Tcp:%s%a+") then
        i = 1
        for item in string.gmatch(line, "%s(%a+)") do  
            tcp_data_name[i] = item
            i = i + 1
        end
    elseif line:match("Tcp:%s%d+") then
        i = 1
        for item in string.gmatch(line, "(%d+)") do
            tcp_data[tcp_data_name[i]] = item
            i = i + 1
        end
        break
    end
    line = file:read()
end

io.close(file)

tcp_link_num = tcp_data["CurrEstab"]
param = string.format("id=6&value=%d", tcp_link_num)
data = parse_report_arg(param)

rc, ret_str = send_data(data)
if false == rc then
    logger:error(ret_str)
end


--f = io.popen("netstat -an | awk '/^tcp/ {++S[$NF]} END {for(a in S) print a, S[a]}'")
f = io.popen("ss -ant | awk '/^(CLOSE-WAIT|TIME-WAIT)/ {++S[$1]} END {for(a in S) print a, S[a]}'")
result = f:read("*a")
f:close()

--print(result)

tcp_time_wait_v=0
tcp_close_wait_v=0

for item in string.gmatch(result,"%a+-%a+%s%d+") do
    if item:match("TIME") then
       tcp_time_wait_v=string.match(item,"%d+")
       print(string.format("TIME-WAIT = %d", tcp_time_wait_v))
   elseif item:match("CLOSE") then
       tcp_close_wait_v=string.match(item,"%d+")
       print(string.format("CLOSE-WAIT = %d", tcp_close_wait_v))
   end
end

tcp_time_wait_msg = string.format("id=11894&value=%d", tcp_time_wait_v)
tcp_time_wait_msg_all = parse_report_arg(tcp_time_wait_msg)
rc, ret_str = send_data(tcp_time_wait_msg_all)
if false == rc then
    logger:error(ret_str)
end

tcp_close_wait_msg = string.format("id=11896&value=%d", tcp_close_wait_v)
tcp_close_wait_msg_all = parse_report_arg(tcp_close_wait_msg)
rc, ret_str = send_data(tcp_close_wait_msg_all)
if false == rc then
    logger:error(ret_str)
end
