#!/bin/bash

PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
export PATH

MASK="114.80.107.226|222.73.61.16|121.9.221.135"
msg="less than 1000Mb/s"

ifconfig |grep -w "inet addr"|grep -E $MASK && exit 1

DEVICE_ARRAY=`grep -v -E "Receive|bytes" /proc/net/dev|awk -F ":" '{print $1}'|grep "eth[0-9]$"`

for DEVICE in `echo $DEVICE_ARRAY`
do
#check if eth_device link or not
	/sbin/ifconfig |grep "Link encap"|awk '{print $1}'|grep "eth"|grep -w "$DEVICE" 1>&/dev/null
	if [ "$?" -eq 0 ];then
		SPEED=`ethtool $DEVICE | grep Speed |awk -F ":" '{print $2}'|awk -F "Mb/s" '{print $1}'`
        echo $SPEED | grep -iq 'unknow' && continue

        # KVM instance does not distinguish between nic's speed
        if [ "x${SPEED}" = "x" ];then
        	grep -qi 'vm_type=1' /home/dspeak/yyms/hostinfo.ini && SPEED="1000"
        	[ "x${SPEED}" = "x" ] && \
        	ethtool -i $DEVICE | grep -qiE "vif|virtio_net" && SPEED="1000"
        fi
		RECEIVE=`grep -m1 "${DEVICE}:" /proc/net/dev|awk -F ":" '{print $2}'|awk '{print $1}'`
		TRANSMIT=`grep -m1 "${DEVICE}:" /proc/net/dev|awk -F ":" '{print $2}'|awk '{print $9}'`

		case $DEVICE in
		"eth0")
			if [ $SPEED -eq 1000 ];then
				INID=60
				OUTID=61
			elif [ $SPEED -eq 10000 ];then
				INID=11533
				OUTID=11537
			fi
			SPEEDID=30;;
		"eth1")
			if [ $SPEED -eq 1000 ];then
				INID=62
				OUTID=63
			elif [ $SPEED -eq 10000 ];then
				INID=11541
				OUTID=11543
			fi
			SPEEDID=31;;
		"eth2")
			if [ $SPEED -eq 1000 ];then
				INID=64
				OUTID=65
			elif [ $SPEED -eq 10000 ];then
				INID=11547
				OUTID=11549
			fi
			SPEEDID=32;;
		"eth3")
			if [ $SPEED -eq 1000 ];then
				INID=66
				OUTID=67
			elif [ $SPEED -eq 10000 ];then
				INID=11553
				OUTID=11555
			fi
			SPEEDID=33;;
		"eth4")
			if [ $SPEED -eq 1000 ];then
				INID=68
				OUTID=69
			elif [ $SPEED -eq 10000 ];then
				INID=11559
				OUTID=11561
			fi
			SPEEDID=34;;
		"eth5")
			if [ $SPEED -eq 1000 ];then
				INID=11615
				OUTID=11617
			elif [ $SPEED -eq 10000 ];then
				INID=11631
				OUTID=11633
			fi
			SPEEDID=11669;;
		"eth6")
			if [ $SPEED -eq 1000 ];then
				INID=11619
				OUTID=11621
			elif [ $SPEED -eq 10000 ];then
				INID=11635
				OUTID=11637
			fi
			SPEEDID=11671;;
		"eth7")
			if [ $SPEED -eq 1000 ];then
				INID=11623
				OUTID=11625
			elif [ $SPEED -eq 10000 ];then
				INID=11639
				OUTID=11641
			fi
			SPEEDID=11673;;
		"eth8")
			if [ $SPEED -eq 1000 ];then
				INID=11627
				OUTID=11629
			elif [ $SPEED -eq 10000 ];then
				INID=11643
				OUTID=11645
			fi
			SPEEDID=11675;;

		*)
				INID=4
				OUTID=4
				SPEEDID=4;;
		esac
		if [[ "$INID" == "4" ]] || [[ "$OUTID" == "4" ]];then
			python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py 4 72186 0 Cannot_find_eth_device:$DEVICE
		else
			retin=`python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report.py "id=$INID&value=$RECEIVE&dst=COUNTER"`
			echo $retin
			retout=`python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report.py "id=$OUTID&value=$TRANSMIT&dst=COUNTER"`
			echo $retout
			if [ $SPEED -lt 1000 ];then
				python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_alarm.py "$SPEEDID" '' "$DEVICE $msg"
			fi
		fi
	fi
done
