#!/bin/bash
# author: zhouyajing@yy.com
# 网卡包量上报，包括接收包量，接收丢包量，发送包量，发送丢包量
# 2015-01-05 重写修复多vlan网卡包量统计.

function pkg_send() {
    local net_dev=$1
    local rxpid=$2
    local txpid=$3
    local rxdid=$4
    local txdid=$5
    [ "$#" -ne 5 ] && return

    awk -F ':' '{if($1 ~ /'$net_dev'/){print $2}}' /proc/net/dev| \
    awk '{rxp=rxp+$2;rxd=rxd+$4;txp=txp+$10;txd=txd+$12;}
        END{printf("%d %d %d %d\n",rxp,rxd,txp,txd)}' | \
    while read rxp rxd txp txd;
    do
        param="id=$rxpid&value=$rxp&dst=COUNTER|id=$txpid&value=$txp&dst=COUNTER|id=$rxdid&value=$rxd&dst=COUNTER|id=$txdid&value=$txd&dst=COUNTER"
        ret=$(python /home/dspeak/yyms/yymp/yymp_report_script/yymp_report_multi.py $param)
        echo $ret
    done
}

netdevs=$(awk -F':' '{
    if($1 ~/eth/){gsub(/ /,"",$1);split($1,a,/\./);print a[1]}
    }' /proc/net/dev| sort -u)

for netdev in $netdevs;do
    /sbin/ifconfig |awk '{if($0 ~ /Link encap/){print $1}}'| \
    grep -w "${netdev}" 1>&/dev/null || continue

    case $netdev in
        "eth0")
            rxp_id=10546
            txp_id=10548
            rxd_id=10566
            txd_id=10568
            ;;
        "eth1")
            rxp_id=10550
            txp_id=10552
            rxd_id=10570
            txd_id=10572
            ;;
        "eth2")
            rxp_id=10554
            txp_id=10556
            rxd_id=10574
            txd_id=10576
            ;;
        "eth3")
            rxp_id=10558
            txp_id=10560
            rxd_id=10578
            txd_id=10580
            ;;
        "eth4")
            rxp_id=10562
            txp_id=10564
            rxd_id=10582
            txd_id=10584
            ;;
        "eth5")
            rxp_id=12127
            txp_id=12129
            rxd_id=12131
            txd_id=12133
            ;;
        "eth6")
            rxp_id=12135
            txp_id=12137
            rxd_id=12139
            txd_id=12141
            ;;
        "*")
            rxp_id=0
    esac

    [ "x${rxp_id}" != "x0" ] && pkg_send "$netdev" "$rxp_id" "$txp_id" "$rxd_id" "$txd_id"
    unset rxp_id
done

