import os,sys,time
sys.path.append("/home/dspeak/yyms/yymp/yymp_report_script")
from agent_protocol import UnixUdpClient
import pprint
from subprocess import Popen, PIPE
import traceback
import logging
import logging.config

def get_cpu(pid):
  ps = []
  pp = Popen(['sh','/home/dspeak/yyms/yymp/script/getPercentCpuOfProcess.sh',str(pid)], stdout=PIPE)
  line = pp.stdout.read()
  return line

def get_mem(pid):
  ps = []
  pp = Popen(['sh','/home/dspeak/yyms/yymp/script/getMemOfProcess.sh',str(pid)], stdout=PIPE)
  line = pp.stdout.read()
  return line

def get_pname_pver(pid):
  proc_list_dir = "/home/dspeak/yyms/proc_tmp"	
  if not os.path.exists(proc_list_dir):
    return None

  files = os.listdir(proc_list_dir)
  for file in files:
    pname, pver, tmp_pid = file.split(".")
    if pid == tmp_pid:
      return (pname, pver)	
  return None

def proc(pid,port):
  logger = None
  try:
    logging.config.fileConfig("/home/dspeak/yyms/yyms_agent_2_d/script/pstat_log.conf")
    logger = logging.getLogger('root')
  except:
    #print traceback.print_exc()
    pass
  
  pname_pver = get_pname_pver(pid)
  if pname_pver is None:
    return	  

  pname = pname_pver[0]
  pver  = pname_pver[1]  

  cpu = get_cpu(pid)
  cpu = cpu.replace('\n','')
  mem = get_mem(pid)
  mem = mem.replace('\n','')
  ts = int(time.time())
  pub_str1 = '''"step":10,"type":1,"dst":"GAUGE","min": "0","max": "200000000000"'''
  pub_str2 = '''"port":%d,"pid":%s,"pname":"%s","version":"%s", "ts":%d'''% (port,pid,pname,pver,ts)
  ret_str = '['
  for fid in [(105,cpu),(106,mem)]:
    ret_str += '''{%s,%s,"value":%s,"id":%d},'''%(pub_str1,pub_str2,fid[1],fid[0])
  ret_str = ret_str[0:len(ret_str)-1]
  ret_str += ']'
  
  logger.info(ret_str)  
  return ret_str
  
def main():
  if(len(sys.argv) < 3):
    print("usage: python get_cpu_mem.py pid port \"...\"");
  pid = sys.argv[1]
  port = long(sys.argv[2])  
  retstr = proc(pid,port)  
  agent_transfer(retstr)

def agent_transfer(msg):
  try:
    uc = UnixUdpClient()
    uc.write_fid(0, 0, long(time.time()), msg)
  except:
    #traceback.print_exc()
    pass	

if __name__ == '__main__':
  main()

