import os
import traceback


def check_pid(pid):        
    """ Check For the existence of a unix pid. """
    try:
        os.kill(pid, 0)
    except OSError:
        return False
    else:
        return True


def get_proc_list():
  proc_info_path = "/home/dspeak/yyms/proc_info/"
  port_set = set()
  pid_port_set  = set()  
  try:
    file_list = os.listdir(proc_info_path)
    for file in file_list:
      pid_stime_port = file.split('-')
      (pid, port) = int(pid_stime_port[0]), pid_stime_port[2]
      
      if check_pid(pid) == False:
        file_path = os.path.join(proc_info_path, file)
        os.remove(file_path)
      else:
        port_set.add(port)
        pid_port_set.add((pid, port))		
 
    return (port_set, pid_port_set)
  except:
    traceback.print_exc()
    return (None, None)

if __name__ == '__main__':
  print get_proc_list() 
