import os,sys,time
sys.path.append("/home/dspeak/yyms/yymp/yymp_report_script")
from agent_protocol import UnixUdpClient
import socket
import pprint
from subprocess import Popen, PIPE
import traceback
import logging
import logging.config

class Proc:
  def __init__(self):
    self.__sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM, 0)
    self.__sock.settimeout(1)
    self.__buffer_size = 10240;
    
  def __del__(self):
    self.__sock.close()

  def connect(self, port):
    self.__sock.connect(("127.0.0.1", port))

  def send_and_recv(self, cmd):
    self.__sock.send(cmd)

    total_data=[]
    while True:
      data = self.__sock.recv(self.__buffer_size)
      if not data: break
      total_data.append(data)
      if data.rfind("\r\n\r\n") is not -1: 
        break;
    ret = ''.join(total_data)
    ret = ret.strip()    
    if ret.endswith('>'):
      ret = ret[:len(ret)-1]
    return ret

  def get_all(self):
    return self.send_and_recv("agent get all\r\n")

  def get_clear(self):
    return self.send_and_recv("agent get clear\r\n")

  def str2obj(self, jsonstr):
    return eval(jsonstr)    
  
  def get_proc(self):
    ret = self.send_and_recv("agent get proc")
    return eval(ret)

  def get_dep(self):
    ret = self.send_and_recv("agent get dep")
    return eval(ret)

def get_cpu(pid):
  ps = []
  pp = Popen(['sh','/home/dspeak/yyms/yymp/script/getPercentCpuOfProcess.sh',str(pid)], stdout=PIPE)
  line = pp.stdout.read()
  return line

def get_mem(pid):
  ps = []
  pp = Popen(['sh','/home/dspeak/yyms/yymp/script/getMemOfProcess.sh',str(pid)], stdout=PIPE)
  line = pp.stdout.read()
  return line

def deal_json_s(str,name):
  jstr = eval(str)
  pname = jstr['proc']['pname']
  if pname is name:
    return True
  else:
    return False

def deal_json_pid(str,name):
  try:
    jstr = eval(str)
    pname = jstr['proc']['pname']
    pid = jstr['proc']['pid']
    time = jstr['proc']['time']
    if pname is name:
      return True,pid,time
    else:
      return False,0,0
  except:
    print 'deal_json_pid error'
    return False,0,0


def deal_json(rstr,port):
  logger = None
  try:
    logging.config.fileConfig("/home/dspeak/yyms/yyms_agent_2_d/script/pstat_log.conf")
    logger = logging.getLogger('root')
  except:
    #print traceback.print_exc()
    pass

  rstr = rstr.replace('\t','')
  rstr = rstr.replace('\r','')
  rstr = rstr.replace('\n','')
  rstr = rstr.replace(',}','}')
  rstr = rstr.replace(',]',']')

  jstr = eval(rstr)
  pid = jstr['proc']['pid']
  pname = jstr['proc']['pname']
  pver = jstr['proc']['pver']
  stime = int(jstr['proc']['time'])

  try:
    if not os.path.exists("/home/dspeak/yyms/proc_list"):
      os.mkdir("/home/dspeak/yyms/proc_list")
    if not os.path.exists("/home/dspeak/yyms/proc_list/%s.%s" % (pname, pid)):
      open("/home/dspeak/yyms/proc_list/%s.%s" % (pname, pid), "w").close()
    else:
      os.utime("/home/dspeak/yyms/proc_list/%s.%s" % (pname, pid), None)
  except:
    if logger:
      logger.exception("")

  try:
    if not os.path.exists("/home/dspeak/yyms/proc_tmp"):
      os.mkdir("/home/dspeak/yyms/proc_tmp")
    if not os.path.exists("/home/dspeak/yyms/proc_tmp/%s.%s.%s" % (pname, pver, pid)):	 
      open("/home/dspeak/yyms/proc_tmp/%s.%s.%s" % (pname, pver, pid), "w").close()		
    else:
      os.utime("/home/dspeak/yyms/proc_tmp/%s.%s.%s" % (pname, pver, pid), None)		
  except:
    if logger:
      logger.exception("")		

  if jstr['proc'].has_key('user'):
    users = jstr['proc']['user']
  else:
    users = 0
  if jstr['proc'].has_key('queue'):
    queue = jstr['proc']['queue']
  elif jstr['stat'].has_key('queue'):
    queue = jstr['stat']['queue']['queue']
  else:
    queue = 0

  total_req = 0
  total_time_cost = 0
  max_time = 0
  for item in jstr['stat']['uri']:
    if item['uri'].endswith('| 11') or item['uri'].endswith('145| 50') or item['uri'].endswith('146| 50') or item['uri'].endswith('  0|  0'): 
      continue;
    total_req += item['counter64']
    total_time_cost += item['time_cost']
    mtime = item['max_time']
    if time > max_time:
      max_time = mtime
    try:
      #syslog.syslog(syslog.LOG_USER|syslog.LOG_DEBUG, '''yyms {\"pid\":%s,\"uri\":\"%s\",\"counter64\":%s,\"time_cost\":%s,\"max_time\":%s} \n'''%(pid,item['uri'],item['counter64'],item['time_cost'],item['max_time']))
      logger.info(''' {\"pid\":%s,\"uri\":\"%s\",\"counter64\":%s,\"time_cost\":%s,\"max_time\":%s}'''%(pid,item['uri'],item['counter64'],item['time_cost'],item['max_time']))
      pass
    except:
      print "write error"
      pass;

  req_avg_time = 0.0;
  if total_req is not 0:
    req_avg_time = total_time_cost*1.0
    req_avg_time /= total_req;
    total_req = total_req/(10*1.0);
    
  cpu = get_cpu(pid)
  cpu = cpu.replace('\n','')
  mem = get_mem(pid)
  mem = mem.replace('\n','')
  ts = int(time.time())
  pub_str1 = '''"step":10,"type":1,"dst":"GAUGE","min": "0","max": "200000000000"'''
  pub_str2 = '''"port":%d,"pid":%s,"pname":"%s","version":"%s","stime":%s,"ts":%d'''% (port,pid,pname,pver,stime,ts)
  ret_str = '['
  for fid in [(100,total_req),(101,users),(102,req_avg_time),(103,max_time),(104,queue),(105,cpu),(106,mem)]:
    ret_str += '''{%s,%s,"value":%s,"id":%d},'''%(pub_str1,pub_str2,fid[1],fid[0])
  ret_str = ret_str[0:len(ret_str)-1]
  ret_str += ']'
  return ret_str
  
def main():
  try:	
    if(len(sys.argv) < 2):
      print("usage: python pstat.py port \"...\"");
    port = long(sys.argv[1]);
    proc = Proc();
    proc.connect(port);
    rstr = proc.get_clear()
    retstr = deal_json(rstr,port)
    agent_transfer(retstr)
    #print retstr
  except:
    #traceback.print_exc()	  
    pass	

def agent_transfer(msg):
  try:
    uc = UnixUdpClient()
    uc.write_fid(0, 0, long(time.time()), msg)
  except:
    #traceback.print_exc()
    pass

if __name__ == '__main__':
  main()

