import os,sys,signal,time,shlex,logging
g_caller = os.path.basename(__file__)
from subprocess import Popen, PIPE

sys.path.append("/home/dspeak/yyms/yymp/yymp_pylibs/APScheduler-2.0.3")
sys.path.append("/home/dspeak/yyms/yymp/yymp_pylibs/yymp_common")
from apscheduler.scheduler import Scheduler
from app_conf import log_config
from get_proc import *

class LoggerC:
  def __init__(self):
    self.logger = None
    log_config(g_caller)
    self.logger = logging
  
Logger = LoggerC()

def call(cmd_str,timeout = 10):
  try:
    args = shlex.split(cmd_str)
    if len(args) == 0:
      restr = '\r\n\r\n'
      return restr

    pp = Popen(args, stdout=PIPE,stderr=PIPE)

    start_ts = int(time.time())
    while pp.poll() is None and (int(time.time()) - start_ts) < timeout -1:
      time.sleep(1)

    if pp.poll() == None: # child is not exit yet!
      os.kill(pp.pid, signal.SIGTERM)
      os.kill(pp.pid, signal.SIGKILL)
      pp.wait()
      return '\r\n\r\n'

    #restr,errstr= pp.communicate()
    #return restr
  except:
    Logger.logger.exception('')
    #restr = '\r\n\r\n'
    #return restr
  
def job_function(cmd_line,timeout):
  try:
    call(cmd_line,timeout)
    Logger.logger.info('cmd_line:%s,timeout:%s'%(cmd_line,timeout))
  except:
    Logger.logger.exception('')

def job_clear_proc_tmp():
  try:
    Logger.logger.info("clear proc tmp")	  
    proc_list_dir = "/home/dspeak/yyms/proc_tmp"
    if not os.path.exists(proc_list_dir):
      return		

    cur_ts = int(time.time())
    files = os.listdir(proc_list_dir)      	
    for file in files:
      path = os.path.join(proc_list_dir, file)
      ctime = int(os.stat(path).st_mtime)
      if cur_ts - ctime > 86400:
        os.remove(path)
        Logger.logger.info("remove %s" %path)		
  except:
    Logger.logger.exception('')	  
      
if __name__ == '__main__':  	
  (port_list, pid_port_list) = get_proc_list()
  thread_nums = 20
  if port_list:
    t = int(len(port_list) * 1.2 * 2)
    if t > thread_nums:
      thread_nums = t
  sched = Scheduler({"apscheduler.threadpool.max_threads":thread_nums+1})
  sched.start()
  sched.add_interval_job(job_clear_proc_tmp, days=1)  
  pid_port_list = None
  while(True):
    try:
      (port_list_now, pid_port_list_now) = get_proc_list()
      if pid_port_list_now != pid_port_list:
        port_list = port_list_now
        pid_port_list = pid_port_list_now		
        try:
          sched.unschedule_func(job_function)
        except:
          Logger.logger.exception('')
        if len(port_list)*2 > thread_nums:
          thread_nums = int(len(port_list) * 1.2 * 2)
          sched.shutdown()
          sched = Scheduler({"apscheduler.threadpool.max_threads":thread_nums+1})
          sched.start()
          sched.add_interval_job(job_clear_proc_tmp, days=1) 		  
        for port in port_list:
          Logger.logger.info('add proc cron, port:%s'%port)
          sched.add_cron_job(job_function,second='*/10', args=["python pstat2.py %s"%port,10])
        for pid_port in pid_port_list:
          Logger.logger.info('add proc cron, pid:%s, port:%s' %(pid_port[0], pid_port[1]))
          sched.add_cron_job(job_function,second='*/10', args=["python get_cpu_mem.py %s %s" %(pid_port[0], long(pid_port[1])),10])		  
      else:
        Logger.logger.info('no proc cron change, port list:%s, pid_port list:%s'%(str(port_list), str(pid_port_list)))
        
    except:
      Logger.logger.exception('')
    time.sleep(60)
