#-*-coding:utf-8 -*-
import os,sys
import ConfigParser
import logging.config

class Config(object):
    def __init__(self, conf_file="./etc/app.conf"):
        self.__conf_file = conf_file
        self.config = ConfigParser.SafeConfigParser()
        self.config.read(self.__conf_file)

    def __reload(self):
        self.config.read(self.__conf_file)

    @staticmethod
    def instance():
        if not hasattr(Config, '_instance'):
            Config._instance = Config()
        return Config._instance


def log_config(caller):
    log_conf = Config.instance().config.get("log", "conf")
    log_path = Config.instance().config.get("log", "log_path")
    log_fullpath = "%s%s.log" % (log_path, caller)
    p = os.path.dirname(log_path)
    if(not os.path.exists(p)):
        os.makedirs(p)
    try:
        logging.config.fileConfig(log_conf,
                defaults=dict(log_fullpath=log_fullpath))
    except IOError:
        sys.exit(-1)
        pass
