#-*-coding:utf-8 -*-

import ConfigParser
import logging
import logging.config
import os,sys,stat


class Config(object):
    def __init__(self, conf_file="./etc/app.conf"):
        self.__conf_file = conf_file
        self.config = ConfigParser.SafeConfigParser()
        self.config.read(self.__conf_file)

    def __reload(self):
        self.config.read(self.__conf_file)

    @staticmethod
    def instance():
        if not hasattr(Config, '_instance'):
            Config._instance = Config()
        return Config._instance


def log_config():
    log_conf = Config.instance().config.get("log", "conf")
    log_path = Config.instance().config.get("log", "log_path")
    p = os.path.dirname(log_path)
    if(not os.path.exists(p)):
        os.makedirs(p)
    try:
        logging.config.fileConfig(log_conf,
                defaults=dict(log_path=log_path))
        if os.getuid() == 0:
            os.chmod(log_path, stat.S_IRGRP|stat.S_IXGRP|stat.S_IRWXU|stat.S_IRWXO)
    except IOError:
        #sys.exit(-1)
        pass
