#!/usr/bin/env python
#-*-coding:utf-8-*-

"""
usage:
    yymp_report.py "k=v&k=v&k=v"
        or
    echo "k=v&k=v&k=v" | yymp_report.py
"""
import os
module_file_dir = os.path.dirname(__file__)
if(module_file_dir):
    os.chdir(module_file_dir)
import sys
sys.path.append("../yymp_pylibs/yymp_common")
import logging
import time

from app_conf import *


def handler(kv):
    comm_dir = Config.instance().config.get("common_dir", "dir")
    sys.path.append(comm_dir)
    try:
        from agent_protocol import UnixUdpClient
        conn = UnixUdpClient()
        conn.write_fid(0, 0, long(time.time()), kv)
    except Exception, e:
        logging.exception(e)
        sys.exit()


def cut_arg(arg):
    d = dict()
    has_id = False
    has_value = False
    kv_list = arg.split('&')
    for i in kv_list:
        if i.find("=") > 0:
            k, v = i.split("=")
            k = k.strip()
            v = v.strip()
            if k == "id":
                has_id = True
                try:
                    v = int(v)
                except ValueError, e:
                    logging.error("Can't convert id to int")
                    sys.exit()
                d[k] = v
            elif k == "value":
                has_value = True
                try:
                    v = float(v)
                except ValueError, e:
                    logging.error("Can't convert value to float ")
                    sys.exit()
                d[k] = v
            else:
                d[k] = v
        else:
            logging.error("Invalid input format")
            sys.exit()

    if has_id and has_value:
        return d
    else:
        logging.error("Must has 'id' and 'value' key")
        sys.exit()


def parse_arg():
    kv = dict()
    if len(sys.argv) == 1:
        for line in sys.stdin:
            kv = cut_arg(line)
            break   # only one line in stdin, so break
    elif len(sys.argv) == 2:
        kv = cut_arg(sys.argv[1])
    else:
        logging.error("Invalid input format")
        sys.exit()
    kv["step"] = 60
    dst = kv.get("dst", "GAUGE")
    dst = dst.upper()
    if(dst not in ["GAUGE", "COUNTER"]):
        dst = "GAUGE"
    kv["dst"] = dst
    kv["min"] = "0"
    #kv["max"] = "200000000000"
    max_threshold = kv.get("max", "1.84467440737e+19")
    kv["max"] = max_threshold
    kv["ts"] = int(time.time())
    if(kv.has_key("pid")):
        kv["pid"] = int(kv["pid"])
    if(kv.has_key("port")):
        kv["port"] = int(kv["port"])
    kv = str(kv)
    return "[%s]" % (kv.replace("'", '"'))


def main():
    log_config()
    json_str = dict()
    json_str = parse_arg()
    if json_str is not None and len(json_str) > 0:
        handler(json_str)
        print json_str

if __name__ == "__main__":
    main()
