#!/usr/bin/env python
#-*-coding:utf-8-*-

"""
usage:
    yymp_report_int.py id int-value
        or
    echo "id int-value" | yymp_report_int.py
"""

import os
module_file_dir = os.path.dirname(__file__)
if(module_file_dir):
    os.chdir(module_file_dir)
import sys
sys.path.append("../yymp_pylibs/yymp_common")
import logging
import time

from app_conf import *


def handler(kv):
    comm_dir = Config.instance().config.get("common_dir", "dir")
    sys.path.append(comm_dir)
    try:
        from agent_protocol import UnixUdpClient
        conn = UnixUdpClient()
        conn.write_fid(0, 0, long(time.time()), kv)
    except Exception, e:
        logging.exception(e)
        sys.exit()


def parse_arg():
    kv = dict()
    if len(sys.argv) == 1:
        for line in sys.stdin:
            line = line.strip()
            line = line.split(" ")
            if len(line) == 2:
                try:
                    id = int(line[0])
                    value = float(line[1])
                except ValueError, e:
                    logging.error("Can't convert id or value")
                    sys.exit()
                else:
                    kv["id"] = id
                    kv["value"] = value
            else:
                logging.error("Invalid input format.")
                sys.exit()
            break   # only one line in stdin, so break

    elif len(sys.argv) == 3:
        try:
            id = int(sys.argv[1])
            value = float(sys.argv[2])
        except ValueError, e:
            logging.error("Can't convert id or value")
            sys.exit()
        else:
            kv["id"] = id
            kv["value"] = value
    else:
        logging.error("Invalid input format")
        sys.exit()

    kv["ts"] = int(time.time())
    kv["step"] = 60
    kv["dst"] = "GAUGE"
    kv["min"] = "0"
    kv["max"] = "1.84467440737e+19"
    ret_list = []
    ret_list.append(kv) 
    #kv = str(kv)
    #return kv
    return str(ret_list).replace("'", '"')


def main():
    log_config()
    json_str = dict()
    json_str = parse_arg()
    handler(json_str)
    print json_str

if __name__ == "__main__":
    main()
