#!/usr/bin/env python
#-*-coding:utf-8-*-

"""
usage:
    yymp_report_multi.py "k=v&k=v|k=v&k=v"
        or
    echo "k=v&k=v|k=v&k=v" | yymp_report.py    
"""
import os
module_file_dir = os.path.dirname(__file__)
if(module_file_dir):
    os.chdir(module_file_dir)
import sys
sys.path.append("../yymp_pylibs/yymp_common")
import logging
import time


from app_conf import *

def handler(data):
    comm_dir = Config.instance().config.get("common_dir", "dir")
    sys.path.append(comm_dir)
    try:
        from agent_protocol import UnixUdpClient
        conn = UnixUdpClient()
        conn.write_fid(0, 0, long(time.time()), data)
    except Exception, e:
        logging.exception(e)
        sys.exit()

def builtin_transfer(kv):
    kv["id"] = int(kv["id"])
    kv["value"] = float(kv["value"])
    kv["step"] = 60
    dst = kv.get("dst", "GAUGE")
    dst = dst.upper()
    if(dst not in ["GAUGE", "COUNTER"]):
        dst = "GAUGE"
    kv["dst"] = dst
    kv["min"] = "0"
    kv["max"] = kv.get("max", "1.84467440737e+19")
    kv["ts"] = int(time.time())
    if(kv.has_key("pid")):
        kv["pid"] = int(kv["pid"])
    if(kv.has_key("port")):
        kv["port"] = int(kv["port"])
    
def arg_line_to_json(line):
    ret = []
    rs = [ item.strip()  for item in line.split("|") if item.strip() != ""]
    for r in rs:
        try:
            d = dict([item.split("=") for item in r.split("&")])
            builtin_transfer(d)
            ret.append(d)
        except:
            logging.exception(r)
    return ret

def parser_arg_ex():
    ret = []
    if len(sys.argv) == 1:
        for line in sys.stdin:
            ret = arg_line_to_json(line)
            break
    elif len(sys.argv) == 2:
        ret = arg_line_to_json(sys.argv[1])
    else:
        logging.error("Invalid input format")
        sys.exit()
    return ret
    
def main():
    log_config()
    json_str = parser_arg_ex()
    if json_str is not None and len(json_str) > 0:
        json_str = str(json_str).replace("'", '"')
        handler(json_str)
        print json_str

if __name__ == "__main__":
    main()
