#!/usr/bin/env python
#-*-coding:utf-8-*-

"""
usage:
    yymp_report_alarm.py id msg
        or
    echo "id msg" | yymp_report_alarm.py
"""
import os
module_file_dir = os.path.dirname(__file__)
if(module_file_dir):
    os.chdir(module_file_dir)
import sys
#sys.path.append("../yymp_pylibs/")
sys.path.append("../yymp_pylibs/yymp_common")
import logging
import time

from app_conf import *
from alarm_to_center_node import alarm2redis
from hostinfo import HostInfo
from hostinfo import CenterNode


def handler(kv):
##    comm_dir = Config.instance().config.get("common_dir", "dir")
##    sys.path.append(comm_dir)
##    try:
##        from agent_protocol import UnixUdpClient
##        conn = UnixUdpClient()
##        conn.write_fid(12345, 1, long(time.time()), kv)
##    except Exception, e:
##        logging.exception(e)
##        sys.exit()

    hostinfoObj = HostInfo.get_hostinfo()
    hid = hostinfoObj.get("guid", "")
    localIp = hostinfoObj.get("ips", [""])[0]
    print hid, localIp
    print CenterNode.get_center_node_list()
    print kv


def parse_arg():
    kv = dict()
    if len(sys.argv) == 1:
        for line in sys.stdin:
            line = line.lstrip()
            line = line.split(" ", 2)   # 将id,sid与msg切分开
            if len(line) == 3:
                try:
                    id = int(line[0])
                    sid = int(line[1])
                except ValueError, e:
                    logging.error("Can't convert id to int")
                    sys.exit()
                else:
                    msg = line[1]
                    kv["id"] = id
                    kv["sid"] = sid
                    kv["msg"] = msg
            else:
                logging.error("Invalid input format.")
                sys.exit()
            break   # only one line in stdin, so break

    elif len(sys.argv) >= 4:
        try:
            id = int(sys.argv[1])
            sid = int(sys.argv[2])
        except ValueError, e:
            logging.error("Can't convert id or sid to int")
            sys.exit()
        else:
            #兼容msg未加引号而且msg中包含空格的情况
            #如yymp_report_alarm.py id msg1 msg2 msg3 ...
            #msg1 msg2 msg3将会被当成一条msg
            msg = sys.argv[2]
            for arg in sys.argv[3:]:
                msg += " "
                msg += arg
            kv["id"] = id
            kv["sid"] = sid
            kv["msg"] = msg.replace("'", "")
    else:
        logging.error("Invalid input format")
        sys.exit()

    kv = str(kv)
    return "[%s]" % (kv.replace("'", '"'))


def main():
    log_config()
    json_str = dict()
    json_str = parse_arg()
    handler(json_str)
    print json_str

if __name__ == "__main__":
    main()
