#!/usr/bin/env python
# -*- coding:utf8 -*-

import os,sys,time
import urllib2
import traceback
from get_local_ip import *

def get_url(url):
    try:
        r = urllib2.urlopen(url)
        data = r.read()
        return data
    except:
        traceback.print_exc()
    return None

def choose_url():
    try:
        fd = open("/home/dspeak/yyms/hostinfo", "r")
        host_info = eval(fd.read())
        fd.close()
        isps = set()
        urls = set()
        for ip in host_info["ips"]:
            isps.add(ip["isp"])
        if 4 in isps:
            for ip in center_node_ip_4:
                urls.add("http://%s:40100/get_room_ips?md5=" % ip)
        if 5 in isps:
            for ip in center_node_ip_5:
                urls.add("http://%s:40100/get_room_ips?md5=" % ip)
        if len(urls) == 0:
            for ip in center_node_full_ip_list:
                urls.add("http://%s:40100/get_room_ips?md5=" % ip)
        return urls
    except:
        traceback.print_exc()
        return []
    
def get_md5(data):
    try:
        import hashlib
        m = hashlib.md5()
    except:
        import md5
        m = md5.new()
    m.update(data)
    return m.hexdigest().lower()

if __name__ == '__main__':
    try:
        path = "/home/dspeak/yyms/"
        md5_path = "%s/intranet_ip_list.md5" % path
        file_path = "%s/intranet_ip_list.ini" % path
        md5 = None
        if os.path.exists(md5_path):
            fd = open(md5_path, "r")
            md5 = fd.read()
            fd.close()
        urls = choose_url()
        for url in urls:
            if md5:
                data = get_url(url + md5)
            else:
                data = get_url(url)
            if data == "0":
                break
            if len(data) > 32:
                ips = data[32:]
                if data[0:32] == get_md5(ips):
                    fd = open(file_path, "w")
                    fd.write(ips)
                    fd.close()
                    fd = open(md5_path, "w")
                    fd.write(data[0:32])
                    fd.close()
                    break
    except:
        traceback.print_exc()
        
