import os
module_file_dir = os.path.dirname(__file__)
if(module_file_dir):
    os.chdir(module_file_dir)
    
import redis
from redis import ConnectionError
import time
import sys
sys.path.insert(0, "/home/dspeak/yyms/yymp/yymp_pylibs/yymp_common")
import proxy_module
import random
import traceback
import thread
import logging
import logging.config
import ConfigParser
from get_local_ip import *


class LoggerC:
  def __init__(self):
    self.logger = None
    logging.config.fileConfig("trans_log.conf")
    self.logger = logging.getLogger('root')
  
Logger = LoggerC()
Logger.logger.info('log ok')

class RedisCache:
  def __init__(self):
    self.datanodes = []

  def set_conn(self, key_pre):
    if key_pre == "yyms_alarmnodes_":
      return self.set_cn_conn(key_pre)		
    else:
      return self.set_dn_conn(key_pre)

  def set_cn_conn(self, key_pre):
    Logger.logger.info("get alarm node")	  
    ips = get_conf_center_ips()
    self.datanodes = []	
    for item in ips:
      try:		
        (host, port) = item
        self.datanodes.append((host, 44934))		
      except:
        Logger.logger.exception("")

    if len(self.datanodes) == 0:
      Logger.logger.info('set alarmnodes failed')
      return False
    else:
      Logger.logger.info('%s:%s'%(key_pre,str(self.datanodes)))
      return True	  
	

  def set_dn_conn(self, key_pre):
    Logger.logger.info("get data node") 	  
    ips = get_conf_dn_ips()
    self.datanodes = []
    for item in ips:
      try:      
        self.datanodes.append((item, 6379))		
      except:
        Logger.logger.exception("")		  

    if len(self.datanodes) == 0:
      Logger.logger.info('set datanodes failed')
      return False
    else:
      Logger.logger.info('%s:%s'%(key_pre,str(self.datanodes)))
      return True
  
  def push_data(self,datas,key):
    if len(self.datanodes) == 0:
      Logger.logger.info("no %s nodes"%key)
      return -1;
    bSend = False
    for dns in self.datanodes:
      try:
        (host,port) = dns
        conn = redis.Redis(host=host, port=port+10,socket_timeout=5)
        cur_time = int(time.time())
        for data in datas:
          if cur_time - data["ts"] >= 1200 and key == "alarm":
              continue
          rkey = ""
          if data.has_key("type") and key == 'merged' and data["type"] == 1:
            rkey = 'proc'
          elif key == 'alarm' :
            rkey = 'yymp_alarm_%s_%s' %(data.get("notice_fl", 0), data.get("alarm_level", 3))
          else:
            rkey = key
          Logger.logger.info('trans to %s:%s %s | %s'%(host,port,rkey,data))		  
          conn.rpush(rkey,data)
        bSend = True
      except ConnectionError:
        Logger.logger.exception('trans to %s:%s failed!' % (host, port))
      except:
        Logger.logger.exception("")
        pass;
    if not bSend:
        return -1
    return 0


class Transfer :
  def __init__(self,filenamelist,tagname,confkey,datakey):
    self.cur_ts = 0
    self.seq = 0
    self.file_time = 0
    self.file_name_list = filenamelist
    self.tag_name = tagname
    self.conf_key = confkey
    self.data_key = datakey
    self.redis = RedisCache()
    self.sleep_time = 3
    self.max_sleep_time = 10
    self.timer = 100
   
  def time_to_getConfig(self):
    self.timer += 1
    if self.timer > 100:
      self.timer = 1
      return True
    else:
      return False
    
  def set_to_getConfig(self):
    self.timer = 100
    
  def reset_sleep_time(self):
    self.sleep_time = 3
    
  def get_sleep_time(self):
    ti = self.sleep_time 
    self.sleep_time = 2*self.sleep_time
    if self.sleep_time > self.max_sleep_time:
      self.sleep_time = self.max_sleep_time
    return ti
    
  def save_ts(self):
    try:
      f = open(self.tag_name, 'w')
      tag = "%s %s %s"%(self.cur_ts,self.seq,self.file_time)
      f.write(tag)
      f.close()
    except:
      Logger.logger.exception('')
      pass;
    
  def load_ts(self):
    try:
      f = open(self.tag_name, 'r')
      strs = str(f.read())
      strl = strs.split()
      if len(strl) == 3:
        self.cur_ts = int(strl[0])
        self.seq = int(strl[1])
        self.file_time = int(strl[2])
      elif len(strl) == 2:
        self.cur_ts = int(strl[0])
        self.seq = int(strl[1])
        self.file_time = 0
      elif len(strl) == 1:
        self.cur_ts = int(strl[0])
        self.seq = 0
        self.file_time = 0
      f.close()
    except:
      self.cur_ts = 0
      self.seq = 0
      self.file_time = 0
      Logger.logger.exception('')
      pass;

  def read_pre(self):
    read_files = []

    for i in range(1,11):
      try:
        lines = None
        pre_file = open(self.file_name_list[i],'rb')
        first_line = eval(pre_file.readline())
        first_ts = first_line['ts']
        if first_ts >= self.cur_ts:
          read_files.append(self.file_name_list[i])
          pre_file.close()
        else:
          end_line = eval(pre_file.readlines()[-1])
          if end_line["ts"] >= self.cur_ts:
            read_files.append(self.file_name_list[i])
            pre_file.close()
            continue
          pre_file.close()
          break;
      except:
        Logger.logger.exception('')
    
    Logger.logger.info('pre files:%s'%str(read_files))

    for filename in read_files:
      try:
        pre_file = open(filename,'rb')
        Logger.logger.info(filename)
        lines = pre_file.readlines()
        records = self.read_line(lines)
        if self.push_records(records) == -1:
            Logger.logger.warning("send pre records failed!")
            pre_file.close()
            return -1
        pre_file.close()
      except:
        Logger.logger.exception('')
    
  def read_line(self,lines):
    if lines is None:
      return None
    records = []
    cur_ts = 0
    cur_seq = 0
    pre_seq = self.seq
    guid = get_guid2()
    for line in lines:
      send_tag = False
      
      jstr = ""
      try:
        jstr = eval(line)
        cur_ts = jstr['ts']
      except:
        Logger.logger.exception('')
        continue;
            
      if cur_ts > self.cur_ts:
        send_tag = True
      elif cur_ts == self.cur_ts:
        cur_seq += 1
        if cur_seq > pre_seq:
          pre_seq = cur_seq
          send_tag = True
        else:
          continue;
      else:
        pass;
      
      if send_tag:
        try:
          data = jstr['da']
          if data.has_key('dsname'):
            data['id'] = int(data['dsname'])
          records.append(data)
          self.reset_sleep_time()
        except:
          Logger.logger.exception('')
          pass
    return records

  def push_records(self,records):
    if records is None or len(records) == 0:
      return 0;
    else:
      return self.redis.push_data(records,self.data_key)
     
  def transfer(self):
    lines = None
    first_line_str = ''
    cur_file = None
    try:
      cur_file = open(self.file_name_list[0],'rb')
      file_time = int(os.path.getmtime(self.file_name_list[0]))
      first_line_str = cur_file.readline()
      if len(first_line_str) > 0:
        first_line = eval(first_line_str)
        first_ts = first_line['ts']
        if first_ts >= self.cur_ts and file_time != self.file_time:
          if self.read_pre() == -1:
            return
          else:
            self.seq = 0
        cur_file.seek(0)
      lines = cur_file.readlines()
      if lines is None or len(lines)==0:
        return;
    except:
      Logger.logger.exception('')
      Logger.logger.info(first_line_str)
      return;
    #Logger.logger.info('after pre,data type:%s'%(self.data_key))
    
    cur_ts = 0
    cur_seq = 0
    last_ts = 0
    records = []
    guid = get_guid2()
    for line in lines:
      jstr = ""
      try:
        if len(line) == 0:
          continue;
        jstr = eval(line.strip())
        cur_ts = jstr['ts']
      except:
        Logger.logger.exception('')
        continue;
      send_tag = False
      if cur_ts == self.cur_ts:
        cur_seq += 1
        if cur_seq > self.seq:
          self.seq = cur_seq
          send_tag = True
        else:
          continue;
      if cur_ts > self.cur_ts:
        send_tag = True
        if cur_ts == last_ts:
          cur_seq += 1
        elif cur_ts > last_ts:
          cur_seq = 1
      if send_tag:
        try:
          data = jstr['da']
          if data.has_key('dsname'):
            data['id'] = int(data['dsname'])
          records.append(data)
          self.reset_sleep_time()
        except:
          Logger.logger.exception('')
          pass
      last_ts = cur_ts;

    #Logger.logger.info('try records num:%s,data type:%s'%(len(records),self.data_key))
    if self.push_records(records) == -1:
        Logger.logger.warning("send data to datanode uncomplete!")
        return
    if cur_ts > self.cur_ts:
      self.cur_ts = cur_ts
      self.seq = cur_seq
    self.file_time = file_time
    cur_file.close()
    Logger.logger.info('records num:%s,last tag:%s,data type:%s'%(len(records),"%s %s %s"%(self.cur_ts,self.seq,self.file_time),self.data_key))
    
  def run(self):
    while(True):
      try:
        self.load_ts()
        
        if self.time_to_getConfig():
          Logger.logger.info('try to get datanode')
          if not self.redis.set_conn(self.conf_key):
            Logger.logger.info('no datanode and sleep')
            self.set_to_getConfig()
            time.sleep(self.max_sleep_time)
            continue;
          
        self.transfer()
        self.save_ts()
        time.sleep(self.get_sleep_time())
      except:
        Logger.logger.exception('')
        time.sleep(self.max_sleep_time)
      
def trans_alarm_data():
  file_name = "/home/dspeak/yyms/yymp/yymp_agent/bin/alarm_data/alarm_data.log"
  filenamelist = []
  filenamelist.append(file_name)
  for i in range(1,11):
    filenamelist.append("%s.%s"%(file_name,i))

  tagname = '/home/dspeak/yyms/yymp/yymp_agent/bin/alarm_data/alarm_data'
  conf_key = 'yyms_alarmnodes_'
  data_key = 'alarm'
  alarm_trans = Transfer(filenamelist,tagname,conf_key,data_key)
  alarm_trans.run()

def trans_merged_data():
  file_name = "/home/dspeak/yyms/yymp/yymp_agent/bin/merged_data/merged_data.log"
  filenamelist = []
  filenamelist.append(file_name)
  for i in range(1,11):
    filenamelist.append("%s.%s"%(file_name,i))

  tagname = '/home/dspeak/yyms/yymp/yymp_agent/bin/merged_data/merged_data'
  conf_key = 'yyms_datanodes_'
  data_key = 'merged'
  merged_trans = Transfer(filenamelist,tagname,conf_key,data_key)
  merged_trans.run()

def trans_proc_data():
    filenamelist = [
'/home/dspeak/yyms/yyms_agent_2_d/build/proc_data/proc_data.log',
]
    tagname = '/home/dspeak/yyms/yyms_agent_2_d/assist/proc_data'
   # alarm_trans = Transfer(filenamelist,tagname,ip,port,key)
   # alarm_trans.run()

if __name__ == '__main__':
  try:
    Logger.logger.info('transfer start')
    thread.start_new_thread(trans_alarm_data,())
    thread.start_new_thread(trans_merged_data,())
    #thread.start_new_thread(trans_proc_data,())
  except:
    print traceback.print_exc()
  while True:
    time.sleep(1000)
  pass
