#!/bin/bash

cat /etc/issue|grep -iqE "CentOS|Red" && STATUS_FILE="/var/lib/logrotate.status"
cat /etc/issue|grep -iqE "Ubuntu|Debian" && STATUS_FILE="/var/lib/logrotate/status"
CONF_DIR="/usr/local/i386/public_repos/initial_system/syslog"

#Only for test
IPADDR=$(/sbin/ifconfig|grep Bcast|grep -v -E "inet addr:192.168|inet addr:172.16|inet addr:10.0"|head -n 1|awk '{print $2}'|awk -F : '{print $2}')
if [ "x${IPADDR}" = "x" ];then
    IPADDR=$(/sbin/ifconfig|grep "inet addr:"|grep -v 127.0.0.1|awk -F 'Bcast' '{print $1}'|awk -F : '{print $NF}')
fi


# logrotate status file will contain some error, we should check it.
if [ -s $STATUS_FILE ];then
    cd "${STATUS_FILE%/*}"
    head -1 $STATUS_FILE > ${STATUS_FILE}.clean
    sed 's/"//g' $STATUS_FILE | while read logfile date
    do
        [ -e "$logfile" ] && [ -n "$date" ] && \
        echo "\"$logfile\" $date" >> ${STATUS_FILE}.clean
    done
    mv ${STATUS_FILE}.clean ${STATUS_FILE}

    unc=$(awk '{if(NR>1){if($1 !~ /^\"/){printf("yes");exit}}}' $STATUS_FILE)
    ccow=$(awk '{if(NR>1){if(NF != 2){printf("yes");exit}}}' $STATUS_FILE)
    empline=$(egrep '[^[:print:]]' $STATUS_FILE)
    if [ "x${ccow}" == "xyes" ] || \
        [ "x${empline}" == "x0" ] || \
        [ "x${unc}" == "xyes" ];then
        rm -f $STATUS_FILE
        touch $STATUS_FILE
    fi
    cd - >/dev/null
else
    [ ! -f $STATUS_FILE ] && touch $STATUS_FILE
fi

[ ! -d /var/log/system_log ] && mkdir -p /var/log/system_log/

if [ -x /usr/sbin/logrotate ];then
    [ -s ${CONF_DIR}/logrotate.d_hourly ] && \
    /usr/sbin/logrotate ${CONF_DIR}/logrotate.d_hourly

    [ -s ${CONF_DIR}/logrotate.d_weblog_hourly ] && \
    /usr/sbin/logrotate ${CONF_DIR}/logrotate.d_weblog_hourly 2>/dev/null

    [ -s ${CONF_DIR}/logrotate.d_daily ] && \
    /usr/sbin/logrotate ${CONF_DIR}/logrotate.d_daily

    [ -s ${CONF_DIR}/logrotate.d_weblog_daily ] && \
    /usr/sbin/logrotate ${CONF_DIR}/logrotate.d_weblog_daily 2>/dev/null

    /usr/sbin/logrotate /etc/logrotate.conf
fi

# define clean script by yourself.
/bin/bash $CONF_DIR/clean_log/weblog_clean.sh

exit 0
